<?LassoScript

	if: !((var: 'security_token') >> 'migration');
		redirect_url: 'http://' + server_name + '/';
		abort;
	/if;

	encode_set: -encodenone;

	'#[version: 7.0]\r\n';
	'#Lasso Security Settings\r\n';
	'#Copyright 2003-' + (date_getyear: date_getcurrentdate) + ' LassoSoft, LLC\r\n';
	'#<a href="http://www.lassosoft.com/">http://www.lassosoft.com/</a>\r\n';
	'#\r\n';
	'#\r\n';
	'#    The security settings can be imported into LP7 Lasso Administration using\r\n';
	'#    the "Import..." command in the Setup > Global > Import/Export section.\r\n';
	'#\r\n';
	'#    Do not edit this file directly.  No user-servicable parts inside.\r\n';
	'#\r\n';
	'#\r\n';

	var: 'schema' = (array);
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='global_prefs'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='jdbc_drivers'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasources'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasource_hosts'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasource_databases'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_database_tables'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_table_fields'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_users', 'query'=(array: -op='gt', 'id'='2')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_ug_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_tags', 'query'=(array: -op='neq', 'enabled'='Y')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_groups', 'query'=(array: -op='gt', 'id'='2')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_host_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_db_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_table_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_file_perms'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_generic_perms'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_tag_map', 'query'=(array: -op='neq', 'allow_exec'='Y', -op='neq', 'id_group'='1')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='sites'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='site_prefs'));
	$schema->(insert: (map: 'database'='site', 'table'='_OutgoingEmailPrefs'));
	$schema->(insert: (map: 'database'='site', 'table'='_Schedule'));
	$schema->(insert: (map: 'database'='site', 'table'='_Maintenance'));
	$schema->(insert: (map: 'database'='lasso_admin', 'table'='admin_prefs'));
	
	loop: $schema->size;
		var: 'temp_schema' = $schema->(get: loop_count);
		var: 'inline' = (array:
				-database=$temp_schema->(find: 'database'),
				-table=$temp_schema->(find: 'table'),
				-maxrecords='all'		
		);
		
		if: ($temp_schema->(find: 'query') != null);
			$inline->(merge: $temp_schema->(find: 'query'));
			$inline->(insert: -search='action');
		else;
			$inline->(insert: -findall='action');
		/if;
		
		inline: $inline;
			
			var: 'names' = array;
			var: 'temp_fields' = $temp_schema->(find: 'field');
			if: ($temp_fields->type == 'array');
				loop: $temp_fields->size;
					$names->(insert: $temp_fields->(get: loop_count));
				/loop;
			else;
				loop: (field_name: -count);
					$names->(insert: (field_name: loop_count));
				/loop;
			/if;
			
			'[' + (database_name) + '.' + (table_name) + ': ';
			loop: $names->size;
				if: (loop_count > 1);
					', ';
				/if;
				$names->(get: loop_count);
			/loop; 
			']\r\n';
			
			records;
				'  ("';
				loop: $names->size;
					if: (loop_count > 1);
						'","';
					/if;
					encode_sql: (field: $names->(get: loop_count));
				/loop;
				'")';
				if: (loop_count < found_count);
					',';
				/if;
				'\r\n';
			/records;

			'[/' + (table_name) + ']\r\n';
			
		/inline;
	/loop;
	
	'#END\r\n';
	'\r\n';

	/encode_set;
?>
