[if: !((var: 'security_token') >> 'migration')][redirect_url: 'http://' + (server_name) + '/'][abort][/if]
<?LassoScript

	//
	// Custom Tags
	//
	include: (lassoapp_link: 'tags.lasso');

	//
	// Cache Control
	//
	_migration_nocache;
	
	//
	// Session
	//
	
	if: (action_param:'logout') == 'true';
		session_end: -name='_migration';
		redirect_url: (lassoapp_link: 'logout.lasso');
	else;
		session_start: -name='_migration', -expires=1440, -usecookie;
		
		_migration_addvar: -session='_migration', -name='admin_datetime', -default=(string: date);
		_migration_addvar: -session='_migration', -name='admin_increment', -default='123453';
		_migration_addvar: -session='_migration', -name='admin_username', -override=(client_username), -default='';
		_migration_addvar: -session='_migration', -name='admin_ipaddress', -default=(string: _client_address_old);
	/if;
		
	var: 'admin_increment' = (integer: $admin_increment) + 3;
	
	//
	// Tab Arrays
	//
	
	var: 'admin_tab_disabled1' = (array);
	
	Variable: 'admin_tab_array1' = (Array:
		'migrate'='Migrate',
		'export'='Export',
	);

	// Current Tab
	
	Variable: 'admin_tab1' = (action_param: 'tab1', (action_param: 'tab1', -count));

	// Default Tabs
	
	// Title
	
	var: 'admin_title' = 'Lasso Settings Migrator';
	var: 'temp' = (_migration_array_find: -array=$admin_tab_array1, -pattern=$admin_tab1);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;
	/if;

	//
	// LassoApp Links
	//

	var: 'admin_link_map' = (map:
		'default.lasso' = (lassoapp_link: 'default.lasso'),
		'default_css.lasso' = (lassoapp_link: 'default_css.lasso'),
		'migrate/default.lasso' = (lassoapp_link: 'migrate/default.lasso'),
		'migrate/dialog.lasso' = (lassoapp_link: 'migrate/dialog.lasso'),
		'migrate/library.lasso' = (lassoapp_link: 'migrate/library.lasso'),
		'migrate/library2.lasso' = (lassoapp_link: 'migrate/library2.lasso'),
		'export/default.lasso' = (lassoapp_link: 'export/default.lasso'),
		'export/export.lasso' = (lassoapp_link: 'export/export.lasso'),
		'export/library.lasso' = (lassoapp_link: 'export/library.lasso'),
		'images/logo_left.gif' = (lassoapp_link: 'images/logo_left.gif'),
		'images/logo_right.gif' = (lassoapp_link: 'images/logo_right.gif'),		
		'images/tab1_enabled_left.gif' = (lassoapp_link: 'images/tab1_enabled_left.gif'),		
		'images/tab1_enabled_right.gif' = (lassoapp_link: 'images/tab1_enabled_right.gif'),		
		'images/tab1_disabled_left.gif' = (lassoapp_link: 'images/tab1_disabled_left.gif'),		
		'images/tab1_disabled_right.gif' = (lassoapp_link: 'images/tab1_disabled_right.gif'),		
		'images/lassopower.gif' = (lassoapp_link: 'images/lassopower.gif'),		
	);
	
	define_tag: 'admin_link', -required='link';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			local: 'link' = params->(get:1);
		/if;
		if: $admin_link_map->(find: #link) != null;
			return: $admin_link_map->(find: #link);
		else;
			return: (lassoapp_link: #link);
		/if;
	/define_tag;
	
	if: (var_defined:'admin_file')==false;
		var:'admin_file'=(LassoApp_Link:'default.lasso');
	/if;
	
	if:(var_defined:'dialog_file')==false;
		var:'dialog_file'=(LassoApp_Link: 'dialog.lasso');
	/if;

	var: 'admin_link' = $admin_file +
		'?tab1=' + $admin_tab1 +
		'&-session=_migration:' + (session_id: -name='_migration') +
		'&increment=' + $admin_increment;

	var: 'wide_stripe' = '#bfbfbf';

?>
