[if: !((var: 'security_token') >> 'migration')][redirect_url: 'http://' + (server_name) + '/'][abort][/if]
<?LassoScript

//
// Variables
//

_migration_addvar: -name='dsthost_connectorid', -default='1', -session='_migration', -override=(action_param: 'dsthost_connectorid');
_migration_addvar: -name='dsthost_hostid', -session='_migration', -override=(action_param: 'dsthost_hostid');
_migration_addvar: -name='srchost_connectorid', -default=1, -session='_migration', -override=(action_param: 'srchost_connectorid');
_migration_addvar: -name='srchost_hostid', -default=1, -session='_migration', -override=(action_param: 'srchost_hostid');

_migration_addvar: -name='migrate_action', -default='None', -override=(action_param: 'migrate_action', (action_param: 'migrate_action', -count));
_migration_addvar: -name='dialog_action', -default='None', -override=(action_param: 'dialog_action');
_migration_addvar: -name='migrate_checked', -session='_migration', -override=(array);
_migration_addvar: -name='migrate_checkaction', -override=(action_param: 'migrate_checkaction');

_migration_addvar: -name='srchost_oldhostid', -session='_migration';
_migration_addvar: -name='dsthost_oldhostid', -session='_migration';

// Checkboxes
var: 'migrate_checked' = (array);
loop: (action_param: 'migrate_checked', -count); $migrate_checked->(insert: (action_param: 'migrate_checked', loop_count)); /loop;

if: ((action_param: 'migrate_message') >> 'success');
	var: 'migrate_message' = 'The selected database settings were successfully migrated to the destination host.';
else: ((action_param: 'migrate_message') >> 'error');
	var: 'migrate_message' = 'An error occurred while migrating the selected database settings to the destination host.';
/if;

//
// Build Menus
//

var: 'srchost_connectormap' = (array);
var: 'srchost_hostmap' = (array);
var: 'srchost_databasemap' = (array);

if: ($migrate_action >> 'Refresh') && ($srchost_connectorid != 0);
	_migration_refreshsecurity;
/if;

// Default host
if: ($srchost_connectorid < 1);
	$srchost_connectorid = 1;
/if;

var: 'srchost_connectormap' = (_migration_listconnectors);
var: 'temp' = (_migration_defaultconnector: -id=$srchost_connectorid, $srchost_connectormap);
if: ($temp != null);
	var: 'srchost_connectorid' = $temp->first;
	var: 'srchost_connectordetail' = $temp->second;
	var: 'srchost_connectorname' = $srchost_connectordetail->(find: 'name');
	var: 'srchost_connectoralias' = $srchost_connectordetail->(find: 'alias');
	var: 'srchost_connectortype' = (_migration_connectortype: -name=$srchost_connectordetail->(find: 'name'));
else;
	var: 'srchost_connectorid' = 0;
	var: 'srchost_connectordetail' = null;
/if;

if: ($migrate_action >> 'Refresh') && ($srchost_connectorid != 0);
	_migration_refreshconnector: -connector=$srchost_connectorid;
/if;

if: ($srchost_connectorid > 0);
	var: 'srchost_hostmap' = (_migration_listhosts: -connector=$srchost_connectorid);
	var: 'temp' = (_migration_defaulthost: -id=$srchost_hostid, $srchost_hostmap);
	if: ($temp != null);
		var: 'srchost_hostid' = $temp->first;
		var: 'srchost_hostdetail' = $temp->second;
	else;
		var: 'srchost_hostid' = 0;
		var: 'srchost_hostdetail' = null;
	/if;
else;
	var: 'srchost_hostid' = 0;
	var: 'srchost_hostdetail' = null;
/if;

if: ($srchost_hostid > 0);
	var: 'srchost_databasemap' = (_migration_listdatabases: -host=$srchost_hostid);
/if;


//
// Destination Host
//

var: 'dsthost_connectormap' = (array);
var: 'dsthost_hostmap' = (array);
var: 'dsthost_databasemap' = (array);

var: 'internal_need' = false;
var: 'internal_id' = false;
var: 'internal_insert' = null;

var: 'dsthost_connectormap' = (_migration_listconnectors);
var: 'temp' = (_migration_defaultconnector: -id=$srchost_connectorid, $dsthost_connectormap);
if: ($temp != null);
	if: $temp->second->(find: 'name') == 'InternalMySQLDS';
		loop: $dsthost_connectormap->size;
			if: ($dsthost_connectormap->(get: loop_count)->second->(find: 'name') == 'MySQLDS');
				var: 'temp' = $dsthost_connectormap->(get: loop_count);
				loop_abort;
			/if;
		/loop;
	else: $temp->second->(find: 'name') == 'MySQLDS';
		var: 'internal_need' = true;
		loop: $dsthost_connectormap->size;
			if: ($dsthost_connectormap->(get: loop_count)->second->(find: 'name') == 'InternalMySQLDS');
				var: 'internal_id' = $dsthost_connectormap->(get: loop_count)->first;
				loop_abort;
			/if;
		/loop;
	/if;
/if;
if: ($temp != null);
	var: 'dsthost_connectorid' = $temp->first;
	var: 'dsthost_connectordetail' = $temp->second;
	var: 'dsthost_connectoralias' = $dsthost_connectordetail->(find: 'alias');
else;
	var: 'dsthost_connectorid' = 0;
	var: 'dsthost_connectordetail' = null;
/if;

if: ($internal_need == true);
	var: 'internal_hostmap' = (_migration_listhosts: -connector=$internal_id);
	if: ($internal_hostmap->size > 0);
		var: 'internal_insert' = $internal_hostmap->(get:1);
	/if;
/if;

if: ($dsthost_connectorid > 0);
	var: 'dsthost_hostmap' = (_migration_listhosts: -connector=$dsthost_connectorid);
	$dsthost_hostmap->(removeall: $srchost_hostid);
	$__migration_hosts_array->(removeall: $srchost_hostid);
	if: ($internal_insert != null);
		$dsthost_hostmap->(insert: $internal_insert);
		$__migration_hosts_array->(insert: $internal_insert);
	/if;
	var: 'temp' = (_migration_defaulthost: -id=$dsthost_hostid, $dsthost_hostmap);
	if: ($temp != null);
		var: 'dsthost_hostid' = $temp->first;
		var: 'dsthost_hostdetail' = $temp->second;
	else;
		var: 'dsthost_hostid' = 0;
		var: 'dsthost_hostdetail' = null;
	/if;
else;
	var: 'dsthost_hostid' = 0;
	var: 'dsthost_hostdetail' = null;
/if;

if: ($dsthost_hostid > 0);
	var: 'dsthost_databasemap' = (_migration_listdatabases: -host=$dsthost_hostid);
/if;


//
// Process Action
//

if: $dialog_action >> 'Migrate';

	loop: $migrate_checked->size;
		var: 'chk_temp' = $migrate_checked->(get: loop_count);
		var: 'src_temp' = null;
		var: 'dst_temp' = null;
		
		
		loop: $srchost_databasemap->size;
			var: 'src_name' = $srchost_databasemap->(get: loop_count)->second->(find: 'name');
			if: ($src_name == $chk_temp);
				var: 'src_temp' = $srchost_databasemap->(get: loop_count)->second;
				loop_abort;
			/if;
		/loop;
		
		var: 'dst_host' = $dsthost_hostid;
		var: 'dst_dsrc' = $dsthost_connectorid;

		loop: $dsthost_databasemap->size;
			var: 'dst_name' = $dsthost_databasemap->(get: loop_count)->second->(find: 'name');
			var: 'dst_host' = $dsthost_databasemap->(get: loop_count)->second->(find: 'id_host');
			var: 'dst_dsrc' = $dsthost_databasemap->(get: loop_count)->second->(find: 'id_datasource');
			if: ($dst_name == $chk_temp);
				var: 'dst_temp' = $dsthost_databasemap->(get: loop_count)->second;
				loop_abort;
			/if;
		/loop;
		
		if: ($dst_temp != null);
			var: 'dst_host' = $dst_temp->(find: 'id_host');
			var: 'dst_dsrc' = $dst_temp->(find: 'id_datasource');
		/if;
		
		if: ($src_temp != null) && ($dsthost_connectorid > 0) && ($dsthost_hostid > 0);
		
			// Force both databases to load
			inline: -database=$src_temp->(find: 'alias'), -show; /inline;
			if: ($dst_temp != null);
				inline: -database=$dst_temp->(find: 'alias'), -show; /inline;
			/if;
		
			if: ($dst_temp != null);
			
				// Delete the database setting from the dst host (cascading)
				_migration_deletedatabase: -database=$dst_temp->(find: 'id');
			
			/if;
		
			// Migrate the database to the dst host
			// This is done by adjusting the 'id_host' of the database record.
			// All table/field/permissions point to this database record so will inherit change.
			
			inline: -update,
					-database='lasso_internal',
					-table='security_datasource_databases',
					-keyfield='id',
					-keyvalue=$src_temp->(find: 'id'),
					'id_host' = $dst_host,
					'id_datasource' = $dst_dsrc;
			/inline;
			
			if: ($src_temp->(find: 'status') != 'not available');
				// Add a new database record with a note that it has been migrated
				inline: -add,
						-database='lasso_internal',
						-table='security_datasource_databases',
						-keyfield='id',
						'id_host' = $src_temp->(find: 'id_host'),
						'id_datasource' = $src_temp->(find: 'id_datasource'),
						'name' = $src_temp->(find: 'name'),
						'alias' = $src_temp->(find: 'name') + ' {Migrated}',
						'enabled' = 'N';
				/inline;
			/if;

		/if;
	/loop;

	_migration_refreshsecurity;
	_migration_refreshconnector: $srchost_connectorid;
	_migration_refreshconnector: $dsthost_connectorid;
	redirect_url: $admin_link + '&migrate_message=success';

/if;


//
// Migrate Lists
//

var: 'migrate_mapping' = (array);
var: 'src_status' = (map);
var: 'dst_status' = (map);
var: 'src_only' = (array);
var: 'dst_only' = (array);

if: ($srchost_databasemap->size > 0) && ($dsthost_databasemap->size > 0);

	loop: $srchost_databasemap->size;
		var: 'src_temp' = $srchost_databasemap->(get: loop_count);
		var: 'src_name' = $src_temp->second->(find: 'name');
		$src_only->(insert: $src_name);
	/loop;
	
	loop: $dsthost_databasemap->size;
		var: 'dst_temp' = $dsthost_databasemap->(get: loop_count);
		var: 'dst_name' = $dst_temp->second->(find: 'name');
		$dst_only->(insert: $dst_name);
	/loop;
	
	loop: $srchost_databasemap->size;
		var: 'src_temp' = $srchost_databasemap->(get: loop_count);
		var: 'src_name' = $src_temp->second->(find: 'name');
		$src_status->(insert: $src_name = $src_temp->second->(find: 'status'));
		
		if: ($src_name == 'lasso_internal') || ($src_name == 'site') || ($src_name == 'lasso_admin');
			$src_only->(removeall: $src_name);
			$dst_only->(removeall: $src_name);
		/if;
	
		loop: $dsthost_databasemap->size;
			var: 'dst_temp' = $dsthost_databasemap->(get: loop_count);
			var: 'dst_name' = $dst_temp->second->(find: 'name');
			$dst_status->(insert: $dst_name = $dst_temp->second->(find: 'status'));
			
			if: ($src_name == $dst_name);
				$migrate_mapping->(insert: $src_name);
				$src_only->(removeall: $src_name);
				$dst_only->(removeall: $src_name);
			/if;
		/loop;
	
	/loop;

/if;

// Use default checkboxes?
var: 'migrate_default' = (($dsthost_oldhostid != $dsthost_hostid) || ($srchost_oldhostid != $srchost_hostid));
var: 'dsthost_oldhostid' = $dsthost_hostid;
var: 'srchost_oldhostid' = $srchost_hostid;

// Checkbox actions
if: ($migrate_checkaction >> 'None');
	var: 'migrate_checked' = (array);
else: ($migrate_checkaction >> 'Match') || ($migrate_default == true);
	var: 'migrate_checked' = (array);
	loop: $migrate_mapping->size;
		if: $src_status->(find: $migrate_mapping->(get: loop_count)) >> 'Enabled';
			$migrate_checked->(insert: $migrate_mapping->(get: loop_count));
		/if;
	/loop;
/if;

$migrate_mapping->(merge: $src_only);
$migrate_mapping->sort;

if: ($migrate_checkaction >> 'All');
	var: 'migrate_checked' = $migrate_mapping;
/if;
	
?>
