[if: !((var: 'security_token') >> 'migration')][redirect_url: 'http://' + (server_name) + '/'][abort][/if]
<?LassoScript

	if: !(lasso_tagexists: 'encode_sql');
		define_tag: 'encode_sql';
			local: 'output' = params->(get:1);
			#output = (string_replace: #output, -find='\"', -replace='\\\"');
			#output = (string_replace: #output, -find='\'', -replace='\\\'');
			return: #output;
		/define_tag;
	/if;

	define_tag: '_debug', -priority='replace';
		var: '_debug_count' = (integer: (var: '_debug_count')) + 1;
		local: 'colors'=(array: 'blue','red','green');
		local: 'output' = '<font size="1" color="' + #colors->(get: ($_debug_count % #colors->size) + 1) + '" face="Verdana">';
		#output += 'An error has occurred processing this LassoApp:<br /><b>';
		iterate: (params), (local: 'temp');
			#output += #temp + ' ';
		/iterate;
		#output += '</b><br />Please report this error to <a href="mailto:bugs@lassosoft.com">bugs@lassosoft.com</a>.';
		#output += '</font><br />';
		return: #output;
	/define_tag;
	
	define_tag: '_migration_nocache', -priority='replace';
		$__http_header__ += 'Expires: Mon, 26 Jul 1997 05:00:00 GMT\r\n';
		$__http_header__ += 'Last-Modified: ' + (date_format: (Date_LocaltoGMT: date), -dateforamt='%a, %d %m %Y %H:%M:%S') + ' GMT\r\n';
		$__http_header__ += 'Cache-Control: no-store, no-cache, must-revalidate\r\n';
		$__http_header__ += 'Cache-Control: post-check=0, pre-check=0\r\n';
		$__http_header__ += 'Pragma: no-cache\r\n';
	/define_tag;
	
	define_tag: '_migration_range', -required='value', -required='min', -required='max', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		return: (math_min: #max, (math_max: #min, #value));
	/define_tag;
	
	define_tag: '_migration_array_find', -required='array', -required='pattern', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		if: !(#array->type == 'array');
			return: 'None';
		/if;
		protect;
			return: #array->(find: #pattern)->(get:1)->second;
	/protect;
		if: (#pattern == 0);
			return: 'None';
		/if;
		return: (string: #pattern);
	/define_tag;
	
	define_tag: '_migration_addvar', -required='name', -optional='default', -optional='session', -optional='override', -optional='force', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		if: ((var_defined: #name) == false) || ((var: #name) == null);
			var: #name = '';
		/if;
		if: (local_defined: 'force');
			var: #name = #force;
		else: (local_defined: 'override') && (#override != '');
			var: #name = #override;
		else: (local_defined: 'default') && ((var: #name) == '') && (#default != '');
			var: #name = #default;
		/if;
		if: (local_defined: 'session') && (#session != '');
			session_addvar: -name=#session, #name;
		/if;
	/define_tag;
	
	define_tag: '_migration_short_cleanup', -required='output', -required='size', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			local: 'output' = params->(get:1);
			local: 'size' = params->(get:2);
		/if;
		local: '_output'=(string: #output);
		local: '_size'=(integer: #size);
	
		if: #_output == '';
			return: ' ';
		/if;
	
		if: #_output->length < #_size;
			#_output = (string_replace: -find='href', -replace='&#104;&#114;&#101;&#102;', #_output);
			return: #_output;
		/if;
	
		#_output = #_output->(substring:0,(#_size - 3));
		if: (#_output->(endswith: '...'));
			return: #_output;
		else: (#_output->(endswith: '..'));
			return: #_output + '.';
		else: (#_output->(endswith: '.'));
			return: #_output + '..';
		else;
			return: #_output + '...';
		/if;
	/define_tag;
	
	define_tag: '_migration_wrap_cleanup', -required='input', -required='wrap', -required='size', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		local: '_input'=(string: #input);
		local: '_wrap'=(integer: #wrap);
		local: '_size'=(integer: #size);
		local: '_margin'=(integer: (#wrap / 4.0));
	
		if: #_input->length < #_wrap;
			#_input = (string_replace: -find='href', -replace='&#104;&#114;&#101;&#102;', #_input);
			return: #_input;
		/if;
	
		local: '_pattern' = '\\s*(.{0,' + (#_wrap - #_margin) + '}\\w{0,' + (#_margin) + '})';
		local: '_lines' = (string_findregexp: #_input, -find=#_pattern);
	
		local: '_output' = '';
		local: '_count' = 0;
		loop: -loopfrom=2, -loopto=#_lines->size, -loopincrement=2;
			#_output += (encode_html: #_lines->(get: loop_count)) + '<br>';
			#_count += 1;
			if: #_count >= #_size;
				loop_abort;
			/if;
		/loop;
	
		if: #_lines->size > (#_count * 2);
			#_output += '...';
		else;
			#_output->(removetrailing: '<br>');
		/if;
	
		#_output = (string_replace: -find='href', -replace='&#104;&#114;&#101;&#102;', #_output);
	
		return: #_output;
	/define_tag;
	
	define_tag:'_migration_ifempty', -priority='replace';
		if: params->(get:1) != '';
			return: params->get:1;
		else;
			return: params->get:2;
		/if;
	/define_tag;
	
	define_tag:'_migration_ifnull', -priority='replace';
		if: params->(get:1) != null;
			return: params->get:1;
		else;
			return: params->get:2;
		/if;
	/define_tag;
	
	define_tag: '_migration_connectortype', -priority='replace', -required='name';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		if: (#name >> 'com.microsoft.jdbc.sqlserver.SQLServerDriver');
			return: 'omnipilot sqlserver jdbc';
		else: (#name >> 'fmremotedatasource');
			return: 'omnipilot filemaker pro';
		else: (#name >> 'fmserveradvanceddatasource');
			return: 'omnipilot filemaker server';
		else: (#name >> 'internalmysqlds');
			return: 'internal mysql';
		else: (#name >> 'mysqlds');
			return: 'omnipilot mysql';
		else: (#name >> 'sqliteconnector');
			return: 'omnipilot sqlite';
		else: (lasso_tagexists: '_jdbc_driverinfo') && (_jdbc_driverinfo: #name)->(isa: 'array');
			return: 'thirdparty jdbc';
		else;
			return: 'thirdparty';
		/if;
	/define_tag;

	_migration_addvar: -name='__migration_connectors_array', -default=null;
	_migration_addvar: -name='__migration_connector_id', -default=null;
	_migration_addvar: -name='__migration_hosts_array', -default=null;
	_migration_addvar: -name='__migration_host_id', -default=null;
	_migration_addvar: -name='__migration_databases_array', -default=null;
	_migration_addvar: -name='__migration_database_id', -default=null;
	_migration_addvar: -name='__migration_tables_array', -default=null;
	_migration_addvar: -name='__migration_table_id', -default=null;
	_migration_addvar: -name='__migration_fields_array', -default=null;
	_migration_addvar: -name='__migration_groups_array', -default=null;
	_migration_addvar: -name='__migration_users_array', -default=null;
		
	//
	// Define Lasso Administration Helper Tags
	//
	
	define_tag: '_migration_internaldatabase', -priority='replace';
		return: 'lasso_internal';
	/define_tag;
	
	define_tag:'_migration_refreshsecurity', -priority='replace';
		_security_flushcaches;
		var: '__migration_connectors_array' = null;
		var: '__migration_connector_id' = null;
		var: '__migration_hosts_array' = null;
		var: '__migration_host_id' = null;
		var: '__migration_databases_array' = null;
		var: '__migration_database_id' = null;
		var: '__migration_tables_array' = null;
		var: '__migration_table_id' = null;
		var: '__migration_fields_array' = null;
		var: '__migration_groups_array' = null;
		var: '__migration_users_array' = null;
	/define_tag;
	
	define_tag:'_migration_listconnectors', -priority='replace';
		if: ((var: '__migration_connectors_array') != null) && ((var: '__migration_connectors_array')->size > 0);
			return: (var: '__migration_connectors_array');
		/if;
	
		// Find friendly connector names
		local: 'connector_map' = (map:
			'internalmysqlds'='Lasso Connector for Lasso MySQL',
			'fmremotedatasource'='Lasso Connector for FileMaker Pro',
			'mysqlds'='Lasso Connector for MySQL',
			'sqliteconnector'='Lasso Connector for SQLite',
		);
		inline: -database='lasso_internal', -table='global_prefs', 'store_key'='_admin_connector_alias:', -search, -maxrecords='all';
			records;
				local: 'temp_name' = (string: (field: 'store_key'))->(substring: 25);
				local: 'temp_alias' = (string: (field: 'data'));
				#connector_map->(insert: #temp_name = #temp_alias);
			/records;
		/inline;
	
		local: 'output' = (array);
		inline: -search, -database='lasso_internal', -table='security_datasources', -op='neq', 'name'='_email_sender',
			-returnfield='name', -returnfield='id', -returnfield='enabled', -MaxRecords='all';
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
			records;
				local: 'temp' = (map);
				loop: (field_name: -count);
					#temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
				/loop;
				if: (field: 'enabled') == 'Y';
					#temp->(insert: 'status'='Enabled');
				else: (field: 'enabled') == 'N';
					#temp->(insert: 'status'='Disabled');
				/if;
				#temp->(insert: 'alias'=(_migration_ifnull: #connector_map->(find: (field: 'name')), (field: 'name')));
				#output->(insert: (field: 'id') = #temp);
			/records;
		/inline;
		var: '__migration_connectors_array' = #output;
		var: '__migration_hosts_array' = null;
		var: '__migration_databases_array' = null;
		var: '__migration_tables_array' = null;
		var: '__migration_fields_array' = null;
		return: #output;
	/define_tag;
	
	define_tag:'_migration_updateconnector', -required='connector', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		local: 'temp' = (params);
		local: 'params' = (array);
	
		loop: #temp->size;
			if: #temp->(get: loop_count)->type == 'pair';
				#params->(insert: #temp->(get: loop_count));
			/if;
		/loop;
	
		inline: -update, -database='lasso_internal', -table='security_datasources', -keyfield='id', -keyvalue=#connector, #params;
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
		/inline;
	/define_tag;
	
	define_tag:'_migration_defaultconnector', -required='id', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		if: ((var: '__migration_connectors_array') == null) || ((var: '__migration_connectors_array')->type != 'array');
			return: null;
		/if;
		if: (local_defined: 'id') && (#id > 0);
			local: 'temp' = (var: '__migration_connectors_array')->(find: #id);
			if: #temp->size > 0;
				return: #temp->(get:1);
			/if;
		/if;
		if: (var_defined: '__migration_connector_id') && ((var: '__migration_connector_id') > 0);
			local: 'temp' = (var: '__migration_connectors_array')->(find: (var: '__migration_connector_id'));
			if: #temp->size > 0;
				return: #temp->(get:1);
			/if;
		/if;
		if: ((var: '__migration_connectors_array')->size > 0);
			return: (var: '__migration_connectors_array')->(get:1);
		/if;
		return: null;
	/define_tag;
	
	define_tag:'_migration_refreshconnector', -required='connector', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		if: (#connector) == 1;
			inline: -database='lasso_internal', -sql='flush tables';
			/inline;
		/if;
		_datasource_reload: (integer: #connector);
	/define_tag;
	
	define_tag:'_migration_listhosts', -required='connector', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		local: 'output' = (array);
		if: ((var: '__migration_hosts_array') != null) && ((var: '__migration_connector_id') == #connector);
			return: (var: '__migration_hosts_array');
		/if;
	
		// Find friendly host names
		if: ((decimal: (lasso_version: -lassoversion)) < 8.0);
			local: 'host_map' = (map: 
				'1'='Lasso MySQL',
			);
		else;
			local: 'host_map' = (map: 
				'1'='Lasso Internal',
			);
		/if;
		if: ((decimal: (lasso_version: -lassoversion)) < 7.0);
			protect;
				inline:  -search, -database='lasso_admin', -table='admin_prefs', -keyfield='id',
					-op='eq', 'type'='host', -op='eq', 'pref_name'='alias:' + #connector;
					if: (found_count) > 0;
						local: 'temp' = (field: 'pref_value');
						local: 'temp_map' = null;
						if: #temp != '';
							local: 'temp' = (decode_base64: #temp);
							#temp_map->(unserialize: #temp);
							if: #temp_map->type == 'map';
								local: 'host_map' = #temp_map;
							/if;
						/if;
					/if;
				/inline;
			/protect;
		else;
			inline: -database='lasso_internal', -table='global_prefs', 'store_key'='_admin_host_alias:', -search, -maxrecords='all';
				records;
					local: 'temp_name' = (string: (field: 'store_key'))->(substring: 19);
					local: 'temp_alias' = (string: (field: 'data'));
					#host_map->(insert: #temp_name = #temp_alias);
				/records;
			/inline;
		/if;
		inline: -search, -database='lasso_internal', -table='security_datasource_hosts', -op='eq', 'id_datasource'=#connector, -MaxRecords='all';
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
			records;
				local: 'temp' = (map);
				loop: (field_name: -count);
					#temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
				/loop;
				#temp->(insert: 'alias'=(_migration_ifnull: #host_map->(find: (field: 'id')), ((field: 'name') + ':' + (field: 'port'))));
				if: (field: 'enabled') == 'Y';
					#temp->(insert: 'status'='Enabled');
				else: (field: 'enabled') == 'N';
					#temp->(insert: 'status'='Disabled');
				/if;
				#output->(insert: (field: 'id') = #temp);
			/records;
		/inline;
		var: '__migration_hosts_array' = #output;
		var: '__migration_connector_id' = #connector;
		var: '__migration_databases_array' = null;
		var: '__migration_tables_array' = null;
		var: '__migration_fields_array' = null;
		return: #output;
	/define_tag;
	
	define_tag:'_migration_defaulthost', -required='id', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		if: ((var: '__migration_hosts_array') == null) || ((var: '__migration_hosts_array')->type != 'array');
			return: null;
		/if;
		if: (local_defined: 'id') && (#id > 0);
			local: 'temp' = (var: '__migration_hosts_array')->(find: #id);
			if: #temp->size > 0;
				return: #temp->(get:1);
			/if;
		/if;
		if: (var_defined: '__migration_host_id') && ((var: '__migration_host_id') > 0);
			local: 'temp' = (var: '__migration_hosts_array')->(find: (var: '__migration_host_id'));
			if: #temp->size > 0;
				return: #temp->(get:1);
			/if;
		/if;
		if: ((var: '__migration_hosts_array')->size > 0);
			return: (var: '__migration_hosts_array')->(get:1);
		/if;
		return: null;
	/define_tag;
	
	define_tag:'_migration_updatehost', -required='host', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		local: 'temp' = (params);
		local: 'params' = (array);
	
		loop: #temp->size;
			if: #temp->(get: loop_count)->type == 'pair';
				#params->(insert: #temp->(get: loop_count));
			/if;
		/loop;
	
		inline: -update, -database='lasso_internal', -table='security_datasource_hosts', -keyfield='id', -keyvalue=#host, #params;
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
		/inline;
	/define_tag;
	
	define_tag:'_migration_deletehost', -required='host', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		inline: -delete, -database='lasso_internal', -table='security_datasource_hosts', -keyfield='id', -keyvalue=#host;
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
		/inline;
	
		local: 'databases'=(_migration_listdatabases: -host=#host);
		loop: #databases->size;
			_migration_deletedatabase: -database=#databases->(get: loop_count)->first;
		/loop;
	/define_tag;
	
	define_tag:'_migration_listdatabases', -required='host', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		local: 'output' = (array);
		if: ((var: '__migration_databases_array') != null) && ((var: '__migration_host_id') == #host);
			return: (var: '__migration_databases_array');
		/if;
		inline: -search, -database='lasso_internal', -table='security_datasource_hosts', -keyfield='id', -keyvalue=#host;
			if: (string: (field: 'enabled')) >> 'Y';
				local: 'enabled' = 'Y';
			else;
				local: 'enabled' = 'N';
			/if;
		/inline;
		inline: -search, -database='lasso_internal', -table='security_datasource_databases', -op='eq', 'id_host'=#host, -MaxRecords='all';
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
			if: #enabled >> 'Y';
				local: 'live' = (_database_names: (field: 'id_datasource'), (field: 'id_host'));
			else;
				local: 'live' = (array);
			/if;
			records;
				local: 'temp' = (map);
				loop: (field_name: -count);
					#temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
				/loop;
				if: #live->(find: (field: 'name')) != (array);
					if: (field: 'enabled') == 'Y';
						#temp->(insert: 'status'='Enabled');
					else: (field: 'alias') >> '{Migrated}';
						#temp->(insert: 'status'='Migrated');
					else: (field: 'enabled') == 'N';
						#temp->(insert: 'status'='Disabled');
					else;
						#temp->(insert: 'status'='New');
					/if;
				else;
					#temp->(insert: 'status'='Not Available');
				/if;
				if: #temp->(find: 'alias') == '';
					#temp->(insert: 'alias'=(field: 'name'));
				/if;
				if: ((field: 'alias') == '') || ((field: 'alias') == (field: 'name'));
					#temp->(insert: 'label'=(field: 'name'));
				else;
					#temp->(insert: 'label'=(field: 'name') + ' (' + (field: 'alias') + ')');
				/if;
				#output->(insert: (field: 'id') = #temp);
			/records;
		/inline;
		var: '__migration_databases_array' = #output;
		var: '__migration_host_id' = #host;
		var: '__migration_tables_array' = null;
		var: '__migration_fields_array' = null;
		return: #output;
	/define_tag;
	
	define_tag:'_migration_defaultdatabase', -required='id', -required='array', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		if: !(local_defined: 'array');
			local: 'array' = (var: '__migration_databases_array');
		/if;
		if: (#array == null) || (#array->type != 'array');
			return: null;
		/if;
		if: (local_defined: 'id') && (#id > 0);
			local: 'temp' = #array->(find: #id);
			if: #temp->size > 0;
				return: #temp->(get:1);
			/if;
		/if;
		if: (var_defined: '__migration_database_id') && ((var: '__migration_database_id') > 0);
			local: 'temp' = #array->(find: (var: '__migration_database_id'));
			if: #temp->size > 0;
				return: #temp->(get:1);
			/if;
		/if;
		if: (#array->size > 0);
			return: #array->(get:1);
		/if;
		return: null;
	/define_tag;
	
	define_tag:'_migration_updatedatabase', -required='database', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		local: 'temp' = (params);
		local: 'params' = (array);
	
		loop: #temp->size;
			if: #temp->(get: loop_count)->type == 'pair';
				#params->(insert: #temp->(get: loop_count));
			/if;
		/loop;
	
		inline: -update, -database='lasso_internal', -table='security_datasource_databases', -keyfield='id', -keyvalue=#database, #params;
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
		/inline;
	/define_tag;
	
	define_tag:'_migration_deletedatabase', -required='database', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		inline: -delete, -database='lasso_internal', -table='security_datasource_databases', -keyfield='id', -keyvalue=#database;
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
		/inline;
	
		local: 'tables'=(_migration_listtables: -database=#database);
		loop: #tables->size;
			_migration_deletetable: -table=#tables->(get: loop_count)->first;
		/loop;

		inline: -delete, -database='lasso_internal', -table='security_group_databasemap', -keyfield='id_database', -keyvalue=#database;
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
		/inline;

	/define_tag;
	
	define_tag:'_migration_listtables', -required='database', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		local: 'output' = (array);
		if: ((var: '__migration_tables_array') != null) && ((var: '__migration_database_id') == #database);
			return: (var: '__migration_tables_array');
		/if;
	
		local: 'db' = (var: '__migration_databases_array')->(find: #database);
		if: (#db != null) && (#db->size > 0);
			local: 'database_alias' = #db->(get:1)->second->(find: 'alias');
			local: 'database_status' = #db->(get:1)->second->(find: 'status');
			if: #database_status >> 'Enabled';
				inline: -show, -database=#database_alias; /inline;
			/if;
		/if;
	
		inline: -search, -database='lasso_internal', -table='security_database_tables', -op='eq', 'id_database'=#database, -MaxRecords='all';
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
			records;
				local: 'temp' = (map);
				loop: (field_name: -count);
					#temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
				/loop;
				if: (field: 'enabled') == 'Y';
					#temp->(insert: 'status'='Enabled');
				else: (field: 'enabled') == 'N';
					#temp->(insert: 'status'='Disabled');
				/if;
				if: #temp->(find: 'alias') == '';
					#temp->(insert: 'alias'=(field: 'name'));
				/if;
				if: ((field: 'alias') == '') || ((field: 'alias') == (field: 'name'));
					#temp->(insert: 'label'=(field: 'name'));
				else;
					#temp->(insert: 'label'=(field: 'name') + ' (' + (field: 'alias') + ')');
				/if;
				if: (local_defined: 'database_alias') && (#database_alias != '');
					#temp->(insert: 'database_alias' = #database_alias);
				/if;
				if: (local_defined: 'database_status') && (#database_status != '');
					#temp->(insert: 'database_status' = #database_status);
				/if;
				#output->(insert: (field: 'id') = #temp);
			/records;
		/inline;
		var: '__migration_tables_array' = #output;
		var: '__migration_database_id' = #database;
		var: '__migration_fields_array' = null;
		return: #output;
	/define_tag;
	
	define_tag:'_migration_deletetable', -required='table', -priority='replace';
		if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
			loop: (params)->size;
				if: (params)->(get: loop_count)->type == 'pair';
					local: 'temp_name' = (params)->(get: loop_count)->first;
					#temp_name->(removeleading: '-');
					local: #temp_name = (params)->(get: loop_count)->second;
				/if;
			/loop;
		/if;
		inline: -delete, -database='lasso_internal', -table='security_database_tables', -keyfield='id', -keyvalue=#table;
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
		/inline;
	
		inline: -delete, -database='lasso_internal', -table='security_table_fields', -keyfield='id_table', -keyvalue=#table;
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
		/inline;
	
		inline: -delete, -database='lasso_internal', -table='security_group_tablemap', -keyfield='id_table', -keyvalue=#table;
			var: '_error' = (error_currenterror);
			var: '_code' = (error_currenterror: -errorcode);
		/inline;
	
	/define_tag;
	
	if: !(lasso_tagexists: 'site_id');
		define_tag: 'site_id';
			return: lasso_siteid;
		/define_tag;
	/if;
	
	// Required for backward compatibility with 8.0.x.
	if: !(lasso_tagexists: 'site_name');
		define_tag: 'site_name';
			return: lasso_sitename;
		/define_tag;
	/if;
	
?>
