#include "Lasso8ConnectorforApache.h"
#include "POSTReader.h"
#include "osErrors.h"
#ifndef _WINDOWS
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <syslog.h>
#include <ctype.h>
#define LP_OPEN_FLAGS (O_RDONLY)
#else
#include <winsock2.h>
#define LP_OPEN_FLAGS (O_RDONLY | O_BINARY)
typedef __int32 int32_t;
#endif
#include <vector>
#include <sys/stat.h>
#include <http_request.h>
#include <http_log.h>
#include <apr_strings.h>

#if !defined(S_ISDIR) && defined(S_IFDIR)
#define S_ISDIR(m) (((m) & S_IFMT) == S_IFDIR)
#endif

#ifndef CRLF
#define CRLF "\r\n";
#endif

#ifndef INVALID_SOCKET
#define INVALID_SOCKET (-1)
#endif

#define AP_LOG_FAIL(F,S) \
	//ap_log_cerror(__FILE__, __LINE__, APLOG_CRIT, 0, r->connection, F,S);
#define AP_LOG_FAIL_2(F,S,S2) \
	//ap_log_cerror(__FILE__, __LINE__, APLOG_CRIT, 0, r->connection, F,S,S2);
#define AP_LOG_FAIL_3(F,S,S2,S3) \
	//ap_log_cerror(__FILE__, __LINE__, APLOG_CRIT, 0, r->connection, F,S,S2,S3);
#define AP_LOG_FAIL_4(F,S,S2,S3,S4) \
	//ap_log_cerror(__FILE__, __LINE__, APLOG_CRIT, 0, r->connection, F,S,S2,S3,S4);

unsigned int gtime_out = 1000;

unsigned short gLassoPort = 14552;
struct sockaddr_in gLassoAddr;

static char gAddress[128] = "127.0.0.1";

#define DEFAULT_BUFFER (1024*1024)

#ifdef _WINDOWS
_declspec(dllexport)
#endif
void register_hooks(apr_pool_t *p);
void register_hooks(apr_pool_t *p)
{
	ap_hook_handler(lasso_handler, NULL, NULL, APR_HOOK_MIDDLE);
	ap_hook_child_init(child_init_handler,NULL,NULL,APR_HOOK_MIDDLE);
}

/*
 * This is the structure that is used to interface with Apache. Not all
 * parameters will be used. - CJS
*/
extern "C"
{
	module AP_MODULE_DECLARE_DATA lasso8_module =
	{
		STANDARD20_MODULE_STUFF,
		NULL,			/* dir config creater */
		NULL,			/* dir merger ensure strictness */
		NULL,			/* server config */
		NULL,			/* merge server config */
		NULL,			/* command table */
		register_hooks,		/* register hooks */
	};
}
int lasso_handler (request_rec *r)
{
	SOCKET sock = INVALID_SOCKET;
	int res = 0;
	LPCommandBlock block;
	char * data = NULL;
	bool splitHeaders = false;
	int reqOpen = 1;
	unsigned int timeout = 1000;
	READ_RESULT read = READ_ERROR;
	int return_value = DECLINED;
	std::string tmpHeaders;

	if ( strcmp(r->handler,"lasso8-handler") != 0 )
		return DECLINED;

	apr_bucket_brigade * bb = NULL;

	LP8POSTReader reader(apr_table_get(r->headers_in, "Content-Type"));
	if (!get_post(0, r, &reader))
		return HTTP_INTERNAL_SERVER_ERROR;

	sock = open_connection();

	if ( sock == INVALID_SOCKET )
	{
		return HTTP_INTERNAL_SERVER_ERROR;
	}

	/* start reading command blocks from Lasso */
	while ( reqOpen == 1 && (read = read_block(sock, &block, &data, &timeout)) == READ_OK )
	{
		AP_LOG_FAIL_3("%s %d %d", "Read block", (int)block.fCmd, (int)block.fDataSize);
		switch( block.fCmd )
		{
			case cmdGetParam:
				{
					char * myData = data;
					int numParams = 0;

					// scan to see how many params
					for (unsigned int pos = 0; pos < block.fDataSize;)
					{
						++numParams;
						pos += sizeof(RequestParamKeyword);

						int dSize = *(int32_t*)(data+pos);
						pos += (ntohl(dSize)+sizeof(int32_t));
					}

					block.fCmd = cmdGetParamRep;
					block.fDataSize = 0;
					block.fResultCode = 0;

					struct ptr_size
					{
						char * data;
						int32_t size;
					};

					ptr_size * rec = (ptr_size*)malloc(numParams*sizeof(ptr_size));

					for ( int x = 0; x < numParams; ++x )
					{
						RequestParamKeyword word = (RequestParamKeyword)ntohl(*(RequestParamKeyword*)myData);
						int dLen = ntohl(*(int32_t*)(myData+sizeof(RequestParamKeyword)));

						char * pData = NULL;
						int dSize = 0;

						myData += (sizeof(RequestParamKeyword) + sizeof(int32_t));

						if ( word == rpPostKeyword )
						{
							const std::string * str = reader.GetPostArgs();
							if ( str != NULL )
							{
								pData = (char*)malloc(str->size());
								dSize = (int)str->size();
								memcpy(pData, str->c_str(), (int)str->size());
							}
						}
						else
						{
							int res = get_param(r, word, dLen > 0 ? myData : NULL, &pData, &dSize);
							AP_LOG_FAIL("~get_param %d", dSize);
							if ( res < 0 )
								block.fResultCode = res;
						}
						rec[x].data = pData;
						rec[x].size = dSize;
						AP_LOG_FAIL_2("~ %d %d", __LINE__, dSize);
						block.fDataSize += (dSize + sizeof(int32_t));
					}

					AP_LOG_FAIL_2("~ %d %d", __LINE__, block.fDataSize);

					/* alloc a buffer for the data portion of the block*/
					char * pData = (char*)malloc(block.fDataSize);
					char * ppData = pData;

					AP_LOG_FAIL_2("~ %d %d", __LINE__, block.fDataSize);

					for ( int i = 0; i < numParams; ++i )
					{
						int mSize = htonl(rec[i].size);
						memcpy(ppData, &mSize, sizeof(int32_t));
						memcpy(ppData+sizeof(int32_t), rec[i].data, rec[i].size);
						ppData += (sizeof(int32_t) + rec[i].size);

						free(rec[i].data);
					}

					AP_LOG_FAIL("HERE 4 %d", (int)block.fDataSize);
					res = send_block(sock, &block, pData);

					// dispose rec and each pointer within!
					free(rec);
					free(pData);
				}
				break;
			case cmdPushData:
				if (block.fDataSize > 0)
				{
					char * cpy = data;
					// APACHE 2.0
					// we now have to determine the HTTP response code that Lasso is wanting to send
					// and add headers manually... sigh
					if ( return_value == DECLINED )
					{
						if (tmpHeaders.size()) // incomplete headers
						{
							tmpHeaders.append(data);
							free(data);
							cpy = data = (char*)tmpHeaders.data();
							splitHeaders = true;
						}
						if ( strncasecmp("HTTP/1.", data, 7) == 0 ) // header start
						{
							return_value = atoi(data + 9);

							r->status = return_value;

							char * final = strstr(cpy, "\r\n\r\n");
							if (final == NULL)
							{
								return_value = DECLINED;
								if (tmpHeaders.size() == 0)
									tmpHeaders.append(data);
								// else it's already been accounted for
								break;
							}
							final += 2;

							cpy = strstr(cpy, CRLF);
							cpy += 2;
							char * p(NULL);
							while(cpy != NULL && cpy != final)
							{
								p = strstr(cpy, ":");
								if ( p == cpy )
								{
									++cpy;
									break;
								}
								*p = '\0';
								AP_LOG_FAIL_2("%s %s", "OK, here 1", cpy);
								++p;
								while(isspace(*p))
									++p;

								AP_LOG_FAIL_2("%s %s", "OK, here 2", cpy);
								char *tmp = strstr(p, CRLF);
								*tmp = '\0';

								AP_LOG_FAIL_2("%s %s", "OK, here 3", cpy);

								if ( strcasecmp(cpy, "Content-type") == 0 )
								{
									ap_set_content_type(r, apr_pstrdup(r->pool, p));
								}
								else
								{
									AP_LOG_FAIL_2("%s %s", "OK, here 4", cpy);
									apr_table_add(r->headers_out, cpy, p);
									AP_LOG_FAIL_2("%s %s", "OK, here 5", cpy);
								}
								cpy = tmp + 2;
							}
							cpy += 2;
							ap_send_http_header (r);
							tmpHeaders.clear();
						}
					}
					if ( block.fDataSize - (cpy-data) > 0 )
					{
						bb = apr_brigade_create(r->pool, r->connection->bucket_alloc);
						apr_bucket * b;
						if (cpy == data)
						{
							b = apr_bucket_heap_create(cpy, block.fDataSize, free, r->connection->bucket_alloc);
							data = NULL;
						}
						else
						{
							b = apr_bucket_heap_create(cpy, block.fDataSize-(cpy-data), NULL, r->connection->bucket_alloc);
						}
						APR_BRIGADE_INSERT_TAIL(bb, b);
						APR_BRIGADE_INSERT_TAIL(bb, apr_bucket_flush_create(r->connection->bucket_alloc));
						ap_pass_brigade(r->output_filters, bb);
						bb = NULL;
					}
				}
				break;
			case cmdCloseReq:
				bb = apr_brigade_create(r->pool, r->connection->bucket_alloc);
				APR_BRIGADE_INSERT_TAIL(bb, apr_bucket_eos_create(r->connection->bucket_alloc));
				ap_pass_brigade(r->output_filters, bb);
				bb = NULL;
				reqOpen = 0;
#ifdef WIN32
				release_connection(sock);
				sock = INVALID_SOCKET;
#endif
				break;
			default:
				break;
		}
		if (data)
		{
			if (!splitHeaders) // header data stored in std::string
				free(data);
			splitHeaders = false;
			data = NULL;
		}
	}
	if ( read != READ_OK ) // error from the read; close this connection
	{
		// check if the browser is still connected (if possible)
		// if it's not, continue on your merry way
		// if it is, goto the shit above
		release_connection(sock, true);
		sock = INVALID_SOCKET;
		if (read == READ_TIMEOUT)
		{
			static const char * kErrMsg = "LassoConnectorforApache: timed out while waiting for data from LassoService.";
			ap_rwrite(kErrMsg, (int)strlen(kErrMsg), r);
		}
		return HTTP_INTERNAL_SERVER_ERROR;
	}
	if ( sock != INVALID_SOCKET )
		release_connection(sock, true);
	ap_finalize_request_protocol(r);
	return OK;
}

static void copy_string(const char * in, char ** out, int * size )
{
	if ( in != NULL )
	{
		*out = (char*)malloc(strlen(in)+1);
		*size = (int)strlen(in);
		strcpy(*out, in);
	}
}

/*
 * Workaround for Client_Headers/Full_Request tags under Apache.
 * Produces concatenated sequence of substrings referenced as elements within
 * the array. The string will be empty if all substrings are empty or null,
 * or if there are no elements in the array.	- 07.04.2001 - AK
 */
struct tabletracker
{
	char * data;
	int maxlen;
	int curLen;
	request_rec * r;
};

int walktable(void * data, const char * key, const char * val)
{
	const char * kDelim = ": ";
	const char * kEnd = "\r\n";
	const int kDelimLen = 2;
	const int kEndLen = 2;

	tabletracker * tt = (tabletracker*)data;
	int keyLen = (int)strlen(key);
	int valLen = (int)strlen(val);

	int available = tt->maxlen - tt->curLen;
	request_rec * r = tt->r;
//	AP_LOG_FAIL_4("HERE %d %d %d %d", (int)keyLen, (int)valLen, (int)available, keyLen + valLen + kDelimLen + kEndLen);

	while ( available < keyLen + valLen + kDelimLen + kEndLen )
	{
		char * newP = (char*)malloc(tt->maxlen * 4);
		memcpy(newP, tt->data, tt->curLen);
		free(tt->data);
		tt->data = newP;
		tt->maxlen *= 2;
		available = tt->maxlen - tt->curLen;
	}

//	AP_LOG_FAIL_4("HERE2 %d %d %d %d", (int)available, keyLen + valLen + kDelimLen + kEndLen,
//		tt->maxlen, tt->curLen);

	memcpy(tt->data+tt->curLen, key, keyLen);
	tt->curLen += keyLen;
	memcpy(tt->data+tt->curLen, kDelim, kDelimLen);
	tt->curLen += kDelimLen;
	memcpy(tt->data+tt->curLen, val, valLen);
	tt->curLen += valLen;
	memcpy(tt->data+tt->curLen, kEnd, kEndLen);
	tt->curLen += kEndLen;
	return TRUE;
}

static void concat_headers(request_rec * r, const apr_table_t * tab, char ** outData, int * outLen)
{
	tabletracker tt;
	tt.data = (char*)malloc(1024);
	tt.maxlen = 1024;
	tt.curLen = 0;
	tt.r = r;
	apr_table_do(walktable, &tt, tab, NULL);

//	AP_LOG_FAIL_2("HERE POST %d %d", tt.curLen, tt.maxlen);

	*outData = tt.data;
	*outLen = tt.curLen;
}

int get_param( request_rec * r, RequestParamKeyword word, const char * param, char ** data, int * outLen )
{
	int good = 1;
	switch( word )
	{
		case rpPathArgKeyword:
			copy_string(r->path_info, data, outLen);
			break;
		case rpSearchArgKeyword:
			copy_string(r->args, data, outLen);
			break;
		case rpAuthorizationKeyword:
			{
				const char * str = apr_table_get(r->headers_in, "Authorization");
				if (str)
					copy_string(str, data, outLen);
				else
					copy_string("", data, outLen);
			}
			break;
		case rpUserKeyword:
			{
				const char * str = apr_table_get(r->headers_in, "Authorization");
				if ( str != NULL && strncasecmp("basic ", str, 6) == 0 )
				{
					/* move past the first space */
					while(*str && !isspace(*str))
						++str;
					if ( *str == ' ' )
					{
						++str;
						char * res = ap_pbase64decode(r->pool, str);
						char * res2 = res;
						/* terminate at the colon */
						while( res && *res && *res != ':' )
							++res;
						if ( *res == ':' ) *res = '\0';
							copy_string(res2, data, outLen);
					}
					break;
				}
				copy_string("", data, outLen);
			}
			break;
		case rpPasswordKeyword:
			{
				const char * str = apr_table_get(r->headers_in, "Authorization");
				if ( str != NULL && strncasecmp("basic ", str, 6) == 0 )
				{
					/* move past the first space */
					while(*str && !isspace(*str))
						++str;
					if ( *str == ' ' )
					{
						++str;
						char * res = ap_pbase64decode(r->pool, const_cast<char*>(str));
						/* use what's after the colon */
						while( res && *res && *res != ':' )
							++res;
						if ( *res == ':' )
							++res;
						copy_string(res, data, outLen);
					}
					break;
				}

				copy_string("", data, outLen);
			}
			break;
		case rpFromUser:
			break;
		case rpAddressKeyword:
			copy_string(r->connection->remote_ip, data, outLen);
			break;
		case rpMethodKeyword:
			copy_string(r->method, data, outLen);
			break;
		case rpServerName:
			copy_string(ap_get_server_name(r), data, outLen);
			break;
		case rpServerPort:
			*data = (char*)malloc(20);
			sprintf(*data, "%d", (int)ap_get_server_port(r));
			*outLen = (int)strlen(*data);
			break;
		case rpScriptName:
			copy_string(r->uri, data, outLen);
			break;
		case rpContentType:
			copy_string(apr_table_get(r->headers_in, "Content-Type"), data, outLen);
			break;
		case rpContentLength:
			copy_string(apr_table_get(r->headers_in, "Content-Length"), data, outLen);
			break;
		case rpReferrerKeyword:
			{
				const char * res = apr_table_get(r->headers_in, "Referer");
				if ( res == NULL )
					res = apr_table_get(r->headers_in, "Referrer");
				copy_string(res, data, outLen);
			}
			break;
		case rpUserAgentKeyword:
			copy_string(apr_table_get(r->headers_in, "User-Agent"), data, outLen);
			break;
		case rpActionKeyword:
		case rpActionPathKeyword:
			break;
		case rpClientIPAddress:
			copy_string(r->connection->remote_ip, data, outLen);
			break;
		case rpFullRequestKeyword:
			concat_headers( r, r->headers_in, data, outLen );
			break;
		case rpRealmsKeyword:
		case rpCurrentRealmKeyword:
			break;
		case rpCookiesKeyword:
			copy_string(apr_table_get(r->headers_in, "Cookie"), data, outLen);
			break;
		case rpSessionRootPath:
			{
				const char * fn = r->uri;//filename;//uri

				const char * found = strrchr(fn, '/');
				if ( found != NULL )
				{
					int num = int((found-fn)+1);
					*data = (char*)malloc(num+1);
					strncpy(*data, fn, num);
					*outLen = num;
				}
			}
			break;
		case rpResolveFilePath:
			{
				if (param == NULL)
					param = "/";
				request_rec * subrec = ap_sub_req_lookup_uri(param, r, NULL);
				bool isDir = false;
				struct stat st;
				if ( subrec->filename )
				{
					// Apache 2 Only
					// if param ends with a slash and uri does not end with a slash
					// filename needs to get truncated to the last slash part
					bool doTrunc = param[strlen(param)-1] == '/' && subrec->uri[strlen(subrec->uri)-1] != '/';

					*data = (char*)malloc( strlen(subrec->filename) + 2 + (subrec->path_info ? strlen(subrec->path_info) : 0) );
					strcpy(*data, subrec->filename);
					if ( subrec->path_info )
						strcat(*data, subrec->path_info);

					if (doTrunc)
					{
						int last = int(strlen(*data)-1);
						while(last > 0 && (*data)[last] != '/')
							--last;
						if (last >= 0)
							(*data)[last+1] = '\0';
					}

					if ( (*data)[strlen(*data)-1] != '/' )
					{
						isDir = ::stat(*data, &st) == 0 ? S_ISDIR(st.st_mode) : false;
						if ( !isDir )
							isDir = param[strlen(param)-1] == '/';

						if ( isDir )
							strcat(*data, "/");
					}

					*outLen = (int)strlen(*data);
				}
				ap_destroy_sub_req(subrec);
			}
			break;
		case rpWebFileData:
			if ( param != NULL )
			{
				char path[1024] = "";
				if ( param[0] != '/' ) // relative from session root
				{
					const char * fn = r->filename;
					const char * found = strrchr(fn, '/');
					if ( found != NULL )
					{
						strncat(path, fn, (found-fn)+1);
					}
					strcat(path, param);
				}
				else
				{
					request_rec * subrec = ap_sub_req_lookup_uri(param, r, NULL);
					strcat(path, subrec->filename);
					ap_destroy_sub_req(subrec);
				}

				int f = open(path, LP_OPEN_FLAGS, 0);
				if ( f != -1 )
				{
					struct stat st;

					::stat(path, &st);
					int filelen = st.st_size;

					*data = (char*)malloc(filelen+1);
					int res = read(f, *data, filelen);
					if ( res > -1 )
					{
						(*data)[res] = '\0';
						*outLen = filelen;
					}
					else
					{
						(*data)[0] = '\0';
						*outLen = 0;
					}
					close(f);
				}
				else
				{
					good = osErrFileNotFound;
				}
			}
			break;
		case rpIndexFile:
		default:
			break;
	}
//	if ( *data == NULL )
//	{
//		*data = (char*)malloc(1);
//		(*data)[0] = '\0';
//		*outLen = 1;
//	}
	return good;
}

int get_post( SOCKET sock, request_rec * r, LP8POSTReader * reader )
{
	int toRead = 0;
	if ( ap_setup_client_block(r, REQUEST_CHUNKED_ERROR) == OK )
	{
		if ( ap_should_client_block(r) == 1)
		{
			char * buffer = new char[(unsigned int)(DEFAULT_BUFFER+1)];
			int readLen = 0;
			toRead = (int)r->remaining;
			int readSize = (int)DEFAULT_BUFFER;

			while ( (readLen = ap_get_client_block(r, buffer, readSize)) > 0 )
			{
				buffer[readLen] = '\0';
				reader->AddToBuffer(buffer, readLen);
				toRead -= readLen;
				readSize = toRead < DEFAULT_BUFFER ? toRead : DEFAULT_BUFFER;
			}

			delete [] buffer;
		}
	}
	return toRead == 0 ? 1 : 0;
}

#ifdef WIN32
#define ENTER_CS() EnterCriticalSection(&gSocketCacheLock)
#define EXIT_CS() LeaveCriticalSection(&gSocketCacheLock)
#else
#define ENTER_CS() pthread_mutex_lock(&gSocketCacheLock)
#define EXIT_CS() pthread_mutex_unlock(&gSocketCacheLock)
#endif

SOCKET open_connection()
{
	SOCKET s = INVALID_SOCKET;
	/*
	open a socket and connect
	need to add support for resolving hostnames
	*/
	if ( (s = socket(AF_INET, SOCK_STREAM, 0)) != INVALID_SOCKET )
	{
		if ( connect(s, (struct sockaddr*)&gLassoAddr, sizeof(struct sockaddr_in)) == 0 )
		{
			return s;
		}
		release_connection(s, true);
	}
	s = INVALID_SOCKET;
	return s;
}

void release_connection( SOCKET sock, bool justKillIt )
{
	if ( sock != INVALID_SOCKET ) // just close it
	{
#ifdef WIN32
		shutdown(sock, SD_BOTH);
		closesocket(sock);
#else
		close(sock);
#endif
	}
}

void child_init_handler(apr_pool_t *pchild, server_rec *s)
{
	gLassoAddr.sin_family = AF_INET;
	gLassoAddr.sin_port = htons(gLassoPort);
	gLassoAddr.sin_addr.s_addr = inet_addr( gAddress );
	gLassoAddr.sin_zero[0] = gLassoAddr.sin_zero[1] = gLassoAddr.sin_zero[2] = gLassoAddr.sin_zero[3] = 0;
}
