/*
	File:		WSAPI_Main.h

	Contains:	xxx put contents here xxx

	Written by:	Joe Kalash

	Copyright:	 1997 by StarNine Technologies, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	  3/6/98	jtk		Add cOpenStreamOnSocket.
		 <2>	10/27/97	jtk		Added routingfilter(), and closeStreamWithTimeout() calls.

	To Do:
*/

//WSAPI_Private.h

/*
W*API Mac Glue Interface
Copyright 1995, StarNine Techologies, Inc. All rights reserved.

This file defines the private glue interface between the Mac Web server and the W*API
plug-in framework.

*/

#ifndef _WSAPI_PRIVATE
#define _WSAPI_PRIVATE 1

#include "WSAPI.h"

#define WSAPI_PrivateInit 127 //private code to initialize plug-in interface

#define WSAPI_Version_10 0x01000000
#define WSAPI_Version_11 0x01010000
#define WSAPI_Version_12 0x01020000
#define WSAPI_Version_13 0x01030000		// Added WSAPI_RegisterRouter


typedef WSAPI_ErrorCode (*WSAPI_CallbackErrProcPtr)(WSAPI_CommandPBPtr pb, ...); //no need for UPP since no mixed mode calls are made
typedef Ptr (*WSAPI_CallbackPtrProcPtr)(WSAPI_CommandPBPtr pb, ...);
typedef void (*WSAPI_CallbackVoidProcPtr)(WSAPI_CommandPBPtr pb, ...) ;


typedef enum {
	cSendHTTPData,
	cHTTPConnectionStatus,
	cRegisterAction,
	cGetParameter,
	cRequestIdleTime,
	cYieldTime,
	cAllocateMemory,
	cFreeMemory,
	cDisplayMessage,
	cOpenStream,
	cCloseStream,
	cReadStream,
	cWriteStream,
	cStatusStream,
	cIPNameToAddr,
	cAllocateOSMemory,
	cFreeOSMemory,
	cSetParameter,
	cNewDescriptor,
	cDisposeDescriptor,
	cGetDescriptor,
	cSetDescriptor,
	cRegisterSuffix,
	cWaitForIPCMessage,
	cSendIPCMessage,
	cWriteLogEntry,
	cReadHTTPData,
	cValidateUser,
	cRegisterAccessControl,
	cGetIndexedParameter,
	cSetIndexedParameter,
	cRegisterFilter,
	cCreateWindow,
	cDisposeWindow,
	cHideWindow,
	cActivateWindow,
	cListenStream,
	cListenCancel,
	cIPAddrToName,
	cRegisterLogging,
	cRegisterRoutingFilter,
	cCloseStreamWithTimeout,
	cOpenStreamOnSocket,
	/* WSAPI/2 Callbacks */
	cReallocateMemory,
	cAllocatePoolMemory,
	cReallocatePoolMemory,
	cFreePoolMemory,
	cRegisterAccessControl_2,
	cRegisterAuthenticator,
	cNewCommandPB,
	cDisposeCommandPB,
	cRegisterService,
	cCallService,
	cRegisterFileInfo,
	cLastCallback
} WPICallbacks;

typedef struct {
	WSAPI_CallbackErrProcPtr addr [cLastCallback];
} WSAPI_Callbacks, *WSAPI_CallbacksPtr;

//this structure should hold connection-specific info as passed in from the server
typedef void *WSAPI_CookiePtr;

typedef struct {
	WSAPI_CookiePtr	cookie;
	WSAPI_CommandPBPtr commandPtr;
	WSAPI_CallbacksPtr callbacks;
} WSAPI_ArgsStruct, *WSAPI_ArgsPtr;

#endif	
