
#include "stdafx.h"

#include "PlaySound.NET.h"
#include <Windows.h>
#include <Mmsystem.h>

// this is the namespace we will place our tag in
static const char * kAudioNamespaceName = "audio";
// this is the name of the tag we are registering
static const char * kPlaySound = "playsound";
// here is the description of the tag we are registering
static const char * kDescription = "audio_playsound(<path to sound file>) - Plays the specified WAV sound file.";

// this is the standard entry point which Lasso looks for in every LCAPI module.
void registerLassoModule()
{
	lasso_registerTagModule(kAudioNamespaceName, kPlaySound, audio_playsound, REG_FLAGS_TAG_DEFAULT, kDescription);
}

// here is the prototype for the tag we will implement
osError audio_playsound(lasso_request_t token, tag_action_t)
{
	// this will hold the provided path name
	auto_lasso_value_t thePath;
	INITVAL(&thePath);
	
	// if a parameter was not provided...
	osError err = lasso_getTagParam(token, 0, &thePath);
	if (err != osErrNoErr)
		return err; // bail
		
	// make sure that this file path is permitted for read access
	err = lasso_operationAllowed(token, kReadFiles, (void*)thePath.name);
	if (err != osErrNoErr)
		return err; // bail
		
	// now convert the path to a full platform specific path
	osPathname dst = "";
	lasso_getPlatformSpecificPath(thePath.name, dst);
	
	PlaySound(dst, NULL, SND_ASYNC);
	return err;
}
