import com.omnipilot.lassopro.*;

import com.lowagie.text.*;

/**
 * This class holds all the implementations of the member tags of the
 * PDF_Image tag.
 * @author	- Mindfire Solutions (www.mindfiresolutions.com)
 */

public class PDFImage
{

	private Image myImage;

	/**
	 * This is the constructor of the class.
	 * The random number for the key is generated here.
	 */
	public PDFImage()
	{
	}

	/**
	 * This method creates an image.
	 */
	 public int CreateImage(String sFile,String sUrl,String sRaw,float fHeight,
	 						float fWidth,boolean bProportional,float fRotate)
	 {
		try
		{
			if(!sFile.equals(""))
				myImage = Image.getInstance(sFile);
			else if(!sUrl.equals(""))
				myImage = Image.getInstance(new java.net.URL(sUrl));
			else if(!sRaw.equals(""))
				myImage = Image.getInstance(sRaw.getBytes());
		}
		catch(BadElementException be) {
			System.err.println(be.getMessage());
			return 1;
		}
		catch(java.net.MalformedURLException me) {
			System.err.println(me.getMessage());
			return 1;
		}
		catch(java.io.IOException ioe) {
			System.err.println(ioe.getMessage());
			return 1;
		}

		if(bProportional)
		{
			if(fHeight!=0 && fWidth!=0)
				myImage.scaleToFit(fWidth, fHeight);
		}
		else
		{
			if(fHeight>0)
				myImage.scaleAbsoluteHeight(fHeight);

			if(fWidth>0)
				myImage.scaleAbsoluteWidth(fWidth);
		}

		if(fRotate!=0)
			myImage.setRotation(fRotate);

		return 0;
	 }

	/**
	 * This method returns the Image.
	 * @return      the Image.
	 */

	public Image getImage()
	{
		return this.myImage;
	}

}
