import com.lowagie.text.*;
import com.lowagie.text.pdf.*;

/**
 * This class holds all the implementations of the member tags of the
 * PDF_Text tag.
 * @author	- Mindfire Solutions (www.mindfiresolutions.com)
 */

public class PDFRead
{

	PdfReader myReader = null;

	/**
	 * This is the constructor of the class.
	 */
	public PDFRead()
	{

	}

	/**
	 * This method is used to cread a PDFRead object
	 * Create a reader for the specified file name.
	 */
	public int CreatePDFRead(String PDFFileName)
	{
		try
		{
			myReader = new PdfReader(PDFFileName);
			//System.out.println("myReader: " + myReader);
			return 0;
		}
		catch (Exception de) {
			de.printStackTrace();
            System.err.println(de.getMessage());
			return 1;
        }
	}

	/**
	 * This method returns the retrieve the total number of pages.
	 * @return      the Count an int value.
	 */

	public int getCount()
	{
		return myReader.getNumberOfPages();
	}

	/**
	 * This method returns the size of the page whose number is specified
	 * else returns the size of the first page of the document.
	 * @return  the page size.
	 */

	public Rectangle getPageSize(int index)
	{
		return myReader.getPageSize(index);
	}

	/**
	* @return PdfReader object
	*/
	public PdfReader getRead()
	{
		return myReader;
	}

}
