<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">
  <xsl:template match="/">
    <TABLE STYLE="border:1px solid black">

	  <!-- 
        - FMP XML Output Format 
       -->
      <xsl:for-each select="FMPXMLRESULT/METADATA">
        <TR STYLE="font-family:Verdana; font-size:12pt; padding:0px 6px">
	      <xsl:for-each select="FIELD">
	          <TD STYLE="border:1px solid blue"><b><xsl:value-of select="@NAME"/></b></TD>
	      </xsl:for-each>
        </TR>
      </xsl:for-each>
      <xsl:for-each select="FMPXMLRESULT/RESULTSET/ROW">
        <TR STYLE="font-family:Verdana; font-size:12pt; padding:0px 6px">
	      <xsl:for-each select="COL">
	          <TD STYLE="border:1px solid black"><xsl:value-of select="DATA"/></TD>
	      </xsl:for-each>
        </TR>
      </xsl:for-each>

	  <!-- 
        - DSO XML Output Format (FMP) 
       -->
      <xsl:for-each select="FMPDSORESULT/ROW">
        <TR STYLE="font-family:Verdana; font-size:12pt; padding:0px 6px">
	      <xsl:for-each>
	          <TD STYLE="border:1px solid black"><xsl:value-of select="."/></TD>
	      </xsl:for-each>
        </TR>
      </xsl:for-each>

	  <!-- 
        - SQL XML Raw Elements Output Format (MS) 
       -->
      <xsl:for-each select="root/row">
        <TR STYLE="font-family:Verdana; font-size:12pt; padding:0px 6px">
	      <xsl:for-each match="*">
	          <TD STYLE="border:1px solid black"><xsl:value-of select="."/></TD>
	      </xsl:for-each>
        </TR>
      </xsl:for-each>

    </TABLE>
  </xsl:template>
</xsl:stylesheet>
