<?LassoScript

	_admin_addvar: -session='_browse', 'export_type', -default='Comma', -override=(action_param: 'export_type', (action_param: 'export_type', -count));
	_admin_addvar: 'export_mode', -default='Preview';
	_admin_addvar: 'export_action', -default='None', -override=(action_param: 'export_action');

	if: (lasso_version: -lassoplatform) >> 'Win32';
		_admin_addvar: -session='_browse', 'export_lineending', -default='Windows', -override=(action_param: 'export_lineending', (action_param: 'export_lineending', -count));
	else;
		_admin_addvar: -session='_browse', 'export_lineending', -default='UNIX', -override=(action_param: 'export_lineending', (action_param: 'export_lineending', -count));
	/if;
	_admin_addvar: -session='_browse', 'export_fieldnames', -default='No', -override=(action_param: 'export_fieldnames', (action_param: 'export_fieldnames', -count));
	_admin_addvar: -session='_browse', 'export_allfields', -default='No', -override=(action_param: 'export_allfields', (action_param: 'export_allfields', -count));

	_admin_addvar: -session='_browse', 'export_xmlroot', -default='root', -override=(action_param: 'export_xmlroot', (action_param: 'export_xmlroot', -count));
	_admin_addvar: -session='_browse', 'export_xmlschema', -default='No', -override=(action_param: 'export_xmlschema', (action_param: 'export_xmlschema', -count));
	_admin_addvar: -session='_browse', 'export_xmlrecord', -default='record', -override=(action_param: 'export_xmlrecord', (action_param: 'export_xmlrecord', -count));
	_admin_addvar: -session='_browse', 'export_xmlfield', -default='field', -override=(action_param: 'export_xmlfield', (action_param: 'export_xmlfield', -count));
	_admin_addvar: -session='_browse', 'export_xmlfieldnames', -default='No', -override=(action_param: 'export_xmlfieldnames', (action_param: 'export_xmlfieldnames', -count));
	_admin_addvar: -session='_browse', 'export_xmlbase64', -default='No', -override=(action_param: 'export_xmlbase64', (action_param: 'export_xmlbase64', -count));

	_admin_addvar: 'export_filename', -default='Export.txt', -override=(action_param: 'export_filename');
	_admin_addvar: -session='_browse', 'export_filedate', -default='Yes', -override=(action_param: 'export_filedate');

	// Set the export_token
	_admin_addvar: 'export_token', -default=(lasso_uniqueid + '_' + $admin_increment), -override=(action_param: 'export_token');
	if: !(global_defined: '_databasebrowser_export_') || !(global: '_databasebrowser_export_')->(isa: 'map');
		global: '_databasebrowser_export_' = (map);
	/if;
			

	var: 'export_folder' = (_admin_servicepath) + 'LassoAdmin/Browse/';

	if: $export_action >> 'Reset';

		var: 'export_lineending'='UNIX';
		var: 'export_fieldnames'='No';
		var: 'export_allfields'='No';
		var: 'export_xmlroot'='root';
		var: 'export_xmlschema'='No';
		var: 'export_xmlrecord'='record';
		var: 'export_xmlfield'='field';
		var: 'export_xmlfieldnames'='No';
		var: 'export_xmlbase64'='No';
		var: 'export_filename'='Export.txt';
		var: 'export_filedate'='Yes';

	else: ($export_action >> 'Export');
		var: 'export_mode' = 'Export';
	/if;

	if: $export_mode == 'Preview';
		var: 'export_maxrecords'=5;
		var: 'export_skiprecords'=0;
	else;
		var: 'export_maxrecords'='All';
		var: 'export_skiprecords'=0;
	/if;

	var: 'export_preview' = '';
	var: 'export_output' = '';

	if: $export_lineending == 'UNIX';
		var: 'endofline' = '\n';
	else: $export_lineending == 'Macintosh';
		var: 'endofline' = '\r';
	else; // $export_lineending == 'Windows';
		var: 'endofline' = '\r\n';
	/if;

	if: ((var_defined: 'browse_inline') == false) || ((var: 'browse_inline') == null) || ((var: 'browse_inline') == array);
		var:'browse_inline' = (array: -findall='', -database=$browse_databasealias, -table=$browse_tablealias, -keyfield=$browse_keyfield, -skiprecords=$browse_skiprecords, -maxrecords=$browse_maxrecords);

		if: ($browse_sortfield != '');
			$browse_inline->insert:(pair:'-sortfield'=$browse_sortfield);
			if: ($browse_sortorder != '');
				$browse_inline->(insert: (pair: '-sortorder'=$browse_sortorder));
			/if;
		/if;
	/if;

	if: (var_defined: 'browse_inline');

		if: ($export_type == 'Comma') || ($export_type == 'Tab');

			if: $export_type == 'Comma';
				var: 'delimiter' = ',';
				var: 'surround' = '\"';
			else; // $export_type == 'Tab';
				var: 'delimiter' = '\t';
				var: 'surround' = '';
			/if;

			inline: $browse_inline, -maxrecords=$export_maxrecords;
				var: 'error'=(error_currenterror),'code'=(error_currenterror: -errorcode),'found_count'=(found_count),'shown_first'=(shown_first),'shown_last'=(shown_last),'shown_count'=(shown_count);
				if: $export_fieldnames == 'Yes';
					loop: (field_name: -count);
						var: 'name'=(field_name: loop_count);
						var: 'temp'=$browse_fieldsettings->(find: $name);
						if: ($export_allfields == 'Yes') || ($temp != array) && ($temp->(get:1)->type == 'pair') && ($temp->(get:1)->second->type == 'map') && ($temp->(get:1)->second->(find: 'export_allow') != 'No');
							$export_output += $surround;
							$export_output += (encode_xml: $name);
							$export_output += $surround;
							$export_output += $delimiter;
						/if;
					/loop;
					$export_output->(removetrailing: $delimiter);
					$export_output += $endofline;
				/if;
				records;
					loop: (field_name: -count);
						var: 'name'=(field_name: loop_count);
						var: 'temp'=$browse_fieldsettings->(find: $name);
						if: ($export_allfields == 'Yes') || ($temp != array) && ($temp->(get:1)->type == 'pair') && ($temp->(get:1)->second->type == 'map') && ($temp->(get:1)->second->(find: 'export_allow') != 'No');
							$export_output += $surround;
							$export_output += (field: (field_name: loop_count), -encodexml);
							$export_output += $surround;
							$export_output += $delimiter;
						/if;
					/loop;
					$export_output->(removetrailing: $delimiter);
					$export_output += $endofline;

					if: ((loop_count) <= 5);
						$export_preview = $export_output;
						if: ($found_count > (loop_count));
							$export_preview += '\r...';
						/if;
					/if;

				/records;
				$export_output->(removetrailing: $endofline);
			/inline;

		else: $export_type == 'XML';

			$export_output += '<?xml version="1.0" encoding="UTF-8"?>' + $endofline;

			$export_output += '<' + (var: 'export_xmlroot', -encodexml) + '>' + $endofline;

			inline: $browse_inline, -maxrecords=$export_maxrecords;
				var: 'error'=(error_currenterror),'code'=(error_currenterror: -errorcode),'found_count'=(found_count),'shown_first'=(shown_first),'shown_last'=(shown_last),'shown_count'=(shown_count);
				records;

					$export_output += '  <' + (var: 'export_xmlrecord', -encodexml) + '>' + $endofline;

					loop: (field_name: -count);
						var: 'name'=(field_name: loop_count);
						var: 'temp'=$browse_fieldsettings->(find: $name);
						if: ($export_allfields == 'Yes') || ($temp != array) && ($temp->(get:1)->type == 'pair') && ($temp->(get:1)->second->type == 'map') && ($temp->(get:1)->second->(find: 'export_allow') != 'No');
							if: ($export_xmlfieldnames == 'Yes');
								$export_output += '    <' + (var: 'name', -encodexml) + '>';
							else;
								$export_output += '    <' + (var: 'export_xmlfield', -encodexml) + ' name="' + (var: 'name', -encodexml) + '">';
							/if;
							$export_output += (field: (field_name: loop_count), -encodexml);
							if: ($export_xmlfieldnames == 'Yes');
								$export_output += '</' + (var: 'name', -encodexml) + '>';
							else;
								$export_output += '</' + (var: 'export_xmlfield', -encodexml) + '>';
							/if;
							$export_output += $endofline;
						/if;
					/loop;

					$export_output += '  </' + (var: 'export_xmlrecord', -encodexml) + '>' + $endofline;

					if: ((loop_count) <= 5);
						$export_preview = $export_output;
						if: ($found_count > (loop_count));
							$export_preview += '\r...';
						/if;
					/if;

				/records;
			/inline;

			$export_output += '</' + (var: 'export_xmlroot', -encodexml) + '>';

		else: $export_type == 'MySQL';


		/if;


		if: $export_action >> 'Preview';

			$export_preview = $export_output;

		else;

			$shown_last = (math_min: 5, $found_count);
			$shown_count = $shown_last;

		/if;

		if: ($export_action >> 'Perform') || ($export_action >> 'Download');

			(global: '_databasebrowser_export_')->(insert: $export_token = false);

			var: 'export_fullname' = $export_filename;

			if: (var: 'export_filedate') == 'Yes';
				 $export_fullname = (string_replace: $export_fullname, -find='.', -replace='_' + (date_format: (date), -format='%Y%m%d_%H%M%S') + '.');
			/if;

			if: !(file_exists: $export_folder);
				file_create: $export_folder;
			/if;

			if: !(file_exists: $export_folder);
				var: 'error'='Export folder not found.  Please create a folder named "Browse" in the Lasso Professional 8/LassoAdmin folder';
			else;

				var: 'export_fullpath' = $export_folder + $export_fullname;

				if: (file_exists: $export_fullpath);
					 var: 'export_backup'=$export_fullpath;
					 $export_backup = (string_replace: $export_backup, -find='.', -replace='2.');
					 file_move: $export_fullpath, $export_backup, -fileoverwrite;
					if: (file_currenterror: -errorcode) != (error_noerror: -errorcode);
						var: 'error'=(file_currenterror), 'code'=(file_currenterror: -errorcode);
					/if;
				/if;

				file_create: $export_fullpath, -fileoverwrite;
				if: (file_currenterror: -errorcode) != (error_noerror: -errorcode);
					var: 'error'=(file_currenterror), 'code'=(file_currenterror: -errorcode);
				else;
					file_write: $export_fullpath, $export_output, -fileoverwrite;
					if: (file_currenterror: -errorcode) != (error_noerror: -errorcode);
						var: 'error'=(file_currenterror), 'code'=(file_currenterror: -errorcode);
					else: ($export_action >> 'Download');
						var: 'message'='The file "' + $export_fullname + '" should download in a new window.';
					else;
						var: 'message'='The file "' + $export_fullname + '" was successfully written to the Lasso Professional 8/LassoAdmin/Browse folder.';
					/if;
				/if;
				
				(global: '_databasebrowser_export_')->(insert: $export_token = $export_fullpath);
			
				var: 'export_token' = (lasso_uniqueid + '_' + $admin_increment);
				
			/if;

		/if;

	else;
		var: 'error' = 'An unknown error occured.';
	/if;

	null: (file_exists: $export_folder);
	if: (file_currenterror != error_noerror);
		var: 'error' = ' - This site does not have permission to access files outside of the Web server root.  Use the "Export" options in the side bar of the "List" tab to export files.';
		var: 'code' = -1;
	/if;

?>

