<?LassoScript

	define_tag: '_xml_children', -required='xml';
		if: (#xml->type != 'xml') || !(#xml->haschildren);
			return: (array);
		/if;
		local: 'output' = array;
		iterate: #xml->children, (local: 'temp');
			if: (#temp->name != 'text') && (#temp->contents != '');
				#output->(insert: @#temp);
			/if;
		/iterate;
		return: #output;
	/define_tag;

	_admin_addvar: -session='_browse', 'import_filename', -default='', -override=(action_param: 'import_filename', (action_param: 'import_filename', -count));

	_admin_addvar: -session='_browse', 'import_mode', -default='Preview';
	_admin_addvar: 'import_action', -default='None', -override=(action_param: 'import_action', (action_param: 'import_action', -count));

	_admin_addvar: 'import_type', -override=(action_param: 'import_type', (action_param: 'import_type', -count));
	_admin_addvar: 'import_lineending', -override=(action_param: 'import_lineending', (action_param: 'import_lineending', -count));
	_admin_addvar: 'import_skipfirst', -override=(action_param: 'import_skipfirst', (action_param: 'import_skipfirst', -count));
	_admin_addvar: -session='_browse', 'import_idignore', -default='Yes', -override=(action_param: 'import_idignore', (action_param: 'import_idignore', -count));

	_admin_addvar: 'import_xmlroot', -override=(action_param: 'import_xmlroot', (action_param: 'import_xmlroot', -count));
	_admin_addvar: 'import_xmlrecord', -override=(action_param: 'import_xmlrecord', (action_param: 'import_xmlrecord', -count));
	_admin_addvar: 'import_xmlfield', -override=(action_param: 'import_xmlfield', (action_param: 'import_xmlfield', -count));

	_admin_addvar: -session='_browse', 'import_filecurrent', -default=map;
	_admin_addvar: 'import_fileupload', -default=null;

	var: 'file_contents' = null;

	var: 'import_filelisting' = (array);

	var: 'import_folder' = (_admin_servicepath) + 'LassoAdmin/Browse/';

	if: !(file_exists: $import_folder);
		file_create: $import_folder;
	/if;
	if: !(file_exists: $import_folder);
		var: 'error'='Import folder not found.  Please create a folder named "Browse" in the Lasso Professional 8/LassoAdmin folder';
	else;
		var: 'import_filelisting' = (file_listdirectory: $import_folder);

		loop: -loopfrom=$import_filelisting->size, -loopto=1, -loopincrement=(-1);
			if: $import_filelisting->(get: loop_count)->(get:1) == '.';
				$import_filelisting->(remove: loop_count);
			/if;
		/loop;

		if: (file_currenterror: -errorcode) != (error_noerror: -errorcode);
			var: 'error'=(file_currenterror), 'code'=(file_currenterror: -errorcode);
		/if;
	/if;

	if: (file_uploads->size > 0) && ($import_action !>> 'reset');
		
		var: 'upload' = (file_uploads)->first;
		
		var: 'upload_tempname' = $upload->(find: 'upload.name');
		var: 'upload_filename' = ('Upload_' + (date_format: (date), -format='%Y%m%d_%H%M%S') + '.txt');
		var: 'upload_filepath' = ($import_folder + $upload_filename);
		
		if: (file_exists: $upload_tempname) && (file_exists: $import_folder);
			file_copy: $upload_tempname, $upload_filepath;
		/if;

		if: (file_exists: $upload_filepath);
			$import_filelisting->(insert: $upload_filename);
			$import_filename = $upload_filename;
		/if;
	
	/if;

	if: $import_filename != (action_param: 'import_prevname');
		$import_action  = 'Apply';
	/if;

	if: (action_param: 'header') >> 'select';
		var: 'import_action' = 'reset';
	/if;

	if: ($import_action >> 'Reset');

		var: 'import_lineending'='Automatic';
		var: 'import_fieldnames'='Automatic';
		var: 'import_xmlroot'='';
		var: 'import_xmlrecord'='';
		var: 'import_xmlfield'='';
		var: 'import_filename'='';

	else: ($import_action >> 'Show Preview');
		var: 'import_mode'='Preview';
	else: ($import_action >> 'Hide Preview');
		var: 'import_mode'='Preview'; // 'Listing';
	else: ($import_action >> 'Apply');
		var: 'import_mode'='Preview'; // 'Listing';
	/if;

	if: ($import_filename != '');

		var: 'import_fullpath' = ($import_folder + $import_filename);

		if: ($import_filecurrent->(find: 'name') != $import_filename);
			var: 'import_filecurrent' = (map:
				'name' = $import_filename,
				'type' = 'Automatic',
				'lineending' = 'Automatic',
				'skipfirst' = 'Automatic',
				'path' = $import_fullpath,
			);
		/if;
		
		if: $import_filename == (action_param: 'import_prevname');
			if: (var: 'import_type') != '';
				$import_filecurrent->(insert: 'type'=(var: 'import_type'));
			/if;
			if: (var: 'import_lineending') != '';
				$import_filecurrent->(insert: 'lineending'=(var: 'import_lineending'));
			/if;
			if: (var: 'import_skipfirst') != '';
				$import_filecurrent->(insert: 'skipfirst'=(var: 'import_skipfirst'));
			/if;
		/if;

		if: !(file_exists: $import_fullpath);
		
			$import_filecurrent->(insert: 'error'='The specified file can not be read. Check that the "Lasso" user has permission to access the file.');
			var: 'import_action' = 'Error';
			var: 'import_mode' = 'Listing';

		else; //: ($import_filecurrent->(find: 'lineending') == 'Automatic') || ($import_filecurrent->(find: 'type') == 'Automatic');

			// Fetch the first 256 characters of the file for heuristics and preview
			var: 'file_contents' = (string: (file_read: $import_fullpath, -filestartpos=0, -fileendpos=256));

			var: 'import_filelength' = (file_getsize: $import_fullpath);
			var: 'import_linecount' = (-1);

			if: $file_contents->size == 0;
				$import_filecurrent->(insert: 'error'='File is empty.');
			else;
				// Check to see if the file starts with an XML header
				if: $import_filecurrent->(find: 'type') >> 'Automatic';
					if: $file_contents >> '<?xml';
						$import_filecurrent->(insert: 'type'='Automatic XML');
					else;
						$import_filecurrent->(insert: 'type'='Automatic Text');
					/if;
				/if;

				// Scan the file to find out what type of text it contains.
				if: ($import_filecurrent->(find: 'type') >> 'Text');
					var: 'curpos'=($file_contents->size + 1);
					var: 'lineending'=($import_filecurrent->(find: 'lineending'));
					var: 'texttype'=($import_filecurrent->(find: 'type'));
					var: 'diligence'=false;

					while: ($curpos < $import_filelength) && (($lineending == 'Automatic') || ($texttype == 'Automatic Text'));

						if: ($lineending >> 'Automatic');
							if: $file_contents >> '\r\n';
								$lineending='Automatic Windows';
							else: $file_contents >> '\r';
								// This could be the first half of a \r\n so we double check
								if: $diligence;
									$lineending='Automatic Macintosh';
								/if;
								var: 'diligence' = true;
							else: $file_contents >> '\n';
								$lineending='Automatic UNIX';
							/if;
						/if;
						if: ($texttype >> 'Automatic');
							if: $file_contents >> '\t';
								$texttype='Automatic Tab';
							else: $file_contents >> '",';
								$texttype='Automatic Comma';
							/if;
						/if;
						if: ($curpos < $import_filelength) && (($lineending == 'Automatic') || ($texttype == 'Automatic'));
							$file_contents += (string: (file_read: $import_fullpath, -filestartpos=$curpos, -fileendpos=$curpos+8));
							var: 'curpos'=($file_contents->size + 1);
						/if;

					/while;

					$import_filecurrent->(insert: 'type'=$texttype);
					$import_filecurrent->(insert: 'lineending'=$lineending);

				else: ($import_filecurrent->(find: 'type') >> 'XML');

					var: 'file_contents' = (string: (file_read: $import_fullpath));

					var: 'xml' = (xml: $file_contents);

					if: ($import_xmlroot == '') && ($xml->name != '');
						var: 'import_xmlroot' = $xml->name;
					/if;

					if: ((_xml_children: $xml)->size > 0);
						var: 'xml2' = (_xml_children: $xml)->(get:1);

						if: ($import_xmlrecord == '') && ($xml2->name != '');
							var: 'import_xmlrecord' = $xml2->name;
						/if;

						if: ((_xml_children: $xml2)->size > 0);
							var: 'xml3' = (_xml_children: $xml2)->(get:1);

							if: ($import_xmlfield == '') && ($xml3->name != '');
								var: 'import_xmlfield' = $xml3->name;
							/if;

						/if;

					/if;

				/if;
			/if;

			var: 'import_preview' = $file_contents->(substring: 1, 256);

			var: 'import_preview' = (string_replaceregexp: $import_preview, -find='\\r+', -replace='\n');
			var: 'import_preview' = (string_replaceregexp: $import_preview, -find='\\n+', -replace='\n');
			var: 'import_preview' = (string_replace: $import_preview, -find='","', -replace='", "');
			if: (var: 'import_skipfirst') >> 'Yes';
				var: 'temp' = (string_findposition: $import_preview, -find='\n');
				if: ($temp > 0) && ($temp < $import_preview->size);
					var: 'import_preview' = $import_preview->(substring: $temp, $import_preview->size);
				/if;
			/if;

		/if;

		if: ($import_filecurrent->(find: 'type') >> 'Comma') || ($import_filecurrent->(find: 'type') >> 'Tab');

			// Set up some useful variables for later
			if: $import_filecurrent->(find: 'lineending') >> 'UNIX';
				var: 'endofline' = '\n';
			else: $import_filecurrent->(find: 'lineending')>> 'Macintosh';
				var: 'endofline' = '\r';
			else; // $import_filecurrent->(find: 'lineending') >> 'Windows';
				var: 'endofline' = '\r\n';
			/if;

			if: $import_filecurrent->(find: 'type') >> 'Comma';
				var: 'surround' = '\"';
				var: 'delimiter' = '","';
			else; // $import_filecurrent->(find: 'type') >> 'Tab';
				var: 'delimiter' = '\t';
				var: 'surround' = '\t';
			/if;

		else: ($import_filecurrent->(find: 'type') >> 'xml');

			if: ($import_action != '') && ($file_contents != '');

				var: 'file_contents' = (string: (file_read: $import_fullpath));

				var: 'xml_root' = (xml: $file_contents);
				var: 'xml_records' = (_xml_children: $xml_root);

				if: ($xml_records->size > 0);
					var: 'xml_fields' = (_xml_children: $xml_records->(get:1));
				else;
					var: 'xml_fields' = (array);
				/if;

			/if;

		/if;

	/if;

	if: $import_action >> 'Perform';

		var: 'base_inline' = (array: -database=$browse_databasealias, -table=$browse_tablealias);
		var: 'result_array'=(array);
		var: 'error_array'=(array);

		if: ($import_type >> 'Comma') || ($import_type >> 'Tab');

			var: 'import_match' = (field_names);

			var: 'done' = false;
			var: 'file_contents' = (string: (file_read: $import_fullpath));
			var: 'file_location' = 1;
			var: 'start_time' = date;
			var: 'skip_first' = ($import_filecurrent->(find: 'skipfirst') >> 'Yes');
			
			while: $done == false;

				var: 'import_inline' = $base_inline;
				$import_inline->(insert: -add='');

				var: 'temp_location' = $file_contents->(find: $endofline, $file_location);
				if: $temp_location > 0;
					var: 'temp' = $file_contents->(substring: $file_location, ($temp_location - $file_location));
					$file_location = $temp_location + $endofline->size;
				else;
					var: 'temp' = $file_contents->(substring: $file_location);
					var: 'done' = true;
				/if;

				var: 'line_fields' = $temp->(split: $delimiter);
				if: $line_fields->size > 0;
					$line_fields->(get:1)->(removeleading: $surround);
					$line_fields->(get:$line_fields->size)->(removetrailing: $surround);
				/if;

				if: ($skip_first == true);
					var: 'skip_first' = false;
				else: ($line_fields->size == 0);
					// Don't import empty records;
				else: ($line_fields->size == 1) && ($line_fields->(get: 1) == '');
					// Don't import empty records;
				else;	
							
					loop: (math_min: $line_fields->size, $browse_fieldmap->size);
						var: 'name' = $browse_fieldmap->(get:loop_count)->second->(find: 'name');
						var: 'value' = $line_fields->(get:loop_count);
						
						if: ($name == $browse_keyfield);
							if: ($import_idignore == 'No');
								var: 'check_inline' = $base_inline;
								$check_inline->(insert: -search='');
								$check_inline->(insert: -keyfield=$name);
								$check_inline->(insert: -keyvalue=$value);
								inline: -log=$__startup_loglevel__, $check_inline;
									if: (found_count) == 1;
										$import_inline->(insert: -update='');
										$import_inline->(insert: -keyfield=$name);
										$import_inline->(insert: -keyvalue=$value);
									/if;
								/inline;
							else;
								// The keyfield is not included in the import
							/if;
						else;
							$import_inline->(insert: $name=$value);
						/if;
					/loop;

					inline: $import_inline;
						if: (error_currenterror: -errorcode) != (error_noerror: -errrocode);
							$error_array->(insert: (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')');
						else;
							$result_array->(insert: keyfield_value);
						/if;
					/inline;

				/if;
			/while;
	
			var: 'duration' = (date_difference: date, $start_time, -secondsbetween);
			
		else: $import_type >> 'XML';

			var: 'start_time' = date;
			var: 'file_contents' = (string: (file_read: $import_fullpath));
			var: 'xml_root' = (xml: $file_contents);
			var: 'xml_records' = (_xml_children: $xml_root);

			if: ($xml_records->size > 0);
				var: 'xml_fields' = (_xml_children: $xml_records->(get:1));
			else;
				var: 'xml_fields' = (array);
			/if;

			iterate: $xml_records, (var: 'temp_record');

				var: 'import_inline' = $base_inline;
				$import_inline->(insert: -add='');

				var: 'xml_fields' = (_xml_children: $temp_record);

				var: 'line_fields' = (array);
				iterate: $xml_fields, (var: 'temp');
					$line_fields->(insert: $temp->contents);
				/iterate;

				loop: (math_min: $line_fields->size, $browse_fieldmap->size);
					var: 'name' = $browse_fieldmap->(get:loop_count)->second->(find: 'name');
					var: 'value' = $line_fields->(get:loop_count);
					
					if: ($name == $browse_keyfield);
						if: ($import_idignore == 'No');
							var: 'check_inline' = $base_inline;
							$check_inline->(insert: -search='');
							$check_inline->(insert: -keyfield=$name);
							$check_inline->(insert: -keyvalue=$value);
							inline: -log=$__startup_loglevel__, $check_inline;
								if: (found_count) == 1;
									$import_inline->(insert: -update='');
									$import_inline->(insert: -keyfield=$name);
									$import_inline->(insert: -keyvalue=$value);
								/if;
							/inline;
						else;
							// The keyfield is not included in the import
						/if;
					else;
						$import_inline->(insert: $name=$value);
					/if;
				/loop;
						
				inline: $import_inline;
					if: (error_currenterror: -errorcode) != (error_noerror: -errrocode);
						$error_array->(insert: (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')');
					else;
						$result_array->(insert: keyfield_value);
					/if;
				/inline;

			/iterate;
	
			var: 'duration' = (date_difference: date, $start_time, -secondsbetween);

		/if;

		if: ((var: 'result_array') != null) && ((var: 'result_array')->size > 0);
			var: 'message' = $result_array->size + ' records were imported';
			if: (var_defined: 'duration');
				if: $duration <= 0;
					$message += ' in less than a second';
				else: $duration <= 1;
					$message += ' in about one second';
				else;
				 	$message += ' in ' + $duration + ' seconds';
				/if;
			/if;
			$message += '.';
		/if;

		if: ((var: 'error_array') != null) && ((var: 'error_array')->size > 0);
			var: 'error' = 'The following errors were reported:';
			loop: $error_array->size;
				$error += ' ' + $error_array->(get: loop_count) + ',';
			/loop;
			$error->(removetrailing: ',');
			$error += '.';
			var: 'code' = (-1);
		/if;
	/if;

	null: (file_exists: $import_folder);
	if: (file_currenterror != error_noerror);
		var: 'error' = ' - This site does not have permission to access files outside of the Web server root.';
		var: 'code' = -1;
	/if;
?>
