<?LassoScript

//
// Variables
//

_admin_addvar: 'browse_action', -default='none', -override=(action_param: 'browse_action');
_admin_addvar: 'browse_referrer', -default='search', -override=(action_param: 'browse_referrer');

_admin_addvar: 'browse_skiprecords', -default=0, -override=(action_param: 'browse_skiprecords');
_admin_addvar: 'browse_maxrecords', -override=(action_param: 'browse_maxrecords');
_admin_addvar: 'found_count', -override=(action_param: 'found_count');
_admin_addvar: 'browse_navigation', -override=(action_param: 'browse_navigation');

_admin_addvar: 'browse_showfields', -session='_browse', -default='all', -override=(action_param: 'browse_showfields');
_admin_addvar: 'browse_maxrecords', -session='_browse', -default='50', -override=(action_param: 'browse_maxrecords');
_admin_addvar: 'browse_fieldheight', -session='_browse', -default='4', -override=(action_param: 'browse_fieldheight');
_admin_addvar: 'browse_autosubmit', -session='_browse', -default='No', -override=(action_param: 'browse_autosubmit');
_admin_addvar: 'browse_exportformat', -session='_browse', -default='tab', -override=(action_param: 'browse_exportformat');
_admin_addvar: 'browse_exportlines', -session='_browse', -default=(((lasso_version: -platform) >> 'win') ? 'win' | 'unix'), -override=(action_param: 'browse_exportlines');
_admin_addvar: 'browse_exportfields', -session='_browse', -default='y', -override=(action_param: 'browse_exportfields');

if: ((var: 'view_action') >> 'Show') || ((var: 'view_action') >> 'Apply') || ((var: 'view_action') >> 'Automatic');
	var: 'browse_maxrecords' = 1;
else;
	var: 'browse_maxrecords' = (if_null: $browse_tablesettings->(find: 'list_length'), 50);
/if;

if: (variable: 'browse_action') == 'None';
	if: (if_null: $browse_tablesettings->(find: 'search_findall'), 'No') == 'Yes';
		variable: 'browse_action'='Find All';
	else;
		variable: 'found_count'=0;
		variable: 'browse_action'='Unknown';
	/if;
/if;

var: 'browse_skiprecords' = (integer: $browse_skiprecords);
var: 'browse_maxrecords' = (integer: $browse_maxrecords);
var: 'found_count' = (integer: $found_count);

if: ($browse_navigation >> 'Next');
	$browse_skiprecords = ($browse_skiprecords + $browse_maxrecords);
else: ($browse_navigation >> 'Prev');
	$browse_skiprecords = (math_max: $browse_skiprecords - $browse_maxrecords, 0);
else: ($browse_navigation >> 'Last');
	$browse_skiprecords = $found_count - (($found_count - 1) % $browse_maxrecords);
else: ($browse_navigation >> 'First') || ($browse_navigation >> 'Sort');
	$browse_skiprecords = 0;
else: ($browse_navigation >> 'Jump') || (($browse_referrer == $admin_tab2) && ((action_param: 'browse_navigation_skip') != ''));
	$browse_skiprecords = (math_max: (integer: (action_param: 'browse_navigation_skip')) - 1, 0);
/if;

if: ($browse_skiprecords > 0) && ($found_count > 0);
	$browse_skiprecords = (math_max: (math_min: ($found_count - 1), $browse_skiprecords), 0);
/if;

var: 'link_detail' = (var: 'admin_link') +
	'&browse_databaseid=' + (var:'browse_databaseid',-encodeurl) +
	'&browse_tableid=' + (var:'browse_tableid',-encodeurl) +
	'&browse_fieldid=' + (var:'browse_fieldid',-encodeurl) +
	'&browse_sortfield=' + (var:'browse_sortfield',-encodeurl) +
	'&browse_sortorder=' + (var:'browse_sortorder',-encodeurl) +
	'&tab2=' + (if_null: $browse_tablesettings->(find: 'list_response'), 'Detail') +
	'&action=none';

// -----------
// main

if: ($browse_inline == null) ||
    ( ($browse_inline->(find: -search) == (array)) && ($browse_inline->(find: -findall) == (array)) ) ||
    ( (var_defined: 'reset_inline') && ($reset_inline == true) );
	var:'browse_inline' = (array: -findall='', -database=$browse_databasealias, -table=$browse_tablealias, -keyfield=$browse_keyfield);
/if;

var: 'list_inline' = $browse_inline;

if: ($browse_sortfield != '');
	$list_inline->(insert: (pair: '-sortfield'=$browse_sortfield));
	if: ($list_inline != '');
		$list_inline->(insert: (pair: '-sortorder'=$browse_sortorder));
	/if;
/if;

$list_inline->(insert: (pair: '-maxrecords'=$browse_maxrecords));
$list_inline->(insert: (pair: '-skiprecords'=$browse_skiprecords));

inline: $list_inline, -inlinename='browse_results';
	var:'found_count'=found_count, 'shown_first'=shown_first, 'shown_last'=shown_last, 'shown_count'=shown_count;
/inline;

if: ($browse_action >> 'Export');
	file_serve: (include: (lassoapp_link: 'browse/export.lasso')), -type='application/force-download', -file='BrowseExport_' + date->(format: '%Y%m%d%H%M%S') + '.txt';
/if;

if: (var:'found_count') == 0;

	var: 'list_link' = (var: 'admin_link') +
		'&tab2=' + $browse_referrer +
		'&browse_databaseid=' + $browse_databaseid +
		'&browse_tableid=' + $browse_tableid +
		'&browse_fieldid=' + $browse_fieldid  +
		'&err=1&err_msg=No+records+found.';
	redirect_url: $list_link;
	abort;

/if;

if: (if_null: $browse_tablesettings->(find: 'list_response'), 'Detail') >> 'No';
	var: 'link_detail' = '';
/if;

?>