<?LassoScript

//
// Variables
//


_admin_addvar: 'build_action', -default='None', -override=(action_param: 'build_action', (action_param: 'build_action', -count));
_admin_addvar: 'build_datasourceid', -default='1', -session='_browse', -override=(action_param: 'build_datasourceid');
_admin_addvar: 'build_hostid', -session='_browse', -override=(action_param: 'build_hostid');
_admin_addvar: 'build_databaseid', -session='_browse', -override=(action_param: 'build_databaseid');
_admin_addvar: 'build_tableid', -session='_browse', -override=(action_param: 'build_tableid');

_admin_addvar: 'database_name', -override=(action_param: 'database_name');
_admin_addvar: 'database_alias', -override=(action_param: 'database_alias');

_admin_addvar: 'table_name', -override=(action_param: 'table_name');
_admin_addvar: 'table_alias', -override=(action_param: 'table_alias');

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

var: 'reserved_words' = (array:
	'add','all','alter','analyze','and','as','asc','auto_increment','bdb',
	'berkeleydb','between','bigint','binary','blob','both','by','cascade',
	'case','change','char','character','column','columns','constraint',
	'create','cross','current_date','current_time','current_timestamp',
	'database','databases','day_hour','day_minute','day_second','dec',
	'decimal','default','delayed','delete','desc','describe','distinct',
	'distinctrow','double','drop','else','enclosed','escaped','exists',
	'explain','fields','float','for','foreign','from','fulltext','function',
	'grant','group','having','high_priority','hour_minute','hour_second',
	'if','ignore','in','index','infile','inner','innodb','insert','int',
	'integer','interval','into','is','join','key','keys','kill','leading',
	'left','like','limit','lines','load','lock','long','longblob','longtext',
	'low_priority','master_server_id','match','mediumblob','mediumint',
	'mediumtext','middleint','minute_second','mrg_myisam','natural','not',
	'null','numeric','on','optimize','option','optionally','or','order',
	'outer','outfile','partial','precision','primary','privileges',
	'procedure','purge','read','real','references','regexp','rename',
	'replace','require','restrict','returns','revoke','right','rlike',
	'select','set','show','smallint','soname','sql_big_result',
	'sql_calc_found_rows','sql_small_result','ssl','starting','straight_join',
	'striped','table','tables','terminated','then','tinyblob','tinyint',
	'tinytext','to','trailing','union','unique','unlock','unsigned','update',
	'usage','use','user_resources','using','values','varbinary','varchar',
	'varying','when','where','with','write','xor','year_month','zerofill');

//
// Process Action
//

null: (admin_datasourcecascade: -datasource=$build_datasourceid, -host=$build_hostid, -database=$build_databaseid, -table=$build_tableid, -nofield);

var: 'build_tabledetail' = (admin_table: -id=$build_tableid);
var: 'build_fieldmap' = $build_tabledetail->(fields: -useschema);
var: 'build_typemap' = $build_tabledetail->(types);

var: 'datasource_type' = $build_tabledetail->datasource->(find: 'name');

select: $datasource_type;
	case: 'sqliteconnector';
		loop: 10;
			$build_fieldmap->(insert: (map: 
				'id' = 'new' + loop_count,
				'name' = '',
				'type' = 'TEXT',
				'display' = '',
				'default' = '',
				'options' = (array),
			));
		/loop;
	case: 'mysqlds';
		loop: 10;
			$build_fieldmap->(insert: (map: 
				'id' = 'new' + loop_count,
				'name' = '',
				'type' = 'VARCHAR',
				'display' = '',
				'default' = '',
				'options' = (array),
			));
		/loop;
/select;

if: ($build_action >> 'Alter') || ($build_action >> 'Preview');
	
	var: 'build_error' = '';

	select: $datasource_type;
		case: 'sqliteconnector';

			var: 'sql_delete' = (array);
			var: 'sql_mapping' = (array);
			var: 'sql_fields' = (array);
			var: 'sql_names' = (array);
			var: 'needs_update' = false;
			var: 'has_primary' = false;
			
			iterate: $build_fieldmap, (var: 'temp');
			
				loop: (action_param: 'build_delete', -count);
					if: (action_param: 'build_delete', loop_count) == $temp->(find: 'id');
						$temp->(insert: 'type' = 'DELETE');
						$sql_delete->(insert: $temp->(find: 'name'));
						var: 'needs_update' = true;
					/if;
				/loop;

				if: ($temp->(find: 'type') != 'DELETE');
				
					$temp->(insert: 'options' = array); // Clear options
					iterate: (array: 'name','type','display','default','options'), (var: 'key');
						var: 'name' = 'build_' + $key + '_' + $temp->(find: 'id');
						loop: (action_param: $name, -count);
							var: 'value' = (action_param: $name, loop_count);
							if: ($key == 'name') && ($temp->(find: 'id') !>> 'new');
								$sql_mapping->(insert: $temp->(find: 'name') + ' AS ' + $value);
								$sql_names->(insert: $value);
								if: $temp->(find: 'name') != $value;
									$sql_delete->(insert: $temp->(find: 'name'));
								/if;
							/if;
							if: ($key == 'options');
								if: ($temp->(find: 'options') !>> $value);
									$temp->(find: 'options')->(insert: $value);
								/if;
							else;
								$temp->(insert: $key = $value);
							/if;
							var: 'needs_update' = true;
						/loop;
					/iterate;
					loop: (action_param: 'build_options_primarykey', -count);
						if: (action_param: 'build_options_primarykey', loop_count) == $temp->(find: 'id');
							$temp->(find: 'options')->(removeall: 'PRIMARY KEY');
							$temp->(find: 'options')->(insert: 'PRIMARY KEY');
							var: 'needs_update' = true;
						else;
							$temp->(find: 'options')->(removeall: 'PRIMARY KEY');
						/if;
					/loop;
				/if;
								
				if: ($temp->(find: 'name') != '') && ($temp->(find: 'type') != 'DELETE');
					var: 'sql' = $temp->(find: 'name');
					if: ($temp->(find: 'type') != '');
						$sql += ' ' + $temp->(find: 'type');
					/if;
					if: ($temp->(find: 'display') != '');
						$sql += ' (' + $temp->(find: 'display') + ')';
					/if;
					if: ($temp->(find: 'options')->size > 0);
						if: $temp->(find: 'options') >> 'PRIMARY KEY';
							if: ($has_primary);
								$temp->(find: 'options')->(removeall: 'PRIMARY KEY');
							else;
								var: 'has_primary' = true;
							/if;
						/if;
						if: $temp->(find: 'options')->size > 0;
							$sql += ' ' + $temp->(find: 'options')->(join: ' ');
						/if;
					/if;
					if: ($temp->(find: 'default') != '');
						$sql += ' DEFAULT "' + $temp->(find: 'default') + '"';
					/if;
					$sql->trim;
					$sql_fields->(insert: $sql);
				/if;
				
			/iterate;

			var: 'display_sql' = 'CREATE TABLE ' + $build_tabledetail->(find: 'name') + ' (\r\t' + $sql_fields->(join: ',\r\t') + '\r);';

			if: ($build_action >> 'Alter') && ($needs_update == true);
			
				if: $sql_delete->size > 0;
					inline: -log=$__startup_loglevel__,
							-database='lasso_internal', 
							-table='security_table_fields',
							-sql='DELETE FROM security_table_fields WHERE id_table="' + $build_tableid + '" AND name IN ("' + $sql_delete->(join: '","') + '")';
					/inline;
				/if;
	
				var: 'table_name' = $build_tabledetail->(find: 'name');
				var: 'database_alias' = $build_tabledetail->database->(find: 'alias');
				var: 'temp_name' = 'TEMP' + lasso_uniqueid;
				
				protect;
					inline: -database=$database_alias, -sql='BEGIN TRANSACTION';
						fail_if: (error_msg != error_noerror), error_code, error_msg;
		
						inline: -database=$database_alias, -sql='CREATE TEMPORARY TABLE ' + $temp_name + ' AS SELECT * FROM ' + $table_name;
							fail_if: (error_msg != error_noerror), error_code, error_msg;
						/inline;
			
						inline: -database=$database_alias, -sql='DROP TABLE ' + $table_name;
							fail_if: (error_msg != error_noerror), error_code, error_msg;
						/inline;
			
						inline: -database=$database_alias, -sql='CREATE TABLE ' + $table_name + ' (' + $sql_fields->(join: ', ') + ')';
							fail_if: (error_msg != error_noerror), error_code, error_msg;
						/inline;
			
						inline: -database=$database_alias, -sql='INSERT INTO ' + $table_name + ' (' + $sql_names->(join: ', ') + ') SELECT ' + $sql_mapping->(join: ', ') + ' FROM ' + $temp_name;
							fail_if: (error_msg != error_noerror), error_code, error_msg;
						/inline;
			
						inline: -database=$database_alias, -sql='DROP TABLE ' + $temp_name;
							fail_if: (error_msg != error_noerror), error_code, error_msg;
						/inline;
			
						inline: -database=$database_alias, -sql='COMMIT TRANSACTION';
							fail_if: (error_msg != error_noerror), error_code, error_msg;
						/inline;
					/inline;
					
					handle_error;
						var: 'build_error' = 'SQLite Error: ' + (error_msg) + ' (' + error_code + ')';
						inline: -database=$database_alias, -sql='ROLLBACK TRANSACTION';
							fail_if: (error_msg != error_noerror), error_code, error_msg;
						/inline;
					/handle;
				/protect;
			
				if: (var: 'build_error') == '';
					iterate: $build_fieldmap, (var: 'temp');
						if: ($temp->(find: 'id') !>> 'new') && ($temp->(find: 'name') != '') && $temp->(isa: 'admin_object');
							if: ($temp->(find: 'type') == 'delete');
								$temp->delete;
							else;
								$temp->store;
							/if;
						/if;
					/iterate;
				/if;
				
				_admin_refreshconnector: $build_datasourceid;
				_admin_refreshsecurity;

				if: (var: 'build_error') == '';
					var: 'link' = $admin_link + '&tab2=fields' +
						'&build_datasourceid=' + $build_datasourceid +
						'&build_hostid=' + $build_hostid +
						'&build_databaseid=' + $build_databaseid +
						'&build_tableid=' + $build_tableid;
					redirect_url: $link;
				/if;
				
			/if;
			
		case: 'mysqlds';
		
			var: 'sql_fields' = (array);
			var: 'needs_update' = false;
			var: 'has_primary' = false;
			var: 'has_autoinc' = false;
			var: 'sql_delete' = (array);
			
			iterate: $build_fieldmap, (var: 'temp');
				
				loop: (action_param: 'build_ignore', -count);
					if: (action_param: 'build_ignore', loop_count) == $temp->(find: 'id');
						$temp->(insert: 'type' = 'IGNORE');
					/if;
				/loop;

				loop: (action_param: 'build_delete', -count);
					if: (action_param: 'build_delete', loop_count) == $temp->(find: 'id');
						$temp->(insert: 'type' = 'DELETE');
						var: 'sql' = 'DROP `' + $temp->(find: 'name') + '`';
						$sql_fields->(insert: $sql);
						$sql_delete->(insert: $temp->(find: 'name'));
						var: 'needs_update' = true;
					/if;
				/loop;

				if: ($temp->(find: 'type') != 'DELETE') && ($temp->(find: 'type') != 'IGNORE');
				
					$temp->(insert: 'options' = array); // Clear options
					iterate: (array: 'name','type','display','default','options'), (var: 'key');
						var: 'name' = 'build_' + $key + '_' + $temp->(find: 'id');
						loop: (action_param: $name, -count);
							var: 'value' = (action_param: $name, loop_count);
							if: ($key == 'name') && ($temp->(find: 'id') !>> 'new');
								$temp->(insert: 'old_name' = $temp->(find: 'name'));
								$temp->'readonly'->(insert: 'old_name');
								$temp->'readonly'->(removeall: 'name');
								if: $temp->(find: 'name') != $value;
									$sql_delete->(insert: $temp->(find: 'name'));
								/if;
							/if;
							if: ($key == 'options');
								if: ($temp->(find: 'options') !>> $value);
									$temp->(find: 'options')->(insert: $value);
								/if;
							else;
								$temp->(insert: $key = $value);
							/if;
							var: 'needs_update' = true;
						/loop;
					/iterate;
					loop: (action_param: 'build_options_primarykey', -count);
						if: (action_param: 'build_options_primarykey', loop_count) == $temp->(find: 'id');
							$temp->(find: 'options')->(removeall: 'PRIMARY KEY');
							$temp->(find: 'options')->(insert: 'PRIMARY KEY');
							var: 'needs_update' = true;
						else;
							$temp->(find: 'options')->(removeall: 'PRIMARY KEY');
						/if;
					/loop;
				/if;
								
				if: ($temp->(find: 'name') != '') && ($temp->(find: 'type') != 'DELETE') && ($temp->(find: 'type') != 'IGNORE');

					if: $sql_delete->size > 0;
						inline: -log=$__startup_loglevel__,
								-database='lasso_internal', 
								-table='security_table_fields',
								-sql='DELETE FROM security_table_fields WHERE id_table="' + $build_tableid + '" AND name IN ("' + $sql_delete->(join: '","') + '")';
						/inline;
					/if;

					if: ($temp->(find: 'old_name') != null);
						var: 'sql' = 'CHANGE `' + $temp->(find: 'old_name') + '` `' + $temp->(find: 'name') + '`';
					else;
						var: 'sql' = 'ADD `' + $temp->(find: 'name') + '`';
					/if;

					if: ($temp->(find: 'type') != '');
						$sql += ' ' + $temp->(find: 'type');
					/if;
					if: ($temp->(find: 'type') >> 'CHAR') && ($temp->(find: 'display') == '');
						$sql += ' (255)';
					else: ($temp->(find: 'display') != '');
						$sql += ' (' + $temp->(find: 'display') + ')';
					/if;
					if: ($temp->(find: 'options')->size > 0);
						if: $temp->(find: 'options') >> 'PRIMARY KEY';
							if: ($has_primary);
								$temp->(find: 'options')->(removeall: 'PRIMARY KEY');
							else;
								var: 'has_primary' = true;
							/if;
						/if;
						if: $temp->(find: 'options') >> 'AUTO_INCREMENT';
							if: ($has_autoinc);
								$temp->(find: 'options')->(removeall: 'AUTO_INCREMENT');
							else;
								var: 'has_autoinc' = true;
							/if;
						/if;
						if: $temp->(find: 'options')->size > 0;
							$sql += ' ' + $temp->(find: 'options')->(join: ' ');
						/if;
					/if;
					if: ($temp->(find: 'default') != '');
						$sql += ' DEFAULT "' + $temp->(find: 'default') + '"';
					/if;
					$sql->trim;
					$sql_fields->(insert: $sql);
				/if;
				
			/iterate;

			if: $has_primary == true;
				$sql_fields->(insert: 'DROP PRIMARY KEY',1);
			/if;

			if: ($sql_fields->size > 0);
			
				var: 'table_name' = $build_tabledetail->(find: 'name');
				var: 'database_alias' = $build_tabledetail->database->(find: 'alias');

				var: 'display_sql' = 'ALTER TABLE `' + $table_name + '`\r\t' + $sql_fields->(join: ',\r\t');

				if: ($build_action >> 'Alter') && ($needs_update == true);
					inline: -database=$database_alias, -sql='ALTER TABLE `' + $table_name + '` ' + $sql_fields->(join: ', ');
						if: error_code != 0;
							var: 'build_error' = 'MySQL Error: ' + (error_msg) + ' (' + error_code + ')';
						/if;
					/inline;
			
					if: (var: 'build_error') == '';
						iterate: $build_fieldmap, (var: 'temp');
							if: ($temp->(find: 'id') !>> 'new') && ($temp->(find: 'name') != '') && $temp->(isa: 'admin_object');
								if: ($temp->(find: 'type') == 'delete');
									$temp->delete;
								else;
									$temp->store;
								/if;
							/if;
						/iterate;
					/if;
				
					_admin_refreshconnector: $build_datasourceid;
					_admin_refreshsecurity;

					if: (var: 'build_error') == '';
						var: 'link' = $admin_link + '&tab2=fields' +
							'&build_datasourceid=' + $build_datasourceid +
							'&build_hostid=' + $build_hostid +
							'&build_databaseid=' + $build_databaseid +
							'&build_tableid=' + $build_tableid;
						redirect_url: $link;
					/if;

				/if;
			/if;
		
		case;
		
		// Unknown Data Source Type
		
	/select;

/if;

?>