<?LassoScript

//
// Variables
//

_admin_addvar: 'build_action', -default='None', -override=(action_param: 'build_action', 1);
_admin_addvar: 'build_datasourceid', -default='1', -session='_browse', -override=(action_param: 'build_datasourceid');
_admin_addvar: 'build_hostid', -session='_browse', -override=(action_param: 'build_hostid');
_admin_addvar: 'build_databaseid', -session='_browse', -override=(action_param: 'build_databaseid');
_admin_addvar: 'build_tableid', -session='_browse', -override=(action_param: 'build_tableid');

_admin_addvar: 'database_name', -override=(action_param: 'database_name');
_admin_addvar: 'database_alias', -override=(action_param: 'database_alias');

_admin_addvar: 'table_name', -override=(action_param: 'table_name');
_admin_addvar: 'table_alias', -override=(action_param: 'table_alias');
_admin_addvar: 'table_enabled', -override=(action_param: 'table_enabled');

_admin_addvar: 'create_datasourceid', -default='1', -session='_browse', -override=(action_param: 'create_datasourceid');
_admin_addvar: 'create_hostid', -session='_browse', -override=(action_param: 'create_hostid');
_admin_addvar: 'create_databaseid', -session='_browse', -override=(action_param: 'create_databaseid');
_admin_addvar: 'create_tableid', -session='_browse', -override=(action_param: 'create_tableid');

_admin_addvar: 'create_action', -default='None', -override=(action_param: 'create_action', 1);
_admin_addvar: 'create_name', -default='New_Table', -override=(action_param: 'create_name');
_admin_addvar: 'create_alias', -override=(action_param: 'create_alias');
_admin_addvar: 'create_enabled', -override=(action_param: 'create_enabled');
_admin_addvar: 'create_type', -default='New', -override=(action_param: 'create_type');
_admin_addvar: 'create_data', -default='No', -override=(action_param: 'create_data', (action_param: 'create_data', -count));
_admin_addvar: 'create_fmpmodel', -default='No', -override=(action_param: 'create_fmpmodel', (action_param: 'create_fmpmodel', -count));
_admin_addvar: 'create_index', -default='No', -override=(action_param: 'create_index', (action_param: 'create_index', -count));

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

var: 'reserved_words' = (array:
	'add','all','alter','analyze','and','as','asc','auto_increment','bdb',
	'berkeleydb','between','bigint','binary','blob','both','by','cascade',
	'case','change','char','character','column','columns','constraint',
	'create','cross','current_date','current_time','current_timestamp',
	'database','databases','day_hour','day_minute','day_second','dec',
	'decimal','default','delayed','delete','desc','describe','distinct',
	'distinctrow','double','drop','else','enclosed','escaped','exists',
	'explain','fields','float','for','foreign','from','fulltext','function',
	'grant','group','having','high_priority','hour_minute','hour_second',
	'if','ignore','in','index','infile','inner','innodb','insert','int',
	'integer','interval','into','is','join','key','keys','kill','leading',
	'left','like','limit','lines','load','lock','long','longblob','longtext',
	'low_priority','master_server_id','match','mediumblob','mediumint',
	'mediumtext','middleint','minute_second','mrg_myisam','natural','not',
	'null','numeric','on','optimize','option','optionally','or','order',
	'outer','outfile','partial','precision','primary','privileges',
	'procedure','purge','read','real','references','regexp','rename',
	'replace','require','restrict','returns','revoke','right','rlike',
	'select','set','show','smallint','soname','sql_big_result',
	'sql_calc_found_rows','sql_small_result','ssl','starting','straight_join',
	'striped','table','tables','terminated','then','tinyblob','tinyint',
	'tinytext','to','trailing','union','unique','unlock','unsigned','update',
	'usage','use','user_resources','using','values','varbinary','varchar',
	'varying','when','where','with','write','xor','year_month','zerofill');

//
// Process Action
//

if: ($build_action >> 'Update') || ($dialog_action >> 'Delete') || ($build_action >> 'Detail');

	var: 'build_tabledetail' = (admin_table: -id=$build_tableid);

	if: ($build_action >> 'Update');
	
		$build_tabledetail->(insert: 'alias' = $table_alias);
		$build_tabledetail->(insert: 'enabled' = $table_enabled);
		$build_tabledetail->store;
	
		var: 'build_action' = 'Detail';

	else: ($dialog_action >> 'Delete');
	
		inline: -database=$build_tabledetail->database->(find: 'alias'), -sql='DROP TABLE ' + $build_tabledetail->(find: 'name');
			if: (error_currenterror) != (error_noerror);
				var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
			/if;
		/inline;
	
		_admin_deletetable: $build_tableid;
	
		var: 'build_action' = 'Refresh';

	/if;

else: $build_action >> 'Create Fields';

	var: 'link' = $admin_link + '&tab2=addfields' +
		'&build_datasourceid=' + $build_datasourceid +
		'&build_hostid=' + $build_hostid +
		'&build_databaseid=' + $build_databaseid +
		'&build_tableid=' + $build_tableid;
	redirect_url: $link;

else: $build_action >> 'List Fields';

	var: 'link' = $admin_link + '&tab2=fields' +
		'&build_datasourceid=' + $build_datasourceid +
		'&build_hostid=' + $build_hostid +
		'&build_databaseid=' + $build_databaseid +
		'&build_tableid=' + $build_tableid;
	redirect_url: $link;

else: ($build_action >> 'Create') || ($build_action >> 'Duplicate');

	if: ($create_action >> 'Create');

		protect;
			var: 'build_tableid' = (admin_database: -id=$build_databaseid)->(createtable: -name=$create_name, -enabled=$create_enabled);
			var: 'build_tabledetail' = (admin_table: -id=$build_tableid);
			var: 'build_action' = 'Detail';
			
			handle_error;
				var: 'build_error' = error_msg + ' (' + error_code + ').';
			/handle_error;
			
		/protect;
		
	else: ($create_action >> 'Duplicate');

		var: 'build_navigation' = 'last';

		// Copy Table
	
		protect;
			var: 'build_databasedetail' = (admin_database: -id=$build_databaseid);
			var: 'build_type' = $build_databasedetail->datasource->(find: 'name');
	
			var: 'create_tabledetail' = (admin_table: -id=$create_tableid);
			var: 'create_databasedetail' = $create_tabledetail->database;
	
			if: ($create_fmpmodel >> 'Y');
				var: 'new_sql' = $create_tabledetail->(sql: $build_type, $create_name, -usedata);
			else;
				var: 'new_sql' = $create_tabledetail->(sql: $build_type, $create_name);
			/if;
			
			if: $new_sql != '';
				var: 'new_id' = $build_databasedetail->(createtable: -name=$create_name, -sql=$new_sql, -enabled=$create_enabled);
				if: $create_data >> 'Yes';
					var: 'new_table' = (admin_table: $new_id);
					if: $create_databasedetail->host->(find: 'id') == $build_databasedetail->host->(find: 'id');
						$new_table->(copydata: $create_databasedetail->(find: 'name'), $create_tabledetail->(find: 'name'), -direct);
					else;
						$new_table->(copydata: $create_databasedetail->(find: 'alias'), $create_tabledetail->(find: 'alias'));
					/if;
				/if;
				var: 'build_tableid' = $new_id;
				var: 'build_tabledetail' = (admin_table: -id=$build_tableid);
				var: 'build_action' = 'Detail';
			/if;

			handle_error;
				var: 'build_error' = error_msg + ' (' + error_code + ').';
			/handle_error;
			
		/protect;

	/if;


/if;

if: ($build_action >> 'Refresh');
	_admin_refreshsecurity;
	if: ($build_action >> 'Refresh') && ($build_datasourceid != 0);
		_admin_refreshconnector: $build_datasourceid;
	/if;
/if;

?>
