<?LassoScript

	//
	// Custom Tags
	//
	library: (lassoapp_link: 'tags.lasso');
	library: (lassoapp_link: 'tags2.lasso');

	//
	// Cache Control
	//
	_admin_nocache;
	
	//
	// Session
	//
	
	if: (action_param:'logout') == 'true';
		session_end: -name='_browse';
		redirect_url: lassoapp_link('logout.lasso');
	else;
		session_start: -name='_browse', -expires=1440, -usecookie;
		
		_admin_addvar: -session='_browse', -name='admin_datetime', -default=(string: date);
		_admin_addvar: -session='_browse', -name='admin_increment', -default='123453';
		_admin_addvar: -session='_browse', -name='admin_username', -override=(client_username), -default='';
		_admin_addvar: -session='_browse', -name='admin_ipaddress', -default=(string: _client_address_old);
		_admin_addvar: -session='_browse', -name='admin_usertype', -default='none';
	/if;
		
	var: 'admin_increment' = (integer: $admin_increment) + 3;
	
	//
	// Tab Arrays
	//
	
	var: 'admin_tab_disabled1' = (array);
	var: 'admin_tab_disabled2' = (array);
	var: 'admin_tab_disabled3' = (array);
	
		Variable: 'admin_tab_array1' = (Array:
			'sql'='SQL',
			'browse'='Browse',
			'build'='Build',
		);
		Variable: 'admin_tab_array2' = (Array:
			'browse'=(Array:
				'search'='Search',
				'add'='Add',
				'list'='List',
				'detail'='Detail',
				'update'='Update',
				'import'='Import',
				'export'='Export',
			),
			'sql'=(Array:
				'statement'='Statement',
			),
			'build'=(Array:
				'databases'='Databases',
				'tables'='Tables',
				'fields'='Fields',
				'addfields'='Create Fields',
				'indices'='Indices',
			),
		);
		Variable: 'admin_tab_array3' = (Array);

	// Current Tab
	
	Variable: 'admin_tab1' = (action_param: 'tab1', (action_param: 'tab1', -count));
	Variable: 'admin_tab2' = (action_param: 'tab2', (action_param: 'tab2', -count));
	Variable: 'admin_tab3' = (action_param: 'tab3', (action_param: 'tab3', -count));


	// Title
	
	var: 'admin_title' = 'Lasso Site (' + site_name + ' ' + site_id + ') Database Browser ' + (lasso_version: -lassoversion)->(substring: 1, (lasso_version: -lassoversion)->(find: ' ') - 1);;
	var: 'temp' = (_admin_array_find: $admin_tab_array1, $admin_tab1);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;

		var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2);
		if: ($temp != '') && ($temp != 'None');
			$admin_title += ' : ' + $temp;

			var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3);
			if: ($temp != '') && ($temp != 'None');
				$admin_title += ' : ' + $temp;
			/if;
		/if;
	/if;
	
	if: (var_defined:'admin_file')==false;
		var:'admin_file'=(LassoApp_Link:'default.lasso');
	/if;
	
	if:(var_defined:'dialog_file')==false;
		var:'dialog_file'=(LassoApp_Link: 'dialog.lasso');
	/if;

	var: 'admin_link' = $admin_file +
		'?tab1=' + $admin_tab1 +
		'&tab2=' + $admin_tab2 +
		'&tab3=' + $admin_tab3 +
		'&-session=_browse:' + (session_id: -name='_browse') +
		'&increment=' + $admin_increment;

	var: 'wide_stripe' = '#bfbfbf';
	var: 'color_beta' = '#bfbfbf';
	var: 'color_alpha' = '#cccccc';
	
	// Date Format
	Date_SetFormat: '%Q %T';

?>
