<?LassoScript
	encode_set: -encodenone;

	content_type: 'text/plain';

	define_tag: 'encode_export', -required='input';
		local: 'output' = (encode_sql: #input);
		#output >> '\r'; #output->(replace: '\r', '\\r');
		#output >> '\n'; #output->(replace: '\n', '\\n');
		#output >> '\t'; #output->(replace: '\t', '\\t');
		#output >> '\0'; #output->(replace: '\0', '\\0');
		return: @#output;
	/define_tag;

	if: $query_exportlines >> 'mac';
		var: 'lineend' = '\r';
	else: $query_exportlines >> 'win';
		var: 'lineend' = '\r\n';
	else;
		var: 'lineend' = '\n';
	/if;

	inline: -log=$__startup_loglevel__, -database=$query_databasealias, -sql=$query_sql, -maxrecords='all';
		var: 'fields' = field_names;
		var: 'fieldcount' = $fields->size;
		if: $query_exportformat >> 'comma';
			if: $query_exportfields >> 'y';
				iterate: $fields, (var: 'field');
					'"'; 
					encode_export: $field; 
					'"';
					(loop_count != $fieldcount) ? ',';
				/iterate;
				$lineend;
			/if;
			iterate: records_array, (var: 'record');
				iterate: $record, (var: 'field');
					'"'; 
					encode_export: $field; 
					'"';
					(loop_count != $fieldcount) ? ',';
				/iterate;
				$lineend;
			/iterate;
		else: $query_exportformat >> 'tab';
			if: $query_exportfields >> 'y';
				iterate: $fields, (var: 'field');
					encode_export: $field; 
					(loop_count != $fieldcount) ? '\t';
				/iterate;
				$lineend;
			/if;
			iterate: records_array, (var: 'record');
				iterate: $record, (var: 'field');
					encode_export: $field;
					(loop_count != $fieldcount) ? '\t';
				/iterate;
				$lineend;
			/iterate;
		else: $query_exportformat >> 'sql';
			iterate: records_array, (var: 'record');
				'INSERT INTO `' + (encode_sql: $query_tabledetail->(find: 'name')) + '` ';
				if: $query_exportfields >> 'y';
					'(';
					iterate: $fields, (var: 'field');
						'`'; 
						encode_export: $field; 
						'`';
						(loop_count != $fieldcount) ? ',';
					/iterate;
					') ';
				/if;
				'VALUES (';
				iterate: $record, (var: 'field');
					if: $field === null;
						'NULL';
					else;
						'"'; 
						encode_export: $field; 
						'"';
					/if;
					(loop_count != $fieldcount) ? ',';
				/iterate;
				');';
				$lineend;
			/iterate;
		else: $query_exportformat >> 'xml';
			'<?xml version="1.0" encoding="UTF-8"?';
			$lineend;
			'<root>';
			$lineend;
			iterate: records_array, (var: 'record');
				'\t<record>';
				$lineend;
				if: $query_exportfields >> 'y';
					iterate: $record, (var: 'field');
						'\t\t<' + (encode_xml: $fields->(get: loop_count)) + '>';
						encode_xml: encode_export: $field; 
						'</' + (encode_xml: $fields->(get: loop_count)) + '>';
						$lineend;
					/iterate;
				else;
					iterate: $record, (var: 'field');
						'\t\t<field name="' + (encode_xml: $fields->(get: loop_count)) + '">';
						encode_xml: encode_export: $field; 
						'</field>';
						$lineend;
					/iterate;
				/if;
				'\t</record>';
				$lineend;
			/iterate;
			'</root>';
			$lineend;
		/if;
	/inline;

	/encode_set;
?>