<?LassoScript

	//
	// Custom Tags
	//
	library: (lassoapp_link: 'tags.lasso');

	//
	// Cache Control
	//
	_admin_nocache;
	
	//
	// Session
	//
	
	if: (action_param:'logout') == 'true';
		session_end: -name='_groupadmin';
		redirect_url: lassoapp_link('logout.lasso');
	else;
		session_start: -name='_groupadmin', -expires=1440, -usecookie;

		_admin_addvar: -session='_groupadmin', -name='admin_datetime', -default=(string: date);
		_admin_addvar: -session='_groupadmin', -name='admin_increment', -default='123453';
		_admin_addvar: -session='_groupadmin', -name='admin_username', -override=(client_username), -default='';
		_admin_addvar: -session='_groupadmin', -name='admin_ipaddress', -default=(string: _client_address_old);
		_admin_addvar: -session='_groupadmin', -name='admin_usertype', -default='none';
	/if;
		
	var: 'admin_increment' = (integer: $admin_increment) + 3;
	
	//
	// Tab Arrays
	//
	
	var: 'admin_tab_disabled1' = (array);
	var: 'admin_tab_disabled2' = (array);
	var: 'admin_tab_disabled3' = (array);
	
		Variable: 'admin_tab_array1' = (Array:
			'setup'='Group Administration',
		);
		Variable: 'admin_tab_array2' = (Array:
			'setup'=(Array:
				'users'='Users',
				'adduser'='Add User',
			),
		);
		Variable: 'admin_tab_array3' = (Array);

	// Current Tab
	
	Variable: 'admin_tab1' = (action_param: 'tab1', (action_param: 'tab1', -count));
	Variable: 'admin_tab2' = (action_param: 'tab2', (action_param: 'tab2', -count));
	Variable: 'admin_tab3' = (action_param: 'tab3', (action_param: 'tab3', -count));


	// Title
	
	var: 'admin_title' = 'Lasso Group Admin Site (' + site_name + ' ' + site_id + ')';
	var: 'temp' = (_admin_array_find: $admin_tab_array1, $admin_tab1);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;

		var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2);
		if: ($temp != '') && ($temp != 'None');
			$admin_title += ' : ' + $temp;

			var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3);
			if: ($temp != '') && ($temp != 'None');
				$admin_title += ' : ' + $temp;
			/if;
		/if;
	/if;
	
	if: (var_defined:'admin_file')==false;
		var:'admin_file'=(LassoApp_Link:'default.lasso');
	/if;
	
	var: 'admin_link' = $admin_file +
		'?tab1=' + $admin_tab1 +
		'&tab2=' + $admin_tab2 +
		'&tab3=' + $admin_tab3 +
		'&-session=_browse:' + (session_id: -name='_browse') +
		'&increment=' + $admin_increment;

	var: 'wide_stripe' = '#bfbfbf';
	var: 'color_beta' = '#bfbfbf';
	var: 'color_alpha' = '#cccccc';

	// Date Format
	Date_SetFormat: '%Q %T';

?>
