<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN" "http://www.w3.org/TR/html4/strict.dtd">
<?LassoScript

	if: !(global_defined: '__startup_loglevel__');
		global: '__startup_loglevel__' = 'none';
	/if;

	var: 'security_token' = 'admin';

	auth_admin: -NoResponse;

	include: (lassoapp_link: 'library.lasso');
	_admin_nocache;
	
	var: 'response_filepath'=(response_filepath);

	var: 'client_getargs' = (string_replaceregexp: (string: (decode_url: client_getargs)), -find='[, \t]+', -replace=' ');
	var: 'client_getparams' = array;
	
	if: ($client_getargs !>> '&') || ($client_getargs !>> '=');
		var: 'client_getparams' = $client_getargs->(split: ' ');
		iterate: $client_getparams, (var: 'param');
			if: ($param >> '/') && !$param->(beginswith: '[') && !$param->(beginswith: '-') && !$param->(beginswith: '/');
				var: 'tabs' = $param->(split: '/');
				if: $tabs->size == 2;
					var: 'admin_tab1' = $tabs->first;
					var: 'admin_tab2' = $tabs->second;
					$client_getparams->(remove: loop_count);
					loop_abort;
				/if;
			/if;
		/iterate;
	/if;
?>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" >
	<head>
		<title>Lasso Reference</title>
		<meta name="Publisher" content="LassoSoft Inc." />
		<style>[include: (lassoapp_link: 'default_css.lasso')]</style>
		<script type="text/javascript" language="JavaScript">[noprocess]
			function toggleDisplayBlock(idOf,idArrow)
			{
				var element = document.getElementById(idOf);
				if (element != undefined)
				{
					if (element.style.display == 'none')
						element.style.display = 'block'; 
					else
						element.style.display = 'none'; 
					var arrow = document.getElementById(idArrow);
					if (arrow != undefined)
						if (element.style.display == 'none')
							arrow.innerHTML = '&#x25ba;';
						else
							arrow.innerHTML = '&#x25bc;';
					var toggle = document.getElementById('toggle');
					if (toggle != undefined)
						if (toggle.value == 'NaN')
							toggle.value = '';
						if (element.style.display == 'none')
							toggle.value += ('' + idOf + ' ');
						else
							toggle.value -= ('' + idOf);
				}
			}
		[/noprocess]</script>

	<?LassoScript

		var: 'library_errors' = '';
		
		// This variable holds the default tab for each section
		_admin_addvar: -name='admin_memory', -session='_reference', -default=(map);

		// Library One

		If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_memory->(find: '_root');
		/If;
		If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_tab_array1->(get:1)->first;
		/If;
		$admin_memory->(insert: '_root' = $admin_tab1);

		Protect;
			Error_SetErrorCode: 0;
			Error_SetErrorMessage: '';
			Include: (lassoapp_link: (string:  $admin_tab1 + '/library.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				$library_errors += (_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')');
			/Handle;
		/Protect;

		// Library Two

		If: ($admin_tab2 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2) == 'None';
			variable: 'admin_tab2' = $admin_memory->(find: $admin_tab1);
		/If;
		If: ($admin_tab2 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2) == 'None';
			variable: 'admin_tab2' = (_admin_array_find: $admin_tab_array2, $admin_tab1)->(get:1)->first;
		/If;
		$admin_memory->(insert: $admin_tab1 = $admin_tab2);
		Protect;
			Error_SetErrorCode: 0;
			Error_SetErrorMessage: '';
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/library.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				$library_errors += (_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')');
			/Handle;
		/Protect;

		// Reset admin_link based on actual tab visited

		var: 'admin_link' = $admin_file +
			'?' + $admin_tab1+'/'+ $admin_tab2;
	?>
	</head>

	<body>
		<div class="header">
			<div class="header_tab1" align="center">
				<img class="graphic_left" src="[lassoapp_link:'images/logo_left.jpg']" alt="" width="144" height="36" />
				<a href="http://www.lassosoft.com" target="_new"><img class="graphic_right" src="[lassoapp_link:'images/logo_right.jpg']" alt="" width="144" height="36" border=0 /></a>[loop: $admin_tab_array1->size][var: 'temp' = $admin_tab_array1->(get: loop_count)]
				<a href="[Response_FilePath]?[encode_url: $temp->First]/default" class="tab1[If: $temp->First == $admin_tab1] active1[/If]"><img class="corner_left1" src="[lassoapp_link:'images/corner_ffffff_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab1">[encode_html: $temp->Second]</span><img class="corner_right1" src="[lassoapp_link:'images/corner_ffffff_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[Variable: 'temp_array' = (_admin_array_find: $admin_tab_array2, $admin_tab1)]
			<div class="header_tab2"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b>[loop: $temp_array->size][var: 'temp' = $temp_array->(get: loop_count)]
				<a href="[Response_FilePath]?[encode_url: $admin_tab1]/[encode_url: $temp->First]" class="tab2[If: $temp->First == $admin_tab2] active2[/If]"><img class="corner_left2" src="[lassoapp_link:'images/corner_999999_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab2">[encode_html: $temp->Second]</span><img class="corner_right2" src="[lassoapp_link:'images/corner_999999_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[if: $admin_tab_array3->size > 0]
[Variable: 'temp_array' = (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2)]
			<div class="header_tab3">[loop: $temp_array->size][var: 'temp' = $temp_array->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $admin_tab1]&tab2=[encode_url: $admin_tab2]&tab3=[encode_url: $temp->First]" class="tab3[If: $temp->First == $admin_tab3] active3[/If]"><img class="corner_left3" src="[lassoapp_link:'images/corner_cccccc_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab3">[encode_html: $temp->Second]</span><img class="corner_right3" src="[lassoapp_link:'images/corner_cccccc_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[/if]
		</div>

		<div class="body">
	<?LassoScript

		var: 'library_errors', -encodenone;

		var: 'houston' = false;
		
		inline: -log=$__startup_loglevel__, $ref_tag_inline, -maxrecords=1, -uselimit, -findall;
			var: 'houston' = (found_count == 0);
		/inline;

		if: $houston;
		
			'<div class="content_top">';
			'<h2>Lasso Reference Database Not Found</h2>';
			'<p>The Lasso Reference database was not found in this site (' + site_name + ' ' + site_id + ').</p>';
			'<p>Please visit the Lasso Reference on a site that has this database installed.</p>';
			'<p>Or, visit the hosted version of the <a href="http://reference.lassosoft.com">Lasso Reference</a>.</p>';
			'</div>';
		
		else;
		
		// Default One

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Default Two

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Default Three

	if: $admin_tab_array3->size > 0;		
		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/' + $admin_tab3 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;
	/if;
	
	/if;
	?>
			<div style="height: 54px;">&nbsp;</div>
		</div>

		<div class="footer">
			<div class="frame_footer">
				<div class="frame_inner">
					<span style="float: left"><a href="[var: 'admin_link']&action=refresh"><b>Refresh</b></a></span>
					<span style="float: right"><a href="[response_filepath]?logout=true"><b>Logout</b></a></span>
					Site [site_name] ([site_id]) &#149; User [Var: 'admin_username'] &#149; [date->format('%-m/%-d/%y %-T')]
				</div>
				<b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b>
			</div>
			&copy; 1996[if: date->year > 1996]-[date->year][/if] LassoSoft Inc.
		</div>
		
	</body>
</html>

<?LassoScript

handle: (Error_Code == 0);
	if: (var_defined: 'admin_title') || (var_defined: 'admin_meta');
		var: 'temp_title' = (var_defined: 'admin_title') ? ((encode_html: $admin_title) + ' - Lasso Reference') | 'Lasso Reference';
		var: 'temp_meta' = (var_defined: 'admin_meta') ? '\r' + $admin_meta + '\r' | '';
		$__html_reply__->(replace: '<title>Lasso Reference</title>', '<title>' + $temp_title + '</title>' + $temp_meta);
	/if;
	$__html_reply__->trim;
/handle;

?>

<?LassoScript
	content_body->trim;
?>