<?LassoScript

	//
	// Custom Tags
	//
	include: (lassoapp_link: 'tags.lasso');

	//
	// Session
	//
	protect;
		if: (action_param:'logout') == 'true';
			session_end: -name='_reference';
			redirect_url: (lassoapp_link: 'logout.lasso');
		else;
			session_start: -name='_reference', -expires=1440, -usecookie;
	
			_admin_addvar: -session='_reference', -name='admin_datetime', -default=(string: date);
			_admin_addvar: -session='_reference', -name='admin_increment', -default='123453';
			_admin_addvar: -session='_reference', -name='admin_username', -override=(client_username), -default='';
			_admin_addvar: -session='_reference', -name='admin_ipaddress', -default=(string: _client_address_old);
			_admin_addvar: -session='_reference', -name='admin_usertype', -default='none';
		/if;
	/protect;
	
	var: 'admin_increment' = (integer: $admin_increment) + 3;

	//
	// Variables
	//
	
	if:(var_defined:'admin_file')==false;
		var:'admin_file'=(LassoApp_Link: 'default.lasso');
		$admin_file->(replace: '.0.', '.');
		$admin_file->(replace: 'reference', 'Reference');
		$admin_file->(replace: 'lassoapp', 'LassoApp');
	/if;
	
	if:(var_defined:'admin_pane')==false;
		var:'admin_pane'=(LassoApp_Link: 'default.lasso');
	/if;
	
	var: 'arrow_graphic'=(LassoApp_Link: 'images/arrow.gif');

	//
	// Tab Arrays
	//

	var: 'admin_tab_disabled1' = (array);
	var: 'admin_tab_disabled2' = (array);
	var: 'admin_tab_disabled3' = (array);

		Variable: 'admin_tab_array1' = (Array:
				'lassoscript'='LassoScript',
				'utility'='Utility',
		);
		Variable: 'admin_tab_array2' = (Array:
			'lassoscript'=(Array:
				'basics'='Basics',
				'browse'='Browse',
				'detail'='Detail',
			),
			'utility'=(Array:
				'regexp'='Regular Expression',
				'xpath'='XML XPath',
				'codetable'='Unicode Code Table',
				'character'='Unicode Character',
			),
		);
		Variable: 'admin_tab_array3' = (Array);

	// Current Tab

	Variable: 'admin_tab1' = (action_param: 'tab1', (action_param: 'tab1', -count));
	Variable: 'admin_tab2' = (action_param: 'tab2', (action_param: 'tab2', -count));
	Variable: 'admin_tab3' = (action_param: 'tab3', (action_param: 'tab3', -count));

	if: $admin_tab1 == 'lassocript' && $admin_tab2 == '';
		var: 'admin_tab2' = 'browse';
	/if;

	var: 'admin_link' = $admin_file + '?' + $admin_tab1 + '/' + $admin_tab2;

	//
	// Define Global Variables
	//
	
	var: 'ref_tag_inline'=(array:-Database='LDML8_Reference',-Layout='Tags',-KeyField='id');
	var: 'ref_param_inline'=(array:-Database='LDML8_Reference',-Layout='Parameters',-KeyField='id');
	var: 'ref_example_inline'=(array:-Database='LDML8_Reference',-Layout='Examples',-KeyField='id');
	var: 'ref_join_inline'=(array:-Database='LDML8_Reference',-Layout='RelatedTags',-KeyField='id');


	//
	// Define Standard Lists
	//

	session_addvar: -name='_reference', 'admin_category_list';
	session_addvar: -name='_reference', 'admin_legacy_list';
	
	if: !(var_defined: 'admin_category_list') || ((var: 'admin_category_list')->type != 'array') || ((var: 'admin_category_list')->size <= 0);
		var: 'admin_category_list' = (array);
		inline: -log=$__startup_loglevel__, $ref_tag_inline, -Search, -Distinct, 'tag_display'='Y', 'tag_basic'='Y', -ReturnField='tag_category', -SortField='tag_category', -MaxRecords='all';
			records;
				var: 'temp' = (string: field: 'tag_category');
				$temp->trim;
				$admin_category_list->(insert: $temp);
			/records;
		/inline;
	/if;
	
	if: !(var_defined: 'admin_legacy_list') || ((var: 'admin_legacy_list')->type != 'array') || ((var: 'admin_legacy_list')->size <= 0);
		var: 'admin_legacy_list' = (array);
		inline: -log=$__startup_loglevel__, $ref_tag_inline, -Search, -Distinct, 'tag_display'='Y', 'tag_basic'='N', -ReturnField='tag_category', -SortField='tag_category', -MaxRecords='all';
			records;
				var: 'temp' = (string: field: 'tag_category');
				$temp->trim;
				$admin_legacy_list->(insert: $temp);
			/records;
		/inline;
	/if;

	// Date Format
	Date_SetFormat: '%Q %T';

?>
