<?LassoScript

	define_tag: '_debug', -priority='replace';
		local: 'output' = '<p style="text-align: center; font-size: 1; color: red; font-family: Verdana;">';
		#output += 'An error has occurred processing Reference.LassoApp:<br />';
		#output += '<b>' + params->(join: ' ') + '</b><br />';
		#output += 'Details: ' + lasso_version + ', ' + date + ', ' + (var: 'admin_tab1') + ' ' + (var: 'admin_tab2') +  ' ' + (var: 'admin_tab3') + '<br />';
		#output += 'Please report this complete error to <a href="mailto:bugs@lassosoft.com">bugs@lassosoft.com</a>.';
		#output += '</p>';
		return: @#output;
	/define_tag;

	define_tag: 'encode_taglink', -required='value', -required='id';
		local: 'output' = #value;
		#output = (string_replaceregexp: #output, -find=' ?\\.\\.\\..*', -replace='');
		(#output >> ' ') || #output->(beginswith: '-') ? return: #id;
		#output->(replace: '%', '%25');
		#output->(replace: '&', '%26');
		#output->(replace: '+', '%2b');
		#output->(replace: '=', '%3d');
		#output->(replace: '?', '%3f');
		return: @#output;
	/define_tag;
	
	//[Include_Safe] performs an include without returning a no records found error.
	define_tag: 'include_safe';
		protect;
			return: (include: (params)->(get:1));
		/protect;
	/define_tag;
	
	define_tag: '_admin_nocache';
		$__http_header__ += 'Expires: Mon, 26 Jul 1997 05:00:00 GMT\r\n';
		$__http_header__ += 'Last-Modified: ' + (Date_LocaltoGMT: date )->(format:'%a, %d %m %Y %H:%M:%S') + ' GMT\r\n';
		$__http_header__ += 'Cache-Control: no-store, no-cache, must-revalidate\r\n';
		$__http_header__ += 'Cache-Control: post-check=0, pre-check=0\r\n';
		$__http_header__ += 'Pragma: no-cache\r\n';
	/define_tag;
	
	define_tag: '_admin_array_find', -required='array', -required='pattern', -priority='replace';
		if: !(#array->(isa: 'array'));
			return: 'None';
		/if;
		protect;
			return: #array->(find: #pattern)->(get:1)->second;
	/protect;
		if: (#pattern == 0);
			return: 'None';
		/if;
		return: (string: #pattern);
	/define_tag;
	
	define_tag: '_admin_addvar', -required='name', -optional='default', -optional='session', -optional='override', -optional='force', -priority='replace';
		if: ((var_defined: #name) == false) || ((var: #name) == null);
			var: #name = '';
		/if;
		if: (local_defined: 'force');
			var: #name = #force;
		else: (local_defined: 'override') && (#override != '');
			var: #name = #override;
		else: (local_defined: 'default') && ((var: #name) == '') && (#default != '');
			var: #name = #default;
		/if;
		if: (local_defined: 'session') && (#session != '');
			session_addvar: -name=#session, #name;
		/if;
	/define_tag;
	
	define_tag: 'variable_default';
		precondition: (params)->(size) > 0;
		precondition: (params)->(get:1)->(type) == 'string';
		if: !(var_defined: (params)->(get:1)) || ((var: (params->(get:1))) == Null);
			var: (params)->(get:1) = '';
		/if;
		if: ((var: (params->(get:1))) == '') && ((params)->(size) > 1);
			loop: -loopfrom=2, -loopto=(params)->(size);
				local: 'temp'=(params)->(get:loop_count);
				if: #temp!=null && #temp!='';
					var: (params)->(get:1) = #temp;
				/if;
			/loop;
		/if;
	/define_tag;
	
	define_tag: 'code_highlight';
		precondition: (params)->(size) == 2;
		local: 'output'=(params)->(get:1);
	//	#output->(replace: '&nbsp;', ' ');
		local: 'tag'=(params)->(get:2);
		if: #tag->(beginswith:'-');
			#output = (string_replaceregexp: #output, -search='(' + #tag + ')(\\W)', -replace='<b>\\1</b>\\2', -ignorecase);
		else: #tag >> '->';
			local: 'index'=#tag->(find: '->');
			local: 'index2'=#tag->(find: ']');
			#tag = #tag->(substring: (#index + 2), (#index2 - #index - 2));
			#output = (string_replaceregexp: #output, -search='([>\\(;])(' + #tag + ')([:\\]\\)])', -replace='\\1<b>\\2</b>\\3', -ignorecase);
		else: #tag->(beginswith:'[');
			local: 'index'=#tag->(find: '[');
			local: 'index2'=#tag->(find: ']');
			#tag = #tag->(substring: (#index + 1), (#index2 - #index - 1));
			#output = (string_replaceregexp: #output, -search='(' + #tag + ')([:\\]\\)])', -replace='<b>\\1</b>\\2', -ignorecase);
			#output = (string_replaceregexp: #output, -search='(/' + #tag + ')([:\\]\\)])', -replace='<b>\\1</b>\\2', -ignorecase);
		/if;
	
		#output = (string_replaceregexp: #output, -search='\\r\\n|\\r|\\n', -replace='<br>', -ignorecase);	
		#output = (string_replaceregexp: #output, -search='<\\?LassoScript', -replace='&lt;?LassoScript', -ignorecase);
		#output = (string_replaceregexp: #output, -search='<(/?a|/?form)', -replace='&lt;\\1', -ignorecase);
		
		// Also fix breaking problems in supported browsers.
		#output = (string_replaceregexp: #output, -search='(\\-[a-zA-Z]+)', -replace='<wbr><nobr>\\1</nobr>');
	
		return: #output;
	/define_tag;
	
	define_tag: 'example_search';
		precondition: (params)->(size) == 1;
		local: 'output'=(params)->(get:1);
		#output = (string_replace: -find=' ', -replace='&nbsp;', #output);
		#output = (string_replace: -find='<', -replace='&lt;', #output);
		#output = (string_replace: -find='>', -replace='&gt;', #output);
		return: #output;
	/define_tag;
	
	define_tag: 'list_cleanup', -required='input';
		local: 'output'=#input;
	
		if: #output >> '...';
			local: 'index'=#output->(find: '...');
			#output = #output->(substring: (1), (#index + 2));
		/if;
	
		return: #output;
	/define_tag;
	
	define_tag: 'status_cleanup', -required='input';
		local: 'output'=#input;
	
	/*	local: 'array' = #output->(split: ',');
		if: #array->size > 1;
			loop: #array->size, -by=2;
				if: loop_count == 1;
					#output = (#array->(get: 1)->trim &) + ', ' + (#array->(get: 2)->trim &);
				else: #array->size > loop_count;
					#output += ',<br>' + (#array->(get: loop_count)->trim &) ;
					if: #array->size > loop_count;
						#output += ', ' + (#array->(get: loop_count + 1)->trim &);
					/if;
				/if;
			/loop;
		/if;
	*/
		#output = (string_replace: #output, -find=',', -replace=', ');
		#output = (string_replace: #output, -find='MySQL', -replace='Lasso MySQL');
		#output = (string_replace: #output, -find='FMP', -replace='FileMaker Pro');
		#output = (string_replaceregexp: #output, -find='LDML(\\w)(\\w)', -replace='Lasso&nbsp;\\1.\\2');
	
		return: @#output;
	/define_tag;

	define_tag: 'language_cleanup', -required='input';
		local: 'array' = #input->(split: ',');
		local: 'size' = #array->size;
		loop: -from=#size-1, -to=2, -by=-1;
			#array->(remove: loop_count);
		/loop;
		local: 'output'=#array->(join: ' ... ');
		#output = (string_replaceregexp: #output, -find='LDML(\\w)(\\w)', -replace='Lasso&nbsp;\\1.\\2');
		return: @#output;
	/define_tag;
	
	define_tag: 'short_cleanup';
		precondition: (params)->(size) == 2;
		local: 'output'=(string: (params)->(get:1));
		local: 'size'=(integer: (params)->(get:2));
	
		if: #output >> '...';
			local: 'index'=#output->(find: '...');
			#output = #output->(substring: (1), (#index + 2));
		/if;
	
		if: #output->length < #size;
			return: #output;
		/if;
	
		#output = #output->(substring:0,(#size - 3));
		if: (#output->(endswith: '...'));
			return: #output;
		else: (#output->(endswith: '..'));
			return: #output + '.';
		else: (#output->(endswith: '.'));
			return: #output + '..';
		else;
			return: #output + '...';
		/if;
	/define_tag;
	
	define_tag: 'wrap', -required='input', -required='wrap', -priority='replace';

		local: '_input'=(string: #input);
		local: '_wrap'=(integer: #wrap);
		local: '_margin'=(math_min: 10, (integer: (#wrap / 4.0)));
	
		if: #_input->length < #_wrap;
			return: #_input;
		/if;
	
		#_input->(replace: '\r\n', '\r');
		#_input->(replace: '\n', '\r');
		#_input->(replace: '<br>', '\r');
		#_input->(replace: '&nbsp;', ' ');
		local: '_lines' = #_input->(split: '\r');
	
		local: '_pattern' = '.{0,' + (#_wrap - #_margin) + '}[^\\r\\n\\t&; ]{0,' + (#_margin) + '}';
		
		loop: -from=#_lines->size, -to=1, -by=-1;
			if: #_lines->(get: loop_count)->size > #_wrap;
				local: '_split' = (string_findregexp: #_lines->(get: loop_count), -find=#_pattern);
				if: (#_split->size > 1);
					loop: #_split->size;
						if: (#_split->(get: loop_count)->(get:1) == ';') && (loop_count > 1);
							#_split->(get: loop_count) = #_split->(get: loop_count)->(substring: 2);
							#_split->(get: loop_count - 1) += ';';
						else: (#_split->(get: loop_count)->(get: #_split->(get: loop_count)->size) == '&') && (loop_count < #_split->size);
							#_split->(get: loop_count) = #_split->(get: loop_count)->(substring: 0, #_split->(get: loop_count)->size);
							#_split->(get: loop_count + 1) = '&' + #_split->(get: loop_count + 1);
						/if;
					/loop;
					#_lines->(remove: loop_count);
					#_lines->(merge: #_split, loop_count);
				/if;
			/if;
		/loop;

		local: '_output' = #_lines->(join: '\r');
	
		#_output->(removetrailing: '\r');
	
		return: #_output;
	/define_tag;

?>
