<?LassoScript

	define_tag: 'example_hex', -required='int', -optional='size';
		local: 'temp' = (integer: #int);
		#temp->(setformat: -hexadecimal=true);
		local: 'temp' = (string_uppercase: (string: #temp) - '0x');
		if: (local_defined: 'size') && (#temp->size < #size);
			#temp = ('0' * (#size - #temp->size)) + #temp;
		/if;
		return: @#temp;
	/define_tag;

	define_tag: 'example_bitformat', -required='data';
		if: #data->(isa: 'bytes');
			local: 'input' = @#data;
		else: #data->(isa: 'integer');
			local: 'input' = bytes->(import64bits: #data) &;
		else;
			local: 'input' = bytes->(importstring: (string: #data)) &;
		/if;
		local: 'output' = '';
		local: 'size' = #input->size;
		local: 'string' = '';
		local: 'numeric' = '';
		iterate: #input, (local: 'integer');
	
			loop: 8;
				#output += (#integer->(bittest: 9 - loop_count) ? '1' | '0');
			/loop;
			#output += ' ';
	
			#numeric += #integer->(setformat: -padding=3) & + ' ';
	
			if: ((#integer >= 32) && (#integer <= 126));
				#string += bytes->(import8bits: #integer) & + '  ';
			else: #integer == 9;
				#string += '\\t ';
			else: #integer == 10;
				#string += '\\n ';
			else: #integer == 11;
				#string += '\\v ';
			else: #integer == 12;
				#string += '\\f ';
			else: #integer == 13;
				#string += '\\r ';
			else;
				#integer->(setformat: -hexadecimal=true);
				#string += (#integer < 16 ? '0' | '') + (string_uppercase: (#integer - '0x')) + ' ';
			/if;
	
			if: (#size == loop_count) && (#size % 4 != 0);
				#output += '         ' * (4 - #size % 4);
				#numeric += '    ' * (4 - #size % 4);
				#string += '   ' * (4 - #size % 4);
			/if;
	
			if: (loop_count % 4 == 0) || (#size == loop_count);
				#output += '| ' + #numeric + '| ' + #string + '|\n';
				local: 'string' = '';
				local: 'numeric' = '';
			/if;
	
		/iterate;
		return: @#output;
	/define_tag;

	var: 'unicode_codetable_array' = (array:
		(array: 'Basic Latin', 					0x0000, 0x0080),
		(array: 'Latin-1 Supplement', 			0x0080, 0x0100),
		(array: 'Latin Extended-A', 			0x0100, 0x0180),
		(array: 'Latin Extended-B', 			0x0180, 0x0250),
		(array: 'IPA Extensions', 				0x0250, 0x02B0),
		(array: 'Spacing Modifier Letters',		0x02B0, 0x0300),
		(array: 'Combining Diacritical Marks', 	0x0300, 0x0370),
		(array: 'Greek and Coptic', 			0x0370, 0x0400),
		(array: 'Cyrillic', 					0x0400, 0x0500),
		(array: 'Cyrillic Supplement', 			0x0500, 0x0530),
		(array: 'Armenian',  					0x0530, 0x0590),
		(array: 'Hebrew',  						0x0590, 0x0600),
		(array: 'Arabic',  						0x0600, 0x0700),
		(array: 'Syriac',  						0x0700, 0x0780),
		(array: 'Thaana',  						0x0780, 0x0900),
		(array: 'Devanagari',  					0x0900, 0x0980),
		(array: 'Bengali',  					0x0980, 0x0A00),
		(array: 'Gurmukhi',  					0x0A00, 0x0A80),
		(array: 'Gujarati',  					0x0A80, 0x0B00),
		(array: 'Oriya',  						0x0B00, 0x0B80),
		(array: 'Tamil',  						0x0B80, 0x0C00),
		(array: 'Telugu',  						0x0C00, 0x0C80),
		(array: 'Kannada',  					0x0C80, 0x0D00),
		(array: 'Maiayalam',  					0x0D00, 0x0D80),
		(array: 'Sinhala',  					0x0D80, 0x0E00),
		(array: 'Thai',  						0x0E00, 0x0E80),
		(array: 'Lao',  						0x0E80, 0x0F00),
		(array: 'Tibetan',  					0x0F00, 0x1000),

		(array: 'Myanmar',						0x1000, 0x10A0),
		(array: 'Georgian',						0x10A0, 0x1100),
		(array: 'Hangul Jamo',					0x1100, 0x1200),
		(array: 'Ethiopic',						0x1200, 0x13A0),
		(array: 'Cherokee',						0x13A0, 0x1400),
		(array: 'Canadian Aboriginal Syllabics',0x1400, 0x1680),
		(array: 'Ogham',						0x1680, 0x16A0),
		(array: 'Runic',						0x16A0, 0x1700),
		(array: 'Tagalog',						0x1700, 0x1720),
		(array: 'Hanunoo',						0x1720, 0x1740),
		(array: 'Buhid',						0x1740, 0x1760),
		(array: 'Tagbanwa',						0x1760, 0x1780),
		(array: 'Khmer',						0x1780, 0x1800),
		(array: 'Mongolian',					0x1800, 0x1900),
		(array: 'Limbu',						0x1900, 0x1950),
		(array: 'Tai Le',						0x1950, 0x19E0),
		(array: 'Khmer Symbols',				0x19E0, 0x1D00),
		(array: 'Phonetic Extensions',			0x1D00, 0x1E00),
		(array: 'Latin Extended Additional',	0x1E00, 0x1F00),
		(array: 'Greek Extended',				0x1F00, 0x2000),

		(array: 'General Punctuation',			0x2000, 0x2070),
		(array: 'Superscripts and Subscripts',	0x2070, 0x20A0),
		(array: 'Currency Symbols',				0x20A0, 0x20D0),
		(array: 'Combining Marks for Symbols',	0x20D0, 0x2100),
		(array: 'Letterlike Symbols',			0x2100, 0x2150),
		(array: 'Number Forms',					0x2150, 0x2190),
		(array: 'Arrows',						0x2190, 0x2200),
		(array: 'Mathematical Operators',		0x2200, 0x2300),
		(array: 'Miscellaneous Technical',		0x2300, 0x2400),
		(array: 'Control Pictures',				0x2400, 0x2440),
		(array: 'Optical Character Recognition',0x2440, 0x2460),
		(array: 'Enclosed Alphanumerics',		0x2460, 0x2500),
		(array: 'Block Drawing',				0x2500, 0x2580),
		(array: 'Block Elements',				0x2580, 0x25A0),
		(array: 'Geometric Shapes',				0x25A0, 0x2600),
		(array: 'Miscellaneous Symbols',		0x2600, 0x2700),
		(array: 'Dingbats',						0x2700, 0x27C0),
		(array: 'Miscellaneous Math Symbosl-A',	0x27C0, 0x27F0),
		(array: 'Supplements Arrows-A',			0x27F0, 0x2800),
		(array: 'Braille Patterns',				0x2800, 0x2900),
		(array: 'Supplemental Arrows-B',		0x2900, 0x2980),
		(array: 'Miscellaneous Math Symbols-B',	0x2980, 0x2A00),
		(array: 'Supplemental Math Operators',	0x2A00, 0x2B00),
		(array: 'Misc. Symbols and Arrows',		0x2B00, 0x2E80),
		(array: 'CJK Radicals Supplement',		0x2E80, 0x2F00),
		(array: 'Kangxi Radicals',				0x2F00, 0x2FF0),
		(array: 'Ideographic Desc. Characters',	0x2FF0, 0x3000),

		(array: 'CJK Symbols and Punctuation',	0x3000, 0x3040),
		(array: 'Hiragana',						0x3040, 0x30A0),
		(array: 'Katakana',						0x30A0, 0x3100),
		(array: 'Bopomofo',						0x3100, 0x3130),
		(array: 'Hangul Compatibility Jamo',	0x3130, 0x3190),
		(array: 'Kanbun',						0x3190, 0x31A0),
		(array: 'Bopomofo Extended',			0x31A0, 0x31F0),
		(array: 'Katakana Phonetic Extensions',	0x31F0, 0x3200),
		(array: 'Enclosed CJK Letters and Months',0x3200, 0x3300),
		(array: 'CJK Compatibility',			0x3300, 0x3400),
		(array: 'CJK Unified Ideographs Ext. A',0x3400, 0x4DC0),
		
		(array: 'Yijing Hexagram Symbols',		0x4DC0, 0x4E00),
		(array: 'CJK Unified Ideographs',		0x4E00, 0xA000),
		
		(array: 'Yi Syllables',					0xA000, 0xA490),
		(array: 'Yi Radicals',					0xA490, 0xAC00),
		(array: 'Hangul Syllables',				0xAC00, 0xE000),
		
		(array: 'CJK Compatibility Ideographs',	0xF900, 0xFB00),
		(array: 'Alphabetic Presentation Forms',0xFB00, 0xFB50),
		(array: 'Arabic Presentation Forms-A',	0xFB50, 0xFE00),
		(array: 'Variation Selectors',			0xFE00, 0xFE20),
		(array: 'Combining Half Marks',			0xFE20, 0xFE30),
		(array: 'CJK Compatibility Forms',		0xFE30, 0xFE50),
		(array: 'Small Form Variants',			0xFE50, 0xFE70),
		(array: 'Arabic Presentation Forms-B',	0xFE70, 0xFF00),
		(array: 'Halfwidth and Fullwidth Forms',0xFF00, 0xFFF0),
		(array: 'Specials',  					0xFFF0, 0x10000),
		
		(array: 'Linear B Syllabary',  			0x10000, 0x10080),
		(array: 'Linear B Ideograms',  			0x10080, 0x10100),
		(array: 'Aegean Numbers',  				0x10100, 0x10300),
		(array: 'Old Italic',  					0x10300, 0x10330),
		(array: 'Gothic',  						0x10330, 0x10380),
		(array: 'Ugaritic',  					0x10380, 0x10400),
		(array: 'Deseret',  					0x10400, 0x10450),
		(array: 'Shavian',  					0x10450, 0x10480),
		(array: 'Osmanya',  					0x10480, 0x10800),
		(array: 'Cypriot Syllabary',  			0x10800, 0x10840),
		(array: 'Byzantine Musical Symbols',	0x1D000, 0x1D100),
		(array: 'Musical Symbols',				0x1D100, 0x1D300),
		(array: 'Tai Xuan Jing Symbols',		0x1D300, 0x1D400),
		(array: 'Math Alphanumeric Symbols',	0x1D400, 0x1D500),
		(array: 'CJK Unified Ideographs Ex. B',	0x20000, 0x2F800),
		(array: 'CJK Compat. Ideographs Supp.',	0x2F800, 0x2FA20),
		(array: 'Tags',  						0xE0000, 0xE0100),

	);
?>