<div class="content_split">
	<div class="content_left">
	
		<h2>Regular Expression Utility</h2>
				
		<form action="[var: 'admin_link']" method="post">
		
		<table>
			<tr>
				<th valign="top" width="72" align="left">Input</th>
				<td>
					<textarea name="text" rows="4" cols="40">[var: 'text']</textarea>
				</td>
				</td>
			</tr>
			<tr>
				<th valign="top" align="left">Find</th>
				<td>
					<textarea name="find" rows="4" cols="40">[var: 'find']</textarea>
				</td>
			</tr>
			<tr>
				<th valign="top" align="left">Replace</th>
				<td>
					<textarea name="replace" rows="4" cols="40">[var: 'replace']</textarea>
				</td>
			</tr>
			<tr>
				<th>&nbsp;</th>
				<td>
					<input type="submit" name="action" value="[noprocess][String_FindRegExp][/noprocess]" />
					&nbsp;
					<input type="submit" name="action" value="[noprocess][String_ReplaceRegExp][/noprocess]" />
				</td>
			</tr>

			<tr><td colspan="2"><hr /></td></tr>

	[if: $result === null]
			<tr>
				<th valign="top" width="72" align="left">Results</th>
				<td>No Results</td>
			</tr>
	[else: $result === (array)]
			<tr>
				<th valign="top" width="72" align="left">Results</th>
				<td>Empty Array</td>
			</tr>
	[else: $result->(isa: 'array')]
			<tr>
				<th valign="top" width="72" align="left">Results</th>
				<td>Array ([$result->size] elements)</td>
			</tr>
			<tr>
				<th>&nbsp;</th>
				<td>
					<textarea name="dummy" rows="[integer: (math_min: (math_max: 4, $result->size), 20)]" cols="40">[encode_html: $result->(join: '\r')]</textarea>
				</td>				
			</tr>
	[else: $result == '']
			<tr>
				<th valign="top" width="72" align="left">Results</th>
				<td>Empty String</td>
			</tr>
	[else]
			<tr>
				<th valign="top" width="72" align="left">Results</th>
				<td>String ([$result->size] chars)</td>
			</tr>
			<tr>
				<th>&nbsp;</th>
				<td>
					<textarea name="dummy" rows="[integer: (math_min: (math_max: 4, ($result->size / 40)), 20)]" cols="40">[encode_html: $result]</textarea>
				</td>				
			</tr>
	[/if]
			
			<tr><td colspan="2"><hr /></td></tr>

			<tr>
				<th valign="top" width="72" align="left">Lasso<br />Code</th>
				<td>
		[if: $action >> 'find']
			<textarea name="dummy" rows="4" cols="40">[noprocess][[/noprocess]String_FindRegExp: '[var: 'text']', -Find='[var: 'find']'[noprocess]][/noprocess]</textarea>
		[else: $action >> 'replace']
			<textarea name="dummy" rows="4" cols="40">[noprocess][[/noprocess]String_ReplaceRegExp: '[var: 'text']', -Find='[var: 'find']', -Replace='[var: 'replace']'[noprocess]][/noprocess]</textarea>
		[/if]
				</td>
			</tr>
		</table>
	
	</div>

	<div class="content_right">
	
[noprocess]

<h2>Regular Expression Reference</h2>

<p><b>Matching Symbols</b></p>

a-z A-Z 0-9 - Alphanumeric characters match the specified character.<br />
. - Period matches any single character.<br />
^ - Circumflex matches the beginning of a line.<br />
$ - Dollar sign matches the end of a line.<br />
\\... - A backslash escapes the next character. \\\\ represents a backslash.<br />
[...] - Square brackets create a character class matching any character included inside.<br />
[^...] - With a carat, any character other than those included inside is matched.<br />
[a-z] - A range of characters can be specified.<br />
\t - A tab character.<br />
\r - A return character.<br />
\n - A new-line character.<br />
\" - A double quote.<br />
\' - A single quote.<br />
\\w - Matches any alphanumeric character or an underscore.<br />
\\W - Matches any non-alphanumeric character.<br />
\\s - Matches a whitespace character (space, tab, return, etc.).<br />
\\S - Matches a non-whitespace character.<br />
\\d - Matches a numeric digit.<br />
\\D - Matches any non-numeric character.<br />

<p><b>Combination Symbols</b></p>

| - Alternation. Matches either the character before or the character after the symbol.<br />
( ) - Grouping. Defines a named group for output. Nine pairs of parentheses can be defined.<br />
* - Asterisk matches 0 or more repetitions of the preceding character.<br />
*? - Matches the shortest possible number of repetitions of the preceding character.<br />
+ - Plus sign matches 1 or more repetitions of the preceding character.<br />
? - Question mark matches 0 or 1 repetitions of the preceding character.<br />
{n} - Matches n repetitions of the preceding character.<br />
{n,} - Matches at least n repetitions of the preceding character.<br />
{n,m} - Matches at least n, but no more than m repetitions of the preceding character.<br />

<p><b>Replacement Symbols</b></p>

\\1 ... \\9 - An escaped number substitutes in the specified group (defined by parentheses) from the source.

[/noprocess]

	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>	
</div>
