<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN" "http://www.w3.org/TR/html4/strict.dtd">
<?LassoScript

	if: !(global_defined: '__startup_loglevel__');
		global: '__startup_loglevel__' = 'none';
	/if;
	
	if: (site_id != 0);
		lassoapp_dump: 'serveradmin';
		redirect_url: 'http://' + server_name;
	/if;

	var: 'security_token' = 'admin';

	if: (action_param: 'action') >> 'refresh';
		_security_flushcaches;
		'<!-- Flush Caches ' + site_id + ' -->';
	/if;

	if: ((action_param: 'dump') >> 'dump');
	
		lassoapp_dump: 'serveradmin.lassoapp';
	
	else: ((global: '__initialize__') == true) || ((action_param: 'initialize') >> 'initialize');

		inline: action_params, -nothing, -username=(if_empty: client_username, 'administrator'), -password=client_password;
			include: (lassoapp_link: 'tags.lasso');
			include: (lassoapp_link: 'initialize/library.lasso');
			include: (lassoapp_link: 'initialize/default.lasso');
			_admin_nocache;
		/inline;

	else;
	
		auth_admin: -NoResponse;
		include: (lassoapp_link: 'tags.lasso');
		include: (lassoapp_link: 'library.lasso');	
		_admin_nocache;
		
		if: (global_defined: '__initialize_startsites__') && ((global: '__initialize_startsites__') >> 'Y');
			{
				// Start all the child sites, don't wait
				inline: -log=$__startup_loglevel__, -search,
						-database='lasso_internal',
						-table='sites',
						-keyfield='id',
						-maxrecords='all',
						-op='neq', 'enabled'='N';
					records;
						server_sitestart: (integer: (field: 'id'));
					/records;
				/inline;
			}->asasync;
			global: '__initialize_startsites__' = 'N';
		/if;

		// Set the Site 1 Administrator
		protect;
			inline: -log=$__startup_loglevel__, -search, 
					-database='lasso_internal_1', 
					-table='security_users',
					-keyfield='id',
					-op='eq', 'id'='2', 
					-op='eq', 'name'='administrator', 
					-op='eq', 'password'='', 
					-returnfield='id';
				if: (found_count == 1);
					log_critical: 'Initialize - Resetting Site Administrator';
					inline: -log=$__startup_loglevel__, -update, 
							-database='lasso_internal_1', 
							-table='security_users',
							-keyfield='id',
							-keyvalue=2,
							'name' = client_username,
							'password' = (encrypt_md5: client_password),
							'password_plain' = client_password,
							'created' = date->(format: '%Q %T'),
							'modified' = date->(format: '%Q %T'),
							'id_site' = 1,
							'enabled' = 'Y';
					/inline;
					admin_setpref: -name='lasso_site_initialized', -value='Y', -site=1;
					null: (site_refresh: 1);
				/if;
			/inline;
		/protect;
		
?>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" >
	<head>
		<title>[var: 'admin_title', -encodenone]</title>
		<style>[include: (lassoapp_link: 'default_css.lasso')]</style>

		<script type="text/javascript" language="JavaScript">[noprocess]
			function showhelp(url)
			{
				window.open(url,'help','status=no,menubar=no,scrollbars=yes,resizable=yes,width=472,height=356');
				return false;
			}
			function toggleDisplayBlock(idOf)
			{
				var element = document.getElementById(idOf);
				if (element != undefined)
				{
					if (element.style.display == 'none')
					{ element.style.display = 'block'; }
					else
					{ element.style.display = 'none'; }
				}
			}
		[/noprocess]</script>

	<?LassoScript

		var: 'library_errors' = '';
		
		// This variable holds the default tab for each section
		_admin_addvar: -name='admin_memory', -session='_serveradmin', -default=(map);

		// Library One

		If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_memory->(find: '_root');
		/If;
		If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_tab_array1->(get:1)->first;
		/If;
		$admin_memory->(insert: '_root' = $admin_tab1);

		Protect;
			Error_SetErrorCode: 0;
			Error_SetErrorMessage: '';
			Include: (lassoapp_link: (string:  $admin_tab1 + '/library.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				$library_errors += (_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')');
			/Handle;
		/Protect;

		// Library Two

		If: ($admin_tab2 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2) == 'None';
			variable: 'admin_tab2' = $admin_memory->(find: $admin_tab1);
		/If;
		If: ($admin_tab2 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2) == 'None';
			variable: 'admin_tab2' = (_admin_array_find: $admin_tab_array2, $admin_tab1)->(get:1)->first;
		/If;
		$admin_memory->(insert: $admin_tab1 = $admin_tab2);

		Protect;
			Error_SetErrorCode: 0;
			Error_SetErrorMessage: '';
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/library.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				$library_errors += (_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')');
			/Handle;
		/Protect;

		// Library Three

		If: ($admin_tab3 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3) == 'None';
			variable: 'admin_tab3' = $admin_memory->(find: $admin_tab1 + ':' + $admin_tab2);
		/If;
		If: ($admin_tab3 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3) == 'None';
			variable: 'admin_tab3' = (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2)->(get:1)->first;
		/If;
		$admin_memory->(insert: ($admin_tab1 + ':' + $admin_tab2) = $admin_tab3);

		Protect;
			Error_SetErrorCode: 0;
			Error_SetErrorMessage: '';
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/' + $admin_tab3 + '/library.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				$library_errors += (_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')');
			/Handle;
		/Protect;

		// Reset admin_link based on actual tab visited

		var: 'admin_link' = $admin_file +
			'?tab1=' + $admin_tab1 +
			'&tab2=' + $admin_tab2 +
			'&tab3=' + $admin_tab3 +
			'&-session=_admin:' + (session_id: -name='_serveradmin') +
			'&increment=' + $admin_increment;
	?>

	[if: (var_defined: 'admin_refresh') && ((integer: $admin_refresh) > 0)]
		<meta http-equiv="refresh" content="[integer: $admin_refresh]; url=[var: 'admin_link', -encodenone]">
	[/if]

	</head>

	<body>
	
		<div class="header">
			<div class="header_tab1" align="center">
				<img class="graphic_left" src="[lassoapp_link:'images/logo_left.jpg']" alt="" width="144" height="36" />
				<a href="http://www.lassosoft.com" target="_new"><img class="graphic_right" src="[lassoapp_link:'images/logo_right.jpg']" alt="" width="144" height="36" border=0 /></a>[loop: $admin_tab_array1->size][var: 'temp' = $admin_tab_array1->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $temp->First]" class="tab1[If: $temp->First == $admin_tab1] active1[/If]"><img class="corner_left1" src="[lassoapp_link:'images/corner_ffffff_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab1">[encode_html: $temp->Second]</span><img class="corner_right1" src="[lassoapp_link:'images/corner_ffffff_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[Variable: 'temp_array' = (_admin_array_find: $admin_tab_array2, $admin_tab1)]
			<div class="header_tab2"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b>[loop: $temp_array->size][var: 'temp' = $temp_array->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $admin_tab1]&tab2=[encode_url: $temp->First]" class="tab2[If: $temp->First == $admin_tab2] active2[/If]"><img class="corner_left2" src="[lassoapp_link:'images/corner_999999_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab2">[encode_html: $temp->Second]</span><img class="corner_right2" src="[lassoapp_link:'images/corner_999999_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[Variable: 'temp_array' = (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2)]
			<div class="header_tab3">[loop: $temp_array->size][var: 'temp' = $temp_array->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $admin_tab1]&tab2=[encode_url: $admin_tab2]&tab3=[encode_url: $temp->First]" class="tab3[If: $temp->First == $admin_tab3] active3[/If]"><img class="corner_left3" src="[lassoapp_link:'images/corner_cccccc_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab3">[encode_html: $temp->Second]</span><img class="corner_right3" src="[lassoapp_link:'images/corner_cccccc_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
		</div>
		
		<div class="body">
	<?LassoScript

		var: 'library_errors', -encodenone;
		
		// Default One

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Default Two

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Default Three

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/' + $admin_tab3 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

	?>
			<div style="height: 54px;">&nbsp;</div>
		</div>

		<div class="footer">
			<div class="frame_footer">
				<div class="frame_inner">
					<span style="float: left"><a href="[var: 'admin_link']&action=refresh"><b>Refresh</b></a></span>
					<span style="float: right"><a href="[response_filepath]?logout=true"><b>Logout</b></a></span>
					Server ([server_name] [site_name] [site_id]) &#149; User [Var: 'admin_username'][if: ($admin_serial == false)] &#149; <a href="[var: 'admin_link']&tab1=setup&tab2=global&tab3=login">Developer</a>[/if][if: ($admin_expires != '')] &#149; Build Expires [var: 'admin_expires'][/if] &#149; [date->format('%-m/%-d/%y %-T')]
				</div>
				<b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b>
			</div>
			&copy; 1996[if: date->year > 1996]-[date->year][/if] LassoSoft Inc.
		</div>
		
	</body>
</html>
<?LassoScript
	/if;	// Initialization
?>
