<?LassoScript

	_admin_addvar: 'action', -override=(action_param: 'action');
	_admin_addvar: 'admin_serial', -override=(action_param: 'admin_serial');
	_admin_addvar: 'admin_username', -override=(action_param: 'admin_username'), -default='serveradmin';
	_admin_addvar: 'admin_password', -override=(action_param: 'admin_password');
	_admin_addvar: 'admin_confirm', -override=(action_param: 'admin_confirm');
	_admin_addvar: 'admin_submit', -override=(action_param: 'admin_submit');
	_admin_addvar: 'admin_needs', -override=(action_param: 'admin_needs'), -default='';
	_admin_addvar: 'admin_splash', -override=(action_param: 'admin_splash'), -default='true';
	
	global: '__initialize_startsites__' = 'Y';

	Variable: 'admin_tab_array1' = (Array:
		'initialize'='Initialize',
	);
	var: 'admin_tab1' = 'initialize';
	
	if: (Admin_CurrentGroups >> 'Administrators') && (client_username != '');
		var: 'username' = client_username;
		var: 'password' = client_password;
		$admin_needs -= 'admin';
	else;
		var: 'username' = 'administrator';
		var: 'password' = '';
		if: ($admin_needs !>> 'admin');
			$admin_needs += 'admin';
		/if;
	/if;
	
	inline: -log=$__startup_loglevel__, -findall, 
			-username=$username, 
			-password=$password, 
			-database='lasso_internal', 
			-table='serial_numbers', 
			-returnfield='id';
		if: (error_msg != error_noerror);
			var: 'username' = 'administrator';
			var: 'password' = '';
			if: ($admin_needs !>> 'admin');
				$admin_needs += 'admin';
			/if;
		/if;
	/inline;
	
	inline: -log=$__startup_loglevel__, -search, 
			-username=$username, 
			-password=$password, 
			-database='lasso_internal', 
			-table='security_users',
			-keyfield='id',
			-op='eq', 'id'=2, 
			-op='neq', 'password'='',
			-returnfield='id';
		if: (found_count == 1);
			$admin_needs -= 'admin';
		else;
			var: 'username' = 'administrator';
			var: 'password' = '';
			if: ($admin_needs !>> 'admin');
				$admin_needs += 'admin';
			/if;
		/if;
	/inline;
	
	inline: -log=$__startup_loglevel__, -search, 
			-username=$username, 
			-password=$password, 
			-database='lasso_internal', 
			-table='serial_numbers', 
			-keyfield='id',
			-opbegin='or',
			-op='bw', 'serial'='LP8.5',
			-op='bw', 'serial'='LS8.5',
			-opend='or',
			-maxrecords=1,
			-returnfield='id';
		if: (found_count == 1);
			$admin_needs -= 'serial';
		else;
			if: ($admin_needs !>> 'serial');
				$admin_needs += 'serial';
			/if;		
		/if;
	/inline;
	
	if: ($admin_needs >> 'serial') || ($admin_needs >> 'admin');
		if: ($admin_needs !>> 'prefs');
			$admin_needs += 'prefs';
		/if;
		if: ($admin_needs !>> 'import');
			$admin_needs += 'import';
		/if;
	/if;

	if: ($admin_needs >> 'prefs');
	
		var: 'defaults' = (map: 
				'lasso_smtp_host' = '',
				'lasso_smtp_port' = 25,
				'lasso_smtp_username' = '',
				'lasso_smtp_password' = '',
				'lasso_smtp_sendmode' = 'direct',
			);		
		var: 'prefs' = $defaults;
		var: 'prefs' = (admin_getpref: $prefs, -username=$username, -password=$password);
	/if;

	if: ($admin_needs >> 'prefs');
	
		var: 'defaults' = (map: 
				'lasso_smtp_host' = '',
				'lasso_smtp_port' = 25,
				'lasso_smtp_username' = '',
				'lasso_smtp_password' = '',
				'lasso_smtp_sendmode' = 'direct',
			);		
		var: 'prefs' = $defaults;
		
		inline: -log=$__startup_loglevel__, -nothing, 
				-username=$username, 
				-password=$password;
				
			var: 'prefs' = (admin_getpref: $prefs);
			
		/inline;
	/if;

	inline: -username=$username, 
			-password=$password;
		// Install LDML Reference
		var: 'src_path' = (admin_lassoservicepath + '/SQLiteDBs/LDML8_Reference');
		var: 'dst_path' = (admin_lassoservicepath + '/LassoSites/default-1/SQLiteDBs/LDML8_Reference');
		if: !(file_exists: $dst_path);
			file_copy: $src_path, $dst_path;
		/if;
	/inline;
	
	// Set Default File Upload Path
	if: (admin_getpref: '_admin_upload_path') == '';
		if: lasso_version >> 'mac';
			var: 'upload_path' = '///var/tmp/';
		else: lasso_version >> 'win';
			var: 'upload_path' = 'C://WINDOWS/TEMP/';
		else;
			var: 'upload_path' = '///tmp/';
		/if;
		admin_setpref: '_admin_upload_path', $upload_path, -username=$username, -password=$password;
		// Install Upload Path Into Site 1
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='security_site_paths',
				-keyfield='id',
				-op='eq', 'id_site'=1,
				-op='eq', 'path'=$upload_path,
				-returnfield='id',
				-maxrecords='all';
			if: (found_count == 0);
				inline: -log=$__startup_loglevel__, -add,
						-database='lasso_internal',
						-table='security_site_paths',
						-keyfield='id',
						'id_site'=1,
						'path'=$upload_path,
						-maxrecords=0;
				/inline;
			/if;
		/inline;		
	/if;
	
	if: ($action >> 'submit');
	
		if: ($admin_needs >> 'serial') && ($admin_submit >> 'serial');
			var: 'admin_serial'=(string_replaceregexp: $admin_serial, -find='\\s', -replace='');
		
			if: $admin_serial == '';
				// Serial number is empty, continue		 
				$admin_needs -= 'serial';
			else;
				inline: -log=$__startup_loglevel__, -search, 
						-username=$username, 
						-password=$password, 
						-database='lasso_internal', 
						-table='serial_numbers', 
						-keyfield='id',
						-maxrecords=1,
						-returnfield='id';
					if: (found_count) == 0;
						inline: -log=$__startup_loglevel__, -add, 
								-username=$username, 
								-password=$password, 
								-database='lasso_internal', 
								-table='serial_numbers', 
								'id' = '1',
								'serial' = (var:'admin_serial');
							if: error_currenterror:-errorcode;
								var:'store_error'='Error storing serial number';
							/if;
						/inline;
					else;
						inline: -log=$__startup_loglevel__, -update, 
								-username=$username, 
								-password=$password, 
								-database='lasso_internal', 
								-table='serial_numbers', 
								-keyfield='id', 
								-keyvalue=(field: 'id'),
								'serial' = $admin_serial;
							if: error_currenterror:-errorcode;
								var:'store_error'='Error storing serial number';
							/if;
						/inline;
					/if;
				/inline;
		
				if: (_security_isserialized == true);
					$admin_needs -= 'serial';
				else;
					// Check serial number, return error if invalid
					var:'admin_serial_error'='Please enter a valid serial number before continuing.';
				/if;

			/if;

		/if;
		
		if: ($admin_needs >> 'admin') && ($admin_submit >> 'admin');
			if: (var: 'admin_username')=='';
				var:'admin_username_error'='Please enter an administrator username.';
			/if;
		
			if: (var: 'admin_password')=='';
				var:'admin_password_error'='Your password must not be blank.';
			else: (var: 'admin_password')!=(var: 'admin_confirm');
				var:'admin_password_error'='Your password and confirmation must match.';
			/if;
		
			if: !(var_defined: 'admin_username_error') && !(var_defined: 'admin_password_error');
		
				inline: -log=$__startup_loglevel__, -search, 
						-username=$username, 
						-password=$password, 
						-database='lasso_internal', 
						-table='security_users',
						-keyfield='id',
						-op='eq', 'id'=2, 
						-returnfield='id';
					if: (found_count) == 0;
						inline: -log=$__startup_loglevel__, -add, 
								-username=$username, 
								-password=$password,
								-database='lasso_internal', 
								-table='security_users',
								'id' = 2,
								'name' = $admin_username,
								'password' = (encrypt_md5: $admin_password),
								'password_plain' = $admin_password,
								'created' = date->(format: '%Q %T'),
								'modified' = date->(format: '%Q %T'),
								'id_site' = 0,
								'enabled' = 'Y';
							if: error_currenterror:-errorcode;
								var:'store_error'='Error creating server administrator username/password';
							else;
								$admin_needs -= 'admin';
							/if;
						/inline;
					else;
						inline: -log=$__startup_loglevel__, -update, 
								-username=$username, 
								-password=$password,
								-database='lasso_internal', 
								-table='security_users',
								-keyfield='id',
								-keyvalue=2,
								'name' = $admin_username,
								'password' = (encrypt_md5: $admin_password),
								'password_plain' = $admin_password,
								'created' = date->(format: '%Q %T'),
								'modified' = date->(format: '%Q %T'),
								'id_site' = 0,
								'enabled' = 'Y';
							if: error_currenterror:-errorcode;
								var:'store_error'='Error storing server administrator username/password';
							else;
								$admin_needs -= 'admin';
							/if;
						/inline;
					/if;
				/inline;

				inline: -log=$__startup_loglevel__, -search,
						-username=$username,
						-password=$password,
						-database='lasso_internal',
						-table='security_ug_map',
						-keyfield='id',
						-op='eq', 'id_user' = 2,
						-op='eq', 'id_group' = 2,
						-returnfield='id',
						-maxrecords=1,
						-uselimit;
					if: (found_count == 0);
						inline: -log=$__startup_loglevel__, -add, 
								-username=$username, 
								-password=$password,
								-database='lasso_internal', 
								-table='security_ug_map',
								'id_user' = 2,
								'id_group' = 2,
								'precedence' = 1,
								'admin' = 'Y',
								'modified' = date->(format: '%Q %T');
							if: error_currenterror:-errorcode;
								var:'store_error'='Error creating server administrator username/password';
							/if;
						/inline;
					/if;
				/inline;

				inline: -log=$__startup_loglevel__, -search, 
						-username=$username, 
						-password=$password, 
						-database='lasso_internal_1', 
						-table='security_users',
						-keyfield='id',
						-op='eq', 'id'=2, 
						-returnfield='id';
					if: (found_count) == 0;
						inline: -log=$__startup_loglevel__, -add, 
								-username=$username, 
								-password=$password,
								-database='lasso_internal_1', 
								-table='security_users',
								'id' = 2,
								'name' = $admin_username,
								'password' = (encrypt_md5: $admin_password),
								'password_plain' = $admin_password,
								'created' = date->(format: '%Q %T'),
								'modified' = date->(format: '%Q %T'),
								'id_site' = 1,
								'enabled' = 'Y';
							if: error_currenterror:-errorcode;
								var:'store_error'='Error creating site administrator username/password';
							else;
								$admin_needs -= 'site';
							/if;
						/inline;
					else;
						inline: -log=$__startup_loglevel__, -update, 
								-username=$username, 
								-password=$password,
								-database='lasso_internal_1', 
								-table='security_users',
								-keyfield='id',
								-keyvalue=2,
								'name' = $admin_username,
								'password' = (encrypt_md5: $admin_password),
								'password_plain' = $admin_password,
								'created' = date->(format: '%Q %T'),
								'modified' = date->(format: '%Q %T'),
								'id_site' = 1,
								'enabled' = 'Y';
							if: error_currenterror:-errorcode;
								var:'store_error'='Error storing site administrator username/password';
							else;
								$admin_needs -= 'site';
							/if;
						/inline;
					/if;
				/inline;
				
				inline: -log=$__startup_loglevel__, -search,
						-username=$username,
						-password=$password,
						-database='lasso_internal_1',
						-table='security_ug_map',
						-keyfield='id',
						-op='eq', 'id_user' = 2,
						-op='eq', 'id_group' = 2,
						-returnfield='id',
						-maxrecords=1,
						-uselimit;
					if: (found_count == 0);
						inline: -log=$__startup_loglevel__, -add, 
								-username=$username, 
								-password=$password,
								-database='lasso_internal_1', 
								-table='security_ug_map',
								'id_user' = 2,
								'id_group' = 2,
								'precedence' = 1,
								'admin' = 'Y',
								'modified' = date->(format: '%Q %T');
							if: error_currenterror:-errorcode;
								var:'store_error'='Error creating site administrator username/password';
							/if;
						/inline;
					/if;
				/inline;
			
				inline: -username=$username, -password=$password;
					admin_setpref: -name='lasso_site_initialized', -value='Y', -site=1;
				/inline;
				
				null: (site_refresh: 1);
			/if;

		/if;
		
		if: ($admin_needs >> 'prefs') && ($admin_submit >> 'prefs');

			iterate: $prefs->keys, (var: 'key');
				if: (action_param: $key, -count) > 0;
					if: (action_param: $key) == '';
						$prefs->(insert: $key = $defaults->(find: $key));
					else;
						$prefs->(insert: $key = (action_param: $key));
					/if;
				/if;
			/iterate;
			
			admin_setpref: $prefs, -username=$username, -password=$password;
			admin_setpref: $prefs, -site=1, -username=$username, -password=$password;
		
			$admin_needs -= 'prefs';

		/if;

		if: ($admin_needs >> 'import') && ($admin_submit >> 'import');

			if: (file_uploads->size > 0);
				
				server_sitestop: 1;
				
				inline: 'action' = 'import', 'site_id' = 1;
					include: (lassoapp_link: 'sites/sites/importexport/library.lasso');
				/inline;
				
			/if;

			$admin_needs -= 'import';
				
		/if;

		if: $admin_needs !>> 'admin';
			global: '__initialize__' = false;
		/if;

	else: ($action >> 'server');
		
		global: '__initialize_startsites__' = 'Y';
	
		inline: -log=$__startup_loglevel__, -nothing, 
				-username=$username, 
				-password=$password;
			_security_flushcaches;
		/inline;
		
		redirect_url: (LassoApp_Link:'default.lasso');
	
	/if;
	
?>
