<?LassoScript

	//
	// Session
	//

	protect;
		if: (action_param:'logout') == 'true';
			session_end: -name='_serveradmin';
			redirect_url: (lassoapp_link: 'logout.lasso');
		else;
			session_start: -name='_serveradmin', -expires=1440, -usecookie;
	
			_admin_addvar: -session='_serveradmin', -name='admin_datetime', -default=(string: date);
			_admin_addvar: -session='_serveradmin', -name='admin_increment', -default='123453';
			_admin_addvar: -session='_serveradmin', -name='admin_username', -override=(client_username), -default='';
			_admin_addvar: -session='_serveradmin', -name='admin_ipaddress', -default=(string: _client_address_old);
			_admin_addvar: -session='_serveradmin', -name='admin_usertype', -default='none';
		/if;
	
		var: 'admin_increment' = (integer: $admin_increment) + 3;
	/protect;

	//
	// Serial Number
	//
	
	if: ((var_defined: 'admin_serialnum') == false) || ((var:'admin_serialnum') == '');
		var: 'admin_serialnum'='';
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='serial_numbers',
				-op='eq', 'id'='1',
				-maxrecords=1;
			records;
				var: 'admin_serialnum' = (field:'serial');
			/records;
		/inline;
		var: 'admin_serialedition' = '';
	/if;

	if: (var_defined: 'admin_serialedition') == false || (var: 'admin_serialedition') == '';
		// Parse the Serial Number
		if: (_security_isserialized) == false;
		  var: 'admin_serialedition'='Single-User';
		else: ($admin_serialnum >> 'LS8.5GL') || ($admin_serialnum >> 'LS8.5DW') || ($admin_serialnum >> 'LP8.5-DEV') || ($admin_serialnum >> 'LS8GL') || ($admin_serialnum >> 'LS8DW') || ($admin_serialnum >> 'LP8-DEV');
		  var: 'admin_serialedition'='Single-User';
		else: ($admin_serialnum >> 'LP8.5-WIN') || ($admin_serialnum >> 'LP8.5-MAC') || ($admin_serialnum >> 'LP8.5-LIN');
		  var: 'admin_serialedition'='Multi-User';
		else;
		  var: 'admin_serialtemp'=(_security_serialexpiration);
		  if: (var: 'admin_serialtemp') != '';
		  	if: $admin_serialnum >> 'EVAL';
			  var: 'admin_serialedition'='Evaluation (Expires ' + $admin_serialtemp + ')';
			else;
			  var: 'admin_serialedition'='Leased (Expires ' + $admin_serialtemp + ')';
			/if;
		  else;
			  var: 'admin_serialedition'='Unknown';
		  /if;
		/if;
	/if;

	//
	// Tab Arrays
	//

	var: 'admin_tab_disabled1' = (array);
	var: 'admin_tab_disabled2' = (array);
	var: 'admin_tab_disabled3' = (array);

	Variable: 'admin_tab_array1' = (Array:
		'setup'='Setup',
		'sites'='Sites',
		'utility'='Utility',
		'support'='Support',
	);
	Variable: 'admin_tab_array2' = (Array:
		'setup'=(Array:
			'global'='Server',
			'chartfx'='Chart FX',
		),
		'sites'=(Array:
			'sites'='Sites',
		),
		'utility'=(Array:
			'sql'='SQL',
			'errors'='Errors',
			'threads'='Threads',
		),
		'support'=(Array:
			'support'='Support',
		),
	);
	Variable: 'admin_tab_array3' = (Array:
		'setup:global'=(Array:
			'login'='Summary',
			'serial'='Serial Number',
			'prefs'='Admin Settings',
			'tags'='Tags',
//			'update'='Updates',
			'importexport'='Import/Export',
		),
		'setup:chartfx'=(Array:
			'serial'='Serial Number'
		),
		'sites:sites'=(Array:
			'sites'='Sites',
			'prefs'='Preferences',
			'paths'='File Paths',
			'importexport'='Import/Export',
		),
		'utility:sql'=(Array:
			'browse'='Statement',
		),
		'utility:email'=(Array:
			'setup'='Setup',
		),
		'utility:threads'=(Array:
			'threads'='Threads',
		),
		'utility:errors'=(Array:
			'errors'='Lasso Errors',
			'setup'='Setup',
		),
		'support:support'=(Array:
			'support'='Support',
		),
	);
		
	// Current Tab

	Variable: 'admin_tab1' = (action_param: 'tab1', (action_param: 'tab1', -count));
	Variable: 'admin_tab2' = (action_param: 'tab2', (action_param: 'tab2', -count));
	Variable: 'admin_tab3' = (action_param: 'tab3', (action_param: 'tab3', -count));

	// Default Tabs

	// Title

	var: 'admin_title' = 'Lasso Server (' + server_name + ') ' + (lasso_version: -lassoversion)->(substring: 1, (lasso_version: -lassoversion)->(find: ' ') - 1);
	var: 'temp' = (_admin_array_find: $admin_tab_array1, $admin_tab1);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;

		var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2);
		if: ($temp != '') && ($temp != 'None');
			$admin_title += ' : ' + $temp;
	
			var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3);
			if: ($temp != '') && ($temp != 'None');
				$admin_title += ' : ' + $temp;
			/if;
		/if;
	/if;

	var: 'admin_expires' = (_security_binaryexpiration);
	var: 'admin_eval' = (_security_serialexpiration);
	var: 'admin_serial' = (_security_isserialized);
	if: ($admin_expires != '');
		$admin_title += ' (Build Expires ' + $admin_expires + ')';
	/if;
	if: ($admin_serial == false);
		$admin_title += ' (Developer)';
	/if;

	//
	// LassoApp Links
	//

	if: (var_defined:'admin_file')==false;
		var:'admin_file'=(lassoapp_link:'default.lasso');
	/if;

	if:(var_defined:'dialog_file')==false;
		var:'dialog_file'=(lassoapp_link: 'dialog.lasso');
	/if;

	var: 'admin_link' = $admin_file +
		'?tab1=' + $admin_tab1 +
		'&tab2=' + $admin_tab2 +
		'&tab3=' + $admin_tab3 +
		'&-session=_admin:' + (session_id: -name='_serveradmin') +
		'&increment=' + $admin_increment;

	var: 'wide_stripe' = '#bfbfbf';
	var: 'color_beta' = '#bfbfbf';
	var: 'color_alpha' = '#cccccc';

	// Date Format
	Date_SetFormat: '%Q %T';

?>
