<?LassoScript

var: 'chartfx_action' = (action_param: 'chartfx_action');
var: 'chartfx_status' = 'Developer';

var: 'prefs' = (map: 'chartfx_serial_number' = '', 'chartfx_challenge_string' = '', 'chartfx_activation_string' = '');
var: 'prefs' = (admin_getpref: $prefs);

if: $chartfx_action >> 'Activate';
	
	var: 'chartfx_serial_number' = (action_param: 'chartfx_serial_number');
	var: 'chartfx_activation_string' = (action_param: 'chartfx_activation_string');

	if: ($chartfx_serial_number != '') && ($chartfx_serial_number !>> '*');
		$prefs->(insert: 'chartfx_serial_number' = $chartfx_serial_number);
	/if;
	
	if: ($chartfx_activation_string == '') && ($chartfx_serial_number != '');

		var: 'chartfx_challenge_string' = (chartfx_getchallengestring: $prefs->(find: 'chartfx_serial_number'));

		if: $chartfx_challenge_string >> 'Not Installed';
			var: 'chartfx_error' = 'The Chart FX module is not installed.';
		else;
			protect;
				var: 'chartfx_activation_string' = (include_url: 'http://register.softwarefx.com/licensecode/GetNetLicense.aspx?Data=' + (encode_stricturl: (bytes: $chartfx_challenge_string, 'iso-8859-1')) + '&Install=1&Process=1');
				handle: true;
					log_always: error_code + ' ' + error_msg;
					error_code = 0;
					error_msg = error_noerror;
				/handle;
			/protect;
		/if;
	/if;

	if: ($chartfx_activation_string != '');
		
		if: $chartfx_activation_string->(beginswith: 'S');
			$chartfx_activation_string -= 'S';
		/if;
			
		chartfx_setactivation: $chartfx_activation_string	
		$prefs->(insert: 'chartfx_activation_string' = $chartfx_activation_string);
	
	/if;
	admin_setpref: $prefs;			

else: $chartfx_action >> 'Remove' || $chartfx_action >> 'Reset';

	$prefs->(insert: 'chartfx_serial_number'='');
	$prefs->(insert: 'chartfx_challenge_string'='');
	$prefs->(insert: 'chartfx_activation_string'='');
	chartfx_setactivation: '';
	admin_setpref: $prefs;			

/if;


// Chart FX Status
if: $prefs->(find: 'chartfx_activation_string') != '';
	var: 'chartfx_status' = 'Activated';
else: $prefs->(find: 'chartfx_serial_number') != '';
	var: 'chartfx_status' = 'Pending Activation';
	var: 'chartfx_challenge_string' = (chartfx_getchallengestring: $prefs->(find: 'chartfx_serial_number'));
else;
	var: 'chartfx_status' = 'Developer';
/if;

// Obscure Serial Number
var: 'chartfx_serialdisplay' = (string_replaceregexp: $prefs->(find: 'chartfx_serial_number'), -find='[0-9].{9}', -replace='**********');

?>
