<?LassoScript
	encode_set: -encodenone;

	content_type: 'text/plain';

	'#[version: 8.0]\r\n';
	'#Lasso Security Settings\r\n';
	'#Copyright 2003-' + date->year + ' LassoSoft Inc.\r\n';
	'#<a href="http://www.lassosoft.com/">http://www.lassosoft.com/</a>\r\n';
	'#\r\n';
	'#    SERVER: ' + site_name + ' (' + site_id + ')\r\n';
	'#\r\n';
	'#    Use the browser\'s "Save" command to save this text into a file.\r\n';
	'#\r\n';
	'#    The security settings can later be imported into Lasso Administration using\r\n';
	'#    the "Import..." command in the Setup > Global > Import/Export section.\r\n';
	'#\r\n';
	'#    Do not edit this file directly.  No user-serviceable parts inside.\r\n';
	'#\r\n';
	'#\r\n';

	var: 'schema' = (array);
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasources', 'query'=(array: -op='gt', 'id'='1')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasource_hosts'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasource_databases'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_database_tables'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_table_fields'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_users', 'query'=(array: -op='gt', 'id'='2')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_ug_map', 'query'=(array: -op='gt', 'id_user'='2', -op='gt', 'id_group'='2')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_groups', 'query'=(array: -op='gt', 'id'='2')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_host_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_db_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_table_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_file_perms'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_generic_perms'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='global_prefs', 'query'=(array: -op='neq', 'store_key'='_session_globalignoreprefixes', -op='neq', 'store_key'='_session_globalattributes', -op='neq', 'store_key'='lasso_site_initialized', -op='neq', 'store_key'='lasso_uptime')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='jdbc_drivers'));
	if: (integer: (lasso_version: -lassoversion)->(get: 1)) >= 8;
		if: (site_id == 0);
			$schema->(insert: (map: 'database'='lasso_internal', 'table'='sites'));
			$schema->(insert: (map: 'database'='lasso_internal', 'table'='sites_criteria'));
			$schema->(insert: (map: 'database'='lasso_internal', 'table'='site_prefs'));
		else;
			$schema->(insert: (map: 'database'='site', 'table'='schedule'));
		/if;
	/if;
	
	var: 'id_datasource' = (array);
	var: 'id_database' = (array);
	var: 'id_table' = (array);
	
	loop: $schema->size;
		var: 'temp_schema' = $schema->(get: loop_count);
		var: 'inline' = (array:
				-database=$temp_schema->(find: 'database'),
				-table=$temp_schema->(find: 'table'),
				-maxrecords='all'		
		);
		
		if: ($temp_schema->(find: 'query') != null) || ((array: 'security_datasource_hosts', 'security_datasource_databases', 'security_database_tables', 'security_table_fields') >> $temp_schema->(find: 'table'));
			if: ($temp_schema->(find: 'query') != null);
				$inline->(merge: $temp_schema->(find: 'query'));
			/if;
			if: ($temp_schema->(find: 'table') == 'security_datasource_hosts') || ($temp_schema->(find: 'table') == 'security_datasource_databases');
				$inline->(insert: -opbegin='or');
				iterate: $id_datasource, (var: 'id');
					$inline->(insert: -op='eq');
					$inline->(insert: 'id_datasource' = $id);
				/iterate;
				$inline->(insert: -opend='or');
			else: ($temp_schema->(find: 'table') == 'security_database_tables') || ($temp_schema->(find: 'table') == 'security_group_db_map');
				$inline->(insert: -opbegin='or');
				iterate: $id_database, (var: 'id');
					$inline->(insert: -op='eq');
					$inline->(insert: 'id_database' = $id);
				/iterate;
				$inline->(insert: -opend='or');
			else: ($temp_schema->(find: 'table') == 'security_table_fields') || ($temp_schema->(find: 'table') == 'security_group_table_map');
				$inline->(insert: -opbegin='or');
				iterate: $id_table, (var: 'id');
					$inline->(insert: -op='eq');
					$inline->(insert: 'id_table' = $id);
				/iterate;
				$inline->(insert: -opend='or');
			/if;
			$inline->(insert: -search='action');
		else;
			$inline->(insert: -findall='action');
		/if;
		
		inline: -log=$__startup_loglevel__, $inline;
			
			var: 'names' = array;
			var: 'temp_fields' = $temp_schema->(find: 'field');
			if: ($temp_fields->type == 'array');
				loop: $temp_fields->size;
					if: ($temp_fields->(get: loop_count) != 'modified') && ($temp_fields->(get: loop_count) != 'allow_out_of_root');
						$names->(insert: $temp_fields->(get: loop_count));
					/if;
				/loop;
			else;
				loop: (field_name: -count);
					if: ((field_name: loop_count) != 'modified') && ((field_name: loop_count) != 'allow_out_of_root');
						$names->(insert: (field_name: loop_count));
					/if;
				/loop;
			/if;
			
			'[' + (database_name) + '.' + (table_name) + ': ';
			loop: $names->size;
				if: (loop_count > 1);
					', ';
				/if;
				$names->(get: loop_count);
			/loop; 
			']\r\n';
			
			records;

				if: $temp_schema->(find: 'table') == 'security_datasources';
					$id_datasource->(insert: (field: 'id'));
				else: $temp_schema->(find: 'table') == 'security_datasource_databases';
					$id_database->(insert: (field: 'id'));
				else: $temp_schema->(find: 'table') == 'security_database_tables';
					$id_table->(insert: (field: 'id'));
				/if;
			
				'  ("';
				loop: $names->size;
					if: (loop_count > 1);
						'","';
					/if;
					(encode_sql: (field: $names->(get: loop_count)));
				/loop;
				'")';
				if: (loop_count < found_count);
					',';
				/if;
				'\r\n';
			/records;

			'[/' + (table_name) + ']\r\n';
			
		/inline;
	/loop;
	
	'#END';

	/encode_set;
?>