<?LassoScript

	_admin_addvar: -name="action", -override=(action_param: 'action'), -default='none';

	lasso_executiontimelimit: 0;
		
	var: 'schema' = (array);
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasources', 'delete'='id > 1'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasource_hosts', 'delete'='id_datasource > 1'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasource_databases'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_database_tables'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_table_fields'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_users', 'delete'='id > 2'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_ug_map', 'delete'='id_group > 2 AND id_user > 2'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_groups', 'delete'='id > 2'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_host_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_db_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_table_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_file_perms'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_generic_perms'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='global_prefs', 'delete'='store_key NOT IN ("lasso_site_initialized","lasso_uptime","_session_globalignoreprefixes","_session_globalattributes")'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='sites'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='sites_criteria'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='site_prefs'));

	if: ($action >> 'Export');
	
		file_serve: (include: (lassoapp_link: 'setup/global/importexport/export.lasso')), -type='application/force-download', -file='Lasso_Server_' + date->(format: '%Y%m%d%H%M%S') + '.txt';
	
	else: ($action >> 'Import');

		var: 'import_files' = (file_uploads);

		var: 'import_error' = '';
		var: 'import_success' = '';
		var: 'import_cancel' = false;

		if: ($import_files->size == 0);
			var: 'import_error' = 'Error - No file selected. Select the file which contains the Lasso 8 server settings file to import.';
			var: 'import_cancel' = true;
		/if;

		if: ($import_error == '');
			protect;
				var: 'import_bytes' = (file_read: $import_files->(get: 1)->(find: 'upload.name'));
			/protect;
			
			If: (Lasso_Version: -LassoPlatform)->contains: 'Mac';
				var: 'import_data' = $import_bytes->(exportstring: 'mac');
			else;
				var: 'import_data' = $import_bytes->(exportstring: 'iso8859-1');
			/if;
		/if;

		if: ($import_cancel == false);

			var: 'import_version' = (string_findregexp: $import_data, -find='\\[version: ?[^\\]]*\\]');
			if: ($import_version->size < 1) || ($import_version->first !>> '8.0');
				var: 'import_error' = 'Error - The import file is in an unknown format. Imports must contain Lasso 8 server settings.';
				var: 'import_cancel' = true;
			/if;

		/if;
		
		if: ($import_cancel == false);
			$import_data->(replace: '[LASSO_SITEID]', site_id);
			$import_data->(replace: '\\\'', '\'\'');
		/if;
		
		if: ($import_cancel == false);

			iterate: $schema, (var: 'temp_schema');

				if: ($import_error == '');

					var: 'import_array' = (string_findregexp: $import_data, -find='\\[' + $temp_schema->(find: 'database') + '\\.' + $temp_schema->(find: 'table') + ': ?([^\\]]*)\\]([^\\[]*)\\[/' + $temp_schema->(find: 'table') + '\\]');

					if: ($import_array->size > 2);
						var: 'import_fields' = $import_array->(get:2);
						var: 'import_temp' = $import_array->(get:3);
						$import_temp->trim;

						var: 'delete_sql' = 'DELETE FROM ' + $temp_schema->(find: 'table');
						if: $temp_schema->(find: 'delete') != null;
							$delete_sql += ' WHERE ' + $temp_schema->(find: 'delete');
						/if;
						$temp_schema->(insert: 'delete_sql' = $delete_sql);

						$temp_schema->(insert: 'insert_sql' = (array));
						if: ($import_temp != '') && ($import_temp !>> ';');
							var: 'import_lines' = (string_findregexp: -find='[^\r\n]*', $import_temp);
							iterate: $import_lines, (var: 'temp_line');
								$temp_line->trim;
								$temp_line->(removetrailing: ',');
								if: (true == $temp_line->(beginswith: '(')) && (false == $temp_line->(endswith: ')'));
									$import_lines->(get: loop_count + 1) = $temp_line + '\r\n' + $import_lines->(get: loop_count + 1);
									loop_continue;
								/if;
								$temp_line->(replace: '\\\\', '\\');
								var: 'insert_sql' = 'INSERT INTO ' + $temp_schema->(find: 'table') + ' (' + $import_fields + ') VALUES ' + $temp_line;
								$temp_schema->(find: 'insert_sql')->(insert: $insert_sql);
							/iterate;
						/if;
					/if;

					if: ($temp_schema->(find: 'insert_sql')->(isa: 'array')) && ($temp_schema->(find: 'insert_sql')->(join: '\r') >> ';');
						var: 'import_error' = 'Error - The import file has been corrupted. Imports must contain Lasso 8 server settings.';
						var: 'import_cancel' = true;
					/if;

				/if;

			/iterate;

		/if;

		error_code = 0;
		error_msg = '';

		if: ($import_cancel == false);

			iterate: $schema, (var: 'temp_schema');

				log_warning: 'Import: ' + $temp_schema->(find: 'database') + '.' + $temp_schema->(find: 'table');

				var: 'delete_sql' = $temp_schema->(find: 'delete_sql');
				var: 'insert_sql' = $temp_schema->(find: 'insert_sql');

				if: ($delete_sql != '');

					inline: -log=$__startup_loglevel__, -database=$temp_schema->(find: 'database'),
							-sql=$delete_sql,
							-maxrecords='all';

						if: (error_currenterror) != (error_noerror);
							$import_error += 'SQLite Warning: ' + (error_currenterror) + '<br>';
						/if;

					/inline;
					error_code = 0;
					error_msg = '';
				/if;

				var: 'temp' = (array);
				iterate: $insert_sql, (var: 'insert_temp');
					
					$temp->(insert: $insert_temp);
					if: ($insert_sql->size == loop_count) || ((loop_count % 25) == 0);
					
						inline: -log=$__startup_loglevel__, -database=$temp_schema->(find: 'database'),
								-sql='BEGIN TRANSACTION; ' + $temp->(join: '; ') + '; COMMIT TRANSACTION;',
								-maxrecords='all';
							if: (error_currenterror) != (error_noerror);
								$import_error += 'SQLite Error: ' + (error_currenterror) + '<br>';
							/if;
						/inline;
						error_code = 0;
						error_msg = '';
						var: 'temp' = (array);
					/if;

				/iterate;

			/iterate;

		/if;

		if: ($import_error == '');

			var: 'import_success' = 'The import completed successfully.';

		/if;

		if: ($import_cancel == false);
			{
				sleep: 1000;
				site_restart;
			}->asasync;
		/if;
		
	/if;

?>
