<?LassoScript

_admin_addvar: 'prefs_action', -override=(action_param: 'prefs_action');
_admin_addvar: 'login_action', -override=(action_param: 'login_action');

_admin_addvar: 'login_username', -override=(action_param: 'login_username');
_admin_addvar: 'login_password', -override=(action_param: 'login_password');
_admin_addvar: 'login_newpassword', -override=(action_param: 'login_newpassword');
_admin_addvar: 'login_newconfirm', -override=(action_param: 'login_newconfirm');

// ---------
// prefs

var: 'settings_defaults' = (map: 
		'lasso_admin_queuerefresh' = '1',
		'lasso_admin_errorrefresh' = '1',
		'lasso_admin_queuesize' = '25',
		'lasso_admin_errorsize' = '25',
		'lasso_admin_listingsize' = '10',
		'lasso_classic_enabled' = 'N',
		'error_reporting' = 'minimal',
		'default_page_encoding' = 'UTF-8',
		'lasso_apps_enabled' = 'Y',
		'lasso_digest_auth' = 'N',
	);		
var: 'settings_prefs' = $settings_defaults;
var: 'settings_prefs' = (admin_getpref: $settings_prefs);

if: $settings_prefs->(find: 'execution_override') !>> 'N';
	$settings_prefs->(insert: 'execution_override' = 'Y');
/if;

// ---------
// admin

var:'admin_map'=map;
inline: -log=$__startup_loglevel__, 
		-search,
		-database='lasso_internal', 
		-table='security_users',
		-op='eq', 'id' = 2,
		-maxrecords=1;
	records;
		iterate:(field_names), (var: 'field');
			$admin_map->(insert:$field = (field:$field));
		/iterate;
	/records;
/inline;


// ---------
// action

if: $prefs_action >> 'Update';

	iterate: $settings_prefs->keys, (var: 'key');
		if: (action_param: $key, -count) > 0;
			if: (action_param: $key) == '';
				$settings_prefs->(insert: $key = $settings_defaults->(find: $key));
			else;
				$settings_prefs->(insert: $key = (action_param: $key));
			/if;
		/if;
	/iterate;
	admin_setpref: $settings_prefs;

	protect;
		_execution_timelimit: $settings_prefs->(find: 'execution_timelimit');
	/protect;

	protect;
		lasso_errorreporting: $settings_prefs->(find: 'error_reporting'), -global;
	/protect;
	
	global: '__encoding__' = $settings_prefs->(find: 'default_page_encoding');

	global: '__digest_auth__' = $settings_prefs->(find: 'lasso_digest_auth');

	_security_flushcaches;

/if;

if: $login_action >> 'Update';

	if: ($login_username == '');

		var: 'error' = 'Please enter your server administrator username.';

	else: ($login_password == '');

		var: 'error' = 'Please enter your server administrator password.';
		
	else: ((encrypt_md5: $login_password) != $admin_map->(find:'password'));

		var: 'error' = 'Incorrect server administrator password.';

	else: ($login_newpassword == '') || ($login_newconfirm == '');

		var: 'error' = 'New password must be non-empty.';

	else: ($login_newpassword != '') && ($login_newconfirm != '') &&
		  ($login_newpassword != $login_newconfirm);

		var: 'error' = 'New password and confirmation password must match.';

	else;
		
		inline: -log=$__startup_loglevel__, 
				-update,
				-database='lasso_internal', 
				-table='security_users',
				-keyfield='id',
				-keyvalue=2,
				'name' = $login_username,
				'password' = (encrypt_md5: $login_newpassword),
				'password_plain' = $login_newpassword;
			inline: -log=$__startup_loglevel__, 
					-search,
					-database='lasso_internal', 
					-table='security_users',
					-op='eq', 'id' = 2,
					-maxrecords=1;
				records;
					iterate:(field_names), (var: 'field');
						$admin_map->(insert:$field = (field:$field));
					/iterate;
				/records;
			/inline;
			_security_flushcaches;
		/inline;

	/if;

/if;

?>
