<?LassoScript

var: 'login_serial' = (action_param:'serial');
var: 'login_action' = (action_param: 'action');
var: 'err' = '';
var: 'err_msg' = '';

// dispatch
if: $login_action >> 'Update Serial';

	if: $login_serial->equals($admin_serialnum, -case);
		$err = 0; $err_msg = 'Serial number unchanged';
	else: ($login_serial == null) || ($login_serial >> '*');
		$err = 5; $err_msg = 'Please enter the new serial number, then try again.';
//	else: ( ($login_serial !>> 'LP8') && ($login_serial !>> 'LS8') && ($login_serial !>> 'EVAL') );
//		$err = 6; $err_msg = 'Please double check your serial number, then try again.';
	else;
		inline: -log=$__startup_loglevel__, -findall,
				-database='lasso_internal',
				-table='serial_numbers',
				-maxrecords=1;
			
			if: (found_count == 1);
				inline: -log=$__startup_loglevel__, -update,
						-database='lasso_internal',
						-table='serial_numbers',
						-keyfield='id',
						-keyvalue='1',
						-maxrecords=1,
						'serial'=$login_serial,
						'modified'=date->(format: '%Q %T');
					_security_flushcaches;
					$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
					if: ($err_msg == error_noerror); //  && (_security_isserialized == true);
						$err = 0;	// fix for err -9985 bug
						$admin_serialnum = $login_serial;
						$err = 8; $err_msg = 'You must restart Lasso Service to load the new serial number.';
					/if;
				/inline;
			else;
				inline: -log=$__startup_loglevel__, -add,
						-database='lasso_internal',
						-table='serial_numbers',
						-keyfield='id',
						-maxrecords=1,
						'serial'=$login_serial,
						'modified'=date->(format: '%Q %T');
						
					_security_flushcaches;
					$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
					if: ($err_msg == error_noerror); // && (_security_isserialized == true);
						$err = 0;	// fix for err -9985 bug
						$admin_serialnum = $login_serial;
						$err = 8; $err_msg = 'You must restart Lasso Service to load the new serial number.';
					/if;
				/inline;
			/if;
		/inline;
	/if;

/if;


// Reset global admin serial number if the serial number has changed.

inline: -log=$__startup_loglevel__, -findall,
		-database='lasso_internal',
		-table='serial_numbers',
		-maxrecords=1;
	records;
		var: 'admin_serialnum' = (field:'serial');
	/records;
/inline;
var: 'admin_serialedition' = '';

// Parse the Serial Number
if: (_security_isserialized) == false;
  var: 'admin_serialedition'='Single-User';
else: ($admin_serialnum >> 'LS8.5GL') || ($admin_serialnum >> 'LS8.5DW') || ($admin_serialnum >> 'LP8.5-DEV') || ($admin_serialnum >> 'LS8GL') || ($admin_serialnum >> 'LS8DW') || ($admin_serialnum >> 'LP8-DEV');
  var: 'admin_serialedition'='Single-User';
else: ($admin_serialnum >> 'LP8-' || $admin_serialnum >> 'COMM-' || $admin_serialnum >> 'CLD-' || $admin_serialnum >> 'EDU-' || $admin_serialnum >> 'HOST-' || $admin_serialnum >> 'Lasso-8.6-');
  var: 'admin_serialedition'='Multi-User';
else;
  var: 'admin_serialtemp'=(_security_serialexpiration);
  if: (var: 'admin_serialtemp') != '';
		if: $admin_serialnum >> 'EVAL';
		  var: 'admin_serialedition'='Evaluation (Expires ' + $admin_serialtemp + ')';
		else;
		  var: 'admin_serialedition'='Leased (Expires ' + $admin_serialtemp + ')';
		/if;
  else;
	  var: 'admin_serialedition'='Unknown';
  /if;
/if;

// Obscure Serial Number
var: 'admin_serialdisplay' = $admin_serialnum;
if: $admin_serialdisplay->size > 4;
	$admin_serialdisplay = $admin_serialdisplay->(substring: 1, $admin_serialdisplay->size - 4);
	$admin_serialdisplay += '****';
/if;

?>
