<?LassoScript


//
// Variables
//

_admin_addvar: 'session_action', -override=(action_param: 'session_action', (action_param: 'session_action', -count));

_admin_addvar: 'session_tag', -override=(action_param: 'session_tag');
_admin_addvar: 'session_attr', -override=(action_param: 'session_attr');
_admin_addvar: 'session_prefix', -override=(action_param: 'session_prefix');

//_admin_addvar: 'session_tags', -override=(action_param: 'session_tags');
//_admin_addvar: 'session_prefixes', -override=(action_param: 'session_prefixes');
_admin_addvar: 'session_database', -session='_serveradmin', -override=(action_param: 'session_database');
_admin_addvar: 'session_table', -session='_serveradmin', -override=(action_param: 'session_table');
_admin_addvar: 'session_option', -session='_serveradmin', -override=(action_param: 'session_option');

var: 'remove_tag' = false;

iterate: $_session_globalattributes, (var: 'temp_tag');
	if: (action_param: 'minus:' + $temp_tag->first + ',' + $temp_tag->second + '.x') != '';
			$_session_globalattributes->(remove: loop_count);
			var: 'remove_tag' = true;
			loop_abort;
		/if;
	/iterate;

if: $remove_tag;
	var: 'session_action' = '';

	inline: -log=$__startup_loglevel__, -delete, -database='lasso_internal', -table='global_prefs',
		-keyfield='store_key', -keyvalue='_session_globalattributes';
	/inline;

	inline: -log=$__startup_loglevel__, -add, -database='lasso_internal', -table='global_prefs',
		'store_key'='_session_globalattributes',
		'data'=$_session_globalattributes->serialize;
	/inline;
/if;

var: 'remove_prefix' = false;

iterate: $_session_globalignoreprefixes, (var: 'temp_prefix');
	if: (action_param: 'minus:' + $temp_prefix + '.x') != '';
			$_session_globalignoreprefixes->(remove: loop_count);
			var: 'remove_prefix' = true;
			loop_abort;
		/if;
	/iterate;

if: $remove_prefix;
	var: 'session_action' = '';

	inline: -log=$__startup_loglevel__, -delete, -database='lasso_internal', -table='global_prefs',
		-keyfield='store_key', -keyvalue='_session_globalignoreprefixes';
	/inline;

	inline: -log=$__startup_loglevel__, -add, -database='lasso_internal', -table='global_prefs',
		'store_key'='_session_globalignoreprefixes',
		'data'=$_session_globalignoreprefixes->serialize;
	/inline;
/if;

var: 'session_needstore' = false;

if: ($session_action >> 'Add Tag');

	if: $session_tag == '';
		var: 'tags_error' = 'No tag was entered.';
	else: $session_attr == '';
	else;
		var: 'temp2_pair' = (pair: $session_tag = $session_attr);

		if: $_session_globalattributes >> $temp2_pair;
			var: 'tags_error' = 'That tag/attribute pair has already been added.';
		else;
			$_session_globalattributes->(insert: $temp2_pair);
			$session_tag = '';
		/if;
	/if;

	inline: -log=$__startup_loglevel__, -delete, -database='lasso_internal', -table='global_prefs',
		-keyfield='store_key', -keyvalue='_session_globalattributes';
	/inline;

	inline: -log=$__startup_loglevel__, -add, -database='lasso_internal', -table='global_prefs',
		'store_key'='_session_globalattributes',
		'data'= $_session_globalattributes->serialize;
	/inline;

else: ($session_action >> 'Add Prefix');

	if: $session_prefix == '';
		var: 'prefix_error' = 'No prefix was entered.';
	else: $_session_globalignoreprefixes >> $session_prefix;
		var: 'prefix_error' = 'That prefix is already ignored.';
	else;
		$_session_globalignoreprefixes->(insert: (string: $session_prefix));
		$session_prefix = '';
	/if;

	inline: -log=$__startup_loglevel__, -delete, -database='lasso_internal', -table='global_prefs',
		-keyfield='store_key', -keyvalue='_session_globalignoreprefixes';
	/inline;

	inline: -log=$__startup_loglevel__, -add, -database='lasso_internal', -table='global_prefs',
		'store_key'='_session_globalignoreprefixes',
		'data'=$_session_globalignoreprefixes->serialize;
	/inline;

else: ($session_action >> 'Reset') || (($session_action >> 'Select') && ($session_option >> 'Default'));

	var: 'session_database' = 'site';
	var: 'session_table' = 'sessions';
	var: 'session_option' = 'Default';
	var: 'session_needstore' = true;
	var: 'session_message' = 'Sessions will be stored in the default site.sessions table.';

else: ($session_action >> 'Create Session Table');

	var: 'session_table' = 'sessions';

	inline: -log=$__startup_loglevel__, -database=$session_database,
		-sql='CREATE TABLE IF NOT EXISTS sessions
				(
					id INT PRIMARY KEY AUTO_INCREMENT,
					session_key CHAR(255) NOT NULL,
					data LONGBLOB,
					last_access TIMESTAMP,
					expire_minutes INT DEFAULT 15,
					UNIQUE (session_key)
				)';
		if: (error_currenterror != error_noerror);
			var: 'session_error' = (error_currenterror + ' (' + (error_currenterror: -errorcode) + ')');
		/if;
	/inline;

	_security_flushcaches;
	_datasource_reload: (lasso_datasourcemodulename: $session_database);

	if: !(var_defined: 'session_error');
		inline: -log=$__startup_loglevel__, -database=$session_database,
				-sql='INSERT INTO `' + (encode_sql: $session_table) + '` (session_key, data, last_access, expire_minutes) VALUES ("' (lasso_uniqueid) '","",NOW(),"1")';
			if: (error_currenterror != error_noerror);
				var: 'session_error' = (error_currenterror + ' (' + (error_currenterror: -errorcode) + ')');
			/if;
		/inline;
	/if;

	if: !(var_defined: 'session_error');
		var: 'session_option' = 'Database';
		var: 'session_needstore' = true;
		var: 'session_message' = 'The session table was created successfully';
	/if;

else: ($session_action >> 'Select');

	if: ($session_database != '') && ($session_database != 'site') && ($session_table != '');

		inline: -log=$__startup_loglevel__, -database=$session_database, -sql='DESCRIBE `' + (encode_sql: $session_table) + '`';
			var: 'fields' = (array: 'id','session_key','data','last_access','expire_minutes');
			records;
				$fields->(removeall: (field: 'field'));
			/records;
			if: (error_currenterror != error_noerror);
				var: 'session_error' = (error_currenterror + ' (' + (error_currenterror: -errorcode) + ')');
			else: ($fields->size > 0);
				var: 'session_error' = 'The selected="selected" table does not have the required fields (' + $fields->(join: ', ') + ' missing).';
			/if;
		/inline;

		if: !(var_defined: 'session_error');
			inline: -log=$__startup_loglevel__, -database=$session_database,
					-sql='INSERT INTO `' + (encode_sql: $session_table) + '` (session_key, data, last_access, expire_minutes) VALUES ("' (lasso_uniqueid) '","",NOW(),"1")';
				if: (error_currenterror != error_noerror);
					var: 'session_error' = (error_currenterror + ' (' + (error_currenterror: -errorcode) + ')');
				/if;
			/inline;
		/if;

		if: !(var_defined: 'session_error');
			var: 'session_option' = '';
			var: 'session_needstore' = true;
			var: 'session_message' = 'The session table has been changed successfully.';
		/if;

	else;

		var: 'session_error' = 'Select a valid database and table.';

	/if;

else: ($session_action >> 'Refresh');

	var: 'session_database' = '';
	var: 'session_table' = '';
	var: 'session_option' = '';

/if;

if: ($session_needstore == true);

	global: '_lasso_session_database' = $session_database;
	global: '_lasso_session_table' = $session_table;

	inline: -log=$__startup_loglevel__, -delete, -database='lasso_internal', -table='global_prefs',
		-keyfield='store_key', -keyvalue='lasso_session_database';
	/inline;
	inline: -log=$__startup_loglevel__, -add, -database='lasso_internal', -table='global_prefs',
		'store_key'='lasso_session_database',
		'data'= $session_database;
	/inline;

	inline: -log=$__startup_loglevel__, -delete, -database='lasso_internal', -table='global_prefs',
		-keyfield='store_key', -keyvalue='lasso_session_table';
	/inline;
	inline: -log=$__startup_loglevel__, -add, -database='lasso_internal', -table='global_prefs',
		'store_key'='lasso_session_table',
		'data'= $session_table;
	/inline;

/if;

//
// Fetch Prefs
//

if: (var: 'session_database') == '';
	var: 'session_database' = (global: '_lasso_session_database');
	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='SELECT store_key, data FROM global_prefs WHERE (store_key = "lasso_session_database")';
		if: (found_count > 0);
			var: 'session_database' = (string: (field: 'data'));
		/if;
	/inline;
	if: ($session_database == '');
		var: 'session_database' = 'site';
	/if;

/if;

if: (var: 'session_table') == '';
	var: 'session_table' = (global: '_lasso_session_table');
	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='SELECT store_key, data FROM global_prefs WHERE (store_key = "lasso_session_table")';
		if: (found_count > 0);
			var: 'session_table' = (string: (field: 'data'));
		/if;
	/inline;
	if: ($session_table == '');
		var: 'session_table' = 'sessions';
	/if;
/if;

if: (var: 'session_option') == '';
	if: ($session_database == 'site') && ($session_table == 'sessions');
		var: 'session_option' = 'Default';
	else;
		var: 'session_option' = 'Database';
	/if;
/if;

//
// Build Menus
//

if: ($session_action >> 'Refresh');
	_admin_refreshsecurity;
/if;

var: 'database_list' = (array);
var: 'table_list' = (array);
var: 'session_needstable' = false;

database_names;
	if: (lasso_datasourceismysql: (database_nameitem));
		$database_list->(insert: database_nameitem = database_nameitem);
	/if;
/database_names;

if: !($database_list >> $session_database);
	$database_list->(insert: $session_database = $session_database);
/if;

var: 'has_session' = false;
database_tablenames: $session_database;
	if: (database_tablenameitem == 'sessions');
		var: 'has_session' = true;
	/if;
	inline: -log=$__startup_loglevel__, -database=$session_database, -sql='DESCRIBE `' + (encode_sql: database_tablenameitem) + '`';
		var: 'fields' = (array: 'id','session_key','data','last_access','expire_minutes');
		records;
			$fields->(removeall: (field: 'field'));
		/records;
		if: ($fields->size == 0);
			$table_list->(insert: database_tablenameitem = database_tablenameitem);
		/if;
	/inline;
/database_tablenames;
if: ($has_session == false);
	var: 'session_needstable' = true;
/if;

if: !($table_list >> $session_table);
	if: ($table_list >> 'sessions');
		var: 'session_table' = 'sessions';
	else: ($table_list->size > 0);
		var: 'session_table' = $table_list->(get:1);
	else;
		var: 'session_table' = '';
	/if;
/if;

?>
