<?LassoScript

//
// Variables
//

_admin_addvar: 'tags_action', -default='None', -override=(action_param: 'tags_action', (action_param: 'tags_action', -count));
_admin_addvar: 'category_action', -default='None', -override=(action_param: 'category_action', (action_param: 'category_action', -count));
_admin_addvar: 'tag_action', -default='None', -override=(action_param: 'tag_action', (action_param: 'tag_action', -count));

_admin_addvar: 'tags_categoryid', -override=(action_param: 'tags_categoryid');

var: 'need_flush' = false;


//
// Tag Map
//

var: 'tags_category' = (array:
	'Administration' = (array: 'Admin_CreateUser','Admin_GroupAssignUser','Admin_GroupRemoveUser','Admin_GroupListUsers','Admin_ChangeUser','Admin_ListGroups'),
	'Database' = (array: 'Database_ChangeField','Database_CreateField','Database_CreateTable','Database_RemoveField','Database_RemoveTable'),
	'File' = (array: 'File','File_Copy','File_Create','File_CreationDate','File_CurrentError','File_Delete','File_Exists','File_GetLineCount','File_GetSize','File_IsDirectory','File_ListDirectory','File_ModDate','File_Move','File_Read','File_ReadLine','File_Rename','File_SetSize','File_Write'),
	'Include' = (array: 'Include','Include_URL','Include_Raw','Library'),
	'Technical' = (array: 'Lasso_ExecutionTimeLimit','LassoApp_Create','LassoApp_Dump','LassoApp_List','Process','Sleep','Net'),
		'Utility' = (array: 'Cache','Email_Immediate','Email_Pop','Email_Send','Event_Schedule','Log','Log_Critical','Log_Deprecated','Log_Detail','Log_SQL','Log_Warning'),
);

var: 'tags_alias' = (array:
	'Database_ChangeField' = (array: 'Database_ChangeColumn'),
	'Database_CreateField' = (array: 'Database_CreateColumn'),
	'Database_RemoveField' = (array: 'Database_RemoveColumn'),
	'File_ListDirectory' = (array: 'Directory_Lister','Directory_NameItem','DirectoryNameItem'),
	'Net' = (array: 'TCP_Close','TCP_Open','TCP_Send'),
);

define_tag: 'tag_id', -required='name';
	local: 'tag' = (tags_find: #name);
	if: #tag->(isa: 'tag');
		return: #tag->id;
	else;
		log_warning: 'Tag Security: [' + #name + '] not found';
	/if;
	return: 0;
/define_tag;

var: 'tags_ids' = (map);
var: 'tags_names' = (map);
var: 'tags_temp' = $tags_category;
$tags_temp->(merge: $tags_alias);
iterate: $tags_temp, (var: 'cat');
	iterate: $cat->second, (var: 'tag');
		var: 'id' = (tag_id: $tag);
		if: $id > 0;
			$tags_ids->(insert: $id = $tag);
			$tags_names->(insert: $tag = $id);
		/if;
	/iterate;
/iterate;


//
// Category Map
//

var: 'tags_categorydetail' = null;
if: ($tags_categoryid != '');
	var: 'tags_categorydetail' = $tags_category->(find: $tags_categoryid)->(get:1)->second;
/if;


//
// Process Action
//

var: 'allow_ids' = (array);
var: 'deny_ids' = (array);

if: ($category_action >> 'Apply') || ($category_action >> 'Enable All') || ($category_action >> 'Disable All');

	if: ($category_action >> 'Enable All');
		var: 'allow_ids' = $tags_ids->keys;
	else: ($category_action >> 'Disable All');
		var: 'deny_ids' = $tags_ids->keys;
	else: ($category_action >> 'Apply');

		iterate: $tags_category, (var: 'item');
			var: 'cat_name' = $item->first;
			var: 'cat_tags' = $item->second;

			if: (action_param: 'category_' + $cat_name) == 'Mixed';
				// Mixed
			else: (action_param: 'category_' + $cat_name) == 'Enabled';
				iterate: $cat_tags, (var: 'tag');
					$allow_ids->(insert: $tags_names->(find: $tag));
					var: 'alias' = $tags_alias->(find: $tag);
					if: ($alias != (array)) && ($alias->size > 0);
						iterate: $alias->(get:1)->second, (var: 'tag2');
							$allow_ids->(insert: $tags_names->(find: $tag2));
						/iterate;
					/if;
				/iterate;
			else: (action_param: 'category_' + $cat_name) == 'Disabled';
				iterate: $cat_tags, (var: 'tag');
					$deny_ids->(insert: $tags_names->(find: $tag));
					var: 'alias' = $tags_alias->(find: $tag);
					if: ($alias != (array)) && ($alias->size > 0);
						iterate: $alias->(get:1)->second, (var: 'tag2');
							$deny_ids->(insert: $tags_names->(find: $tag2));
						/iterate;
					/if;
				/iterate;
			/if;

		/iterate;

	/if;

	var: 'tags_action' = 'None';

else: ($tag_action >> 'Apply') || ($tag_action >> 'Enable All') || ($tag_action >> 'Disable All');

	var: 'cat_ids' = (array);
	iterate: $tags_categorydetail, (var: 'tag');
		$cat_ids->(insert: $tags_names->(find: $tag));
		var: 'alias' = $tags_alias->(find: $tag);
		if: ($alias != (array)) && ($alias->size > 0);
			iterate: $alias->(get:1)->second, (var: 'tag2');
				$cat_ids->(insert: $tags_names->(find: $tag2));
			/iterate;
		/if;
	/iterate;

	if: ($tag_action >> 'Enable All');
		var: 'allow_ids' = $cat_ids;
	else: ($tag_action >> 'Disable All');
		var: 'deny_ids' = $cat_ids;
	else: ($tag_action >> 'Apply');

		iterate: $tags_categorydetail, (var: 'tag');
			if: (action_param: 'tag_' + $tag) == 'Enabled';
				$allow_ids->(insert: $tags_names->(find: $tag));
				var: 'alias' = $tags_alias->(find: $tag);
				if: ($alias != (array)) && ($alias->size > 0);
					iterate: $alias->(get:1)->second, (var: 'tag2');
						$allow_ids->(insert: $tags_names->(find: $tag2));
					/iterate;
				/if;
			else: (action_param: 'tag_' + $tag) == 'Disabled';
				$deny_ids->(insert: $tags_names->(find: $tag));
				var: 'alias' = $tags_alias->(find: $tag);
				if: ($alias != (array)) && ($alias->size > 0);
					iterate: $alias->(get:1)->second, (var: 'tag2');
						$deny_ids->(insert: $tags_names->(find: $tag2));
					/iterate;
				/if;
			/if;
		/iterate;

	/if;

	var: 'tags_action' = 'Detail';

/if;

if: ($allow_ids->size > 0) || ($deny_ids->size > 0);

	if: $allow_ids->size > 0;
		var: 'sql' = 'UPDATE security_tags SET enabled=\'Y\' ' +
			'WHERE id in (' + $allow_ids->(join: ',') + ')';
		inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
		/inline;
	/if;

	if: $deny_ids->size > 0;
		var: 'sql' = 'UPDATE security_tags SET enabled=\'N\' ' +
			'WHERE id in (' + $deny_ids->(join: ',') + ')';
		inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
		/inline;
	/if;

	var: 'need_flush' = true;

/if;


//
// Flush Cache If Needed
//

if: (var: 'need_flush') == true;
	_security_flushcaches;
/if;


//
// Find Tag Permissions
//

var: 'tags_status' = (map);

var: 'sql' = 'SELECT id,name,enabled FROM security_tags ' +
	'WHERE id IN (' + $tags_ids->keys->(join: ',') + ')';

inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
	records;
		var: 'temp' = (map);
		loop: (field_name: -count);
			$temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
		/loop;
		$tags_status->(insert: (field: 'name') = $temp);
	/records;
/inline;

?>
