<?LassoScript

	_admin_addvar: -name="action", -override=(action_param: 'action'), -default='none';
	_admin_addvar: 'site_id', -session='_serveradmin', -override=(action_param: 'site_id');

	lasso_executiontimelimit: 0;

	var: 'sites_map' = (array);
	var: 'sites_ids' = (array);
	
	inline: -log=$__startup_loglevel__, -search,
			-database='lasso_internal',
			-table='sites',
			-keyfield='id',
			-maxrecords='all';
		records;
			var: 'temp' = (map);
			iterate: field_names, (var: 'field');
				if: $field == 'description';
					$temp->(insert: 'description' = (string_replaceregexp: -find='<.*?>', -replace='', (field: $field)));
					$temp->(insert: 'url' = (string_replaceregexp: -find='.*<', -replace='', (field: $field)) - '>');
				else;
					$temp->(insert: $field = (field: $field));
				/if;
			/iterate;
			
			protect;
				$temp->(insert: 'status' = (if_true: (server_siteisrunning: $temp->(find: 'id')), 'Running', 'Not Running'));
			/protect;
			
			$sites_map->(insert: $temp);
			$sites_ids->(insert: (field: 'id'));
		/records;
	/inline;
	
	if: ($sites_map->size == 0);
		// Don't display this page if we've encountered an error
		redirect_url: $admin_link + '&tab3=sites';
	/if;
	
	
	var: 'site_detail' = null;
	
	if: ($site_id <= 0) || ($sites_ids !>> $site_id);
		var: 'site_detail' = $sites_map->first;
		var: 'site_id' = $site_detail->(find: 'id');
	else;
		iterate: $sites_map, (var: 'temp');
			if: $temp->(find: 'id') == $site_id;
				var: 'site_detail' = $temp;
				loop_abort;
			/if;
		/iterate;
	/if;
	
	var: 'schema' = (array);
	var: 'internal_database' = 'lasso_internal_' + $site_id;
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_datasources', 'delete'='id > 1'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_datasource_hosts', 'delete'='id_datasource > 1'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_datasource_databases'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_database_tables'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_table_fields'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_users', 'delete'='id > 2'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_ug_map', 'delete'='id_group > 2 AND id_user > 2'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_groups', 'delete'='id > 2'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_group_host_map'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_group_db_map'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_group_table_map'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_group_file_perms'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='security_group_generic_perms'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='global_prefs', 'delete'='store_key NOT IN ("lasso_site_initialized","lasso_uptime","_session_globalignoreprefixes","_session_globalattributes")'));
	$schema->(insert: (map: 'database'=$internal_database, 'table'='jdbc_drivers'));
	$schema->(insert: (map: 'database'='site', 'table'='schedule'));
	$schema->(insert: (map: 'database'='site', 'table'='rewrite_rule'));
	$schema->(insert: (map: 'database'='site', 'table'='rewrite_trigger'));
	$schema->(insert: (map: 'database'='site', 'table'='rewrite_action'));

	if: ($action >> 'Export');
	
		file_serve: (include: (lassoapp_link: 'sites/sites/importexport/export.lasso')), -type='application/force-download', -file='Lasso_Site_' + $site_id + '_' + date->(format: '%Y%m%d%H%M%S') + '.txt';
	
	else: ($action >> 'Import');

		var: 'import_files' = (file_uploads);

		var: 'import_error' = '';
		var: 'import_success' = '';
		var: 'import_cancel' = false;

		if: ($import_files->size == 0);
			var: 'import_error' = 'Error - No file selected. Select the file which contains the Lasso 8 site settings file to import.';
			var: 'import_cancel' = true;
		/if;

		if: ($import_error == '');
			protect;
				var: 'import_bytes' = (file_read: $import_files->(get: 1)->(find: 'upload.name'));
			/protect;
			
			if: $import_bytes->size == 0;
				var: 'import_error' = 'Error - This site does not have permission to access uploaded files. Use the Server Admin interface to import these site settings or contact your server administrator for more information.';
				var: 'import_cancel' = true;
			/if;
		/if;

		if: ($import_error == '');
			If: (Lasso_Version: -LassoPlatform)->contains: 'Mac';
				var: 'import_data' = $import_bytes->(exportstring: 'mac');
			else;
				var: 'import_data' = $import_bytes->(exportstring: 'iso8859-1');
			/if;
		/if;

		if: ($import_cancel == false);

			var: 'import_version' = (string_findregexp: $import_data, -find='\\[version: ?[^\\]]*\\]');
			if: ($import_version->size < 1) || ($import_version->first !>> '8.0');
				var: 'import_error' = 'Error - The import file is in an unknown format. Imports must be created with Lasso 8 or the Lasso Settings Migrator that shipped with Lasso 8.';
				var: 'import_cancel' = true;
			/if;

		/if;
		
		if: ($import_cancel == false);
			$import_data->(replace: '[LASSO_SITEID]', site_id);
			$import_data->(replace: '\\\'', '\'\'');
		/if;
		
		if: ($import_cancel == false);

			iterate: $schema, (var: 'temp_schema');

				if: ($import_error == '');

					var: 'import_array' = (string_findregexp: $import_data, -find='\\[' + ($temp_schema->(find: 'database') - ('_' + $site_id)) + '[_0-9]*\\.' + $temp_schema->(find: 'table') + ': ?([^\\]]*)\\]([^\\[]*)\\[/' + $temp_schema->(find: 'table') + '\\]');

					if: ($import_array->size > 2);
						var: 'import_fields' = $import_array->(get:2);
						var: 'import_temp' = $import_array->(get:3);
						$import_temp->trim;

						var: 'delete_sql' = 'DELETE FROM ' + $temp_schema->(find: 'table');
						if: $temp_schema->(find: 'delete') != null;
							$delete_sql += ' WHERE ' + $temp_schema->(find: 'delete');
						/if;
						$temp_schema->(insert: 'delete_sql' = $delete_sql);

						$temp_schema->(insert: 'insert_sql' = (array));
						if: ($import_temp != '') && ($import_temp !>> ';');
							var: 'import_lines' = (string_findregexp: -find='[^\r\n]*', $import_temp);
							iterate: $import_lines, (var: 'temp_line');
								$temp_line->trim;
								$temp_line->(removetrailing: ',');
								if: (true == $temp_line->(beginswith: '(')) && (false == $temp_line->(endswith: ')'));
									$import_lines->(get: loop_count + 1) = $temp_line + '\r\n' + $import_lines->(get: loop_count + 1);
									loop_continue;
								/if;
								$temp_line->(replace: '\\\\', '\\');
								var: 'insert_sql' = 'INSERT INTO ' + $temp_schema->(find: 'table') + ' (' + $import_fields + ') VALUES ' + $temp_line;
								$temp_schema->(find: 'insert_sql')->(insert: $insert_sql);
							/iterate;
						/if;
					/if;

					if: ($temp_schema->(find: 'insert_sql')->(isa: 'array')) && ($temp_schema->(find: 'insert_sql')->(join: '\r') >> ';');
						var: 'import_error' = 'Error - The import file has been corrupted. Imports must be created with Lasso 8 or the Lasso Settings Migrator that shipped with Lasso 8.';
						var: 'import_cancel' = true;
					/if;

				/if;

			/iterate;

		/if;

		error_code = 0;
		error_msg = '';

		if: ($import_cancel == false);

			iterate: $schema, (var: 'temp_schema');

				log_warning: 'Import: ' + $temp_schema->(find: 'database') + '.' + $temp_schema->(find: 'table');

				var: 'delete_sql' = $temp_schema->(find: 'delete_sql');
				var: 'insert_sql' = $temp_schema->(find: 'insert_sql');

				if: ($delete_sql != '');

					inline: -log=$__startup_loglevel__, -database=$temp_schema->(find: 'database'),
							-sql=$delete_sql,
							-maxrecords='all';

						if: (error_currenterror) != (error_noerror);
							$import_error += 'SQLite Warning: ' + (error_currenterror) + '<br>';
						/if;

					/inline;
					error_code = 0;
					error_msg = '';
				/if;

				var: 'temp' = (array);
				iterate: $insert_sql, (var: 'insert_temp');
					
					$temp->(insert: $insert_temp);
					if: ($insert_sql->size == loop_count) || ((loop_count % 25) == 0);
					
						inline: -log=$__startup_loglevel__, -database=$temp_schema->(find: 'database'),
								-sql='BEGIN TRANSACTION; ' + $temp->(join: '; ') + '; COMMIT TRANSACTION;',
								-maxrecords='all';
							if: (error_currenterror) != (error_noerror);
								$import_error += 'SQLite Error: ' + (error_currenterror) + '<br>';
							/if;
						/inline;
						error_code = 0;
						error_msg = '';
						var: 'temp' = (array);
					/if;

				/iterate;

			/iterate;

		/if;

		if: ($import_error == '');

			var: 'import_success' = 'The import completed successfully.';

		/if;

		if: ($import_cancel == false);
			{
				sleep: 1000;
				server_sitestop: params->first;
				sleep: 1000;
				server_sitestart: params->first;
			}->(asasync: -params=(array: $site_id));
		/if;
		
	/if;
	
?>
