<?LassoScript

//
// Variables
//

_admin_addvar: 'action', -override=(action_param: 'action');
_admin_addvar: 'site_id', -session='_serveradmin', -override=(action_param: 'site_id');
_admin_addvar: 'path_plus', -override=(action_param: 'path_plus');
_admin_addvar: 'lassoapps_path', -override=(action_param: 'lassoapps_path');

var: 'upload_path' = (admin_getpref: '_admin_upload_path');

//
// Process Action
//

if: ((action_param: 'path_status', -count) > 0);
		
	if: ($site_id > 0);
		loop: (action_param: 'path_status', -count);
			var: 'path_minus' = (action_param: 'path_status', loop_count);
			if: ((integer: (action_param: 'path_minus_' + loop_count + '.x')) > 0);
				inline: -log=$__startup_loglevel__, -search,
						-database='lasso_internal',
						-table='security_site_paths',
						-keyfield='id',
						-op='eq', 'id_site'=$site_id,
						-op='eq', 'path'=$path_minus,
						-returnfield='id',
						-maxrecords='all';
					if: (found_count > 0);
						inline: -log=$__startup_loglevel__, -delete,
								-database='lasso_internal',
								-table='security_site_paths',
								-keyfield='id',
								-keyvalue=(field: 'id'),
								-maxrecords=0;
						/inline;
						inline: -log=$__startup_loglevel__,
								-database='lasso_internal_' + (integer: $site_id),
								-table='security_groups_file_perms',
								-sql='DELETE FROM security_group_file_perms WHERE allow_root = "' + (integer: (field: 'id')) + '"';
						/inline;

						if: (site_refresh: $site_id) == false;
							var: 'site_error' = 'The security cache of the site could not be flushed. Restart the site to apply these changes.';
						/if;
						
					/if;
				/inline;
				
			/if;
		/loop;
	/if;

/if;

if: ($action >> 'Allow Web Server Root');
	var: 'path_plus' = '/';
	var: 'action' = 'add';
else: ($action >> 'Allow File Upload');
	var: 'path_plus' = $upload_path;
	var: 'action' = 'add';
else: ($action >> 'Allow LassoApps');
	var: 'path_plus' = $lassoapps_path;
	var: 'action' = 'add';
/if;

if: ($action >> 'Test');

	var: 'uploads' = file_uploads;
	if: ($uploads->size > 0);
		protect;
			var: 'upload_path' = (string_replaceregexp: $uploads->first->(find: 'path'), -find='[^/]*\\.uld', -replace='');
			admin_setpref: '_admin_upload_path', $upload_path;
		/protect;
	/if;
	
else: ($action >> 'Add');
	
	if: ($site_id > 0) && ($path_plus != '');
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='security_site_paths',
				-keyfield='id',
				-op='eq', 'id_site'=$site_id,
				-op='eq', 'path'=$path_plus,
				-returnfield='id',
				-maxrecords='all';
			if: (found_count == 0);
				inline: -log=$__startup_loglevel__, -add,
						-database='lasso_internal',
						-table='security_site_paths',
						-keyfield='id',
						'id_site'=$site_id,
						'path'=$path_plus,
						-maxrecords=0;
				/inline;

				if: (site_refresh: $site_id) == false;
					var: 'site_error' = 'The security cache of the site could not be flushed. Restart the site to apply these changes.';
				/if;
	
			/if;
		/inline;		
	/if;

else: ($action >> 'Restart');

	log_detail: 'Server Admin: Restarting site ' + $site_id;
	if: ($site_id > 0);
		server_sitestop: $site_id;
		server_sitestart: $site_id;
	/if;

else: ($action >> 'Start');

	log_detail: 'Server Admin: Starting site ' + $site_id;
	if: ($site_id > 0);
		server_sitestart: $site_id;
	/if;

else: ($action >> 'Stop');

	log_detail: 'Server Admin: Stopping site ' + $site_id;
	if: ($site_id > 0);
		server_sitestop: $site_id;
	/if;

/if;

var: 'sites_map' = (array);
var: 'sites_ids' = (array);

inline: -log=$__startup_loglevel__, -search,
		-database='lasso_internal',
		-table='sites',
		-keyfield='id',
		-maxrecords='all';
	records;
		var: 'temp' = (map);
		iterate: field_names, (var: 'field');
			if: $field == 'description';
				$temp->(insert: 'description' = (string_replaceregexp: -find='<.*?>', -replace='', (field: $field)));
				$temp->(insert: 'url' = (string_replaceregexp: -find='.*<', -replace='', (field: $field)) - '>');
			else;
				$temp->(insert: $field = (field: $field));
			/if;
		/iterate;
		
		protect;
			$temp->(insert: 'status' = (if_true: (server_siteisrunning: $temp->(find: 'id')), 'Running', 'Not Running'));
		/protect;
		
		$sites_map->(insert: $temp);
		$sites_ids->(insert: (field: 'id'));
	/records;
/inline;

if: ($sites_map->size == 0);
	// Don't display this page if we've encountered an error
	redirect_url: $admin_link + '&tab3=sites';
/if;


var: 'site_detail' = null;

if: ($site_id <= 0) || ($sites_ids !>> $site_id);
	var: 'site_detail' = $sites_map->first;
	var: 'site_id' = $site_detail->(find: 'id');
else;
	iterate: $sites_map, (var: 'temp');
		if: $temp->(find: 'id') == $site_id;
			var: 'site_detail' = $temp;
			loop_abort;
		/if;
	/iterate;
/if;
	
var: 'site_paths' = (array);

inline: -log=$__startup_loglevel__, -search, 
		-database='lasso_internal', 
		-table='security_site_paths',
		-keyfield='id',
		-op='eq', 'id_site' = $site_id,
		-maxrecords='all';
	records;
		$site_paths->(insert: (field: 'path'));
	/records;
/inline;

var: 'lassoapps_path' = admin_lassoservicepath + '/LassoSites/' + $site_detail->(find: 'name') + '-' + $site_detail->(find: 'id') + '/LassoAdmin/BuildLassoApps/';


?>
