<?LassoScript

_admin_addvar: 'action', -override=(action_param: 'action');
_admin_addvar: 'site_id', -session='_serveradmin', -override=(action_param: 'site_id');
_admin_addvar: 'site_username', -override=(action_param: 'site_username');
_admin_addvar: 'site_password', -override=(action_param: 'site_password');
_admin_addvar: 'site_confirm', -override=(action_param: 'site_confirm');

var: 'site_defaults' = (map:
		'lasso_smtp_username'='', 
		'lasso_smtp_password'='',
		'lasso_smtp_port'=25,
		'lasso_smtp_host'='',
		'lasso_site_initialized'='',
		'lasso_uptime'='',
		'lasso_site_admin_url'='',
);
var: 'site_defaults' = (admin_getpref: $site_defaults);


if: ($action >> 'Update');
	
	if: ($site_id > 0);

		var: 'site_prefs' = $site_defaults;
		iterate: $site_defaults->keys, (var: 'key');
			if: (action_param: $key, -count) > 0;
				if: (action_param: $key) == '';
					$site_prefs->(insert: $key = $site_defaults->(find: $key));
				else;
					$site_prefs->(insert: $key = (action_param: $key));
				/if;
			/if;
		/iterate;
		$site_prefs->(remove: 'lasso_site_admin_url'); // Remove so we don't eliminate the remembered link
		admin_setpref: $site_prefs, -site=$site_id;
		
		inline: -log=$__startup_loglevel__, -search, 
				-database='lasso_internal_' + $site_id, 
				-table='security_users',
				-keyfield='id',
				-op='eq', 'id' = 2,
				-maxrecords=1;
			if: (found_count > 0);
				if: ($site_username != '') && ($site_password != '') && (((field: 'name') != $site_username) || ((field: 'password_plain') != $site_password) || ((field: 'password') != (encrypt_md5: $site_password))) && ($site_confirm == $site_password);
					inline: -log=$__startup_loglevel__, -update, 
							-database='lasso_internal_' + $site_id, 
							-table='security_users',
							-keyfield='id',
							-keyvalue=(field: 'id'),
							'name' = $site_username,
							'password' = (encrypt_md5: $site_password),
							'password_plain' = $site_password,
							'created' = date->(format: '%Q %T'),
							'modified' = date->(format: '%Q %T'),
							'comment' = 'Modified by Server Admin',
							'id_site' = $site_id,
							'enabled' = 'Y';
					/inline;

					if: (site_refresh: $site_id) == false;
						var: 'site_error' = 'The security cache of the site could not be flushed. Restart the site to apply these changes.';
					/if;
					
				/if;
			else;
				if: ($site_confirm == $site_password);
					inline: -log=$__startup_loglevel__, -add, 
							-database='lasso_internal_' + $site_id, 
							-table='security_users',
							'id' = 2,
							'name' = $site_username,
							'password' = (encrypt_md5: $site_password),
							'password_plain' = $site_password,
							'created' = date->(format: '%Q %T'),
							'modified' = date->(format: '%Q %T'),
							'comment' = 'Created by Server Admin',
							'id_site' = $site_id,
							'enabled' = 'Y';
						if: error_currenterror:-errorcode;
							var:'store_error'='Error storing Admin username/password';
							var: 'error' = true;
						/if;
					/inline;
					
					if: (site_refresh: $site_id) == false;
						var: 'site_error' = 'The security cache of the site could not be flushed. Restart the site to apply these changes.';
					/if;

				/if;
			/if;
		/inline;
		
		
	/if;

else: ($action >> 'Restart');

	log_detail: 'Server Admin: Restarting site ' + $site_id;
	if: ($site_id > 0);
		server_sitestop: $site_id;
		server_sitestart: $site_id;
	/if;

else: ($action >> 'Start');

	log_detail: 'Server Admin: Starting site ' + $site_id;
	if: ($site_id > 0);
		server_sitestart: $site_id;
	/if;

else: ($action >> 'Stop');

	log_detail: 'Server Admin: Stopping site ' + $site_id;
	if: ($site_id > 0);
		server_sitestop: $site_id;
	/if;

/if;

var: 'site_master' = (map:
	'id' = 0,
	'name' = 'Master',
	'root' = 'ServerAdmin.LassoApp',
	'host' = '%',
	'enabled' = 'Y',
	'status' = 'Active',
);

var: 'sites_map' = (array);
var: 'sites_ids' = (array);

inline: -log=$__startup_loglevel__, -search,
		-database='lasso_internal',
		-table='sites',
		-keyfield='id',
		-maxrecords='all';
	records;
		var: 'temp' = (map);
		iterate: field_names, (var: 'field');
			if: $field == 'description';
				$temp->(insert: 'description' = (string_replaceregexp: -find='<.*?>', -replace='', (field: $field)));
				$temp->(insert: 'url' = (string_replaceregexp: -find='.*<', -replace='', (field: $field)) - '>');
			else;
				$temp->(insert: $field = (field: $field));
			/if;
		/iterate;
		
		protect;
			$temp->(insert: 'status' = (if_true: (server_siteisrunning: $temp->(find: 'id')), 'Running', 'Not Running'));
		/protect;
		
		$sites_map->(insert: $temp);
		$sites_ids->(insert: (field: 'id'));
	/records;
/inline;

if: ($sites_map->size == 0);
	// Don't display this page if we've encountered an error
	redirect_url: $admin_link + '&tab3=sites';
/if;

var: 'site_detail' = null;

if: ($site_id <= 0) || ($sites_ids !>> $site_id);
	var: 'site_detail' = $sites_map->first;
	var: 'site_id' = $site_detail->(find: 'id');
else;
	iterate: $sites_map, (var: 'temp');
		if: $temp->(find: 'id') == $site_id;
			var: 'site_detail' = $temp;
			loop_abort;
		/if;
	/iterate;
/if;
	
var: 'site_prefs' = $site_defaults;
var: 'site_prefs' = (admin_getpref: -name=$site_prefs, -site=$site_id);
	
inline: -log=$__startup_loglevel__, -search, 
		-database='lasso_internal_' + $site_id, 
		-table='security_users',
		-keyfield='id',
		-op='eq', 'id' = 2,
		-maxrecords=1;
	var: 'site_username' = (field: 'name');
	var: 'site_password' = (field: 'password_plain');
/inline;

?>
