<?LassoScript

_admin_addvar: 'action', -override=(action_param: 'action');
_admin_addvar: 'dialog_action', -override=(action_param: 'dialog_action');
_admin_addvar: 'site_id', -session='_serveradmin', -override=(action_param: 'site_id');
_admin_addvar: 'site_username', -override=(action_param: 'site_username');
_admin_addvar: 'site_password', -override=(action_param: 'site_password');
_admin_addvar: 'site_confirm', -override=(action_param: 'site_confirm');

var: 'crit_id' = 0;

define_tag: 'visit_url', -optional='host', -optional='root';
	if: !(local_defined: 'host'); 
		local: '_host' = 'localhost';
	else: (#host == '%');
		local: '_host' = 'localhost';
	else;
		local: '_host' = (string: #host);
	/if;
	if: !(local_defined: 'root'); 
		local: '_root' = '/'; 
	else: (#root == '/%'); 
		local: '_root' = '/'; 
	else;
		local: '_root' = (string: #root);
	/if;
	
	local: '_host' = (string_replaceregexp: #_host, -find='http:/*', -replace='');
	local: '_host' = (string_replaceregexp: #_host, -find=':[0-9]*', -replace='');
	local: '_host' = (string_replaceregexp: #_host, -find='%', -replace='');
	#_host->(removeleading: '.');
	#_host->(removetrailing: '.');

	local: '_root' = (string_replaceregexp: #_root, -find='%', -replace='');
	#_root->(removeleading: '/');
	#_root->(removetrailing: '/');
	if: (#_root == '');
		local: '_root' = '/';
	else;
		local: '_root' = '/' + #_root + '/';
	/if;
	
	local: '_url' = 'http://' + #_host + #_root + 'SiteAdmin.LassoApp';
	
	return: @#_url;
	
/define_tag;

loop: (action_param: 'site_criteria', -count);
	var: 'crit_id' = (integer: (action_param: 'site_criteria', loop_count));
	if: ((action_param: 'criteria_minus_' + $crit_id, -count) > 0) || 
		((action_param: 'criteria_minus_' + $crit_id + '.x', -count) > 0);
		var: 'action' = 'Minus';
		loop_abort;
	/if;
/loop;

var: 'site_defaults' = (map:
		'lasso_smtp_username'='', 
		'lasso_smtp_password'='',
		'lasso_smtp_port'=25,
		'lasso_smtp_host'='',
		'lasso_site_initialized'='',
		'lasso_uptime'='',
		'lasso_site_admin_url'='',
		'chartfx_activation_string'='',
);
var: 'site_defaults' = (admin_getpref: $site_defaults);

if: ($action >> 'Preferences');

	redirect_url: $admin_link + '&tab3=prefs&site_id=' + $site_id;

else: ($action >> 'File Paths');

	redirect_url: $admin_link + '&tab3=paths&site_id=' + $site_id;

else: ($action >> 'Add Site...');

	// Create Template
	var: 'site_template' = (map:
		'name' = 'New_Site',
		'root' = '/%',
		'host' = '%',
		'enabled' = 'Y',
	);

else: ($action >> 'Add');

	var: 'site_detail' = (map:
		'name' = (action_param: 'site_name'),
		'root' = (action_param: 'site_root_new'),
		'host' = (action_param: 'site_host_new'),
		'enabled' = 'Y',
		'description' = (action_param: 'site_description') + '<' + (action_param: 'site_url') + '>',
	);
	
	if: ((string_replaceregexp: $site_detail->(find: 'name'), -find='[^:/\\\\]', -replace='') != '');
		var: 'site_error' = 'The site name must consist only of alphanumeric characters and the underscore.';
	else;
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='sites',
				-op='eq', 'name' = $site_detail->(find: 'name'),
				-maxrecords=1;
			if: (found_count > 0);
				var: 'site_error' = 'The site name already exists.';
			/if;
		/inline;	
	/if;

	if: ($site_username == client_username);
		var: 'site_error' = 'The site administrator username must be unique from the server administrator username.';
	else: ($site_password != $site_confirm);
		var: 'site_error' = 'The site administrator password and confirmation do not match.';
	/if;

	if: (var_defined: 'site_error');
	
		var: 'site_template' = $site_detail;
		$site_template->(insert: 'url' = (string_replaceregexp: -find='.*<', -replace='', $site_template->(find: 'description')) - '>');
		$site_template->(insert: 'description' = (string_replaceregexp: -find='<.*?>', -replace='', $site_template->(find: 'description')));

	else;
	
		var: 'url' = (visit_url: -host=$site_detail->(find: 'host'), -path=$site_detail->(find: 'path'));
		
		inline: -log=$__startup_loglevel__, -add,
				-database='lasso_internal',
				-table='sites',
				'name' = $site_detail->(find: 'name'),
				'enabled' = ($site_detail->(find: 'enabled') >> 'Y' ? 'Y' | 'N'),
				'description' = $site_detail->(find: 'description') + '<' + $url + '>',
				'created' = date->(format: '%Q %T');
		/inline;
	
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='sites',
				-sortfield='id',
				-sortorder='descending',
				-maxrecords=1,
				-returnfield='id';
			var: 'site_id' = (field: 'id');
			$site_detail->(insert: 'id' = $site_id);
		/inline;
		
		inline: -log=$__startup_loglevel__, -add,
				-database='lasso_internal',
				-table='sites_criteria',
				'id_site' = $site_id,
				'root' = $site_detail->(find: 'root'),
				'host' = $site_detail->(find: 'host');
		/inline;
		
		var: 'dup_id' = (integer: (action_param: 'site_duplicate'));
		var: 'dup_file_map' = (map);
		
		if: ($dup_id > 0);
			// Duplicate File Paths
			inline: -log=$__startup_loglevel__, -search,
					-database='lasso_internal',
					-table='security_site_paths',
					'id_site' = $dup_id,
					-maxrecords='all';
				records;
					local: 'temp_id' = (field: 'id');
					inline: -log=$__startup_loglevel__, -add,
							-database='lasso_internal',
							-table='security_site_paths',
							'id_site' = $site_id,
							'path' = (field: 'path');
					/inline;
					inline: -log=$__startup_loglevel__, -search,
							-database='lasso_internal',
							-table='security_site_paths',
							-sortfield='id',
							-sortorder='descending',
							-maxrecords=1,
							-returnfield='id';
						$dup_file_map->(insert: $temp_id = (field: 'id'));
					/inline;
				/records;
			/inline;
		else;
			// Default File Paths
			var: 'upload_path' = (admin_getpref: '_admin_upload_path');
			if: $upload_path != '';
				inline: -log=$__startup_loglevel__, -add,
						-database='lasso_internal',
						-table='security_site_paths',
						'id_site' = $site_id,
						'path' = $upload_path,
						-maxrecords=0;
				/inline;
			/if;
			inline: -log=$__startup_loglevel__, -add,
					-database='lasso_internal',
					-table='security_site_paths',
					'id_site' = $site_id,
					'path' = '/',
					-maxrecords=0;
			/inline;
		/if;
		
		// Duplicate Databases
		if: ($dup_id > 0);
			inline: -log=$__startup_loglevel__, -search,
					-database='lasso_internal',
					-table='sites',
					-op='eq', 'id' = $dup_id,
					-maxrecords=1;
				if: (found_count) == 1;
					var: 'src_folder' = (field: 'name') + '-' + (field: 'id');
					var: 'src_path' = (admin_lassoservicepath + '/LassoSites/' + $src_folder + '/');
					var: 'dst_folder' = $site_detail->(find: 'name') + '-' + $site_detail->(find: 'id');
					var: 'dst_path' = (admin_lassoservicepath + '/LassoSites/' + $dst_folder + '/');
					file_copy: $src_path, $dst_path;
				/if;
			/inline;
		/if;
		
		// Install LDML Reference
		if: (action_param: 'site_reference') >> 'Y';
			var: 'src_path' = (admin_lassoservicepath + '/SQLiteDBs/LDML8_Reference');
			var: 'dst_folder' = $site_detail->(find: 'name') + '-' + $site_detail->(find: 'id');
			var: 'dst_path' = (admin_lassoservicepath + '/LassoSites/' + $dst_folder + '/SQLiteDBs/LDML8_Reference');
			file_copy: $src_path, $dst_path;
		/if;
		
		// Add lasso_internal_# to the site 0 security
		
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='security_datasource_databases',
				-op='eq', 'name'='lasso_internal_' + $site_id,
				-returnfield='id',
				-maxrecords=1;
			if: (found_count == 0);
				inline: -log=$__startup_loglevel__, -add,
						-database='lasso_internal',
						-table='security_datasource_databases',
						'id_datasource'=1,
						'id_host'=1,
						'name'='lasso_internal_' + $site_id,
						'enabled'='Y';
				/inline;
				_datasource_reload: 1;
			/if;
		/inline;
				
		_security_flushcaches;
		
		// Activate Site
	
		server_sitestart: $site_id;
	
		// Set Preferences
		
		var: 'site_prefs' = $site_defaults;
		iterate: $site_defaults->keys, (var: 'key');
			if: (action_param: $key, -count) > 0;
				if: (action_param: $key) == '';
					$site_prefs->(insert: $key = $site_defaults->(find: $key));
				else;
					$site_prefs->(insert: $key = (action_param: $key));
				/if;
			/if;
		/iterate;
		admin_setpref: $site_prefs, -site=$site_id;
		inline: -log=$__startup_loglevel__, -search, 
				-database='lasso_internal_' + $site_id, 
				-table='security_users',
				-keyfield='id',
				-op='eq', 'id' = 2,
				-maxrecords=1;
			if: (found_count > 0);
				if: ($site_username != '') && ($site_password != '') && (((field: 'name') != $site_username) || ((field: 'password_plain') != $site_password) || ((field: 'password') != (encrypt_md5: $site_password))) && ($site_confirm == $site_password);
					inline: -log=$__startup_loglevel__, -update, 
							-database='lasso_internal_' + $site_id, 
							-table='security_users',
							-keyfield='id',
							-keyvalue=(field: 'id'),
							'name' = $site_username,
							'password' = (encrypt_md5: $site_password),
							'password_plain' = $site_password,
							'created' = date->(format: '%Q %T'),
							'modified' = date->(format: '%Q %T'),
							'comment' = 'Modified by Server Admin',
							'id_site' = $site_id,
							'enabled' = 'Y';
					/inline;
				/if;
			else;
				if: ($site_confirm == $site_password);
					inline: -log=$__startup_loglevel__, -add, 
							-database='lasso_internal_' + $site_id, 
							-table='security_users',
							'id' = 2,
							'name' = $site_username,
							'password' = (encrypt_md5: $site_password),
							'password_plain' = $site_password,
							'created' = date->(format: '%Q %T'),
							'modified' = date->(format: '%Q %T'),
							'comment' = 'Created by Server Admin',
							'id_site' = $site_id,
						'enabled' = 'Y';
						if: error_currenterror:-errorcode;
							var:'store_error'='Error storing Admin username/password';
							var: 'error' = true;
						/if;
					/inline;
				/if;
			/if;
		/inline;

		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal_' + $site_id, 
				-table='security_ug_map',
				-keyfield='id',
				-op='eq', 'id_user' = 2,
				-op='eq', 'id_group' = 2,
				-returnfield='id',
				-maxrecords=1,
				-uselimit;
			if: (found_count == 0);
				inline: -log=$__startup_loglevel__, -add, 
						-database='lasso_internal_' + $site_id, 
						-table='security_ug_map',
						'id_user' = 2,
						'id_group' = 2,
						'precedence' = 1,
						'admin' = 'Y',
						'modified' = date->(format: '%Q %T');
					if: error_currenterror:-errorcode;
						var:'store_error'='Error creating site administrator username/password';
						var: 'error' = true;
					/if;
				/inline;
			/if;
		/inline;

		// Fix file permissions
		if: $dup_file_map->size > 0;
			inline: -log=$__startup_loglevel__, -search,
					-database='lasso_internal_' + $site_id, 
					-table='security_group_file_perms',
					-keyfield='id',
					-maxrecords='all';
				records;
					inline: -log=$__startup_loglevel__, -update, 
							-database='lasso_internal_' + $site_id, 
							-table='security_group_file_perms',
							-keyfield='id',
							-keyvalue=(field: 'id'),
							'allow_root' = (if_null: $dup_file_map->(find: (field: 'allow_root')), (field: 'allow_root'));
					/inline;
				/records;
			/inline;
		/if;

		server_sitestop: $site_id;
		sleep: 1000;
		server_sitestart: $site_id;

		var: 'action' = 'detail';
	/if;

else: ($action >> 'Enable All');

	inline: -log=$__startup_loglevel__, -database='lasso_internal',
			-sql='UPDATE sites SET enabled="Y"';
	/inline;

	inline: -log=$__startup_loglevel__, -search,
			-database='lasso_internal',
			-table='sites',
			-keyfield='id',
			-maxrecords='all',
			-op='gt', 'id'=1;
		records;
			server_sitestart: (integer: (field: 'id'));
		/records;
	/inline;

	_security_flushcaches;

else: ($action >> 'Disable All');

	inline: -log=$__startup_loglevel__, -database='lasso_internal',
			-sql='UPDATE sites SET enabled="N" WHERE id > 1';
	/inline;

	inline: -log=$__startup_loglevel__, -search,
			-database='lasso_internal',
			-table='sites',
			-keyfield='id',
			-maxrecords='all',
			-op='gt', 'id'=1;
		records;
			server_sitestop: (integer: (field: 'id'));
		/records;
	/inline;

	_security_flushcaches;

else: ($action >> 'Update');
	
	if: ($site_id > 0);

		var: 'site_url' = (action_param: 'site_url');
		
		loop: (action_param: 'site_criteria', -count);
			var: 'criteria_id' = (integer: (action_param: 'site_criteria', loop_count));
			if: $criteria_id > 1;
				var: 'criteria_detail' = (map:
					'root' = (action_param: 'site_root_' + $criteria_id),
					'host' = (action_param: 'site_host_' + $criteria_id),
				);
				
				inline: -log=$__startup_loglevel__, -update,
						-database='lasso_internal',
						-table='sites_criteria',
						-keyfield='id',
						-keyvalue=$criteria_id,
						'root' = $criteria_detail->(find: 'root'),
						'host' = $criteria_detail->(find: 'host');
				/inline;
				
				if: ($criteria_detail->(find: 'host') != '') && ($criteria_detail->(find: 'root') != '');
					var: 'site_url' = (visit_url: -host=$criteria_detail->(find: 'host'), -root=$criteria_detail->(find: 'root'));
				/if;
			/if;
		/loop;

		var: 'inline' = (array:
			'description' = (action_param: 'site_description') + '<' + (var: 'site_url') + '>',
		);
		
		var: 'need_name' = ($site_id == 1 ? 'default' | (action_param: 'site_name'));
		var: 'need_copy' = false;
		var: 'need_enabled' = 'Y';
				
		if: ((action_param: 'site_enabled') >> 'N') && ($site_id > 1);
			$inline->(insert: 'enabled' = 'N');
			server_sitestop: $site_id;
			var: 'need_enabled' = 'N';
		else;
			$inline->(insert: 'enabled' = 'Y');
			var: 'need_enabled' = 'Y';
		/if;
		
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='sites',
				-op='eq', 'id' = $site_id,
				-maxrecords=1;
			if: (found_count) == 1;
				var: 'src_folder' = (field: 'name') + '-' + (field: 'id');
				var: 'src_path' = (admin_lassoservicepath + '/LassoSites/' + $src_folder + '/');
				if: (field: 'name') != $need_name;
					$inline->(insert: 'name' = $need_name);
					var: 'need_copy' = true;
					var: 'dst_folder' = $need_name + '-' + (field: 'id');
					var: 'dst_path' = (admin_lassoservicepath + '/LassoSites/' + $dst_folder + '/');
				/if;
			/if;
		/inline;

		if: ($need_copy == true);
			server_sitestop: $site_id;
			sleep: 5000;
			file_move: $src_path, $dst_path;
		/if;
		
		inline: -log=$__startup_loglevel__, -update,
				-database='lasso_internal',
				-table='sites',
				-keyfield='id',
				-keyvalue=$site_id,
				$inline;
		/inline;
	
		_security_flushcaches;

		if: ($need_copy == true);
			sleep: 5000;
			if: $need_enabled >> 'Y';
				server_sitestart: $site_id;
			/if;
		/if;
		
		if: ((action_param: 'site_root_new') != '') || ((action_param: 'site_host_new') != '');
			var: 'criteria_detail' = (map:
				'root' = (action_param: 'site_root_new'),
				'host' = (action_param: 'site_host_new'),
			);
			inline: -log=$__startup_loglevel__, -add,
					-database='lasso_internal',
					-table='sites_criteria',
					'id_site' = $site_id,
					'root' = $criteria_detail->(find: 'root'),
					'host' = $criteria_detail->(find: 'host');
			/inline;
		/if;
		
		var: 'action' = 'detail';
	else;
		var: 'action' = 'none';
	/if;

else: ($action >> 'Minus');

	if: $crit_id > 0;
		inline: -log=$__startup_loglevel__, -delete,
				-database='lasso_internal',
				-table='sites_criteria',
				-keyfield='id',
				-keyvalue=$crit_id;
		/inline;
	/if;
	var: 'action' = 'detail';

	_security_flushcaches;

else: ($dialog_action >> 'Delete');

	if: ($site_id > 0);
		
		server_sitestop: $site_id;
		
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='sites',
				-op='eq', 'id' = $site_id,
				-maxrecords=1;
			if: (found_count) == 1;
				var: 'src_folder' = (field: 'name') + '-' + (field: 'id');
				var: 'src_path' = (admin_lassoservicepath + '/LassoSites/' + $src_folder + '/');
				var: 'dst_folder' = (field: 'name') + '-' + (field: 'id');
				var: 'dst_path' = (admin_lassoservicepath + '/LassoSitesDeleted/' + $dst_folder + '/');
				file_move: $src_path, $dst_path;
			/if;
		/inline;

		inline: -log=$__startup_loglevel__, -sql='delete from sites where id = ' + $site_id,
				-database='lasso_internal',
				-table='sites';
		/inline;
		
		inline: -log=$__startup_loglevel__, -sql='delete from sites_criteria where id_site = ' + $site_id,
				-database='lasso_internal',
				-table='sites_criteria';
		/inline;

		inline: -log=$__startup_loglevel__, -sql='delete from security_site_paths where id_site = ' + $site_id,
				-database='lasso_internal',
				-table='security_site_paths';
		/inline;

	/if;

	_security_flushcaches;

	var: 'action' = 'none';

else: ($action >> 'Start All');

	inline: -log=$__startup_loglevel__, -search,
			-database='lasso_internal',
			-table='sites',
			-keyfield='id',
			-op='eq', 'enabled'='Y',
			-maxrecords='all';
		records;
			if: !(server_siteisrunning: (field: 'id'));
				server_sitestart: (integer: (field: 'id'));
			/if;
		/records;
	/inline;
	
	var: 'action' = 'none';

else: ($action >> 'Stop All');

	inline: -log=$__startup_loglevel__, -search,
			-database='lasso_internal',
			-table='sites',
			-keyfield='id',
			-maxrecords='all';
		records;
			if: (server_siteisrunning: (field: 'id'));
				server_sitestop: (integer: (field: 'id'));
			/if;
		/records;
	/inline;
	
	var: 'action' = 'none';

else: ($action >> 'Restart');

	log_detail: 'Server Admin: Restarting site ' + $site_id;
	if: ($site_id > 0);
		server_sitestop: $site_id;
		server_sitestart: $site_id;
	/if;
	var: 'action' = 'detail';

else: ($action >> 'Start');

	log_detail: 'Server Admin: Starting site ' + $site_id;
	if: ($site_id > 0);
		server_sitestart: $site_id;
	/if;
	var: 'action' = 'detail';

else: ($action >> 'Stop');

	log_detail: 'Server Admin: Stopping site ' + $site_id;
	if: ($site_id > 0);
		server_sitestop: $site_id;
	/if;
	var: 'action' = 'detail';

/if;

var: 'site_master' = (map:
	'id' = 0,
	'name' = 'Master',
	'root' = 'ServerAdmin.LassoApp',
	'host' = '%',
	'enabled' = 'Y',
	'status' = 'Active',
);

var: 'sites_map' = (array);
var: 'sites_criteria' = (array);

inline: -log=$__startup_loglevel__, -search,
		-database='lasso_internal',
		-table='sites',
		-keyfield='id',
		-maxrecords='all';
	records;
		var: 'temp' = (map);
		iterate: field_names, (var: 'field');
			if: $field == 'description';
				$temp->(insert: 'description' = (string_replaceregexp: -find='<.*?>', -replace='', (field: $field)));
				$temp->(insert: 'url' = (string_replaceregexp: -find='.*<', -replace='', (field: $field)) - '>');
			else;
				$temp->(insert: $field = (field: $field));
			/if;
		/iterate;
		
		protect;
			$temp->(insert: 'status' = (if_true: (server_siteisrunning: $temp->(find: 'id')), 'Running', 'Not Running'));
		/protect;
		
		$sites_map->(insert: $temp);
	/records;
/inline;

var: 'site_detail' = null;

if: ($action >> 'Detail');
	if: $site_id == 0;
		var: 'site_detail' = $site_master;
	else:  $site_id > 0;
		iterate: $sites_map, (var: 'temp');
			if: $temp->(find: 'id') == $site_id;
				var: 'site_detail' = $temp;
				loop_abort;
			/if;
		/iterate;
			
		var: 'site_prefs' = $site_defaults;
		var: 'site_prefs' = (admin_getpref: -name=$site_prefs, -site=$site_id);
			
		inline: -log=$__startup_loglevel__, -search, 
				-database='lasso_internal_' + $site_id, 
				-table='security_users',
				-keyfield='id',
				-op='eq', 'id' = 2,
				-maxrecords=1;
			var: 'site_username' = (field: 'name');
			var: 'site_password' = (field: 'password_plain');
		/inline;
		
		var: 'criteria_description' = (array);
		
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='sites_criteria',
				-keyfield='id',
				-op='eq', 'id_site'=$site_id,
				-maxrecords='all';
			records;
				var: 'temp' = (map);
				iterate: field_names, (var: 'field');
					$temp->(insert: $field = (field: $field));
				/iterate;
				$sites_criteria->(insert: $temp);
				$criteria_description->(insert: '<b>Host:</b> ' + (field: 'host') + ' / <b>Root:</b> ' + (field: 'root'));
			/records;
		/inline;

		admin_setpref: -name='lasso_site_criteria', -value=$criteria_description->(join: '<br />'), -site=$site_id;

	else;
		var: 'action' = 'none';
	/if;
/if;

?>
