<?LassoScript

var: 'admin_refresh' = (integer: (admin_getpref: 'lasso_admin_errorrefresh', -default='1')) * 60;

_admin_addvar: 'error_filter', -session='_siteadmin', -default='', -force=(action_param: 'error_filter');
_admin_addvar: 'error_status', -session='_siteadmin', -default='all', -override=(action_param: 'error_status');
_admin_addvar: 'error_action', -default='None', -override=(action_param: 'error_action');

_admin_addvar: 'error_skip', -default=0, -session='_siteadmin', -override=(action_param: 'error_skip');
_admin_addvar: 'error_max', -default=(integer: (admin_getpref: 'lasso_admin_errorsize', -default=25));
_admin_addvar: 'error_navigation', -override=(action_param: 'error_navigation');
_admin_addvar: 'error_found', -default=0, -session='_siteadmin', -override=(action_param: 'error_found');

_admin_addvar: 'error_sortfield', -default='id', -session='_siteadmin', -override=(action_param: 'error_sortfield');
_admin_addvar: 'error_sortorder', -default='descending', -session='_siteadmin', -override=(action_param: 'error_sortorder');

_admin_addvar: 'error_oldfilter', -session='_siteadmin', -override=(action_param: 'error_oldfilter');
_admin_addvar: 'error_oldstatus', -session='_siteadmin', -override=(action_param: 'error_oldstatus');
if: ($error_oldstatus == '') || ($error_oldstatus != $error_status) || ($error_oldfilter == '') || ($error_oldfilter != $error_filter);
	var: 'error_skip' = 0;
/if;

var: 'error_skip' = (integer: $error_skip);
var: 'error_max' = (integer: $error_max);
var: 'error_found' = (integer: $error_found);

if: ($error_navigation >> 'Next');
	$error_skip = (integer: ($error_skip + $error_max));
else: ($error_navigation >> 'Prev');
	$error_skip = (integer: (math_max: $error_skip - $error_max, 0));
else: ($error_navigation >> 'Last');
	$error_skip = $error_found - $error_max;
else: ($error_navigation >> 'First') || ($error_navigation >> 'Sort');
	$error_skip = 0;
else: ($error_navigation >> 'Jump') || ((action_param: 'error_navigation_skip') != '');
	$error_skip = (math_max: (integer: (action_param: 'error_navigation_skip')) - 1, 0);
/if;

if: ($error_skip >= 0) && ($error_found >= 0);
	$error_skip = (math_max: (math_min: $error_found - 1, $error_skip), 0);
/if;


var: 'error_inline' = (array);

$error_inline->(insert: -database='lasso_internal');
$error_inline->(insert: -table='errors');

$error_inline->(insert: -maxrecords=$error_max);
$error_inline->(insert: -skiprecords=$error_skip);

$error_inline->(insert: -sortfield=$error_sortfield);
$error_inline->(insert: -sortorder=$error_sortorder);

if: ($error_filter !== '');
	$error_inline->(insert: -op='cn');
	$error_inline->(insert: 'message'=$error_filter);
/if;	


if: $error_status >> 'all';

	$error_inline->(insert: -search='');

else: $error_status >> 'critical';

	$error_inline->(insert: -search='');
	$error_inline->(insert: -op='eq');
	$error_inline->(insert: 'code'=log_level_critical);

else: $error_status >> 'warning';

	$error_inline->(insert: -search='');
	$error_inline->(insert: -op='eq');
	$error_inline->(insert: 'code'=log_level_warning);

else: $error_status >> 'detail';

	$error_inline->(insert: -search='');
	$error_inline->(insert: -op='eq');
	$error_inline->(insert: 'code'=log_level_detail);

else: $error_status >> 'deprecated';

	$error_inline->(insert: -search='');
	$error_inline->(insert: -op='eq');
	$error_inline->(insert: 'code'=log_level_deprecated);

else: $error_status >> 'sql';

	$error_inline->(insert: -search='');
	$error_inline->(insert: -op='eq');
	$error_inline->(insert: 'code'=log_level_sql);

/if;

if: ($error_action >> 'Delete') && ($error_action >> 'Critical');

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='DELETE FROM errors WHERE code = ' + log_level_critical;
	/inline;

else: ($error_action >> 'Delete') && ($error_action >> 'Warning');

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='DELETE FROM errors WHERE code = ' + log_level_warning;
	/inline;

else: ($error_action >> 'Delete') && ($error_action >> 'Detail');

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='DELETE FROM errors WHERE code = ' + log_level_detail;
	/inline;

else: ($error_action >> 'Delete') && ($error_action >> 'Deprecated');

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='DELETE FROM errors WHERE code = ' + log_level_deprecated;
	/inline;

else: ($error_action >> 'Delete') && ($error_action >> 'Action');

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='DELETE FROM errors WHERE code = ' + log_level_sql;
	/inline;

else: $error_action >> 'Delete All';

	var: 'error_found' = 0;
	var: 'error_skip' = 0;

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='DELETE FROM errors';
	/inline;

/if;

?>
