<?LassoScript

	_admin_addvar: 'action', -override=(action_param: 'action');
	_admin_addvar: 'admin_username', -override=(action_param: 'admin_username');
	_admin_addvar: 'admin_password', -override=(action_param: 'admin_password');
	_admin_addvar: 'admin_confirm', -override=(action_param: 'admin_confirm');
	
	Variable: 'admin_tab_array1' = (Array:
		'initialize'='Initialize',
	);
	var: 'admin_tab1' = 'initialize';
	
	if: (Admin_CurrentGroups >> 'Administrators') && (client_username != '');
		var: 'username' = client_username;
		var: 'password' = client_password;
	else;
		var: 'username' = 'administrator';
		var: 'password' = '';
	/if;

	var: 'pref_defaults' = (map: 
			'lasso_smtp_host' = '',
			'lasso_smtp_port' = 25,
			'lasso_smtp_username' = '',
			'lasso_smtp_password' = '',
			'lasso_admin_email' = '',
			'lasso_site_initialized' = 'Y',
		);		
	var: 'admin_prefs' = $pref_defaults;
	inline: -log=$__startup_loglevel__, -username=$username, -password=$password, -nothing;
		var: 'admin_prefs' = (admin_getpref: $admin_prefs);
	/inline;
	
	var: 'error' = false;

	if: ($action >> 'submit');
	
		if: (var: 'admin_username')=='';
			var:'admin_username_error'='Please enter an administrator username.';
			var: 'error' = true;
		/if;
	
		if: (var: 'admin_password')=='';
			var:'admin_password_error'='Your password must not be blank.';
			var: 'error' = true;
		else: (var: 'admin_password')!=(var: 'admin_confirm');
			var:'admin_password_error'='Your password and confirmation must match.';
			var: 'error' = true;
		/if;
	
		if: !(var_defined: 'admin_username_error') && (!var_defined: 'admin_password_error');

			inline: -log=$__startup_loglevel__, -search, 
					-username=$username,
					-password=$password,
					-database='lasso_internal', 
					-table='security_users',
					-keyfield='id',
					-op='id', 'id'=2, 
					-sortfield='id',
					-returnfield='id';
				if: (found_count) == 0;
					inline: -log=$__startup_loglevel__, -add, 
							-database='lasso_internal', 
							-table='security_users',
							'id' = 2,
							'name' = $admin_username,
							'password' = (encrypt_md5: $admin_password),
							'password_plain' = $admin_password,
							'created' = date->(format: '%Q %T'),
							'enabled' = 'Y';
						if: error_currenterror:-errorcode;
							var:'store_error'='Error creating Admin username/password';
							var: 'error' = true;
						/if;
					/inline;
				else;
					inline: -log=$__startup_loglevel__, -update, 
							-username=$username,
							-password=$password,
							-database='lasso_internal', 
							-table='security_users',
							-keyfield='id',
							-keyvalue=2,
							'name' = $admin_username,
							'password' = (encrypt_md5: $admin_password),
							'password_plain' = $admin_password,
							'created' = date->(format: '%Q %T'),
							'enabled' = 'Y';
						if: error_currenterror:-errorcode;
							var:'store_error'='Error storing Admin username/password';
							var: 'error' = true;
						/if;
					/inline;
					_security_flushcaches;
				/if;
			/inline;
		
		/if;

		if: ($error == false);
			iterate: $admin_prefs->keys, (var: 'key');
				if: (action_param: $key, -count) > 0;
					if: (action_param: $key) == '';
						$admin_prefs->(insert: $key = $pref_defaults->(find: $key));
					else;
						$admin_prefs->(insert: $key = (action_param: $key));
					/if;
				/if;
			/iterate;
			$admin_prefs->(insert: 'lasso_site_initialized' = 'Y');
			inline: -log=$__startup_loglevel__, -username=$username, -password=$password, -nothing;
				admin_setpref: $admin_prefs;
			/inline;
			
			redirect_url: (LassoApp_Link:'default.lasso');
			
		/if;
		
	else;
	
		inline: -log=$__startup_loglevel__, -search,
				-username=$username,
				-password=$password,
				-database='lasso_internal',
				-table='security_users',
				-keyfield='id',
				-op='eq', 'name' = $admin_username,
				-maxrecords='all';
			if: (found_count == 0) && ($admin_username == '');
				var: 'admin_username' = 'siteadmin';
			else;
				var: 'admin_username' = client_username;
			/if;
			var: 'admin_password' = client_password;
			var: 'admin_confirm' = client_password;
		/inline;
	
	/if;
	
?>
