<?LassoScript

	//
	// Session
	//

	protect;
		if: (action_param:'logout') == 'true';
			session_end: -name='_siteadmin';
			redirect_url: (lassoapp_link: 'logout.lasso');
		else;
			session_start: -name='_siteadmin', -expires=1440, -usecookie;
	
			_admin_addvar: -session='_siteadmin', -name='admin_datetime', -default=(string: date);
			_admin_addvar: -session='_siteadmin', -name='admin_increment', -default='123453';
			_admin_addvar: -session='_siteadmin', -name='admin_username', -override=(client_username), -default='';
			_admin_addvar: -session='_siteadmin', -name='admin_ipaddress', -default=(string: _client_address_old);
			_admin_addvar: -session='_siteadmin', -name='admin_usertype', -default='none';
		/if;
	/protect;
	
	var: 'admin_increment' = (integer: $admin_increment) + 3;

	//
	// Tab Arrays
	//

	var: 'admin_tab_disabled1' = (array);
	var: 'admin_tab_disabled2' = (array);
	var: 'admin_tab_disabled3' = (array);

		Variable: 'admin_tab_array1' = (Array:
			'setup'='Setup',
			'utility'='Utility',
			'support'='Support',
		);
		Variable: 'admin_tab_array2' = (Array:
			'setup'=(Array:
				'global'='Site',
				'datasources'='Data Sources',
				'security'='Security',
				'rewrite'='URL Rewrite',
			),
			'utility'=(Array:
				'sql'='SQL',
				'email'='Email',
				'event'='Events',
				'errors'='Errors',
				'threads'='Threads',
				'lassoapps'='LassoApps',
				'cache'='Cache',
			),
			'support'=(Array:
				'support'='Support',
			),
		);
		Variable: 'admin_tab_array3' = (Array:
			'setup:global'=(Array:
				'login'='Summary',
				'prefs'='Admin Settings',
				'syntax'='Lasso Settings',
				'files'='File Extensions',
				'sessions'='Sessions',
				'java'='Java',
				'importexport'='Import/Export',
			),
			'setup:datasources'=(Array:
				'connectors'='Connectors',
				'host'='Hosts',
				'databases'='Databases',
				'tables'='Tables',
				'fields'='Fields',
			),
			'setup:security'=(Array:
				'groups'='Groups',
				'users'='Users',
				'hosts'='Hosts',
				'databases'='Databases',
				'tables'='Tables',
				'files'='Files',
				'tags'='Tags',
			),
			'setup:rewrite'=(Array:
				'list'='Rewrite Rules',
				'edit'='Add Rule',
			),
			'utility:sql'=(Array:
				'browse'='Statement',
			),
			'utility:email'=(Array:
				'email'='Email Queue',
				'parts'='Email Parts',
				'errors'='Email Errors',
				'routes'='Email Routes',
				'addemail'='Send Email',
				'setup'='Setup',
			),
			'utility:event'=(Array:
				'event'='Event Queue',
				'errors'='Event Errors',
				'addevent'='Schedule Event',
			),
			'utility:errors'=(Array:
				'errors'='Lasso Errors',
				'setup'='Setup',
			),
			'utility:threads'=(Array:
				'threads'='Threads',
			),
			'utility:lassoapps'=(Array:
				'list'='List',
				'build'='Build',
				'setup'='Setup',
			),
			'utility:cache'=(Array:
				'list'='List',
				'setup'='Setup',
			),
			'support:support'=(Array:
				'support'='Support',
			),
		);

	// Current Tab

	Variable: 'admin_tab1' = (action_param: 'tab1', (action_param: 'tab1', -count));
	Variable: 'admin_tab2' = (action_param: 'tab2', (action_param: 'tab2', -count));
	Variable: 'admin_tab3' = (action_param: 'tab3', (action_param: 'tab3', -count));

	// Default Tabs

	// Title

	var: 'admin_title' = 'Lasso Site (' + server_name + ' ' + site_name + ' ' + site_id + ') Administration ' + (lasso_version: -lassoversion)->(substring: 1, (lasso_version: -lassoversion)->(find: ' ') - 1);
	var: 'temp' = (_admin_array_find: $admin_tab_array1, $admin_tab1);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;

		var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2);
		if: ($temp != '') && ($temp != 'None');
			$admin_title += ' : ' + $temp;
	
			var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3);
			if: ($temp != '') && ($temp != 'None');
				$admin_title += ' : ' + $temp;
			/if;
		/if;
	/if;
	
	var: 'admin_expires' = (_security_binaryexpiration);
	var: 'admin_eval' = (_security_serialexpiration);
	var: 'admin_serial' = (_security_isserialized);
	if: ($admin_expires != '');
		$admin_title += ' (Build Expires ' + $admin_expires + ')';
	/if;
	if: ($admin_serial == false);
		$admin_title += ' (Developer)';
	/if;

	//
	// LassoApp Links
	//

	if: (var_defined:'admin_file')==false;
		var:'admin_file'=(LassoApp_Link:'default.lasso');
	/if;

	if:(var_defined:'dialog_file')==false;
		var:'dialog_file'=(LassoApp_Link: 'dialog.lasso');
	/if;

	var: 'admin_link' = $admin_file +
		'?tab1=' + $admin_tab1 +
		'&tab2=' + $admin_tab2 +
		'&tab3=' + $admin_tab3 +
		'&-session=_admin:' + (session_id: -name='_siteadmin') +
		'&increment=' + $admin_increment;

	var: 'wide_stripe' = '#bfbfbf';
	var: 'color_beta' = '#bfbfbf';
	var: 'color_alpha' = '#cccccc';

	// Date Format
	Date_SetFormat: '%Q %T';

?>
