<?LassoScript

//
// Variables
//

_admin_addvar: 'datasource_action', -default='None', -override=(action_param: 'datasource_action', (action_param: 'datasource_action', -count));
_admin_addvar: 'datasource_connector_skip', -default=1, -session='_siteadmin', -override=(action_param: 'datasource_connector_skip');
_admin_addvar: 'datasource_navigation', -override=(action_param: 'datasource_navigation');
_admin_addvar: 'datasource_jump', -override=(action_param: 'datasource_jump');

_admin_addvar: 'dialog_action', -override=(action_param: 'dialog_action');

_admin_addvar: 'connector_enabled', -override=(action_param: 'connector_enabled');
_admin_addvar: 'connector_name', -override=(action_param: 'connector_name');
_admin_addvar: 'jdbc_drivertype', -override=(action_param: 'jdbc_drivertype');


//
// Process Action
//

if: $datasource_action >> 'Update';

	_admin_updateconnector: $datasource_connectorid, 'enabled'=$connector_enabled;
	if: $_code != (error_noerror);
		var: 'datasource_error' = $_error + ' (' + $_code + ')';
	else;
		var: 'datasource_message' = 'The connector was updated successfully.';
	/if;

	// Store friendly connector name
	var: 'temp_name' = $datasource_connectordetail->(find: 'name');
	if: ($temp_name != 'sqliteconnector') && ($temp_name != 'mysqlds') && ($temp_name != 'fmremotedatasource') && ($temp_name != 'fmserveradvanceddatasource') && ($temp_name != 'fmserver9datasource');
		admin_setpref: -name='_admin_connector_alias:' + $temp_name, -value=$connector_name;
	/if;

	// JDBC
	if: ($datasource_connectortype >> 'jdbc') && (lasso_tagexists: '_jdbc_driverinfo');
		if: ($jdbc_drivertype != (_jdbc_driverinfo: $datasource_connectorname));
			_jdbc_setdriver: $datasource_connectorname, $jdbc_drivertype;
			_datasource_reload: $datasource_connectorid;
		/if;
	/if;

	var: '__admin_connectors_array' = null;
	var: 'datasource_connectormap' = (_admin_listconnectors);
	var: 'datasource_connectordetail' = $datasource_connectormap->(find: $datasource_connectorid)->(get:1)->second;
	var: 'datasource_action' = 'Detail';

else: $datasource_action >> 'Add Host';

	// Redirect
	var: 'link' = $admin_link + '&tab3=host' +
		'&datasource_connectorid=' + $datasource_connectorid +
		'&datasource_action=Add+Host';
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

else: $dialog_action >> 'Delete';

	_admin_deleteconnector: $datasource_connectorid;

	var: '__admin_connectors_array' = null;
	_admin_refreshsecurity;

	var: 'datasource_connectormap' = (_admin_listconnectors);
	var: 'datasource_connectorid' = 0;

	var: 'datasource_action' = 'Refresh';

else: $datasource_action >> 'List Hosts';

	// Redirect
	var: 'link' = $admin_link + '&tab3=host' +
		'&datasource_connectorid=' + $datasource_connectorid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

else: $datasource_action >> 'List Databases';

	// Redirect
	var: 'link' = $admin_link + '&tab3=databases' +
		'&datasource_connectorid=' + $datasource_connectorid +
		'&datasource_hostid=' + $datasource_hostid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

/if;


//
// Process Navigation
//

if: $datasource_navigation >> 'Prev';
	$datasource_connector_skip -= $admin_listingsize;
else: $datasource_navigation >> 'Next';
	$datasource_connector_skip += $admin_listingsize;
else: $datasource_navigation >> 'First';
	$datasource_connector_skip = 1;
else: $datasource_navigation >> 'Last';
	$datasource_connector_skip = $datasource_connectormap->size - (($datasource_connectormap->size - 1) % $admin_listingsize);
else: $datasource_navigation >> 'Jump';
	$datasource_connector_skip = integer: $datasource_jump;
/if;

var: 'found_count' = $datasource_connectormap->size;
var: 'datasource_connector_skip' = integer: (math_max: 1, (math_min: $datasource_connector_skip, $found_count));
var: 'shown_first' = $datasource_connector_skip;
var: 'shown_last' = integer: (math_min: $found_count, $datasource_connector_skip + ($admin_listingsize - 1));
var: 'shown_count' = ($shown_last - $shown_first + 1);


//
// Count hosts for each connector
//

var: 'datasource_connectorlisthosts' = array;

inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='SELECT DISTINCT id_datasource FROM security_datasource_hosts';
	records;
		$datasource_connectorlisthosts->(insert: (field: 'id_datasource'));
	/records;
/inline;

//
// JDBC
//

if: ($datasource_connectortype >> 'jdbc') && (lasso_tagexists: '_jdbc_driverclasses') && (lasso_tagexists: '_jdbc_driverinfo');

	var: 'jdbc_classmap' = (map:
			0 = 'Unknown Type',
			1 = 'JDBC 2.0 Pooling (Preferred)',
			2 = 'XA Distributed',
			3 = 'JDBC 1.0',
			4 = 'Basic JDBC 2.0 (Not Supported)',
	);

	var: 'jdbc_driverclasses' = (_jdbc_driverclasses: $datasource_connectorname);
	var: 'jdbc_drivertype' = (_jdbc_driverinfo: $datasource_connectorname);

	if: $jdbc_drivertype == null;
		var: 'jdbc_drivertype' = (pair: 'Unknown' = 0);
	/if;

		
/if;

?>
