<?LassoScript

//
// Variables
//

_admin_addvar: 'datasource_action', -default='None', -override=(action_param: 'datasource_action', (action_param: 'datasource_action', -count));
_admin_addvar: 'datasource_database_skip', -default=1, -session='_siteadmin', -override=(action_param: 'datasource_database_skip');
_admin_addvar: 'datasource_navigation', -override=(action_param: 'datasource_navigation');
_admin_addvar: 'datasource_jump', -override=(action_param: 'datasource_jump');

_admin_addvar: 'database_name', -override=(action_param: 'database_name');
_admin_addvar: 'database_alias', -override=(action_param: 'database_alias');
_admin_addvar: 'database_enabled', -override=(action_param: 'database_enabled');
_admin_addvar: 'database_username', -force=(action_param: 'database_username');
_admin_addvar: 'database_password', -force=(action_param: 'database_password');
_admin_addvar: 'database_sqlstop', -force=(action_param: 'database_sqlstop');
_admin_addvar: 'database_usedefaults', -override=(action_param: 'database_usedefaults');
_admin_addvar: 'database_extra', -override=(action_param: 'database_extra');

_admin_addvar: 'table_encoding', -default='', -force=(action_param: 'table_encoding');
if: $table_encoding == '...';
	var: 'table_encoding' = (action_param: 'table_encoding_other');
/if;

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

var: 'utf8_database_array' = (array);




//
// Process Action
//

if: $datasource_action >> 'Update';

	_admin_updatedatabase: $datasource_databaseid,
		'alias'=$database_alias,
		'enabled'=$database_enabled,
		'username'=$database_username,
		'password'=$database_password,
		'sql_stop'=$database_sqlstop,
		'always_use_defaults'=$database_usedefaults,
		'extra'=$database_extra;

	if: $_code != (error_noerror);
		var: 'datasource_error' = $_error + ' (' + $_code + ')';
	else;
		var: 'datasource_message' = 'The database was updated successfully.';
	/if;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);
	var: 'datasource_databasedetail' = $datasource_databasemap->(find: $datasource_databaseid)->(get:1)->second;
	var: 'datasource_databasename' = $datasource_databasedetail->(find: 'name');

	null: _admin_listtables: $datasource_databaseid;

	var: 'datasource_action' = 'Detail';

	if: ($datasource_connectortype >> 'jdbc') || ($datasource_connectortype >> 'filemaker server') || ($datasource_connectortype >> 'sqlite');
		$utf8_database_array->(insert: $datasource_databaseid);
	/if;

else: $dialog_action >> 'Delete Settings';

	_admin_deletedatabase: $datasource_databaseid;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);
	var: 'datasource_databasedetail' = -1;
	var: 'datasource_databasename' = null;

else: $dialog_action >> 'Delete All Settings';

	iterate: $datasource_databasemap, (var: 'temp_database');
		_admin_deletedatabase: $temp_database->first;
	/iterate;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);
	var: 'datasource_databasedetail' = -1;
	var: 'datasource_databasename' = null;

else: $dialog_action >> 'Enable All New';

	iterate: $datasource_databasemap, (var: 'temp_database');
		var: 'id' = $temp_database->first;
		var: 'detail' = $temp_database->second;
		if: $detail->(find: 'status') == 'New';
			_admin_updatedatabase: $id, 'enabled'='Y', 'always_use_defaults'='Y';
		/if;
		if: ($datasource_connectortype >> 'jdbc') || ($datasource_connectortype >> 'filemaker server') || ($datasource_connectortype >> 'sqlite');
			$utf8_database_array->(insert: $id);
		/if;
	/iterate;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);

	iterate: $datasource_databasemap, (var: 'temp');
		null: _admin_listtables: $temp->first;
	/iterate;

else: $dialog_action >> 'Enable All';

	iterate: $datasource_databasemap, (var: 'temp_database');
		var: 'id' = $temp_database->first;
		_admin_updatedatabase: $id, 'enabled'='Y', 'always_use_defaults'='Y';
		if: ($datasource_connectortype >> 'jdbc') || ($datasource_connectortype >> 'filemaker server') || ($datasource_connectortype >> 'sqlite');
			$utf8_database_array->(insert: $id);
		/if;
	/iterate;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);

	iterate: $datasource_databasemap, (var: 'temp');
		null: _admin_listtables: $temp->first;
	/iterate;

else: $dialog_action >> 'Disable All';

	iterate: $datasource_databasemap, (var: 'temp_database');
		var: 'id' = $temp_database->first;
		_admin_updatedatabase: $id, 'enabled'='N';
	/iterate;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);

else: $dialog_action >> 'Perform';

	inline: -log=(global: '__startup_loglevel__'), -database='lasso_internal', 
			-sql='UPDATE security_database_tables \
				SET encoding = \'' + (encode_sql92: $table_encoding) + '\' \
				WHERE id_database = ' + (integer: $datasource_databaseid);			
	/inline;
	
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_action' = 'Detail';

else: $datasource_action >> 'List Tables';

	// Redirect
	var: 'link' = $admin_link + '&tab3=tables' +
		'&datasource_connectorid=' + $datasource_connectorid +
		'&datasource_hostid=' + $datasource_hostid +
		'&datasource_databaseid=' + $datasource_databaseid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

/if;


//
// JDBC/FMSA/SQLite Table Level Encoding
//

var: 'iso_exceptions' = (array: 'security_datasources', 'security_datasource_hosts', 'security_datasource_databases', 'security_database_tables', 'security_table_fields');
var: 'iso_array' = (array);
var: 'utf_array' = (array);

if: ($utf8_database_array->size > 0);

	var: 'sql' = '
		SELECT security_database_tables.id
		FROM security_database_tables 
		LEFT JOIN security_datasource_databases 
			ON (security_database_tables.id_database = security_datasource_databases.id)
		LEFT JOIN security_datasources
			ON (security_datasource_databases.id_datasource = security_datasources.id)
		WHERE (security_datasource_databases.id IN (' + $utf8_database_array->(join: ',') + '))
			AND (security_database_tables.encoding <> "utf-8")
			AND (security_database_tables.name NOT IN ("' + $iso_exceptions->(join: '","') + '"))
	';
	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
		iterate: records_array, (var: 'temp_record');
			$utf_array->(insert: $temp_record->(get:1));
		/iterate;
	/inline;

	var: 'sql' = '
		SELECT security_database_tables.id
		FROM security_database_tables 
		LEFT JOIN security_datasource_databases 
			ON (security_database_tables.id_database = security_datasource_databases.id)
		LEFT JOIN security_datasources
			ON (security_datasource_databases.id_datasource = security_datasources.id)
		WHERE (security_datasource_databases.id IN (' + $utf8_database_array->(join: ',') + '))
			AND (security_database_tables.encoding <> "iso8859-1")
			AND (security_database_tables.name IN ("' + $iso_exceptions->(join: '","') + '"))
	';
	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
		iterate: records_array, (var: 'temp_record');
			$iso_array->(insert: $temp_record->(get:1));
		/iterate;
	/inline;

	if: $utf_array->size > 0;
		log_warning: 'Setting default encoding of SQLite, JDBC, and FileMaker SA tables to UTF-8';
		var: 'sql' = '
			UPDATE security_database_tables
			SET encoding = "utf-8"
			WHERE id IN (' + $utf_array->(join: ',') + ')
		';
		inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
		/inline;
	/if;
	if: $iso_array->size > 0;
		log_warning: 'Setting default encoding of security tables to ISO8859-1';
		var: 'sql' = '
			UPDATE security_database_tables
			SET encoding = "iso8859-1"
			WHERE id IN (' + $iso_array->(join: ',') + ')
		';
		inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
		/inline;
	/if;

/if;


//
// Process Navigation
//

if: $datasource_navigation >> 'Prev';
	$datasource_database_skip -= $admin_listingsize;
else: $datasource_navigation >> 'Next';
	$datasource_database_skip += $admin_listingsize;
else: $datasource_navigation >> 'First';
	$datasource_database_skip = 1;
else: $datasource_navigation >> 'Last';
	$datasource_database_skip = $datasource_databasemap->size - (($datasource_databasemap->size - 1) % $admin_listingsize);
else: $datasource_navigation >> 'Jump';
	$datasource_database_skip = integer: $datasource_jump;
/if;

var: 'found_count' = $datasource_databasemap->size;
var: 'datasource_database_skip' = integer: (math_max: 1, (math_min: $datasource_database_skip, $found_count));
var: 'shown_first' = $datasource_database_skip;
var: 'shown_last' = integer: (math_min: $found_count, $datasource_database_skip + ($admin_listingsize - 1));
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
