<?LassoScript

//
// Variables
//

_admin_addvar: 'datasource_action', -default='None', -override=(action_param: 'datasource_action', (action_param: 'datasource_action', -count));
_admin_addvar: 'datasource_host_skip', -default=1, -session='_siteadmin', -override=(action_param: 'datasource_host_skip');
_admin_addvar: 'datasource_navigation', -override=(action_param: 'datasource_navigation');
_admin_addvar: 'datasource_jump', -override=(action_param: 'datasource_jump');

_admin_addvar: 'create_connectorid', -default='1', -session='_siteadmin', -override=(action_param: 'create_connectorid');
_admin_addvar: 'create_hostid', -session='_siteadmin', -override=(action_param: 'create_hostid');

_admin_addvar: 'create_action', -default='None', -override=(action_param: 'create_action');
_admin_addvar: 'create_alias', -default='New Host', -override=(action_param: 'create_alias');
_admin_addvar: 'create_name', -default='127.0.0.1', -override=(action_param: 'create_name');
_admin_addvar: 'create_port', -override=(action_param: 'create_port');
_admin_addvar: 'create_enabled', -default='Y', -override=(action_param: 'create_enabled');
_admin_addvar: 'create_username', -default='', -force=(action_param: 'create_username');
_admin_addvar: 'create_password', -default='', -force=(action_param: 'create_password');
_admin_addvar: 'create_schema', -default='', -force=(action_param: 'create_schema');
_admin_addvar: 'create_extra', -default='', -force=(action_param: 'create_extra');

_admin_addvar: 'table_encoding', -default='', -force=(action_param: 'table_encoding');
if: $table_encoding == '...';
	var: 'table_encoding' = (action_param: 'table_encoding_other');
/if;

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

_admin_addvar: 'host_alias', -default='New Host', -override=(action_param: 'host_alias');
_admin_addvar: 'host_name', -default='127.0.0.1', -force=(action_param: 'host_name');
_admin_addvar: 'host_port', -force=(action_param: 'host_port');
_admin_addvar: 'host_enabled', -default='Y', -override=(action_param: 'host_enabled');
_admin_addvar: 'host_username', -default='', -force=(action_param: 'host_username');
_admin_addvar: 'host_password', -default='', -force=(action_param: 'host_password');
_admin_addvar: 'host_schema', -default='', -force=(action_param: 'host_schema');
_admin_addvar: 'host_extra', -default='', -force=(action_param: 'host_extra');

//
// JDBC Driver additional properties
//

var: 'host_properties' = (array);
var: 'host_type' = (array);

if: ($datasource_connectortype >> 'jdbc') && ($datasource_connectortype >> 'sqlserver');
	var: 'host_properties' = (array:
		(map: 'choices'=(array: 'cursor', 'direct'), 'description'='Select Method', 'name'='selectMethod', 'required'='false', 'value'='direct'),
		(map: 'choices'='', 'description'='Server Name', 'name'='serverName', 'required'='false', 'value'=''),
		(map: 'choices'='', 'description'='Database Name', 'name'='databaseName', 'required'='false', 'value'=''),
		(map: 'choices'='', 'description'='Login ID', 'name'='user', 'required'='true', 'value'=''),
		(map: 'choices'='', 'description'='Login Password', 'name'='password', 'required'='true', 'value'='')
	);
else: ($datasource_connectortype >> 'jdbc') && (lasso_tagexists: '_jdbc_propertyinfo') && (lasso_tagexists: '_jdbc_driverinfo');
	var: 'host_properties' = (_jdbc_propertyinfo: $datasource_connectorname, $host_name);
	if: $host_properties == null;
		var: 'host_properties' = (array);
	/if;

	var: 'host_type' = (_jdbc_driverinfo: $datasource_connectorname);
	if: $host_type->(isa: 'array') && ($host_type->second != 2);

		var: 'pool_properties' = (array:
			(map: 'choices'='', 'description'='Max Active Connections', 'name'='max-active', 'required'='false', 'value'='0'),
			(map: 'choices'='', 'description'='Max Idle Connections', 'name'='max-idle', 'required'='false', 'value'='0'),
			(map: 'choices'='', 'description'='Max Wait Time', 'name'='max-wait-time', 'required'='false', 'value'='10000'),
			(map: 'choices'='', 'description'='Test Query', 'name'='test-query', 'required'='false', 'value'=''),
			(map: 'choices'='', 'description'='Test While Idle', 'name'='test-while-idle', 'required'='false', 'value'='1'),
			(map: 'choices'='', 'description'='Test On Return', 'name'='test-on-return', 'required'='false', 'value'='1'),
			(map: 'choices'='', 'description'='Test On Borrow', 'name'='test-on-borrow', 'required'='false', 'value'='1'),
			(map: 'choices'='', 'description'='Sweep Run Time', 'name'='swwep-run-time', 'required'='false', 'value'='-1'),
		);

		$host_properties->(merge: $pool_properties);
		
	/if;

/if;

if: $host_properties == null;
	var: 'host_properties' = (array);
/if;



//
// Process Action
//

if: $datasource_action >> 'Update';

	// Update host port based on propertiesaction params
	if: ($datasource_connectortype >> 'jdbc');
		var: 'host_port' = '';
		iterate: $host_properties, (var: 'item');
			var: 'param' = (action_param: 'host_properties_' + $item->(find: 'name'));
			if: ($item->(find: 'name') != 'user') && ($item->(find: 'name') != 'password') && ($param != '');
				$host_port += $item->(find: 'name') + '=' + (encode_stricturl: $param) + '&';
			/if;
		/iterate;
		$host_port->(removetrailing: '&');
	/if;

	if: ((decimal: (lasso_version: -lassoversion)) >= 8.1);
		_admin_updatehost: $datasource_hostid,
			'enabled'=$host_enabled,
			'name'=$host_name,
			'port'=$host_port,
			'username'=$host_username,
			'password'=$host_password,
			'schema'=$host_schema,
			'extra'=$host_extra;
	else;
		_admin_updatehost: $datasource_hostid,
			'enabled'=$host_enabled,
			'name'=$host_name,
			'port'=$host_port,
			'username'=$host_username,
			'password'=$host_password,
			'schema'=$host_schema;
	/if;	

	if: $_code != (error_noerror);
		var: 'datasource_error' = $_error + ' (' + $_code + ')';
	else;
		var: 'datasource_message' = 'The host was updated successfully.';

		if: ($datasource_connectortype >> 'jdbc') && !(var_defined: 'datasource_error');
			if: !(lasso_tagexists: '_jdbc_acceptsurl');
				var: 'datasource_error'='The JDBC datasource connector is not installed.';
			else: (_jdbc_acceptsurl: $datasource_connectorname, $host_name + '?' + $host_port) != true;
				var: 'datasource_error'='A connection could not be established to the JDBC data source.';
			/if;
			if: (error_currenterror) != (error_noerror);
				var: 'datsource_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
			/if;
		/if;

	/if;

	// Store friendly host name
	if: ($datasource_hostid != 1);
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='global_prefs',
				-keyfield='store_key',
				-keyvalue='_admin_host_alias:' + $datasource_hostid,
				-maxrecords=1;
			if: (found_count == 1);
				inline: -log=$__startup_loglevel__, -update,
						-database='lasso_internal',
						-table='global_prefs',
						-keyfield='store_key',
						-keyvalue='_admin_host_alias:' + $datasource_hostid,
						'data' = $host_alias;
				/inline;
			else;
				inline: -log=$__startup_loglevel__, -add,
						-database='lasso_internal',
						-table='global_prefs',
						-keyfield='store_key',
						'store_key' = '_admin_host_alias:' + $datasource_hostid,
						'data' = $host_alias;
				/inline;
			/if;

		/inline;
	/if;

	var: '__admin_hosts_array' = null;
	_admin_refreshconnector: $datasource_connectorid;
	var: 'datasource_hostmap' = (_admin_listhosts: $datasource_connectorid);
	var: 'datasource_hostdetail' = $datasource_hostmap->(find: $datasource_hostid)->(get:1)->second;
	var: 'datasource_action' = 'Detail';

else: $dialog_action >> 'Delete';

	_admin_deletehost: $datasource_hostid;

	var: '__admin_hosts_array' = null;
	_admin_refreshsecurity;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_hostmap' = (_admin_listhosts: $datasource_connectorid);
	var: 'datasource_hostid' = 0;

	var: 'datasource_action' = 'Refresh';

else: $dialog_action >> 'Perform';

	var: 'security_database_tables' = (array);
	inline: -log=(global: '__startup_loglevel__'), -database='lasso_internal', 
			-sql='SELECT security_database_tables.id FROM security_database_tables \
				LEFT JOIN security_datasource_databases ON security_database_tables.id_database = security_datasource_databases.id \
				WHERE security_datasource_databases.id_host = ' + (integer: $datasource_hostid);
		records;
			$security_database_tables->(insert: (field: 'id'));
		/records;
	/inline;
	inline: -log=(global: '__startup_loglevel__'), -database='lasso_internal', 
			-sql='UPDATE security_database_tables \
				SET encoding = \'' + (encode_sql92: $table_encoding) + '\' \
				WHERE id IN (' + $security_database_tables->(join: ',') + ');';			
	/inline;

	var: 'datasource_action' = 'Detail';

else: $datasource_action >> 'List Databases';

	// Redirect
	var: 'link' = $admin_link + '&tab3=databases' +
		'&datasource_connectorid=' + $datasource_connectorid +
		'&datasource_hostid=' + $datasource_hostid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

else: $datasource_action >> 'Add';

	if: $create_action >> 'Add Host';

		var: 'temp_name' = $create_name;
		var: 'temp_port' = $create_port;

		if: ($datasource_connectortype >> 'jdbc');
			if: ((var: 'create_name') == '') ;
				var: 'datasource_error'='Please specify a connection string.';
			else: !(lasso_tagexists: '_jdbc_acceptsurl');
				var: 'datasource_error'='The JDBC datasource connector is not installed.';
			else: (_jdbc_acceptsurl: $datasource_connectorname, $create_name + '?' + $create_port) == false;
				var: 'datasource_error'='A connection could not be established to the JDBC data source.';
			/if;
			if: (error_currenterror) != (error_noerror);
				var: 'datsource_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
			/if;
		else: ($datasource_connectortype >> 'mysql');
			if: ((var: 'create_name') == '') ;
				var: 'datasource_error'='Please specify an IP Address / Host Name.';
			else: ((var: 'create_port') == '') ;
				var: 'datasource_error'='Please specify a port (default 1366)';
				var: 'create_port' = '1366';
			/if;
		else: ($datasource_connectortype >> 'filemaker');
			if: ((var: 'create_name') == '') ;
				var: 'datasource_error'='Please specify an IP Address / Host Name.';
			else: ((var: 'create_port') == '') ;
				var: 'datasource_error'='Please specify a port (default 591)';
				var: 'create_port' = '591';
			/if;
		else;
			if: ((var: 'create_name') == '') ;
				var: 'datasource_error'='Please specify an IP Address / Host Name.';
			/if;
		/if;

		if: ((var: 'datasource_error') == '');

			inline: -log=$__startup_loglevel__, -database='lasso_internal', -table='security_datasource_hosts', -add,
					'id_datasource'=$datasource_connectorid,
					'name'=$temp_name,
					'port'=$temp_port,
					'username'=$create_username,
					'password'=$create_password,
					'enabled'=$create_enabled,
					((decimal: (lasso_version: -lassoversion)) >= 8.1) ? (array: 'extra'=$create_extra) | array;
				if: (error_currenterror) != (error_noerror);
					var: 'datasource_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
				/if;
			/inline;

		/if;

		if: ((var: 'datasource_error') == '');

			var: '__admin_hosts_array' = null;
			var: 'datasource_hostmap' = (_admin_listhosts: $datasource_connectorid);

			var: 'datasource_hostid' = 0;

			iterate: $datasource_hostmap, (var: 'temp_host');
				var: 'temp'=@($temp_host->second);

				if: ($temp->(find: 'name') == $temp_name) && ($temp->(find: 'username') == $create_username);
					var: 'datasource_hostid' = $temp->(find: 'id');
					var: 'datasource_hostdetail' = $temp;
				/if;
			/iterate;

			var: 'datasource_action' = 'Detail';

			// Store friendly host name
			if: ($datasource_hostid != 1);
				inline: -log=$__startup_loglevel__, -search,
						-database='lasso_internal',
						-table='global_prefs',
						-keyfield='store_key',
						-keyvalue='_admin_host_alias:' + $datasource_hostid,
						-maxrecords=1;
					if: (found_count == 1);
						inline: -log=$__startup_loglevel__, -update,
								-database='lasso_internal',
								-table='global_prefs',
								-keyfield='store_key',
								-keyvalue='_admin_host_alias:' + $datasource_hostid,
								'data' = $create_alias;
						/inline;
					else;
						inline: -log=$__startup_loglevel__, -add,
								-database='lasso_internal',
								-table='global_prefs',
								-keyfield='store_key',
								'store_key' = '_admin_host_alias:' + $datasource_hostid,
								'data' = $create_alias;
						/inline;
					/if;

				/inline;
			/if;
			var: '__admin_hosts_array' = null;
			var: '__admin_databases_array' = null;
			_admin_refreshconnector: $datasource_connectorid;
			var: 'datasource_hostmap' = (_admin_listhosts: $datasource_connectorid);
			var: 'datasource_hostdetail' = $datasource_hostmap->(find: $datasource_hostid)->(get:1)->second;

			var: 'datasource_action' = 'Detail';

		/if;
	else;

		// Establish Defaults

		if: ($datasource_connectortype >> 'jdbc') && ($datasource_connectortype >> 'sqlserver');
			var: 'create_alias' = 'New SQL Server Host';
			var: 'create_name' = 'jdbc:microsoft:sqlserver://address:1433';
			var: 'create_port' = '';
		else: ($datasource_connectortype >> 'jdbc') && ($host_type->(isa: 'array')) && ( ($host_type->(get: 2) == 1) || ($host_type->(get: 2) == 2) );
			var: 'create_alias' = 'New JDBC Host';
			var: 'create_name' = '127.0.0.1';
			var: 'create_port' = '';
		else: ($datasource_connectortype >> 'jdbc');
			var: 'create_alias' = 'New JDBC Host';
			var: 'create_name' = 'jdbc:company:product://address:port';
			var: 'create_port' = '';
		else: ($datasource_connectortype >> 'mysql');
			var: 'create_alias' = 'New MySQL Host';
			var: 'create_name' = '127.0.0.1';
			var: 'create_port' = '3306';
			var: 'create_extra' = 'Y';
		else: ($datasource_connectortype >> 'filemaker server');
			var: 'create_alias' = 'New FileMaker SA Host';
			var: 'create_name' = '127.0.0.1';
			var: 'create_port' = '80';
		else: ($datasource_connectortype >> 'filemaker pro');
			var: 'create_alias' = 'New FileMaker Pro Host';
			var: 'create_name' = '127.0.0.1';
			var: 'create_port' = '591';
		else;
			var: 'create_alias' = 'New Host';
			var: 'create_name' = '127.0.0.1';
			var: 'create_port' = '';
		/if;

		var: 'create_username' = '';
		var: 'create_password' = '';
		var: 'create_enabled' = 'Y';
		var: 'create_schema' = '';
	/if;

/if;

if: ($datasource_action >> 'detail');

	if: ($datasource_connectortype >> 'jdbc') && !(var_defined: 'datasource_error');
		if: !(lasso_tagexists: '_jdbc_acceptsurl');
			var: 'datasource_error'='The JDBC datasource connector is not installed.';
		else: (_jdbc_acceptsurl: $datasource_connectorname, $datasource_hostdetail->(find: 'name') + '?' + $datasource_hostdetail->(find: 'port')) != true;
			var: 'datasource_error'='A connection could not be established to the JDBC data source.';
		/if;
		if: (error_currenterror) != (error_noerror);
			var: 'datsource_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
		/if;
	/if;

/if;


//
// Process Navigation
//

if: $datasource_navigation >> 'Prev';
	$datasource_host_skip -= $admin_listingsize;
else: $datasource_navigation >> 'Next';
	$datasource_host_skip += $admin_listingsize;
else: $datasource_navigation >> 'First';
	$datasource_host_skip = 1;
else: $datasource_navigation >> 'Last';
	$datasource_host_skip = $datasource_hostmap->size - (($datasource_hostmap->size - 1) % $admin_listingsize);
else: $datasource_navigation >> 'Jump';
	$datasource_host_skip = integer: $datasource_jump;
/if;

var: 'found_count' = $datasource_hostmap->size;
var: 'datasource_host_skip' = integer: (math_max: 1, (math_min: $datasource_host_skip, $found_count));
var: 'shown_first' = $datasource_host_skip;
var: 'shown_last' = integer: (math_min: $found_count, $datasource_host_skip + ($admin_listingsize - 1));
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
