<?LassoScript

	//
	// Variables
	//

	_admin_addvar: -name='file_action', -override=(action_param: 'file_action'), -default='none';
	_admin_addvar: -name='script_action', -override=(action_param: 'script_action'), -default='none';

	_admin_addvar: -name='new_file_extension', -override=(action_param: 'new_file_extension'), -default='';
	_admin_addvar: -name='new_script_extension', -override=(action_param: 'new_script_extension'), -default='';

	_admin_addvar: -name='current_file_extensions', -session='_siteadmin', -default=(array);
	_admin_addvar: -name='current_script_extensions', -session='_siteadmin', -default=(array);

	_admin_addvar: -name='default_file_extensions', -default=(array: '.txt','.text','.uld','.xml','.xsd','.pdf','.jpg','.gif','.png','.bmp','.psd','.tif','.rgb','.cmyk','.wsdl');
	_admin_addvar: -name='reserved_file_extensions', -default=(array:'.uld');

	_admin_addvar: -name='default_script_extensions', -default=(array: '.las','.lasso','.lassoapp','.htm','.html','.inc','.incl');
	_admin_addvar: -name='reserved_script_extensions', -default=(array:'.lasso','.lassoapp');

	//
	// File Extensions
	//
	
	var: 'temp' = (string: (admin_getpref: 'lasso_file_extensions'));
	var: 'current_file_extensions' = $temp->(split: ' ');
	$current_file_extensions->sort;

	if: ($file_action >> 'reset') || ($temp == '') || ($current_file_extensions->size == 0);
		var: 'current_file_extensions' = $default_file_extensions;
		$current_file_extensions->sort;
	/if;

	iterate: $current_file_extensions, (var: 'temp');
		if: ((action_param: 'file_minus' + $temp + '.x') != '') && !($reserved_file_extensions >> $temp);
			$current_file_extensions->(remove: loop_count);
			var: 'file_action' = 'remove';
			loop_abort;
		/if;
	/iterate;

	if: ($file_action >> 'add');
		var: 'new_file_extension' = (string: $new_file_extension);
		$new_file_extension->trim;
		if: !($new_file_extension->(beginswith: '.'));
			var: 'new_file_extension' = '.' + $new_file_extension;
		/if;

		if: ($new_file_extension == '') || ($new_file_extension == '.');
			var: 'file_action' = 'none';
		else;
			$current_file_extensions->(insert: $new_file_extension);
			$current_file_extensions->sort;
		/if;
	/if;

	if: ($file_action >> 'add') || ($file_action >> 'remove') || ($file_action >> 'reset');
		admin_setpref: -name='lasso_file_extensions', -value=$current_file_extensions->(join: ' ');
 		_security_flushcaches;
	/if;

	//
	// Script Extensions
	//
	
	var: 'temp' = (string: (admin_getpref: 'lasso_script_extensions'));
	var: 'current_script_extensions' = $temp->(split: ' ');
	$current_script_extensions->sort;

	if: ($script_action >> 'reset') || ($temp == '') || ($current_script_extensions->size == 0);
		var: 'current_script_extensions' = $default_script_extensions;
		$current_script_extensions->sort;
	/if;

	iterate: $current_script_extensions, (var: 'temp');
		if: ((action_param: 'script_minus' + $temp + '.x') != '') && !($reserved_script_extensions >> $temp);
			$current_script_extensions->(remove: loop_count);
			var: 'script_action' = 'remove';
			loop_abort;
		/if;
	/iterate;

	if: ($script_action >> 'add');
		var: 'new_script_extension' = (string: $new_script_extension);
		$new_script_extension->trim;
		if: !($new_script_extension->(beginswith: '.'));
			var: 'new_script_extension' = '.' + $new_script_extension;
		/if;

		if: ($new_script_extension == '') || ($new_script_extension == '.');
			var: 'script_action' = 'none';
		else;
			$current_script_extensions->(insert: $new_script_extension);
			$current_script_extensions->sort;
		/if;
	/if;

	if: ($script_action >> 'add') || ($script_action >> 'remove') || ($script_action >> 'reset');
		admin_setpref: -name='lasso_script_extensions', -value=$current_script_extensions->(join: ' ');
 		_security_flushcaches;
	/if;

?>
