<?LassoScript

// -----------
// global vars

if:(lasso_version: -lassoplatform) >> 'WIN32';
	var: 'java_folder' = (string_replace: (_admin_servicepath), -find='/Blue World Communications/Lasso Professional 8/', -replace='/Java/JRE/1.4/lib/');
	var: 'java_folder' = (string_replace: -find='/', -replace='\\', $java_folder);

	var:'kDefaultLibPath' = $java_folder;
	var:'kDefaultClassPath' = $java_folder;
else;
	var:'kDefaultLibPath' = '';
	var:'kDefaultClassPath' = '';
/if;

var:'err'= 0, 'err_msg'='';
var:'db' = 'lasso_internal';
var:'temp' = '';

var:'java_map' = map;
var:'mod_date'='';
var:'java_action' = action_param:'action';
var:'java_params' = (array: 'java_ljapi_enabled', 'java_class_path', 'java_lib_path');


// -----------
// main

if: action_param:'dialog_action' != null;
	var: 'java_action' = action_param:'dialog_action';
/if;

inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='global_prefs', 'store_key'='java';
	records;
		if: $mod_date < (field:'modified');
			$mod_date = (field:'modified');
		/if;
		$java_map->insert:(field:'store_key')=(field:'data');
	/records;
/inline;

// dispatch
if: $java_action >> 'Update';

	loop: $java_params->size;
		var: 'temp' = $java_params->(get:loop_count);

		if: $java_map->(find:$temp)->type == 'null';
			inline: -log=$__startup_loglevel__, -add, -database='lasso_internal', -table='global_prefs',
					'store_key' = $temp, 'data' = (action_param: $temp);
			/inline;
			$java_map->(insert: $temp = (action_param:$temp));
		else;
			inline: -log=$__startup_loglevel__, -update, -database='lasso_internal', -table='global_prefs',
					-keyfield='store_key', -keyvalue=$temp, 'data' = action_param:$temp;
			/inline;
			$java_map->(insert: $temp = (action_param:$temp));
		/if;
	/loop;

else: $java_action >> 'Restart Site';

	protect;
		site_restart;	
	/protect;

/if;

?>
