<?LassoScript

_admin_addvar: 'action', -override=(action_param: 'action');
_admin_addvar: 'recursion_enable', -override=(action_param: 'recursion_enable');
_admin_addvar: 'execution_enable', -override=(action_param: 'execution_enable');
_admin_addvar: 'lasso_urlrewrite', -override=(action_param: 'lasso_urlrewrite');

// ---------
// prefs

var: 'settings_defaults' = (map: 
		'recursion_limit' = 50,
		'execution_timelimit' = 600,
		'lasso_classic_enabled' = 'N',
		'error_reporting' = 'minimal',
		'default_page_encoding' = 'UTF-8',
		'lasso_apps_enabled' = 'Y',
		'lasso_digest_auth' = 'N',
		'lasso_inline_hosts' = 'Y',
		'lasso_urlrewrite' = 'Y',
		'domain_name_server' = '',
	);		
var: 'settings_prefs' = $settings_defaults;
var: 'settings_prefs' = (admin_getpref: $settings_prefs);


// ---------
// action

if: $action >> 'Update';

	var: 'old_encoding' = $settings_prefs->(find: 'default_page_encoding');
	
	iterate: $settings_prefs->keys, (var: 'key');
		if: (action_param: $key, -count) > 0;
			if: (action_param: $key) == '';
				$settings_prefs->(insert: $key = $settings_defaults->(find: $key));
			else;
				$settings_prefs->(insert: $key = (action_param: $key));
			/if;
		/if;
	/iterate;

	if: $settings_prefs->(find: 'default_page_encoding') >> '..';
		$settings_prefs->(insert: 'default_page_encoding' = (action_param: 'page_encoding_other'));
	/if;

	if: !(string_validcharset: $settings_prefs->(find: 'default_page_encoding'));
		if: $old_encoding != '';
			$settings_prefs->(insert: 'default_page_encoding' = $old_encoding);
		else;
			$settings_prefs->(insert: 'default_page_encoding' = $settings_defaults->(find: 'default_page_encoding'));
		/if;
	/if;

	if: $recursion_enable >> 'N';
		$settings_prefs->(insert: 'recursion_limit' = 0);
	/if;

	if: $execution_enable >> 'N';
		$settings_prefs->(insert: 'execution_timelimit' = 0);
	/if;
	
	if: ($settings_prefs->(find: 'execution_timelimit') < 60) && ($settings_prefs->(find: 'execution_timelimit') != 0);
		$settings_prefs->(insert: 'execution_timelimit' = 60);
	/if;

	if: ($settings_prefs->(find: 'domain_name_server') == 'custom');
		$settings_prefs->(insert: 'domain_name_server' = (action_param: 'custom_name_server'));
	/if;
	global: '__domain_name_server__' = $settings_prefs->(find: 'domain_name_server');

	admin_setpref: $settings_prefs;
	
	protect;
		_execution_timelimit: $settings_prefs->(find: 'execution_timelimit');
	/protect;

	protect;
		_recursion_limit: $settings_prefs->(find: 'recursion_limit');
	/protect;

	protect;
		lasso_errorreporting: $settings_prefs->(find: 'error_reporting'), -global;
	/protect;
	
	global: '__encoding__' = $settings_prefs->(find: 'default_page_encoding');

	global: '__digest_auth__' = $settings_prefs->(find: 'lasso_digest_auth');

	if: $lasso_urlrewrite >> 'N';
		loop: -from=site_atbegin->size, -to=1, -by=-1;
			if: site_atbegin->(get: loop_count) == 'rewrite';
			  site_atbegin->(remove: loop_count);
			/if;
		/loop;
	else: $lasso_urlrewrite >> 'Y';
		var: 'rewrite_started' = false;
		loop: -from=site_atbegin->size, -to=1, -by=-1;
			if: site_atbegin->(get: loop_count) == 'rewrite';
				var: 'rewrite_started' = true;
				loop_abort;
			/if;
		/loop;
		if: $rewrite_started == false;
			define_atbegin: url_rewrite;
		/if;
	/if;
	
	_security_flushcaches;

/if;

if: $action >> 'Test';
	
	if: (action_param: 'domain_name_server', -count) > 0;
		if: (action_param: 'domain_name_server') == '';
			$settings_prefs->(insert: 'domain_name_server' = $settings_defaults->(find: 'domain_name_server'));
		else;
			$settings_prefs->(insert: 'domain_name_server' = (action_param: 'domain_name_server'));
		/if;
	/if;
	if: ($settings_prefs->(find: 'domain_name_server') == 'custom');
		$settings_prefs->(insert: 'domain_name_server' = (action_param: 'custom_name_server'));
	/if;

	var: 'current' = $settings_prefs->(find: 'domain_name_server');
	if: $current == '' && (dns_default->size > 0);
		var: 'current' = dns_default->first;
	/if;

	var: 'result' = '';
	protect;
		var: 'result' = (string: (dns_lookup: -hostname=$current, $current, -timeout=5));
	/protect;
	
	if: $result != '';
		var: 'test_message' = 'DNS Lookup succeeded for server ' + $current + '.';
		admin_setpref: 'domain_name_server', $current;
		global: '__domain_name_server__' = $current;
	else;
		var: 'test_error' = 'DNS Lookup failed for server ' + $current + '.';
	/if;
	
/if;

?>
