<?LassoScript

	var: 'trigger_types' = (array:
			'client_url' = '[Client_URL]', 
			'server_name' = '[Server_Name]', 
			'server_port' = '[Server_Port]', 
			'response_fileexists' = '[Response_FileExists]', 
			'response_filepath' = '[Response_FilePath]', 
			'client_getargs' = '[Client_GETArgs]', 
			'client_ip' = '[Client_IP]', 
			'client_header' = '[Client_Header: "name"]', 
			'cookie' = '[Cookie: "name"]', 
			'action_params' = '[Action_Param: "name"]', 
			'client_getparams' = '[Client_GETParams]', 
			'client_postparams' = '[Client_POSTParams]', 
			'true' = '[True]', 
			'variable' = '[Variable: "name"]', 
			'global' = '[Global: "name"]', 
		);

	var: 'trigger_comps' = (array: 
			'true' = 'Is True', 
			'false' = 'Is False', 
			'eq' = 'Equals', 
			'neq' = 'Not Equal To', 
			'cn' = 'Contains', 
			'ncn' = 'Does Not Contain', 
			'rx' = 'Matches Regular Expression', 
			'nrx' = 'Does Not Match Regular Expression', 
			'bw' = 'Begins With', 
			'ew' = 'Ends With', 
			'lt' = 'Less Than', 
			'lte' = 'Less Than or Equal', 
			'gt' = 'Greater Than', 
			'gte' = 'Greater Than or Equal', 
		);

	var: 'action_types' = (array:
			'variable' = '[Variable: "name"="value"]', 
			'global' = '[Global: "name"="value"]', 
			'redirect_url' = '[Redirect_URL: "url"]', 
			'include' = '[Include: "path"]', 
			'library' = '[Library: "path"]', 
			'log_always' = '[Log_Always: "message"]', 
			'log_critical' = '[Log_Critical: "message"]', 
			'log_warning' = '[Log_Warning: "message"]', 
			'log_detail' = '[Log_Detail: "message"]', 
			'log_sql' = '[Log_SQL: "message"]', 
			'log_deprecated' = '[Log_Deprecated: "message"]', 
			'fail' = '[Fail: "code", "message"]', 
			'abort' = '[Abort]', 
		);

	var: 'action_tokens' = (array:
			'[Action_Param:"name"]',
			'[Client_GETParam:"name"]',
			'[Client_POSTParam:"name"]',
			'[Cookie:"name"]',
			'[Error_Code]',
			'[Error_Msg]',
			'[Response_Path]',
			'[Response_FilePath]',
			'[Response_FileName]',
			'[Server_Name]',
			'[Server_Port]',
			'[Trigger:"Number","Part"]',
		);

	define_tag: 'trigger_summary',
			-required='type',
			-required='name',
			-required='comp',
			-required='value';
		local: 'summary' = '';
		if: $trigger_types >> #type;
			#summary += $trigger_types->(find: #type)->first->second;
		else;
			#summary += '' + #type + ';';
		/if;
		if: #summary >> '"name"';
			#summary->(replace: '"name"', '"' + #name + '"');
		/if;
		if: $trigger_comps >> #comp;
			#summary += ' ' + $trigger_comps->(find: #comp)->first->second;
		else;
			#summary += ' ' + #comp;
		/if;
		if: (array: 'true','false') !>> #comp;
			#summary += ' "' + #value + '"';
		/if;
		return: @#summary;
	/define_tag;

	define_tag: 'action_summary',
			-required='type',
			-required='name',
			-required='value';
		local: 'summary' = '';
		if: $action_types >> #type;
			#summary += $action_types->(find: #type)->first->second;
		else;
			#summary += '' + #type + ';';
		/if;
		if: #summary >> '"name"';
			#summary->(replace: '"name"', '"' + #name + '"');
		else: #summary >> '"url"';
			#summary->(replace: '"url"', '"' + #name + '"');
		else: #summary >> '"path"';
			#summary->(replace: '"path"', '"' + #name + '"');
		else: #summary >> '"message"';
			#summary->(replace: '"message"', '"' + #name + '"');
		/if;
		if: #summary >> '"value"';
			#summary->(replace: '"value"', '"' + #value + '"');
		else: #summary >> '"code"';
			#summary->(replace: '"code"', '"' + #value + '"');
		/if;
		return: @#summary;
	/define_tag;
?>
