<?LassoScript

//
// Variables
//

_admin_addvar: 'groups_action', -default='None', -override=(action_param: 'groups_action', (action_param: 'groups_action', -count));

_admin_addvar: 'groups_actionid', -default=-1, -override=(action_param: 'groups_actionid');
_admin_addvar: 'groups_filemap', -default=1;

_admin_addvar: 'file_create', -default='Y', -override=(string: action_param: 'file_create');
_admin_addvar: 'file_read', -default='Y', -override=(string: action_param: 'file_read');
_admin_addvar: 'file_write', -default='Y', -override=(string: action_param: 'file_write');
_admin_addvar: 'file_move', -default='Y', -override=(string: action_param: 'file_move');
_admin_addvar: 'file_copy', -default='Y', -override=(string: action_param: 'file_copy');
_admin_addvar: 'file_delete', -default='Y', -override=(string: action_param: 'file_delete');
_admin_addvar: 'file_inspect', -default='Y', -override=(string: action_param: 'file_inspect');
_admin_addvar: 'file_any_extension', -override=(string: action_param: 'file_any_extension');


//
// Process Action
//

if: ($groups_action >> 'Unassign All');

	var: 'sql' = 'DELETE FROM security_group_file_perms WHERE id_group = ' + (encode_sql: $groups_groupid);
	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql;
	/inline;
	_security_flushcaches;
	var: 'groups_action' = 'None';

else: ($groups_action >> 'Unassign');

	if: $groups_actionid > 0;
		var: 'sql' = 'DELETE FROM security_group_file_perms WHERE id_group = ' + (encode_sql: $groups_groupid) + ' AND allow_root = ' + (encode_sql: $groups_actionid);
		inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql;
		/inline;
		_security_flushcaches;
	/if;
	var: 'groups_action' = 'None';

else: ($groups_action >> 'Assign') || ($groups_action >> 'Allow') || ($groups_action >> 'Deny');

	if: ($groups_action >> 'Allow');
		var: 'file_create'='Y';
		var: 'file_read'='Y';
		var: 'file_write'='Y';
		var: 'file_move'='Y';
		var: 'file_copy'='Y';
		var: 'file_delete'='Y';
		var: 'file_inspect'='Y';
	else: ($groups_action >> 'Deny');
		var: 'file_create'='N';
		var: 'file_read'='N';
		var: 'file_write'='N';
		var: 'file_move'='N';
		var: 'file_copy'='N';
		var: 'file_delete'='N';
		var: 'file_inspect'='N';
		var: 'file_any_extension'='N';
	/if;
	
	if: $file_create == 'I';
		var: 'file_create' = '';
	/if;
	if: $file_read == 'I';
		var: 'file_read' = '';
	/if;
	if: $file_write == 'I';
		var: 'file_write' = '';
	/if;
	if: $file_move == 'I';
		var: 'file_move' = '';
	/if;
	if: $file_copy == 'I';
		var: 'file_copy' = '';
	/if;
	if: $file_delete == 'I';
		var: 'file_delete' = '';
	/if;
	if: $file_inspect == 'I';
		var: 'file_inspect' = '';
	/if;
	if: $file_any_extension == 'I';
		var: 'file_any_extension' = '';
	/if;
	
	inline: -log=$__startup_loglevel__, -search,
			-database='lasso_internal',
			-table='security_group_file_perms',
			-keyfield='id',
			-op='eq', 'id_group' = (string: $groups_groupid),
			-op='eq', 'allow_root' = (integer: $groups_actionid),
			-returnfield='id';
		if: (found_count > 0) && ($groups_actionid != -1);
			inline: -log=$__startup_loglevel__, -update,
					-database='lasso_internal',
					-table='security_group_file_perms',
					-keyfield='id',
					-keyvalue = (field: 'id'),
					'id_group' = (string: $groups_groupid),
					'allow_create'=(string: $file_create),
					'allow_read'=(string: $file_read),
					'allow_write'=(string: $file_write),
					'allow_move'=(string: $file_move),
					'allow_copy'=(string: $file_copy),
					'allow_delete'=(string: $file_delete),
					'allow_inspect'=(string: $file_inspect),
					'allow_root'=(string: $groups_actionid),
					'allow_any_extension'=(string: $file_any_extension);
			/inline;
		else;
			inline: -log=$__startup_loglevel__, -add,
					-database='lasso_internal',
					-table='security_group_file_perms',
					-keyfield='id',
					'id_group' = (string: $groups_groupid),
					'allow_create'=(string: $file_create),
					'allow_read'=(string: $file_read),
					'allow_write'=(string: $file_write),
					'allow_move'=(string: $file_move),
					'allow_copy'=(string: $file_copy),
					'allow_delete'=(string: $file_delete),
					'allow_inspect'=(string: $file_inspect),
					'allow_root'=(string: $groups_actionid),
					'allow_any_extension'=(string: $file_any_extension);
			/inline;
		/if;
	/inline;
	_security_flushcaches;
	var: 'groups_action' = 'Detail';
	
/if;

//
// Find File Permissions for Current Group
//

var: 'groups_fileroots' = map->(insertfrom: admin_allowedfileroots->iterator) &;
var: 'groups_filemap' = (array);

// Clean up bad entries;

var: 'sql' = 'DELETE FROM security_group_file_perms WHERE allow_root ISNULL OR allow_root NOT IN (' $groups_fileroots->keys->(join: ', ') + ')';
inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
/inline;

if: ($groups_groupdetail != null);
	var: 'sql' = 'SELECT * FROM security_group_file_perms WHERE id_group = ' + (encode_sql: $groups_groupdetail->(find: 'id')) + ' AND allow_root IN (' $groups_fileroots->keys->(join: ', ') + ')';

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
		records;
			var: 'file_allow' = (array);
			var: 'file_deny' = (array);
			if: (field: 'allow_inspect') >> 'Y';
				$file_allow->(insert: 'Inspect');
			else: (field: 'allow_inspect') >> 'N';
				$file_deny->(insert: 'Inspect');
			/if;
			if: (field: 'allow_read') >> 'Y';
				$file_allow->(insert: 'Read');
			else: (field: 'allow_read') >> 'N';
				$file_deny->(insert: 'Read');
			/if;
			if: (field: 'allow_create') >> 'Y';
				$file_allow->(insert: 'Create');
			else: (field: 'allow_create') >> 'N';
				$file_deny->(insert: 'Create');
			/if;
			if: (field: 'allow_write') >> 'Y';
				$file_allow->(insert: 'Write');
			else: (field: 'allow_write') >> 'N';
				$file_deny->(insert: 'Write');
			/if;
			if: (field: 'allow_move') >> 'Y';
				$file_allow->(insert: 'Move');
			else: (field: 'allow_move') >> 'N';
				$file_deny->(insert: 'Move');
			/if;
			if: (field: 'allow_copy') >> 'Y';
				$file_allow->(insert: 'Copy');
			else: (field: 'allow_copy') >> 'N';
				$file_deny->(insert: 'Copy');
			/if;
			if: (field: 'allow_delete') >> 'Y';
				$file_allow->(insert: 'Delete');
			else: (field: 'allow_delete') >> 'N';
				$file_deny->(insert: 'Delete');
			/if;
			if: (field: 'allow_any_extension') >> 'Y';
				$file_allow->(insert: 'Any Extension');
			/if;
			var: 'file_temp' = (map);
			if: $file_allow->size == 0;
				$file_temp->(insert: 'allow' = 'None');
			else;
				$file_temp->(insert: 'allow' = $file_allow->(join: ', '));
			/if;
			if: $file_deny->size == 0;
				$file_temp->(insert: 'deny' = 'None');
			else;
				$file_temp->(insert: 'deny' = $file_deny->(join: ', '));
			/if;
			iterate: field_names, (var: 'field');
				$file_temp->(insert: $field = (field: $field));
			/iterate;
			$file_temp->(insert: 'alias' = $groups_fileroots->(find: (field: 'allow_root')));
			$groups_fileroots->(remove: (field: 'allow_root'));
			
			$groups_filemap->(insert: $file_temp);
			
			if: $groups_actionid == (field: 'allow_root');
				var: 'file_create'=(field: 'allow_create');
				var: 'file_read'=(field: 'allow_read');
				var: 'file_write'=(field: 'allow_write');
				var: 'file_move'=(field: 'allow_move');
				var: 'file_copy'=(field: 'allow_copy');
				var: 'file_delete'=(field: 'allow_delete');
				var: 'file_inspect'=(field: 'allow_inspect');
				var: 'file_root'=$groups_actionid;
				var: 'file_alias'=$file_temp->(find: 'alias');
				var: 'file_any_extension'=(field: 'allow_any_extension');
			/if;
			
		/records;
	/inline;

	iterate: $groups_fileroots, (var: 'temp_root');
	
		var: 'file_temp' = (map);
		$file_temp->(insert: 'allow' = 'None');
		$file_temp->(insert: 'deny' = 'None');
		$file_temp->(insert: 'allow_root' = $temp_root->first);
		$file_temp->(insert: 'alias' = $temp_root->second);

		$groups_filemap->(insert: $file_temp);
		
		if: $groups_actionid == $temp_root->first;
			var: 'file_create'='';
			var: 'file_read'='';
			var: 'file_write'='';
			var: 'file_move'='';
			var: 'file_copy'='';
			var: 'file_delete'='';
			var: 'file_inspect'='';
			var: 'file_root'=$groups_actionid;
			var: 'file_alias'=$temp_root->second;
			var: 'file_any_extension'='N';
		/if;
	
	/iterate;
	
/if;

?>
