<?LassoScript

//
// Variables
//

_admin_addvar: 'groups_action', -default='None', -override=(action_param: 'groups_action', (action_param: 'groups_action', -count));
_admin_addvar: 'groups_addaction', -default='None', -override=(action_param: 'groups_addaction', (action_param: 'groups_addaction', -count));

_admin_addvar: 'groups_name', -default='None', -override=(action_param: 'groups_name');
_admin_addvar: 'groups_enabled', -default='None', -override=(action_param: 'groups_enabled');

_admin_addvar: 'groups_actionraw', -default='None', -override=(action_param: 'groups_action');
_admin_addvar: 'groups_group_skip', -default=1, -session='_siteadmin', -override=(action_param: 'groups_group_skip');
_admin_addvar: 'groups_navigation', -override=(action_param: 'groups_navigation');
_admin_addvar: 'groups_jump', -override=(action_param: 'groups_jump');

_admin_addvar: 'dialog_action', -override=(action_param: 'dialog_action');

//
// Process Action
//

if: $groups_addaction >> 'Add';

	// Check for duplicate group name
	iterate: $groups_groupmap, (var: 'temp_group');
		var: 'temp'=($temp_group->second);
		if: $temp->(find: 'name') == $groups_name;
			var: 'groups_error' = 'A group with that name already exists';
		/if;
	/iterate;

	if: (var: 'groups_error') == '';
		_admin_addgroup: 'enabled'=$groups_enabled, 'name'=$groups_name;
		if: $_code != (error_noerror);
			var: 'groups_error' = $_error + ' (' + $_code + ')';
		else;
			var: 'groups_message' = 'The group was added successfully.';
		/if;

	/if;

	if: (var: 'groups_error') != '';
		var: 'groups_groupdetail' = (map: 'name'='New Group', 'enabled'='Y', 'status'='enabled', 'id'=(-1));
		var: 'groups_groupid' = -1;
		var: 'groups_action' = 'Add Group';
	/if;

	if: (var: 'groups_error') == '';
		_admin_refreshsecurity;

		var: 'groups_groupmap' = (_admin_listgroups);
		var: 'groups_groupid' = 0;

		iterate: $groups_groupmap, (var: 'temp_group');
			var: 'temp'=($temp_group->second);

			if: $temp->(find: 'name') == $groups_name;
				var: 'groups_groupid' = $temp->(find: 'id');
				var: 'groups_groupdetail' = $temp;
			/if;
		/iterate;

		var: 'groups_action' = 'Detail Refresh';
	/if;

else: $groups_action >> 'Duplicate';

	// Check for duplicate group name
	var: 'done' = false;
	var: 'temp_name' = $groups_name + ' copy';
	while: $done == false;
		var: 'done' = true;
		iterate: $groups_groupmap, (var: 'temp_group');
			var: 'temp'=($temp_group->second);
			if: $temp->(find: 'name') == $groups_name + loop_count;
				var: 'done' = false;
				loop_abort;
			/if;
		/iterate;
		if: $done == true;
			var: 'groups_name' = $temp_name;
			loop_abort;
		else;
			var: 'temp_name' = $groups_name + ' copy ' + loop_count;
		/if;
		loop_count > 100 ? loop_abort;
	/while;
	
	if: (var: 'groups_error') == '';
		_admin_duplicategroup: $groups_groupid, 'enabled'=$groups_enabled, 'name'=$groups_name;
		if: $_code != (error_noerror);
			var: 'groups_error' = $_error + ' (' + $_code + ')';
		else;
			var: 'groups_message' = 'The group was added successfully.';
		/if;

	/if;

	if: (var: 'groups_error') == '';
		_admin_refreshsecurity;

		var: 'groups_groupmap' = (_admin_listgroups);
		var: 'groups_groupid' = 0;

		iterate: $groups_groupmap, (var: 'temp_group');
			var: 'temp'=($temp_group->second);

			if: $temp->(find: 'name') == $groups_name;
				var: 'groups_groupid' = $temp->(find: 'id');
				var: 'groups_groupdetail' = $temp;
			/if;
		/iterate;

		var: 'groups_action' = 'Detail Refresh';
	/if;

else: $groups_action >> 'Update';

	_admin_updategroup: $groups_groupid, 'enabled'=$groups_enabled, 'name'=$groups_name;
	if: $_code != (error_noerror);
		var: 'groups_error' = $_error + ' (' + $_code + ')';
	else;
		var: 'groups_message' = 'The group was updated successfully.';
	/if;

	if: (var: 'groups_error') == '';
		_admin_refreshsecurity;

		var: 'groups_groupmap' = (_admin_listgroups);
		var: 'groups_groupid' = 0;

		iterate: $groups_groupmap, (var: 'temp_group');
			var: 'temp'=($temp_group->second);

			if: $temp->(find: 'name') == $groups_name;
				var: 'groups_groupid' = $temp->(find: 'id');
				var: 'groups_groupdetail' = $temp;
			/if;
		/iterate;

		var: 'groups_action' = 'Detail Refresh';
	/if;

else: $dialog_action >> 'Delete';

	_admin_deletegroup: $groups_groupid;
	if: $_code != (error_noerror);
		var: 'groups_error' = $_error + ' (' + $_code + ')';
	else;
		var: 'groups_message' = 'The group was deleted successfully.';
	/if;

	if: (var: 'groups_error') == '';
		_admin_refreshsecurity;

		var: 'groups_groupmap' = (_admin_listgroups);
		var: 'groups_groupid' = 0;

		_admin_refreshsecurity;

		var: 'groups_action' = 'None';
	/if;

else: $groups_action >> 'Add Group';

	// Create the template for a new group

	var: 'groups_groupdetail' = (map: 'name'='New Group', 'enabled'='Y', 'status'='enabled', 'id'=(-1));
	var: 'groups_groupid' = -1;

else: $groups_action >> 'List Users';

	// Redirect
	var: 'link' = $admin_link + '&tab2=users&tab3=users' +
		'&users_groupfilter=' + $groups_groupid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

else: $groups_action >> 'Hosts';

	// Redirect
	var: 'link' = $admin_link + '&tab3=hosts' +
		'&groups_groupid=' + $groups_groupid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

else: $groups_action >> 'Databases';

	// Redirect
	var: 'link' = $admin_link + '&tab3=databases' +
		'&groups_groupid=' + $groups_groupid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

else: $groups_action >> 'Tables';

	// Redirect
	var: 'link' = $admin_link + '&tab3=tables' +
		'&groups_groupid=' + $groups_groupid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

else: $groups_action >> 'Files';

	// Redirect
	var: 'link' = $admin_link + '&tab3=files' +
		'&groups_groupid=' + $groups_groupid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

else: $groups_action >> 'Tags';

	// Redirect
	var: 'link' = $admin_link + '&tab3=tags' +
		'&groups_groupid=' + $groups_groupid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

/if;

//
// Remove special groups from group map
//

if: $groups_groupmap->size >= 2;
	$groups_groupmap->(removeall:1);
	$groups_groupmap->(removeall:2);
/if;


//
// Process Navigation
//

if: $groups_navigation >> 'Prev';
	$groups_group_skip -= $admin_listingsize;
else: $groups_navigation >> 'Next';
	$groups_group_skip += $admin_listingsize;
else: $groups_navigation >> 'First';
	$groups_group_skip = 1;
else: $groups_navigation >> 'Last';
	$groups_group_skip = $groups_groupmap->size - (($groups_groupmap->size - 1) % $admin_listingsize);
else: $groups_navigation >> 'Jump';
	$groups_group_skip = integer: $groups_jump;
/if;

var: 'found_count' = $groups_groupmap->size;
var: 'groups_group_skip' = integer: (math_max: 1, (math_min: $groups_group_skip, $found_count));
var: 'shown_first' = $groups_group_skip;
var: 'shown_last' = integer: (math_min: $found_count, $groups_group_skip + ($admin_listingsize - 1));
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
