<?LassoScript

//
// Variables
//

_admin_addvar: 'groups_action', -default='None', -override=(action_param: 'groups_action', (action_param: 'groups_action', -count));
_admin_addvar: 'groups_skip', -default=1, -session='_siteadmin', -override=(action_param: 'groups_skip');
_admin_addvar: 'groups_navigation', -override=(action_param: 'groups_navigation');
_admin_addvar: 'groups_jump', -override=(action_param: 'groups_jump');
_admin_addvar: 'groups_actionid', -default=$groups_hostid, -override=(action_param: 'groups_actionid');
_admin_addvar: 'host_sql', -override=(action_param: 'host_sql');
_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

//
// Process Action
//

if: ($groups_action >> 'Assign') || ($groups_action >> 'Unassign') || ($dialog_action >> 'Unassign All');

	if: ($groups_action >> 'Unassign') || ($dialog_action >> 'Unassign All');
		var: 'host_sql' = 'Ignore';
	/if;

	if: !($host_sql >> 'Mixed');

		local: 'need_allow' = ($host_sql >> 'Allow');
		local: 'need_deny' = ($host_sql >> 'Deny');

		if: ($dialog_action >> 'Unassign All');
			// Delete the host permission map entry
			inline: -log=$__startup_loglevel__, -database='lasso_internal',
					-SQL='DELETE FROM security_group_host_map WHERE id_group=' + $groups_groupid + ' AND id_host > 0',
					-maxrecords='all';
			/inline;
		else;
			// Delete the host permission map entry
			inline: -log=$__startup_loglevel__, -database='lasso_internal',
					-SQL='DELETE FROM security_group_host_map WHERE id_group=' + $groups_groupid + ' AND id_host=' + $groups_actionid,
					-maxrecords='all';
			/inline;
		/if;

		if: #need_allow || #need_deny;

			// Create the host permission map entry
			if: #need_allow && #need_deny;
				var: 'sql' = 'INSERT INTO security_group_host_map (id_group,id_host,allow,deny) VALUES (' + $groups_groupid + ',' + $groups_actionid + ',"Q","Q")';
			else: #need_allow;
				var: 'sql' = 'INSERT INTO security_group_host_map (id_group,id_host,allow,deny) VALUES (' + $groups_groupid + ',' + $groups_actionid + ',"Q","")';
			else: #need_deny;
				var: 'sql' = 'INSERT INTO security_group_host_map (id_group,id_host,allow,deny) VALUES (' + $groups_groupid + ',' + $groups_actionid + ',"","Q")';
			/if;
			inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
			/inline;

		/if;

		var: 'database_list' = (array);

		if: ($dialog_action >> 'Unassign All');

			// Get a list of databases for the current host
			var: 'sql' = 'SELECT id FROM security_datasource_databases WHERE id_host > 0';
			inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql;
				records;
					$database_list->(insert: (field: 'id'));
				/records;
			/inline;

		else;

			// Get a list of databases for the current host
			var: 'sql' = 'SELECT id FROM security_datasource_databases WHERE id_host = ' + $groups_actionid;
			inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql;
				records;
					$database_list->(insert: (field: 'id'));
				/records;
			/inline;

		/if;

		if: $database_list->size > 0;

			// Remove Q permission from all databases in security_group_db_map.
			inline: -log=$__startup_loglevel__, -search,
					-database='lasso_internal',
					-table='security_group_db_map',
					-keyfield='id',
					-opbegin='or',
						-op='cn', 'allow'='Q',
						-op='cn', 'deny'='Q',
					-opend='or',
					-op='eq', 'id_group' = $groups_groupid,
					-maxrecords='all';
				local: 'actions' = (array);
				records;
					if: $database_list >> (field: 'id_database');
						inline: -update,
								-log=$__startup_loglevel__, 
								-database='lasso_internal', 
								-table='security_group_db_map',
								-keyfield='id',
								-keyvalue=(field: 'id'),
								'allow' = ((string_replaceregexp: -find = ',,+', -replace = ',', (field: 'allow') - 'Q')->removeleading(',') & removetrailing(',') &),
								'deny' = ((string_replaceregexp: -find = ',,+', -replace = ',', (field: 'deny') - 'Q')->removeleading(',') & removetrailing(',') &),
								-statementonly;
							#actions->(insert: action_statement);
						/inline;
					/if;
				/records;
			/inline;

			local: 'temp' = (array);
			iterate: #actions, (local: 'insert_temp');
				#temp->(insert: #insert_temp);
				if: (#actions->size == loop_count) || ((loop_count % 25) == 0);
					inline: -log=$__startup_loglevel__, -database='lasso_internal',
							-sql='BEGIN TRANSACTION; ' + #temp->(join: '; ') + '; COMMIT TRANSACTION;',
							-maxrecords='all';
					/inline;
					local: 'temp' = (array);
				/if;
			/iterate;

			local: 'update_list' = (array);

			if: #need_allow || #need_deny;
				log_critical: 'Updating host permissions for host ' + $groups_actionid ' and group ' + $groups_groupid;
				var: 'sql' = 'SELECT id,allow,deny,id_database FROM security_group_db_map WHERE id_group=' + $groups_groupid + ' AND id_database IN (' + $database_list->(join: ',') + ')';
				inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
					records;
						#update_list->(insert: (field: 'id'));
						#database_list->(removeall: (field: 'id_database'));
					/records;
				/inline;
				if: #update_list->size > 0;
					var: 'sql' = '';
					if: #need_allow;
						$sql += 'UPDATE security_group_db_map SET allow="Q" WHERE id IN (' + #update_list->(join: ',') + ') AND (allow == "");';
						$sql += 'UPDATE security_group_db_map SET allow=(allow || ",Q") WHERE id IN (' + #update_list->(join: ',') + ') AND (allow != "") AND (allow NOT LIKE "%Q%");';
					/if;
					if: #need_deny;
						$sql += 'UPDATE security_group_db_map SET deny="Q" WHERE id IN (' + #update_list->(join: ',') + ') AND (deny == "");';
						$sql += 'UPDATE security_group_db_map SET deny=(deny || ",Q") WHERE id IN (' + #update_list->(join: ',') + ') AND (deny != "") AND (deny NOT LIKE "%Q%");';
					/if;
					inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
					/inline;
				/if;

				local: 'temp' = (array);
				iterate: #database_list, (local: 't');
					if: #need_allow && #need_deny;
						var: 'sql' = 'INSERT INTO security_group_db_map (id_group,id_database,allow,deny) VALUES (' + $groups_groupid + ',' + #t + ',"Q","Q")';
					else: #need_allow;
						var: 'sql' = 'INSERT INTO security_group_db_map (id_group,id_database,allow,deny) VALUES (' + $groups_groupid + ',' + #t + ',"Q","")';
					else: #need_deny;
						var: 'sql' = 'INSERT INTO security_group_db_map (id_group,id_database,allow,deny) VALUES (' + $groups_groupid + ',' + #t + ',"","Q")';
					/if;
					#temp->(insert: $sql);
					if: (#database_list->size == loop_count) || ((loop_count % 25) == 0);
						inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='BEGIN TRANSACTION; ' + #temp->(join: '; ') + '; COMMIT TRANSACTION;', -maxrecords=0;
						/inline;
					/if;
				/iterate;
			/if;

			_security_flushcaches;
		/if;

	/if;

	// Clean up any empty entries.
	inline: -log=$__startup_loglevel__, -database='lasso_internal',
			-SQL='DELETE FROM security_group_host_map WHERE ((allow = "") OR (allow ISNULL)) AND ((deny = "") OR (deny ISNULL))',
			-maxrecords='all';
	/inline;
	inline: -log=$__startup_loglevel__, -database='lasso_internal',
			-SQL='DELETE FROM security_group_db_map WHERE ((allow = "") OR (allow ISNULL)) AND ((deny = "") OR (deny ISNULL))',
			-maxrecords='all';
	/inline;
	inline: -log=$__startup_loglevel__, -database='lasso_internal',
			-SQL='DELETE FROM security_group_table_map WHERE ((allow = "") OR (allow ISNULL)) AND ((deny = "") OR (deny ISNULL))',
			-maxrecords='all';
	/inline;

	var: 'groups_action' = 'Detail';

else: $groups_action >> 'List Databases';

	// Redirect
	var: 'link' = $admin_link + '&tab3=databases' +
		'&groups_connectorid=' + $groups_connectorid +
		'&groups_hostid=' + $groups_hostid;
	redirect_url: $link;
	'<a href="' + $link + '">' + $link + '</a>';
	abort;

/if;


//
// Add Permissions to groups_databasemap for current group
//
if: ($groups_groupdetail != null);

	var: 'hosts_perms' = (map);

	var: 'sql' = 'SELECT * FROM security_group_db_map ' +
		'LEFT JOIN security_datasource_databases ON security_group_db_map.id_database = security_datasource_databases.id ' +
		'WHERE security_group_db_map.id_group = ' + $groups_groupdetail->(find: 'id');

	var: 'sql' = 'SELECT * FROM security_group_host_map ' +
		'WHERE security_group_host_map.id_group = ' + $groups_groupdetail->(find: 'id');

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql;

		records;

			var: 'temp' = $hosts_perms->(find: (field: 'id_host'));
			if: $temp == null;
				var: 'temp' = (map: 'allow'=false, 'deny'=false);
			/if;

			$temp->(insert: 'allow' = ($temp->(find: 'allow') || ((field: 'allow') >> 'Q')));
			$temp->(insert: 'deny' = ($temp->(find: 'deny') || ((field: 'deny') >> 'Q')));

			$hosts_perms->(insert: (field: 'id_host') = $temp);

		/records;

	/inline;
/if;

var: 'temp' = (_admin_defaulthost: $groups_hostid, $groups_hostmap);
var_remove: 'groups_hostid'; // Frozen Value
if: ($temp != null);
	var: 'groups_hostid' = $temp->first;
	var: 'groups_hostdetail' = $temp->second;
	var: 'groups_hostname' = $groups_hostdetail->(find: 'name');
	var: 'groups_hostalias' = $groups_hostdetail->(find: 'alias');
else;
	var: 'groups_hostid' = 0;
/if;


//
// Process Navigation
//

if: $groups_navigation >> 'Prev';
	$groups_skip -= $admin_listingsize;
else: $groups_navigation >> 'Next';
	$groups_skip += $admin_listingsize;
else: $groups_navigation >> 'First';
	$groups_skip = 1;
else: $groups_navigation >> 'Last';
	$groups_skip = $groups_hostmap->size;
else: $groups_navigation >> 'Jump';
	$groups_skip = integer: $groups_jump;
/if;

var: 'found_count' = $groups_hostmap->size;
var: 'groups_skip' = integer: (math_max: 1, (math_min: $groups_skip, $found_count));
var: 'shown_first' = $groups_skip;
var: 'shown_last' = integer: (math_min: $found_count, $groups_skip + ($admin_listingsize - 1));
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
