<?LassoScript

//
// Variables
//

_admin_addvar: 'groups_action', -default='None', -override=(action_param: 'groups_action', (action_param: 'groups_action', -count));
_admin_addvar: 'category_action', -default='None', -override=(action_param: 'category_action', (action_param: 'category_action', -count));
_admin_addvar: 'tag_action', -default='None', -override=(action_param: 'tag_action', (action_param: 'tag_action', -count));

_admin_addvar: 'groups_categoryid', -override=(action_param: 'groups_categoryid');

var: 'need_flush' = false;


//
// Tag Map
//

var: 'tags_category' = (array:
	'Administration' = (array: 'Admin_CreateUser','Admin_GroupAssignUser','Admin_GroupRemoveUser','Admin_GroupListUsers','Admin_ChangeUser','Admin_ListGroups'),
	'Database' = (array: 'Database_ChangeField','Database_CreateField','Database_CreateTable','Database_RemoveField','Database_RemoveTable'),
	'File' = (array: 'File','File_Copy','File_Create','File_CreationDate','File_CurrentError','File_Delete','File_Exists','File_GetLineCount','File_GetSize','File_IsDirectory','File_ListDirectory','File_ModDate','File_Move','File_Read','File_ReadLine','File_Rename','File_SetSize','File_Write'),
	'Include' = (array: 'Include','Include_URL','Include_Raw','Library'),
	'Technical' = (array: 'Lasso_ExecutionTimeLimit','LassoApp_Create','LassoApp_Dump','LassoApp_List','Process','Sleep','Net'),
	'Utility' = (array: 'Cache','Email_Immediate','Email_Pop','Email_Send','Event_Schedule','Log','Log_Critical','Log_Deprecated','Log_Detail','Log_SQL','Log_Warning'),
);

var: 'tags_alias' = (array:
	'Database_ChangeField' = (array: 'Database_ChangeColumn'),
	'Database_CreateField' = (array: 'Database_CreateColumn'),
	'Database_RemoveField' = (array: 'Database_RemoveColumn'),
	'File_ListDirectory' = (array: 'Directory_Lister','Directory_NameItem','DirectoryNameItem'),
	'Net' = (array: 'TCP_Close','TCP_Open','TCP_Send'),
	'Cache' = (array: 'Cache_Store','Cache_Fetch','Cache_Object'),
);

define_tag: 'tag_id', -required='name';
	local: 'tag' = (tags_find: #name);
	if: #tag->(isa: 'tag');
			return: #tag->id;
	else;
		log_warning: 'Tag security: [' + #name + '] not found';
	/if;
	return: 0;
/define_tag;

var: 'tags_ids' = (map);
var: 'tags_names' = (map);
var: 'tags_temp' = $tags_category;
$tags_temp->(merge: $tags_alias);
iterate: $tags_temp, (var: 'cat');
	iterate: $cat->second, (var: 'tag');
		var: 'id' = (tag_id: $tag);
		if: $id > 0;
			$tags_ids->(insert: $id = $tag);
			$tags_names->(insert: $tag = $id);
		/if;
	/iterate;
/iterate;


//
// Category Map
//

var: 'groups_categorydetail' = null;
if: ($groups_categoryid != '');
	var: 'groups_categorydetail' = $tags_category->(find: $groups_categoryid)->(get:1)->second;
/if;


//
// Process Action
//

var: 'delete_ids' = (array);
var: 'allow_ids' = (array);
var: 'deny_ids' = (array);

if: ($category_action >> 'Unassign All') || ($category_action >> 'Assign') || ($category_action >> 'Allow All') || ($category_action >> 'Deny All');

	if: ($category_action >> 'Unassign All');
		var: 'delete_ids' = $tags_ids->keys;
	else: ($category_action >> 'Allow All');
		var: 'allow_ids' = $tags_ids->keys;
	else: ($category_action >> 'Deny All');
		var: 'deny_ids' = $tags_ids->keys;
	else: ($category_action >> 'Assign');

		iterate: $tags_category, (var: 'item');
			var: 'cat_name' = $item->first;
			var: 'cat_tags' = $item->second;

			if: (action_param: 'category_' + $cat_name) == 'Mixed';
				// Nothing
			else: (action_param: 'category_' + $cat_name) == 'Allow';
				iterate: $cat_tags, (var: 'tag');
					$allow_ids->(insert: $tags_names->(find: $tag));
					var: 'alias' = $tags_alias->(find: $tag);
					if: ($alias != (array)) && ($alias->size > 0);
						iterate: $alias->(get:1)->second, (var: 'tag2');
							$allow_ids->(insert: $tags_names->(find: $tag2));
						/iterate;
					/if;
				/iterate;
			else: (action_param: 'category_' + $cat_name) == 'Deny';
				iterate: $cat_tags, (var: 'tag');
					$deny_ids->(insert: $tags_names->(find: $tag));
					var: 'alias' = $tags_alias->(find: $tag);
					if: ($alias != (array)) && ($alias->size > 0);
						iterate: $alias->(get:1)->second, (var: 'tag2');
							$deny_ids->(insert: $tags_names->(find: $tag2));
						/iterate;
					/if;
				/iterate;
			else: (action_param: 'category_' + $cat_name) == 'Ignore';
				iterate: $cat_tags, (var: 'tag');
					$delete_ids->(insert: $tags_names->(find: $tag));
					var: 'alias' = $tags_alias->(find: $tag);
					if: ($alias != (array)) && ($alias->size > 0);
						iterate: $alias->(get:1)->second, (var: 'tag2');
							$delete_ids->(insert: $tags_names->(find: $tag2));
						/iterate;
					/if;
				/iterate;
			/if;

		/iterate;

	/if;

	$delete_ids->(merge: $allow_ids);
	$delete_ids->(merge: $deny_ids);
	var: 'groups_action' = 'None';

else: ($tag_action >> 'Unassign All') || ($tag_action >> 'Assign') || ($tag_action >> 'Allow All') || ($tag_action >> 'Deny All');

	var: 'cat_ids' = (array);
	iterate: $groups_categorydetail, (var: 'tag');
		$cat_ids->(insert: $tags_names->(find: $tag));
		var: 'alias' = $tags_alias->(find: $tag);
		if: ($alias != (array)) && ($alias->size > 0);
			iterate: $alias->(get:1)->second, (var: 'tag2');
				$cat_ids->(insert: $tags_names->(find: $tag2));
			/iterate;
		/if;
	/iterate;

	if: ($tag_action >> 'Unassign All');
		var: 'delete_ids' = $cat_ids;
	else: ($tag_action >> 'Allow All');
		var: 'allow_ids' = $cat_ids;
	else: ($tag_action >> 'Deny All');
		var: 'deny_ids' = $cat_ids;
	else: ($tag_action >> 'Assign');

		iterate: $groups_categorydetail, (var: 'tag');
			if: (action_param: 'tag_' + $tag) == 'Allow';
				$allow_ids->(insert: $tags_names->(find: $tag));
				var: 'alias' = $tags_alias->(find: $tag);
				if: ($alias != (array)) && ($alias->size > 0);
					iterate: $alias->(get:1)->second, (var: 'tag2');
						$allow_ids->(insert: $tags_names->(find: $tag2));
					/iterate;
				/if;
			else: (action_param: 'tag_' + $tag) == 'Deny';
				$deny_ids->(insert: $tags_names->(find: $tag));
				var: 'alias' = $tags_alias->(find: $tag);
				if: ($alias != (array)) && ($alias->size > 0);
					iterate: $alias->(get:1)->second, (var: 'tag2');
						$deny_ids->(insert: $tags_names->(find: $tag2));
					/iterate;
				/if;
			else: (action_param: 'tag_' + $tag) == 'Ignore';
				$delete_ids->(insert: $tags_names->(find: $tag));
				var: 'alias' = $tags_alias->(find: $tag);
				if: ($alias != (array)) && ($alias->size > 0);
					iterate: $alias->(get:1)->second, (var: 'tag2');
						$delete_ids->(insert: $tags_names->(find: $tag2));
					/iterate;
				/if;
			/if;
		/iterate;

	/if;

	$delete_ids->(merge: $allow_ids);
	$delete_ids->(merge: $deny_ids);
	var: 'groups_action' = 'Detail';

/if;

if: ($delete_ids->size > 0) || ($allow_ids->size > 0) || ($deny_ids->size > 0);

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='BEGIN TRANSACTION'; /inline;

	if: $delete_ids->size > 0;
		var: 'sql' = 'DELETE FROM security_group_tag_map WHERE id_group = ' + (integer: $groups_groupid) + ' AND id_tag in (' + $delete_ids->(join: ',') + ')';
		inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords=0;
		/inline;
	/if;

	if: ($allow_ids->size > 0);
		iterate: $allow_ids, (var: 'id');
			var: 'sql' = 'INSERT INTO security_group_tag_map (id_group,id_tag,allow_exec) VALUES (' + (integer: $groups_groupid) + ',' + (integer: $id) + ',"Y")';
			inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords=0;
			/inline;
		/iterate;
	/if;

	if: ($deny_ids->size > 0);
		iterate: $deny_ids, (var: 'id');
			var: 'sql' = 'INSERT INTO security_group_tag_map (id_group,id_tag,allow_exec) VALUES (' + (integer: $groups_groupid) + ',' + (integer: $id) + ',"N")';
			inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords=0;
			/inline;
		/iterate;
	/if;

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='COMMIT TRANSACTION'; /inline;

	var: 'need_flush' = true;

/if;


//
// Flush Cache If Needed
//

if: (var: 'need_flush') == true;
	_security_flushcaches;
/if;


//
// Find Tag Permissions
//

var: 'tags_status' = (map);

inline: -log=$__startup_loglevel__, -search,
		-database='lasso_internal', 
		-table='security_group_tag_map', 
		-op='eq', 'id_group' = $groups_groupid, 
		-maxrecords='all';
	records;
		if: $tags_ids->keys >> (field: 'id_tag');
			var: 'temp' = (map);
			loop: (field_name: -count);
				$temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
			/loop;
			$tags_status->(insert: $tags_ids->(find: (field: 'id_tag')) = $temp);
		/if;
	/records;
/inline;

?>

