<?LassoScript

	define_tag: '_debug', -priority='replace';
		local: 'output' = '<p style="text-align: center; font-size: 1; color: red; font-family: Verdana;">';
		#output += 'An error has occurred processing SiteAdmin.LassoApp:<br />';
		#output += '<b>' + params->(join: ' ') + '</b><br />';
		#output += 'Details: ' + lasso_version + ', ' + date + ', ' + (var: 'admin_tab1') + ' ' + (var: 'admin_tab2') +  ' ' + (var: 'admin_tab3') + '<br />';
		#output += 'Please report this complete error to <a href="mailto:bugs@lassosoft.com">bugs@lassosoft.com</a>.';
		#output += '</p>';
		return: @#output;
	/define_tag;

	define_tag: '_admin_nocache', -priority='replace';
		$__http_header__ += 'Expires: Mon, 26 Jul 1997 05:00:00 GMT\r\n';
		$__http_header__ += 'Last-Modified: ' + (Date_LocaltoGMT: date )->(format:'%a, %d %m %Y %H:%M:%S') + ' GMT\r\n';
		$__http_header__ += 'Cache-Control: no-store, no-cache, must-revalidate\r\n';
		$__http_header__ += 'Cache-Control: post-check=0, pre-check=0\r\n';
		$__http_header__ += 'Pragma: no-cache\r\n';
	/define_tag;

	define_tag: '_admin_range', -required='value', -required='min', -required='max', -priority='replace';
		return: (math_min: #max, (math_max: #min, #value));
	/define_tag;

	define_tag: '_admin_array_find', -required='array', -required='pattern', -priority='replace';
		if: !(#array->(isa: 'array'));
			return: 'None';
		/if;
		protect;
			return: #array->(find: #pattern)->(get:1)->second;
	/protect;
		if: (#pattern == 0);
			return: 'None';
		/if;
		return: (string: #pattern);
	/define_tag;

	define_tag: '_admin_addvar', -required='name', -optional='default', -optional='session', -optional='override', -optional='force', -priority='replace';
		if: ((var_defined: #name) == false) || ((var: #name) == null);
			var: #name = '';
		/if;
		if: (local_defined: 'force');
			var: #name = #force;
		else: (local_defined: 'override') && (#override != '');
			var: #name = #override;
		else: (local_defined: 'default') && ((var: #name) == '') && (#default != '');
			var: #name = #default;
		/if;
		if: (local_defined: 'session') && (#session != '');
			session_addvar: -name=#session, #name;
		/if;
	/define_tag;

	define_tag: '_admin_short_cleanup', -required='output', -required='size', -priority='replace';
		local: '_output'=(string: #output);
		local: '_size'=(integer: #size);

		if: #_output == '';
			return: ' ';
		/if;

		if: #_output->size < #_size;
			#_output = (string_replace: -find='href', -replace='&#104;&#114;&#101;&#102;', #_output);
			return: #_output;
		/if;

		#_output = #_output->(substring:0,(#_size - 3));
		if: (#_output->(endswith: '...'));
			return: #_output;
		else: (#_output->(endswith: '..'));
			return: #_output + '.';
		else: (#_output->(endswith: '.'));
			return: #_output + '..';
		else;
			return: #_output + '...';
		/if;
	/define_tag;

	define_tag: '_admin_wrap_cleanup', -required='input', -required='wrap', -required='size', -priority='replace';
		local: '_input'=(string: #input);
		local: '_wrap'=(integer: #wrap);
		local: '_size'=(integer: #size);
		local: '_margin'=(integer: (#wrap / 4.0));

		if: #_input->size < #_wrap;
			#_input = (string_replace: -find='href', -replace='&#104;&#114;&#101;&#102;', #_input);
			return: @#_input;
		/if;

		local: '_pattern' = '\\s*(.{0,' + (#_wrap - #_margin) + '}\\w{0,' + (#_margin) + '})';
		local: '_lines' = (string_findregexp: #_input, -find=#_pattern);

		local: '_output' = '';
		local: '_count' = 0;
		loop: -loopfrom=2, -loopto=#_lines->size, -loopincrement=2;
			#_output += (encode_html: #_lines->(get: loop_count)) + '<br />';
			#_count += 1;
			if: #_count >= #_size;
				loop_abort;
			/if;
		/loop;

		if: #_lines->size > (#_count * 2);
			#_output += '...';
		else;
			#_output->(removetrailing: '<br />');
		/if;

		#_output = (string_replace: -find='href', -replace='&#104;&#114;&#101;&#102;', #_output);

		return: @#_output;
	/define_tag;

	define_tag: '_admin_connectortype', -priority='replace', -required='name';
		if: (#name >> 'com.microsoft.jdbc.sqlserver.SQLServerDriver');
			return: 'omnipilot sqlserver jdbc';
		else: (#name == 'fmremotedatasource');
			return: 'omnipilot filemaker pro';
		else: (#name == 'fmserveradvanceddatasource');
			return: 'omnipilot filemaker server';
		else: (#name == 'fmserver9datasource');
			return: 'omnipilot filemaker server';
		else: (#name == 'internalmysqlds');
			return: 'internal mysql';
		else: (#name == 'mysqlds');
			return: 'omnipilot mysql';
		else: (#name == 'sqliteconnector');
			return: 'omnipilot sqlite';
		else: (#name == 'spotlightds');
			return: 'omnipilot spotlightds';
		else: (#name == 'sqlserver');
			return: 'omnipilot sqlserver';
		else: (#name == 'postgresql');
			return: 'omnipilot postgresql';
		else: (#name == 'openbase');
			return: 'omnipilot openbase';
		else: (#name == 'oracle');
			return: 'omnipilot oracle';
		else: (#name == 'odbc');
			return: 'omnipilot odbc';
		else: (lasso_tagexists: '_jdbc_driverinfo') && (_jdbc_driverinfo: #name)->(isa: 'array');
			return: 'thirdparty jdbc';
		else;
			return: 'thirdparty';
		/if;
	/define_tag;

	_admin_addvar: '__admin_connectors_array', -default=null;
	_admin_addvar: '__admin_connector_id', -default=null;
	_admin_addvar: '__admin_hosts_array', -default=null;
	_admin_addvar: '__admin_host_id', -default=null;
	_admin_addvar: '__admin_databases_array', -default=null;
	_admin_addvar: '__admin_database_id', -default=null;
	_admin_addvar: '__admin_tables_array', -default=null;
	_admin_addvar: '__admin_table_id', -default=null;
	_admin_addvar: '__admin_fields_array', -default=null;
	_admin_addvar: '__admin_groups_array', -default=null;
	_admin_addvar: '__admin_users_array', -default=null;

	define_tag: 'admin_datasourcecascade',
			-optional='datasource',
			-optional='host',
			-optional='database',
			-optional='table',
			-optional='field',
			-optional='render',
			-optional='prefix',
			-optional='suffix',
			-optional='label',
			-optional='sqlonly',
			-optional='datasourceonly';
			
		if: !(local_defined: 'render');
			local: 'render' = 'table';
		/if;
		if: !(local_defined: 'prefix');
			local: 'prefix' = '';
		/if;
		if: !(local_defined: 'suffix');
			local: 'suffix' = '';
		/if;
		if: !(local_defined: 'label');
			local: 'label' = '';
		/if;
		if: !(local_defined: 'class');
			if: (local_defined: 'forheader');
				local: 'class' = 'std_pop_medium';
			else: (local_defined: 'forsidebar');
				local: 'class' = 'sidebar';
			else;
				local: 'class' = 'std_pop_large';
			/if;
		/if;
		
		if: (local_defined: 'forheader') && !(local_defined: 'notabletag');
			local: 'notabletag' = true;
		else: (local_defined: 'forsidebar') && !(local_defined: 'notabletag');
			local: 'notabletag' = true;
		/if;
		
		if: (local_defined: 'forheader');
			local: 'output_pre' = '&nbsp;' + #label;
			local: 'output_mid' = ':&nbsp';
			local: 'output_end' = '';
		else: (local_defined: 'forsidebar');
			local: 'output_pre' = '<p><b>' + #label;
			local: 'output_mid' = '</b><br />';
			local: 'output_end' = '</p>';
		else;
			local: 'output_pre' = '<tr><th width="35%">' + #label;
			local: 'output_mid' = '</th><td>';
			local: 'output_end' = '</td></tr>';
		/if;
		
		local: 'output' = '';
		if: !(local_defined: 'notabletag');
			#output += '<table>';
		/if;
		local: 'error' = '';

		if: (local_defined: 'datasource');
			// Nothing
		else: (local_defined: 'host');
			inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_datasource_hosts', -keyfield='id', -keyvalue=#host, -maxrecords=1, -returnfield='id_datasource';
				local: 'datasource' = (field: 'id_datasource');
			/inline;
		else: (local_defined: 'database');
			inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_datasource_databases', -keyfield='id', -keyvalue=#database, -maxrecords=1, -returnfield='id_host', -returnfield='id_datasource';
				local: 'datasource' = (field: 'id_datasource');
				local: 'host' = (field: 'id_host');
			/inline;
		else: (local_defined: 'table');
			inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_database_tables', -keyfield='id', -keyvalue=#table, -maxrecords=1, -returnfield='id_database';
				local: 'database' = (field: 'id_database');
			/inline;
			inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_datasource_databases', -keyfield='id', -keyvalue=#database, -maxrecords=1, -returnfield='id_datasource', -returnfield='id_datasource';
				local: 'datasource' = (field: 'id_datasource');
				local: 'host' = (field: 'id_host');
			/inline;
		else: (local_defined: 'field');
			inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_table_fields', -keyfield='id', -keyvalue=#field, -maxrecords=1, -returnfield='id_table';
				local: 'table' = (field: 'id_table');
			/inline;
			inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_database_tables', -keyfield='id', -keyvalue=#table, -maxrecords=1, -returnfield='id_database';
				local: 'database' = (field: 'id_database');
			/inline;
			inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_datasource_databases', -keyfield='id', -keyvalue=#database, -maxrecords=1, -returnfield='id_host', -returnfield='id_datasource';
				local: 'datasource' = (field: 'id_datasource');
				local: 'host' = (field: 'id_host');
			/inline;
		else;
			// Default
			local: 'datasource' = 1;
		/if;
		
		if: !(local_defined: 'datasource');
			local: 'datasource' = 0;
		/if;
		if: !(local_defined: 'host');
			local: 'host' = 0;
		/if;
		if: !(local_defined: 'database');
			local: 'database' = 0;
		/if;
		if: !(local_defined: 'table');
			local: 'table' = 0;
		/if;
		if: !(local_defined: 'field');
			local: 'field' = 0;
		/if;

		local: 'inline_params' = (array: -op='eq', 'enabled'='Y');
		if: (local_defined: 'datasourceonly');
			local: 'inline_params' = (array:
				-op='eq', 'id'=#datasource,
			);
		else: (local_defined: 'sqlonly');
			local: 'inline_params' = (array:
				-opbegin='and',
					-op='neq', 'name'='SpotlightDS',
					-op='neq', 'name'='FMRemoteDataSource',
					-op='neq', 'name'='FMServerAdvancedDataSource',
					-op='neq', 'name'='FMServer9DataSource',
				-opend='and',
			);
		/if;

		inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_datasources', -keyfield='id', #inline_params, -maxrecords='all';
			
			// Host Count
			local: 'hosts' = map;
			inline: -log=$__startup_loglevel__, -database='lasso_internal', -table='security_datasource_hosts', -sql='SELECT id_datasource, COUNT(id) AS cnt FROM security_datasource_hosts GROUP BY id_datasource', -maxrecords='all';
				records;
					#hosts->(insert: (field: 'id_datasource') = (field: 'cnt'));
				/records;
			/inline;
			local: 'found_count' = #hosts->size;
			
			if: (#found_count == 0);
				local: 'datasource' = 0;
				local: 'host' = 0;
				local: 'database' = 0;
				local: 'table' = 0;
				local: 'field' = 0;
				if: !(local_defined: 'nodatasource') && (#error == '');
					local: 'error' = 'No Datasources Found.';
				/if;
			else: !(local_defined: 'nodatasource');
				local: 'found' = false;
				#output += #output_pre + 'Datasource' + #output_mid;
				
				// Look up labels
				local: 'labels' = _admin_defaultconnectornames;				
				inline: -log=$__startup_loglevel__, -database='lasso_internal', -table='global_prefs', -op='bw', 'store_key'='_admin_connector_alias:', -search, -maxrecords='all';
					records;
						#labels->(insert: ((field: 'store_key') - '_admin_connector_alias:') = (string: (field: 'data')));
					/records;
				/inline;
				if: (local_defined: 'forsidebar');
					iterate: #labels->keys, (local: 'key');
						#labels->(find: #key) -= 'Lasso Connector for ';
					/iterate;
				/if;

				#output += '<select name="' + #prefix + 'datasource' + #suffix + '"' + ((local_defined: 'nodatasourcerefresh') ? '' | ' onchange="this.form.submit()"') + ' class="' + #class + '">';
				records;
					if: #hosts->(find: (field: 'id')) <= 0;
						loop_continue;
					else: (field: 'id') == (local: 'datasource');
						#found = true;
						#output += '<option value="' + (field: 'id') + '" selected="selected">' + (if_null: #labels->(find: (field: 'name')), (field: 'name')) + '</option>';
					else;
						#output += '<option value="' + (field: 'id') + '">' + (if_null: #labels->(find: (field: 'name')), (field: 'name')) + '</option>';
					/if;
				/records;
				#output += '</select>';
				#output += #output_end;
				if: (#found == false) || ((local: 'datasource') <= 0) || ((local: 'datasource') == '');
					local: 'datasource' = (field: 'id');
				/if;
			/if;
		/inline;
		
		inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_datasource_hosts', -keyfield='id', -op='eq', 'id_datasource'=#datasource, -op='eq', 'enabled'='Y', -maxrecords='all';
			if: (found_count == 0);
				local: 'host' = 0;
				local: 'database' = 0;
				local: 'table' = 0;
				local: 'field' = 0;
				if: !(local_defined: 'nohost') && (#error == '');
					local: 'error' = 'No Hosts Found.';
				/if;
			else: !(local_defined: 'nohost');
				local: 'found' = false;
				#output += #output_pre + 'Host' + #output_mid;

				// Look up labels
				local: 'labels' = (map: 1 = 'Internal');				
				inline: -log=$__startup_loglevel__, -database='lasso_internal', -table='global_prefs', -op='bw', 'store_key'='_admin_host_alias:', -search, -maxrecords='all';
					records;
						#labels->(insert: ((field: 'store_key') - '_admin_host_alias:') = (string: (field: 'data')));
					/records;
				/inline;

				#output += '<select name="' + #prefix + 'host' + #suffix + '"' + ((local_defined: 'nohostrefresh') ? '' | ' onchange="this.form.submit()"') + ' class="' + #class + '">';
				records;
					if: (field: 'id') == (local: 'host');
						#found = true;
						#output += '<option value="' + (field: 'id') + '" selected="selected">' + (if_null: #labels->(find: (field: 'id')), (field: 'name')) + '</option>';
					else;
						#output += '<option value="' + (field: 'id') + '">' + (if_null: #labels->(find: (field: 'id')), (field: 'name')) + '</option>';
					/if;
				/records;
				#output += '</select>';
				#output += #output_end;
				if: (#found == false) || ((local: 'host') <= 0) || ((local: 'host') == '');
					local: 'host' = (field: 'id');
				/if;
			/if;
		/inline;
		
		inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_datasource_databases', -keyfield='id', -op='eq', 'id_host'=#host, -op='eq', 'enabled'='Y', -maxrecords='all', ((#datasource == 1) ? (array: -opbegin='not', -op='ew', 'name'='-journal', -opend='not', -op='neq', 'name'=':memory:'));
			if: (found_count == 0);
				local: 'database' = 0;
				local: 'table' = 0;
				local: 'field' = 0;
				if: !(local_defined: 'nodatabase') && (#error == '');
					local: 'error' = 'No Databases Found.';
				/if;
			else: !(local_defined: 'nodatabase');
				local: 'found' = false;
				#output += #output_pre + 'Database' + #output_mid;
				#output += '<select name="' + #prefix + 'database' + #suffix + '"' + ((local_defined: 'nodatabaserefresh') ? '' | ' onchange="this.form.submit()"') + ' class="' + #class + '">';
				records;
					if: (field: 'id') == (local: 'database');
						#found = true;
						#output += '<option value="' + (field: 'id') + '" selected="selected">' + (field: 'name') + '</option>';
					else;
						#output += '<option value="' + (field: 'id') + '">' + (field: 'name') + '</option>';
					/if;
				/records;
				#output += '</select>';
				#output += #output_end;
				if: (#found == false) || ((local: 'database') <= 0) || ((local: 'database') == '');
					local: 'database' = (field: 'id');
				/if;
			/if;
		/inline;
		
		inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_database_tables', -keyfield='id', -op='eq', 'id_database'=#database, -op='eq', 'enabled'='Y', -maxrecords='all';
			if: (found_count == 0);
				local: 'table' = 0;
				local: 'field' = 0;
				if: !(local_defined: 'notable') && (#error == '');
					local: 'error' = 'No Tables Found.';
				/if;
			else: !(local_defined: 'notable');
				local: 'found' = false;
				#output += #output_pre + 'Table' + #output_mid;
				#output += '<select name="' + #prefix + 'table' + #suffix + '"' + ((local_defined: 'notablerefresh') ? '' | ' onchange="this.form.submit()"') + ' class="' + #class + '">';
				records;
					if: (field: 'id') == (local: 'table');
						#found = true;
						#output += '<option value="' + (field: 'id') + '" selected="selected">' + (field: 'name') + '</option>';
					else;
						#output += '<option value="' + (field: 'id') + '">' + (field: 'name') + '</option>';
					/if;
				/records;
				#output += '</select>';
				#output += #output_end;
				if: (#found == false) || ((local: 'table') <= 0) || ((local: 'table') == '');
					local: 'table' = (field: 'id');
				/if;
			/if;
		/inline;
		
		inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_table_fields', -keyfield='id', -op='eq', 'id_table'=#table, -op='eq', 'enabled'='Y', -maxrecords='all';
			if: (found_count == 0);
				local: 'field' = 00;
				if: !(local_defined: 'nofield') && (#error == '');
					local: 'error' = 'No Fields Found.';
				/if;
			else: !(local_defined: 'nofield');
				local: 'found' = false;
	 			if: (local_defined: 'keyfield');
					#output += #output_pre + 'Key Field' + #output_mid;
				else;
					#output += #output_pre + 'Field' + #output_mid;
				/if;
				#output += '<select name="' + #prefix + 'field' + #suffix + '"' + ((local_defined: 'nofieldrefresh') ? '' | ' onchange="this.form.submit()"') + ' class="' + #class + '">';
				records;
					if: (field: 'id') == (local: 'field');
						#found = true;
						#output += '<option value="' + (field: 'id') + '" selected="selected">' + (field: 'name') + '</option>';
					else;
						#output += '<option value="' + (field: 'id') + '">' + (field: 'name') + '</option>';
					/if;
				/records;
				#output += '</select>';
				#output += #output_end;
				if: (#found == false) || ((local: 'field') <= 0) || ((local: 'field') == '');
					local: 'field' = (field: 'id');
				/if;
			/if;
		/inline;
		
		if: !(local_defined: 'notabletag');
			#output += '</table>';
		/if;
		
		if: !(local_defined: 'noerror') && (#error != '');
			if: (local_defined: 'forheader');
				#output += '<span class="error">' + #error + '</span>';
			else: (local_defined: 'forsidebar');
				#output += '<p style="color: red"><b>' + #error + '</b></p>';
			else: !(local_defined: 'notabletag');
				#output += '<p class="error">' + #error + '</p><p>&nbsp;</p>';
			else;
				#output += '<tr><td colspan="2"><p class="error">' + #error + '</p></td></tr>';
			/if;
		/if;
		
		return: @#output;
	/define_tag;

?>