<?LassoScript

	_admin_addvar: 'action', -override=(action_param: 'action', (action_param: 'action', -count));

	_admin_addvar: 'cache_totalstoragelimit', -override=(action_param: 'cache_totalstoragelimit'), -default=(50*1024*1024);
	_admin_addvar: 'cache_host', -override=(action_param: 'cache_host'), -default='Y';
	_admin_addvar: 'cache_enable', -override=(action_param: 'cache_enable'), -default='Y';
	_admin_addvar: 'cache_expirefrequency', -override=(action_param: 'cache_expirefrequency');

	var: 'prefs_list' = (array: 'cache_totalstoragelimit', 'cache_host', 'cache_enable', 'cache_expirefrequency');

	if: ($action >> 'reset');

		var: 'cache_totalstoragelimit' = (50*1024*1024);
		var: 'cache_host' = 'Y';
		var: 'cache_enable' = 'Y';
		var: 'cache_expirefrequency' = 'never';

	/if;

	if: ($action >> 'update') || ($action >> 'reset');

		(global: '_cache_preference') = null;

		var: 'cache_totalstoragelimit' = (integer: $cache_totalstoragelimit);
		if: $cache_totalstoragelimit < 0;
			var: 'cache_totalstoragelimit' = (-1);
		/if;

		if: $cache_host != 'N';
			var: 'cache_host' = 'Y';
		/if;

		if: $cache_enable != 'N';
			var: 'cache_enable' = 'Y';
		/if;

		iterate: $prefs_list, (var: 'temp');
			inline: -log=$__startup_loglevel__, -delete,
					-database='lasso_internal',
					-table='global_prefs',
					-keyfield='store_key',
					-keyvalue='_' + $temp;
			/inline;

			inline: -log=$__startup_loglevel__, -add,
					-database='lasso_internal',
					-table='global_prefs',
					'store_key'='_' + $temp,
					'data'=(var: $temp);
			/inline;
		/iterate;

		// Reset the global cache preferences
		global: '_cache_preference' = (cache_preferences);

		if: ((var: 'cache_expirefrequency') == 'hourly');
			global: '_cache_lastexpiration' = date->(format: '%Q %T');
		else: ((var: 'cache_expirefrequency') == 'daily');
			global: '_cache_lastexpiration' = date->(format: '%Q 00:00:01');
		else: ((var: 'cache_expirefrequency') == 'weekly');
			global: '_cache_lastexpiration' = date->(subtract: -day=6) & (format: '%Q 00:00:01');
		/if;

	/if;

	iterate: $prefs_list, (var: 'temp');
		inline: -log=$__startup_loglevel__, -search,
				-database='lasso_internal',
				-table='global_prefs',
				-keyfield='store_key',
				-keyvalue='_' + $temp;
			if: (found_count > 0);
				var: $temp = (field: 'data');
			/if;
		/inline;
	/iterate;

	!global_defined('_cache_preference') ? global('_cache_preference' = cache_preferences);
	!global('_cache_preference')->isa('map') ? global('_cache_preference' = cache_preferences);

?>
