<?LassoScript

// Variables

_admin_addvar: 'email_action', -override=(action_param: 'email_action');
_admin_addvar: 'email_from', -override=(action_param: 'email_from');
_admin_addvar: 'email_to', -override=(action_param: 'email_to');
_admin_addvar: 'email_cc', -override=(action_param: 'email_cc');
_admin_addvar: 'email_bcc', -override=(action_param: 'email_bcc');
_admin_addvar: 'email_subject', -override=(action_param: 'email_subject');
_admin_addvar: 'email_body', -override=(action_param: 'email_body');


// Preferences

var: 'email_defaults' = (map: 
		'lasso_smtp_pause' = 'N',
		'lasso_smtp_host' = '',
		'lasso_smtp_sendmode' = 'direct',
	);
var: 'email_prefs' = $email_defaults;
var: 'email_prefs' = (admin_getpref: $email_prefs);

// Action

if: ($email_action >> 'Send');

	if: (($email_to == '') && ($email_cc == '') && ($email_bcc == ''));
		var: 'error' = 'A recipient must be specified for the email.';
	else: ($email_from == '');
		var: 'error' = 'The message has no from address.';
	else: ($email_subject == '');
		var: 'error' = 'The message has no subject.';
	else: ($email_body == '');
		var: 'error' = 'The message has no body.';
	else;
		Protect;
			Email_Send:
				-From=$email_from,
				-Subject=$email_subject,
				-Body=$email_body,
				-To=$email_to,
				-CC=$email_cc,
				-BCC=$email_bcc;
				
			inline: -log=$__startup_loglevel__, -search,
					-database='site',
					-table='smtp_queue',
					-op='eq', 'id_site'=(email_result),
					-maxrecords=1,
					-uselimit,
					-returnfield='id';
				var:'email_id' = (field:'id');
			/inline;
	
			if: ((global: '__SMTP_Queue_Status__') !>> 'Pause');
				global: '__SMTP_Queue_Status__'='Active';
			/if;
			if: ((global: '__SMTP_Stage_Status__') !>> 'Pause');
				global: '__SMTP_Stage_Status__'='Active';
			/if;
		
			redirect_url: (var: 'admin_link') + '&tab3=email';
				
			Handle_Error;
				var: 'error' = (string_replaceregexp: error_msg, -find='at:.*', -replace='');
			/Handle_Error;
		
		/Protect;
	/if;

/if;

?>
