<?LassoScript

var: 'admin_refresh' = (integer: (admin_getpref: 'lasso_admin_queuerefresh', -default='1')) * 60;

_admin_addvar: 'email_filter', -session='_siteadmin', -default='', -force=(action_param: 'email_filter');
_admin_addvar: 'email_status', -session='_siteadmin', -default='queued', -override=(action_param: 'email_status');
_admin_addvar: 'email_action', -default='None', -override=(action_param: 'email_action');
_admin_addvar: 'email_mode', -default='Listing', -override=(action_param: 'email_mode');

_admin_addvar: 'email_id', -default='', -override=(action_param: 'email_id');
_admin_addvar: 'part_id', -default='', -override=(action_param: 'part_id');

_admin_addvar: 'email_skip', -default=0, -session='_siteadmin', -override=(action_param: 'email_skip');
_admin_addvar: 'email_max', -default=(integer: (admin_getpref: 'lasso_admin_queuesize', -default=25));
_admin_addvar: 'email_navigation', -override=(action_param: 'email_navigation');
_admin_addvar: 'email_found', -override=(action_param: 'email_found');

_admin_addvar: 'email_sortfield', -default='id', -session='_siteadmin', -override=(action_param: 'email_sortfield');
_admin_addvar: 'email_sortorder', -default='descending', -session='_siteadmin', -override=(action_param: 'email_sortorder');

_admin_addvar: 'email_oldfilter', -session='_siteadmin', -override=(action_param: 'email_oldfilter');
_admin_addvar: 'email_oldstatus', -session='_siteadmin', -override=(action_param: 'email_oldstatus');
if: ($email_oldstatus == '') || ($email_oldstatus != $email_status) || ($email_oldfilter == '') || ($email_oldfilter != $email_filter);
	var: 'email_skip' = 0;
/if;

var: 'email_skip' = (integer: $email_skip);
var: 'email_max' = (integer: $email_max);
var: 'email_found' = (integer: $email_found);

if: ($email_navigation >> 'Next');
	$email_skip = $email_skip + $email_max;
else: ($email_navigation >> 'Prev');
	$email_skip = (math_max: $email_skip - $email_max, 0);
else: ($email_navigation >> 'Last');
	$email_skip = $email_found - (($email_found - 1) % $email_max);
else: ($email_navigation >> 'First') || ($email_navigation >> 'Sort');
	$email_skip = 0;
else: ($email_navigation >> 'Jump') || ((action_param: 'email_navigation_skip') != '');
	$email_skip = (math_max: (integer: (action_param: 'email_navigation_skip')) - 1, 0);
/if;

if: ($email_skip > 0) && ($email_found > 0);
	$email_skip = (math_max: (math_min: $email_found - 1, $email_skip), 0);
/if;


var: 'email_inline' = (array);

$email_inline->(insert: -search='action');
$email_inline->(insert: -database='site');
$email_inline->(insert: -table='smtp_queue');

if: $email_mode >> 'one';
	$email_inline->(insert: -maxrecords=1);
else;
	$email_inline->(insert: -maxrecords=$email_max);
/if;
$email_inline->(insert: -skiprecords=$email_skip);

$email_inline->(insert: -sortfield=$email_sortfield);
$email_inline->(insert: -sortorder=$email_sortorder);

if: ($email_filter !== '');
	$email_inline->(insert: -op='cn');
	$email_inline->(insert: 'mime_text'=$email_filter);
/if;	

if: ($email_status >> 'all');

	// Nothing
	
else: ($email_status >> 'queued');

	$email_inline->(insert: -opbegin='or');
	$email_inline->(insert: -op='eq');
	$email_inline->(insert: 'queue_status'='sending');
	$email_inline->(insert: -op='eq');
	$email_inline->(insert: 'queue_status'='queued');
	$email_inline->(insert: -opend='or');

else: $email_status >> 'sent';

	$email_inline->(insert: -op='eq');
	$email_inline->(insert: 'queue_status'='sent');

else: $email_status >> 'error';

	$email_inline->(insert: -op='eq');
	$email_inline->(insert: 'queue_status'='error');

else: $email_status >> 'delete';

	$email_inline->(insert: -op='eq');
	$email_inline->(insert: 'queue_status'='delete');

/if;

if: ($email_action >> 'Delete') && ($email_action >> 'Error');

	var: 'queue_ids' = array;	
	inline: -log=$__startup_loglevel__, -database='site', -sql='SELECT id FROM smtp_queue WHERE queue_status = "error"', -maxrecords='all';
		records;
			$queue_ids->(insert: (field: 'id'));
		/records;
	/inline;
	if: $queue_ids->size > 0;
		inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_stage WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_error SET id_email = 0, id_queue = 0 WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_queue WHERE id IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
	/if;
	
else: ($email_action >> 'Delete') && ($email_action >> 'Sent');

	var: 'queue_ids' = array;	
	inline: -log=$__startup_loglevel__, -database='site', -sql='SELECT id FROM smtp_queue WHERE queue_status = "sent"', -maxrecords='all';
		records;
			$queue_ids->(insert: (field: 'id'));
		/records;
	/inline;
	if: $queue_ids->size > 0;
		inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_stage WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_error SET id_email = 0, id_queue = 0 WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_queue WHERE id IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
	/if;
	
else: ($email_action >> 'Delete') && ($email_action >> 'Queued');

	var: 'queue_ids' = array;	
	inline: -log=$__startup_loglevel__, -database='site', -sql='SELECT id FROM smtp_queue WHERE queue_status = "queued" OR queue_status = "sending"', -maxrecords='all';
		records;
			$queue_ids->(insert: (field: 'id'));
		/records;
	/inline;
	if: $queue_ids->size > 0;
		inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_stage WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_error SET id_email = 0, id_queue = 0 WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_queue WHERE id IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
	/if;
	
else: ($email_action >> 'Delete') && ($email_action >> 'Hold');

	var: 'queue_ids' = array;	
	inline: -log=$__startup_loglevel__, -database='site', -sql='SELECT id FROM smtp_queue WHERE queue_status = "hold"', -maxrecords='all';
		records;
			$queue_ids->(insert: (field: 'id'));
		/records;
	/inline;
	if: $queue_ids->size > 0;
		inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_stage WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_error SET id_email = 0, id_queue = 0 WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_queue WHERE id IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
	/if;
	
else: $email_action >> 'Delete All';

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_stage';
	/inline;
	inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_error SET id_email = 0, id_queue = 0';
	/inline;
	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_queue';
	/inline;

else: $email_action >> 'Stop';

	global: '__SMTP_Queue_Status__'='Pause';
	global: '__SMTP_Stage_Status__'='Pause';
	admin_setpref: 'lasso_smtp_pause', 'Y';

else: $email_action >> 'Resume';

	global: '__SMTP_Queue_Status__'='Active';
	global: '__SMTP_Stage_Status__'='Active';
	admin_setpref: 'lasso_smtp_pause', 'N';

else: $email_action >> 'Delete';

protect;
	if: $part_id > 0;
		inline: -log=$__startup_loglevel__,
				-delete,
				-database='site',
				-table='smtp_stage',
				-keyfield='id',
				-keyvalue=$part_id;
		/inline;
		inline: -log=$__startup_loglevel__,
				-update,
				-database='site',
				-table='smtp_error',
				-keyfield='id_queue',
				-keyvalue=$part_id,
				'id_queue' = 0;
		/inline;
	else: $email_id > 0;
		inline: -log=$__startup_loglevel__,
				-delete,
				-database='site',
				-table='smtp_stage',
				-keyfield='id_email',
				-keyvalue=$email_id;
		/inline;
		inline: -log=$__startup_loglevel__,
				-update,
				-database='site',
				-table='smtp_error',
				-keyfield='id_email',
				-keyvalue=$email_id,
				'id_email' = 0, 
				'id_queue' = 0;
		/inline;
		inline: -log=$__startup_loglevel__,
				-delete,
				-database='site',
				-table='smtp_queue',
				-keyfield='id',
				-keyvalue=$email_id;
		/inline;
	/if;
/protect;

else: $email_action >> 'Try' && $email_action >> 'Queued';

	var: 'queue_ids' = array;	
	inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_stage SET queue_date="' + date->(format: '%Q %T') + '" WHERE queue_status = "queued" OR queue_status = "sending"';
	/inline;
	inline: -log=$__startup_loglevel__, -database='site', -sql='SELECT id FROM smtp_queue WHERE (queue_status = "queued" OR queue_status = "sending") AND queue_date < datetime("now","localtime")', -maxrecords='all';
		records;
			$queue_ids->(insert: (field: 'id'));
		/records;
	/inline;
	if: $queue_ids->size > 0;
		inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_stage SET queue_date="' + date->(format: '%Q %T') + '" WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_queue SET queue_date="' + date->(format: '%Q %T') + '" WHERE id IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
	/if;
	if: ((global: '__SMTP_Queue_Status__') !>> 'Pause');
		global: '__SMTP_Queue_Status__'='Active';
	/if;
	if: ((global: '__SMTP_Stage_Status__') !>> 'Pause');
		global: '__SMTP_Stage_Status__'='Active';
	/if;

else: $email_action >> 'Try' && $email_action >> 'Hold';

	inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_stage SET queue_status = "queued", queue_date="' + date->(format: '%Q %T') + '" WHERE queue_status = "hold"';
	/inline;
	var: 'queue_ids' = array;	
	inline: -log=$__startup_loglevel__, -database='site', -sql='SELECT id FROM smtp_queue WHERE queue_status = "hold"', -maxrecords='all';
		records;
			$queue_ids->(insert: (field: 'id'));
		/records;
	/inline;
	if: $queue_ids->size > 0;
		inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_stage SET queue_status = "queued", queue_date="' + date->(format: '%Q %T') + '" WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_queue SET queue_status = "queued", queue_date="' + date->(format: '%Q %T') + '" WHERE id IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
	/if;
	if: ((global: '__SMTP_Queue_Status__') !>> 'Pause');
		global: '__SMTP_Queue_Status__'='Active';
	/if;
	if: ((global: '__SMTP_Stage_Status__') !>> 'Pause');
		global: '__SMTP_Stage_Status__'='Active';
	/if;

else: $email_action >> 'Try';

	if: $part_id > 0;
		inline: -log=$__startup_loglevel__,
				-search,
				-database='site',
				-table='smtp_stage',
				-keyfield='id',
				-eq, 'id'=$part_id, 
				-opbegin='or',
				-eq, 'queue_status' = 'queued',
				-eq, 'queue_status' = 'hold',
				-opend='or',
				-maxrecords='all';
			records;
				inline: -log=$__startup_loglevel__,
						-update,
						-database='site',
						-table='smtp_stage',
						-keyfield='id',
						-keyvalue=(field: 'id'),
						'queue_date' = date->(format: '%Q %T'),
						'queue_status' = 'queued';
				/inline;
			/records;
		/inline;
	else: $email_id > 0;
		inline: -log=$__startup_loglevel__,
				-search,
				-database='site',
				-table='smtp_queue',
				-keyfield='id',
				-eq, 'id'=$email_id, 
				-opbegin='or',
				-eq, 'queue_status' = 'queued',
				-eq, 'queue_status' = 'hold',
				-opend='or',
				-maxrecords='all';
			records;
				inline: -log=$__startup_loglevel__,
						-update,
						-database='site',
						-table='smtp_queue',
						-keyfield='id',
						-keyvalue=(field: 'id'),
						'queue_date' = date->(format: '%Q %T'),
						'queue_status' = 'queued';
				/inline;
			/records;
		/inline;
		inline: -log=$__startup_loglevel__,
				-search,
				-database='site',
				-table='smtp_stage',
				-keyfield='id',
				-eq, 'id_email'=$email_id, 
				-opbegin='or',
				-eq, 'queue_status' = 'queued',
				-eq, 'queue_status' = 'hold',
				-opend='or',
				-maxrecords='all';
			records;
				inline: -log=$__startup_loglevel__,
						-update,
						-database='site',
						-table='smtp_stage',
						-keyfield='id',
						-keyvalue=(field: 'id'),
						'queue_date' = date->(format: '%Q %T'),
						'queue_status' = 'queued';
				/inline;
			/records;
		/inline;
	/if;
	if: ((global: '__SMTP_Queue_Status__') !>> 'Pause');
		global: '__SMTP_Queue_Status__'='Active';
	/if;
	if: ((global: '__SMTP_Stage_Status__') !>> 'Pause');
		global: '__SMTP_Stage_Status__'='Active';
	/if;
	
else: $email_action >> 'Hold';

	if: $part_id > 0;
		inline: -log=$__startup_loglevel__,
				-search,
				-database='site',
				-table='smtp_stage',
				-keyfield='id',
				-eq, 'id'=$part_id, 
				-eq, 'queue_status' = 'queued',
				-maxrecords='all';
			records;
				inline: -log=$__startup_loglevel__,
						-update,
						-database='site',
						-table='smtp_stage',
						-keyfield='id',
						-keyvalue=(field: 'id'),
						'queue_status' = 'hold';
				/inline;
			/records;
		/inline;
	else: $email_id > 0;
		inline: -log=$__startup_loglevel__,
				-search,
				-database='site',
				-table='smtp_queue',
				-keyfield='id',
				-eq, 'id'=$email_id, 
				-eq, 'queue_status' = 'queued',
				-maxrecords='all';
			records;
				inline: -log=$__startup_loglevel__,
						-update,
						-database='site',
						-table='smtp_queue',
						-keyfield='id',
						-keyvalue=(field: 'id'),
						'queue_status' = 'hold';
				/inline;
			/records;
		/inline;
		inline: -log=$__startup_loglevel__,
				-search,
				-database='site',
				-table='smtp_stage',
				-keyfield='id',
				-eq, 'id_email'=$email_id, 
				-eq, 'queue_status' = 'queued',
				-maxrecords='all';
			records;
				inline: -log=$__startup_loglevel__,
						-update,
						-database='site',
						-table='smtp_stage',
						-keyfield='id',
						-keyvalue=(field: 'id'),
						'queue_status' = 'hold';
				/inline;
			/records;
		/inline;
	/if;
	
else: $email_action >> 'Requeue All';

	var: 'queue_ids' = array;	
	inline: -log=$__startup_loglevel__, -database='site', -sql='SELECT id FROM smtp_queue WHERE queue_status = "error"', -maxrecords='all';
		records;
			$queue_ids->(insert: (field: 'id'));
		/records;
	/inline;
	if: $queue_ids->size > 0;
		inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_stage WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_error SET id_email = 0, id_queue = 0 WHERE id_email IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
		inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE smtp_queue SET queue_status="queued", queue_error="", queue_retries=' + (integer: (admin_getpref: 'lasso_smtp_max_retries', -default=5)) + ', queue_number=0, queue_date="' + date->(format: '%Q %T') + '" WHERE id IN (' + $queue_ids->(join: ', ') + ')';
		/inline;
	/if;
	if: ((global: '__SMTP_Queue_Status__') !>> 'Pause');
		global: '__SMTP_Queue_Status__'='Active';
	/if;
	if: ((global: '__SMTP_Stage_Status__') !>> 'Pause');
		global: '__SMTP_Stage_Status__'='Active';
	/if;

else: $email_action >> 'Requeue';

protect;
	if: $part_id > 0;
		inline: -log=$__startup_loglevel__,
				-update,
				-database='site',
				-table='smtp_error',
				-keyfield='id_queue',
				-keyvalue=$part_id,
				'id_queue' = 0;
		/inline;
		inline: -log=$__startup_loglevel__,
				-update,
				-database='site',
				-table='smtp_stage',
				-keyfield='id',
				-keyvalue=$part_id,
				'queue_status' = 'queued',
				'queue_error' = '',
				'queue_retries' = (integer: (admin_getpref: 'lasso_smtp_max_retries', -default=5)),
				'queue_number' = 0,
				'queue_date' = date->(format: '%Q %T');
		/inline;
		inline: -log=$__startup_loglevel__,
				-search,
				-database='site',
				-table='smtp_stage',
				-keyfield='id',
				-keyvalue=$part_id,
				-returnfield='id_email';
			inline: -log=$__startup_loglevel__,
					-update,
					-database='site',
					-table='smtp_queue',
					-keyfield='id',
					-keyvalue=(field: 'id_email'),
					'queue_status' = 'sending',
					'queue_error' = '',
					'queue_retries' = (integer: (admin_getpref: 'lasso_smtp_max_retries', -default=5)),
					'queue_number' = 0,
					'queue_date' = date->(format: '%Q %T');
			/inline;
		/inline;
	else: $email_id > 0;
		inline: -log=$__startup_loglevel__,
				-delete,
				-database='site',
				-table='smtp_stage',
				-keyfield='id_email',
				-keyvalue=$email_id;
		/inline;
		inline: -log=$__startup_loglevel__,
				-update,
				-database='site',
				-table='smtp_error',
				-keyfield='id_email',
				-keyvalue=$email_id,
				'id_email' = 0, 
				'id_queue' = 0;
		/inline;
		inline: -log=$__startup_loglevel__,
				-update,
				-database='site',
				-table='smtp_queue',
				-keyfield='id',
				-keyvalue=$email_id,
				'queue_status' = 'queued',
				'queue_error' = '',
				'queue_retries' = (integer: (admin_getpref: 'lasso_smtp_max_retries', -default=5)),
				'queue_number' = 0,
				'queue_date' = date->(format: '%Q %T');
		/inline;
	/if;
/protect;
	if: ((global: '__SMTP_Queue_Status__') !>> 'Pause');
		global: '__SMTP_Queue_Status__'='Active';
	/if;
	if: ((global: '__SMTP_Stage_Status__') !>> 'Pause');
		global: '__SMTP_Stage_Status__'='Active';
	/if;

else: $email_action >> 'Clear' && ($email_id != '');

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_error WHERE id_email = "' + (integer: $email_id) + '"';
	/inline;

/if;

?>