[inline: -log=$__startup_loglevel__, $email_inline]

<?LassoScript
	var: 'found_count' = (found_count);
	var: 'shown_count' = (shown_count);
	var: 'shown_first' = (shown_first);
	var: 'shown_last' = (shown_last);
	var: 'error_count' = 0;
	var: 'queued_count' = 0;
	var: 'hold_count' = 0;
	var: 'sent_count' = 0;
	var: 'stage_ids' = (array);
	records;
		if: (field: 'queue_status') >> 'sending';
			$queued_count += 1;
		else: (field: 'queue_status') >> 'queued';
			$queued_count += 1;
		else: (field: 'queue_status') >> 'hold';
			$hold_count += 1;
		else: (field: 'queue_status') >> 'error';
			$error_count += 1;
		else: (field: 'queue_status') >> 'sent';
			$sent_count += 1;
		/if;
		$stage_ids->(insert: (field: 'id'));
	/records;
	if: $stage_ids->size > 0;
		inline: -log=$__startup_loglevel__,
				-database='site',
				-table='smtp_error',
				-SQL='SELECT * FROM smtp_error WHERE id_queue IN (' + $stage_ids->(join: ', ') + ') ORDER BY id DESC',
				-maxrecords='all',
				-inlinename='smtp_error';
		/inline;
	/if;

?>

<div class="sidebar">

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" name="email_oldfilter" value="[var: 'email_filter']">
<input type="hidden" name="email_oldstatus" value="[var: 'email_status']">
<input type="hidden" name="email_skip" value="[var: 'email_skip']">	
<input type="hidden" name="email_found" value="[var: 'found_count']">
<input type="hidden" name="email_id" value="[var: 'email_id']">

	<h2 onclick="toggleDisplayBlock('srch')">Email Parts</h2>
	<div id="srch">
		[if: $email_id != '']
			<p>Showing parts for email [var: 'email_id']</p>
			<p style="margin-bottom: 3px; align: right;">
				<input type="submit" name="email_action" value="Show All Parts" />
			</p>
		[else]
			<p>Showing all parts</p>
		[/if]
		<p>
			<b>Status</b>
			<br />
			<select name="email_status" onchange="this.form.submit();">
				<option value="all" [if: (var: 'email_status') >> 'all']selected="selected"[/if]>Any Parts</option>
				<option value="queued" [if: (var: 'email_status') >> 'queued']selected="selected"[/if]>Queued Parts</option>
				<option value="hold" [if: (var: 'email_status') >> 'hold']selected="selected"[/if]>Hold Parts</option>
				<option value="sent" [if: (var: 'email_status') >> 'sent']selected="selected"[/if]>Sent Parts</option>
				<option value="error" [if: (var: 'email_status') >> 'error']selected="selected"[/if]>Part Errors</option>
			</select>
		</p>
		<p>
			<b>Filter</b>
			<br />
			<input type="text" name="email_filter" value="[var: 'email_filter']" size="16" />
		</p>
		<p style="margin-bottom: 3px; align: right;">
			<input type="submit" name="email_action" value="Select" class="half" />
			<input type="submit" name="email_action" value="Refresh" class="half" />
		</p>
	</div>

	<div id="none">
		<p>
			<input type="Submit" name="email_action" value="[if: (global: '__SMTP_Stage_Status__') >> 'Pause']Resume[else]Stop[/if] Queue" />
		</p>
	</div>
	
	<h2 onclick="toggleDisplayBlock('sum')">Summary</h2>
	<div id="sum">
		<p>
			[if: ((var: 'found_count') > 0) && ((var: 'shown_count') > 0)]
				Showing 
				[if: (var: 'shown_count') == 1] Record [var: 'shown_first'][else][var: 'shown_count'] Records[/if]
				[if: (var: 'found_count') > 1]of [var: 'found_count'] Found[/if]
			[else]
				No Records Found
			[/if]
		</p>
		<p>
			Email Queue: [Global: '__SMTP_Queue_Status__'] [if: (Global: '__SMTP_Queue_Status__') >> 'Sleep'] Until [Date_Format: (Global: '__SMTP_Queue_Sleep__'), -Format='%T'][/If]
		</p>
		<p>
			Parts Queue: [Global: '__SMTP_Stage_Status__'] [if: (Global: '__SMTP_Stage_Status__') >> 'Sleep'] Until [Date_Format: (Global: '__SMTP_Stage_Sleep__'), -Format='%T'][/If]
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('act')">Actions</h2>
	<div id="act"[if: (var: 'found_count') == 0] style="display: none;"[/if]>

		[if: ((var: 'sent_count') > 0)]
		<p>
			<input type="submit" name="email_action" value="Delete All Sent" onclick="return confirm('Are you sure you want to delete all sent parts?');" />
		</p>
		[/if]
		<p>
			<input type="submit" name="email_action" value="Delete All" onclick="return confirm('Are you sure you want to delete all parts?');" />
		</p>
	[if: ((var: 'error_count') > 0) || ((var: 'queued_count') > 0) || ((var: 'hold_count') > 0)]
		[if: ((var: 'queued_count') > 0)]
		<p>
			<input type="submit" name="email_action" value="Delete All Queued" onclick="return confirm('Are you sure you want to delete unsent parts?');" />
		</p>
		<p>
			<input type="submit" name="email_action" value="Try All Queued" />
		</p>
		[/if]
		[if: ((var: 'hold_count') > 0)]
		<p>
			<input type="submit" name="email_action" value="Delete All Hold" onclick="return confirm('Are you sure you want to delete all hold parts?');" />
		</p>
		<p>
			<input type="submit" name="email_action" value="Try All Hold" />
		</p>
		[/if]
		[if: ((var: 'error_count') > 0)]
		<p>
			<input type="submit" name="email_action" value="Delete All Errors" onclick="return confirm('Are you sure you want to delete all error parts?');" />
		</p>
		<p>
			<input type="submit" name="email_action" value="Requeue All Errors" />
		</p>
		[/if]
	[/if]
	</div>

	<h2 onclick="toggleDisplayBlock('nav')">Navigation</h2>
	<div id="nav"[if: ((var: 'found_count') <= (var: 'shown_count'))] style="display: none;"[/if]>
		<table border="0" cellpadding="0" cellspacing="0">
		[if:((var: 'shown_first') > 1) || ((var: 'shown_last') < (var: 'found_count'))]
			<tr>
			[if:((var: 'shown_first') > 1)]
				<td><input type="submit" value="Prev" name="email_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			[if:((var: 'shown_last') < (var: 'found_count'))]
				<td><input type="submit" value="Next" name="email_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			</tr>
		[/if]
			<tr>
				<td><input type="text" value="[var: 'shown_first']" name="email_navigation_skip" class="half"></td>
				<td><input type="submit" value="Jump" name="email_navigation" class="half" /></td>
			</tr>
		[if:((var: 'shown_first') > 1) || ((var: 'shown_last') < (var: 'found_count'))]
			<tr>
			[if:((var: 'shown_first') > 1)]
				<td><input type="submit" value="First" name="email_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			[if:((var: 'shown_last') < (var: 'found_count'))]
				<td><input type="submit" value="Last" name="email_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			</tr>
		[/if]
		</table>
	</div>

</form>

</div>

<div class="content_full2">
	[records]
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
		<span>
			<span style="float: right; text-align: right; width: 16%;">
				[if: ((field: 'queue_status') >> 'error')]<a href="[var: 'admin_link', -encodenone]&email_action=requeue&part_id=[field: 'id']">Requeue</a><br />[/if]
				[if: ((field: 'queue_status') >> 'queued') || ((field: 'queue_status') >> 'sending')]<a href="[var: 'admin_link', -encodenone]&email_action=hold&part_id=[field: 'id']">Hold</a><br />[/if]
				[if: ((field: 'queue_status') >> 'queued') || ((field: 'queue_status') >> 'hold')]<a href="[var: 'admin_link', -encodenone]&email_action=try&part_id=[field: 'id']">Try Now</a><br />[/if]
				<a href="[var: 'admin_link', -encodenone]&email_action=delete&part_id=[field: 'id']" onclick="return confirm('Are you sure you want to delete this part?');">Delete</a>
			</span>
			<span style="float: right; width: 50%;"><br />
			[if: (field: 'mime_text') == ''](Message Text Removed)[else][protect][var: 'parse' = (email_parse: (field: 'mime_text'))]
					<b>Subject:</b> [encode_html: $parse->subject]<br />
					<b>To:</b> [encode_html: $parse->to]<br />
					<b>From:</b> [encode_html: $parse->from]<br />
					<b>Date:</b> [field: 'queue_date']<br />
					<b>Body:</b> [encode_html: (string: $parse->body)->(substring: 0,255)]
				[/protect][/if]
		</span>
[if: (field: 'queue_status') >> 'sending' || (field: 'queue_status') >> 'queued']
		<b>Status: </b> [if: (field: 'queue_status') >> 'sending']Sending[else]Queued[/if]
		[if: (field: 'queue_retries') == 1]<br /><b>Retries:</b> 1 Retry
		[else: (field: 'queue_retries') > 1]<br /><b>Retries:</b> [field: 'queue_retries'] Retries[/if]
		[protect]<br /><b>Next Try:</b> [date_format: (field: 'queue_date'), -format='%Q %T'][/protect]
[else]
		<b>Status: </b> [if: (field: 'queue_status') >> 'error']Error[else: (field: 'queue_status') >> 'sent']Sent[else][field: 'queue_status'][/if]
		[protect]<br /><b>Time: </b> [date_format: (field: 'queue_date'), -format='%Q %T'][/protect]
[/if]				
		<br /><b>Recipients:</b> [field: 'mime_recipients']
		<br /><b>SMTP Host:</b> [if_empty: (field: 'smtp_host'), '(Default)']
	</span>
	<br style="clear: both;" />

[var: 'id_part' = (field: 'id')]
[records: -inlinename='smtp_error'][if: (field: 'id_queue') != $id_part][loop_continue][/if]
	<div class="content_panel" style="background: #999999"><b class="c1"></b><b class="c2"></b><b class="c3"></b><b class="c4"></b><div class="content_inner">
		<span>
			<span style="float: right; text-align: right; width: 16%;">
				<a href="[var: 'admin_link', -encodenone]&tab3=errors&email_action=show&email_id=[field: 'id_email']&email_status=all">Show All</a><br />
				<a href="[var: 'admin_link', -encodenone]&email_action=clear&part_id=[field: 'id_queue']">Clear</a>
			</span>
			<b>Last Error:</b> [if: (field: 'severity') == 'warning']Warning[else: (field: 'severity') == 'fatal']Fatal[else][field: 'severity'][/if] [field: 'code']<br />
			[protect]<b>Time:</b> [date_format: (field: 'datetime'), -format='%Q %T']<br />[/protect]
			<b>Message: </b> [string_replace: (field: 'error'), -find='\r', -replace=' ', -encodenone]
		</span>
	</div><b class="c4"></b><b class="c3"></b><b class="c2"></b><b class="c1"></b></div>
	[loop_abort]
[/records]

	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
[/records]

[if: found_count == 0]
	<p class="error">No Email Found</p>
[/if]

</div>
	
[/inline]

