<?LassoScript

//
// Variables
//

_admin_addvar: 'route_action', -default='None', -override=(action_param: 'route_action', (action_param: 'route_action', -count));
_admin_addvar: 'route_addaction', -default='None', -override=(action_param: 'route_addaction', (action_param: 'route_addaction', -count));
_admin_addvar: 'route_detailid', -default=-1, -override=(action_param: 'route_detailid');
_admin_addvar: 'route_status', -default='cache', -override=(action_param: 'route_status');

_admin_addvar: 'route_domain', -default='', -override=(action_param: 'route_domain');
_admin_addvar: 'route_host', -default='', -override=(action_param: 'route_host');
_admin_addvar: 'route_port', -default='25', -override=(action_param: 'route_port');
_admin_addvar: 'route_retry', -default='600', -override=(action_param: 'route_retry');
_admin_addvar: 'route_timeout', -default='15', -override=(action_param: 'route_timeout');
_admin_addvar: 'route_username', -default='', -override=(action_param: 'route_username');
_admin_addvar: 'route_password', -default='', -override=(action_param: 'route_password');
_admin_addvar: 'route_ssl', -default='N', -override=(action_param: 'route_ssl');
_admin_addvar: 'route_priority', -default='1', -override=(action_param: 'route_priority');
_admin_addvar: 'route_comment', -default='', -override=(action_param: 'route_comment');

var: 'route_detail' = null;

//
// Process Action
//

if: $route_addaction >> 'Add';

	inline: -loglevel=$__startup_loglevel__,
			-add,
			-database='site',
			-table='smtp_route',
			-keyfield='id',
			'domain'=$route_domain,
			'host'=$route_host,
//			'port'=$route_port,
			'retry'=$route_retry,
			'timeout'=$route_timeout,
			'username'=$route_username,
			'password'=$route_password,
			'ssl'=$route_ssl,
			'priority'=$route_priority,
			'comment'=$route_comment,
			'datetime'=date->(format: '%Q %T');
		var: 'route_detailid'=keyfield_value;
	/inline;
	
	var: 'route_action' = 'detail';

else: ($route_action >> 'Update') && ($route_detailid > 0);

	inline: -loglevel=$__startup_loglevel__,
			-update,
			-database='site',
			-table='smtp_route',
			-keyfield='id',
			-keyvalue=$route_detailid,
			'domain'=$route_domain,
			'host'=$route_host,
//			'port'=$route_port,
			'retry'=$route_retry,
			'timeout'=$route_timeout,
			'username'=$route_username,
			'password'=$route_password,
			'ssl'=$route_ssl,
			'priority'=$route_priority,
			'comment'=$route_comment,
			'datetime'=date->(format: '%Q %T');
	/inline;

	var: 'route_action' = 'detail';

else: ($route_action >> 'Delete') && ($route_detailid > 0);

	inline: -loglevel=$__startup_loglevel__,
			-delete,
			-database='site',
			-table=(($route_status >> 'cache') ? 'smtp_cache' | 'smtp_route'),
			-keyfield='id',
			-keyvalue=$route_detailid;
	/inline;

	var: 'route_detailid' = -1;
	var: 'route_action' = 'none';

else: $route_action >> 'Add Route';

	// Create the template for a new route

	var: 'route_detail' = (map:
			'domain'='',
			'host'='',
//			'port'=25,
			'retry'='600',
			'timeout'='15',
			'username'='',
			'password'='',
			'ssl'='N',
			'priority'='1',
		);

/if;

if: ($route_action >> 'detail') && ($route_detailid > 0);
	inline: -loglevel=$__startup_loglevel__,
			-search,
			-database='site',
			-table=(($route_status >> 'cache') ? 'smtp_cache' | 'smtp_route'),
			-keyfield='id',
			-keyvalue=$route_detailid,
			-maxrecords=1;
		records;
			var: 'route_detail' = map;
			iterate: (field_names), (var: 'field');
				$route_detail->(insert: $field = (field: $field));
			/iterate;
		/records;
	/inline;
/if;


?>
