<?LassoScript

_admin_addvar: 'error_action', -default='None', -override=(action_param: 'error_action');
_admin_addvar: 'error_critical', -default='None', -override=(action_param: 'error_critical');
_admin_addvar: 'error_warning', -default='None', -override=(action_param: 'error_warning');
_admin_addvar: 'error_detail', -default='None', -override=(action_param: 'error_detail');
_admin_addvar: 'error_deprecated', -default='None', -override=(action_param: 'error_deprecated');
_admin_addvar: 'error_sql', -default='None', -override=(action_param: 'error_sql');

var: 'error_critical' = (string_replace: -find='\r', -replace=', ', $error_critical);
var: 'error_warning' = (string_replace: -find='\r', -replace=', ', $error_warning);
var: 'error_detail' = (string_replace: -find='\r', -replace=', ', $error_detail);
var: 'error_deprecated' = (string_replace: -find='\r', -replace=', ', $error_deprecated);
var: 'error_sql' = (string_replace: -find='\r', -replace=', ', $error_sql);

if: $error_action >> 'Reset';
	var: 'error_critical' = 'database, console, file';
	var: 'error_warning' = 'console';
	var: 'error_detail' = 'console';
	var: 'error_deprecated' = 'console';
	var: 'error_sql' = 'console';
	var: 'error_action' = 'Update';
/if;

if: $error_action >> 'Update';

	var: 'level' = log_level_critical;
	var: 'file'=0, 'database'=0, 'console'=0;
	if: $error_critical >> 'file';
		var: 'file' = log_destination_file;
	/if;
	if: $error_critical >> 'database';
		var: 'database' = log_destination_database;
	/if;
	if: $error_critical >> 'console';
		var: 'console' = log_destination_console;
	/if;
	log_setdestination: $level, $file, $database, $console;

	var: 'level' = log_level_warning;
	var: 'file'=0, 'database'=0, 'console'=0;
	if: $error_warning >> 'file';
		var: 'file' = log_destination_file;
	/if;
	if: $error_warning >> 'database';
		var: 'database' = log_destination_database;
	/if;
	if: $error_warning >> 'console';
		var: 'console' = log_destination_console;
	/if;
	log_setdestination: $level, $file, $database, $console;

	var: 'level' = log_level_detail;
	var: 'file'=0, 'database'=0, 'console'=0;
	if: $error_detail >> 'file';
		var: 'file' = log_destination_file;
	/if;
	if: $error_detail >> 'database';
		var: 'database' = log_destination_database;
	/if;
	if: $error_detail >> 'console';
		var: 'console' = log_destination_console;
	/if;
	log_setdestination: $level, $file, $database, $console;

	var: 'level' = log_level_deprecated;
	var: 'file'=0, 'database'=0, 'console'=0;
	if: $error_deprecated >> 'file';
		var: 'file' = log_destination_file;
	/if;
	if: $error_deprecated >> 'database';
		var: 'database' = log_destination_database;
	/if;
	if: $error_deprecated >> 'console';
		var: 'console' = log_destination_console;
	/if;
	log_setdestination: $level, $file, $database, $console;

	var: 'level' = log_level_sql;
	var: 'file'=0, 'database'=0, 'console'=0;
	if: $error_sql >> 'file';
		var: 'file' = log_destination_file;
	/if;
	if: $error_sql >> 'database';
		var: 'database' = log_destination_database;
	/if;
	if: $error_sql >> 'console';
		var: 'console' = log_destination_console;
	/if;
	log_setdestination: $level, $file, $database, $console;

	log_always: 'The routing of error messages has been changed.';
	log_critical: 'Critical error messages are now being logged to ' + $error_critical + '.';
	log_warning: 'Warning Messages are now being logged to ' + $error_warning + '.';
	log_detail: 'Detailed status messages are now being logged to ' + $error_detail + '.';
	log_sql: 'Action Statements are now being logged to ' + $error_sql + '.';
	log_deprecated: 'Deprecated status messages are now being logged to ' + $error_deprecated + '.';

/if;

var: 'error_critical' = '';
var: 'error_warning' = '';
var: 'error_detail' = '';
var: 'error_deprecated' = '';
var: 'error_sql' = '';

inline: -log=$__startup_loglevel__, -database='lasso_internal', -table='global_prefs', -search, -op='bw', 'store_key'='log';
	records;
		var: 'key' = (integer: (field: 'data'));
		var: 'prefs' = '';
		if: $key->(bittest: 1);
			$prefs += 'console,';
		/if;
		if: $key->(bittest: 2);
			$prefs += 'file,';
		/if;
		if: $key->(bittest: 3);
			$prefs += 'database,';
		/if;

		$prefs->(removetrailing: ',');

		if: (field: 'store_key') == 'log_critical_dest';
			var: 'error_critical' = $prefs;
		else: (field: 'store_key') == 'log_detail_pref';
			var: 'error_detail' = $prefs;
		else: (field: 'store_key') == 'log_warning_dest';
			var: 'error_warning' = $prefs;
		else: (field: 'store_key') == 'log_deprecated_pref';
			var: 'error_deprecated' = $prefs;
		else: (field: 'store_key') == 'log_sql_pref';
			var: 'error_sql' = $prefs;
		/if;
	/records;
		
/inline;

?>
