<?LassoScript

// ---------
// global vars

_admin_addvar: 'event_action', -default='none', -override=(action_param: 'event_action', (action_param: 'event_action', -count));
_admin_addvar: 'event_id', -default='', -override=(action_param: 'event_id');

_admin_addvar: 'event_url', -default='', -override=(action_param: 'event_url');
_admin_addvar: 'event_startdate', -default='', -force=(action_param: 'event_startdate');
_admin_addvar: 'event_enddate', -default='', -force=(action_param: 'event_enddate');
_admin_addvar: 'event_restart', -default='Yes', -override=(action_param: 'event_restart');
_admin_addvar: 'event_delay', -default='60', -override=(action_param: 'event_delay');
_admin_addvar: 'event_username', -default='', -force=(action_param: 'event_username');
_admin_addvar: 'event_password', -default='', -force=(action_param: 'event_password');

_admin_addvar: 'event_admin', -default='', -override=(action_param: 'event_admin');
_admin_addvar: 'event_repeat', -default='Once', -override=(action_param: 'event_repeat');
_admin_addvar: 'event_day', -default=(string: date->dayofweek), -override=(action_param: 'event_day');
_admin_addvar: 'event_time', -default=(string: date->(format: '%H:%M:%S')), -override=(action_param: 'event_time');

if: $event_startdate == 'YYYY-MM-DD HH:MM:SS';
	var: 'event_startdate' = '';
/if;

if: $event_enddate == 'YYYY-MM-DD HH:MM:SS';
	var: 'event_enddate' = '';
/if;

if: $event_repeat >> 'Once';
	var: 'event_delay' = 0;
	var: 'event_realdate' = $event_startdate;
	var: 'event_realrepeat' = 'No';
else: $event_repeat >> 'Daily';
	var: 'event_delay' = 24 * 60;
	var: 'event_realdate' = (string: date->(format: '%Q')) + ' ' + $event_time;
	if: (date_difference: date, $event_realdate, -minutesbetween) > 0;
		var: 'event_realdate' = (string: (date_add: $event_realdate, -day=1));
	/if;
	var: 'event_realrepeat' = 'Yes';
else: $event_repeat >> 'Weekly';
	var: 'event_delay' = 7 * 24 * 60;
	var: 'day' = (integer: $event_day) - (integer: date->dayofweek);
	if: $day < 0; $day += 7; /if;
	var: 'event_realdate' = (date_format: (date_add: date, -day=$day), -format='%Q') + ' ' + $event_time;
	if: (date_difference: date, $event_realdate, -minutesbetween) > 0;
		var: 'event_realdate' = (string: (date_add: $event_realdate, -day=7));
	/if;
	var: 'event_realrepeat' = 'Yes';
else: $event_repeat >> 'Custom';
	var: 'event_realdate' = $event_startdate;
	var: 'event_realrepeat' = 'Yes';
/if;

// ---------
// main

if: ($event_action >> 'Edit');

	inline:  -log=$__startup_loglevel__,
			-search='',
			-database='site',
			-table='schedule',
			-keyfield='id',
			-keyvalue=$event_id;
		if: (found_count > 0);
		
			var: 'event_url' = (field: 'executeaction');
			var: 'event_startdate' = (field: 'date_time_start');
			var: 'event_enddate' = (field: 'date_time_end');
			var: 'event_restart' = (field: 'restart');
			var: 'event_delay' = (field: 'delay');
			var: 'event_username' = (field: 'username');
			var: 'event_password' = (field: 'password');
			var: 'event_repeat' = 'Once';
			
			if: (field: 'repeat') == 1;
				if: (field: 'delay') == 7 * 24 * 60;
					var: 'event_repeat' = 'Weekly';
					var: 'event_time' = (date: (field: 'next_execute'))->(format: '%T');
					var: 'event_day' = (date: (field: 'next_execute'))->(format: '%w');
				else: (field: 'delay') == 24 * 60;
					var: 'event_repeat' = 'Daily';
					var: 'event_time' = (date: (field: 'next_execute'))->(format: '%T');
				else;
					var: 'event_repeat' = 'Custom';
				/if;
			/if;
		else;
			var: 'event_id' = '';
		/if;
	/inline;

	var: 'event_action' = 'none';
	
else: ($event_action >> 'Schedule');

	if: $event_id != '';
		inline:  -log=$__startup_loglevel__,
				-delete='',
				-database='site',
				-table='schedule',
				-keyfield='id',
				-keyvalue=$event_id;
		/inline;
	/if;

	if: $event_realdate == '';
		var: 'event_realdate' = (string: date);
	/if;

	if: $event_enddate == '';
		var: 'event_enddate' = '1/1/3001 00:00:00';
	/if;

	Event_Schedule:
		-URL=$event_url,
		-Start=$event_realdate,
		-End=$event_enddate,
		-Restart=($event_restart == 'Yes'),
		-Repeat=($event_realrepeat == 'Yes'),
		-Delay=$event_delay,
		-Username=$event_username,
		-Password=$event_password;

	var: 'event_status' = 'schedule';

	redirect_url: (var: 'admin_link') +
		'&tab3=event' +
		'&event_status=' + $event_status +
		'&event_skip=1000000';
	abort;

/if;

if: $event_startdate == '' || $event_startdate >> '3001';
	var: 'event_startdate' = 'YYYY-MM-DD HH:MM:SS';
/if;
if: $event_enddate == '' || $event_enddate >> '3001'
	var: 'event_enddate' = 'YYYY-MM-DD HH:MM:SS';
/if;



if: $event_id != '';
	iterate: $admin_tab_array3, (var: 'temp1');
		if: $temp1->first == ($admin_tab1 + ':' + $admin_tab2);
			iterate: $temp1->second, (var: 'temp2');
				if: $temp2->first == 'addevent';
					$temp2->second = 'Edit Event';
				/if;
			/iterate;
		/if;
	/iterate;
/if;

?>
