<?LassoScript
	var: 'event_map' = map;
	inline: -log=$__startup_loglevel__,
			-findall,
			-database='site',
			-table='schedule',
			-returnfield='id',
			-returnfield='executeaction',
			-maxrecords='all';
		records;
			$event_map->(insert: (field: 'id') = (field: 'executeaction'));
		/records;
	/inline;

	inline: -log=$__startup_loglevel__, $error_inline;
		var: 'error_found' = found_count;
		var: 'found_count' = (found_count);
		var: 'shown_count' = (shown_count);
		var: 'shown_first' = (shown_first);
		var: 'shown_last' = (shown_last);
?>

<div class="sidebar">

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" name="error_oldfilter" value="[var: 'error_filter']">
<input type="hidden" name="error_skip" value="[var: 'error_skip']">	
<input type="hidden" name="error_found" value="[var: 'error_found']">
<input type="hidden" name="event_id" value="[var: 'event_id']">

	<h2 onclick="toggleDisplayBlock('srch')">Event Errors</h2>

	<div id="srch">
	[if: $event_id != '']
		<p>Showing errors for event "[_admin_wrap_cleanup: $event_map->(find: $event_id), -wrap=24, -size=4]" ([var: 'event_id'])
		<p style="margin-bottom: 3px; align: right;">
			<input type="submit" name="error_action" value="Show All Errors" />
		</p>
	[else]
		<p>Showing all errors</p>
	[/if]
		<p>
			<b>Filter</b>
			<br />
			<input type="text" name="error_filter" value="[var: 'error_filter']" size="16" />
		</p>
		<p style="margin-bottom: 3px; align: right;">
			<input type="submit" name="mysql_action" value="Select" class="half" />
			<input type="submit" name="mysql_action" value="Refresh" class="half" />
		</p>
	</div>

	<div id="none">
		<p>
			<input type="submit" name="error_action" value="[if: ((Global: '__Schedule_Status__') == 'Pause')]Resume[else]Pause All[/if] Events"  />
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('sum')">Summary</h2>
	<div id="sum">
		<p>
			[if: ((var: 'found_count') > 0) && ((var: 'shown_count') > 0)]
				Showing 
				[if: (var: 'shown_count') == 1] record [var: 'shown_first'][else][var: 'shown_count'] records[/if]
				[if: (var: 'found_count') > 1]of [var: 'found_count'] found[/if]
			[else]
				No Records Found
			[/if]
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('act')">Actions</h2>
	<div id="act"[if: (var: 'found_count') == 0] style="display: none;"[/if]>
		<p>
			<input type="submit" name="error_action" value="Clear All Errors" />
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('nav')">Navigation</h2>
	<div id="nav"[if: ((var: 'found_count') <= (var: 'shown_count'))] style="display: none;"[/if]>
		<table border="0" cellpadding="0" cellspacing="0">
		[if:((var: 'shown_first') > 1) || ((var: 'shown_last') < (var: 'found_count'))]
			<tr>
			[if:((var: 'shown_first') > 1)]
				<td><input type="submit" value="Prev" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			[if:((var: 'shown_last') < (var: 'found_count'))]
				<td><input type="submit" value="Next" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			</tr>
		[/if]
			<tr>
				<td><input type="text" value="[var: 'shown_first']" name="error_navigation_skip" class="half"></td>
				<td><input type="submit" value="Jump" name="error_navigation" class="half" /></td>
			</tr>
		[if:((var: 'shown_first') > 1) || ((var: 'shown_last') < (var: 'found_count'))]
			<tr>
			[if:((var: 'shown_first') > 1)]
				<td><input type="submit" value="First" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			[if:((var: 'shown_last') < (var: 'found_count'))]
				<td><input type="submit" value="Last" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			</tr>
		[/if]
		</table>
	</div>

</form>

</div>

<div class="content_full2">
	[records]
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
		<span>
			<span class="onethird" style="text-align: right">
				<a href="[$admin_link + '&tab3=addevent&event_action=edit&event_id=' + (field: 'id_schedule')]">Edit Event</a><br />
			[if: (field: 'id_schedule') != $event_id]	
				<a href="[$admin_link + '&event_action=show&event_id=' + (field: 'id_schedule')]">Show Related</a>
			[/if]
			</span>
			<span class="onethird">
				<b>Event: </b> "[encode_html: $event_map->(find: (field: 'id_schedule'))]" ([field: 'id_schedule'])<br />
				<b>Message: </b> [field: 'error']
			</span>
			[protect]<b>Time:</b> [date_format: (field: 'date_time'), -format='%Q %T']<br />[/protect]
			<b>Code:</b> [field: 'code']
		</span>
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
	[/records]
[if: (found_count) == 0]
		<p class="error">No Errors Found</p>
[/if]

</div>

[/inline]
