<?LassoScript

var: 'lassoapp_root'=(action_param:'lassoapp_root');
var: 'lassoapp_entry'=(action_param:'lassoapp_entry');
var: 'lassoapp_result'=(action_param: 'lassoapp_result');
var: 'lassoapp_action'=(action_param: 'lassoapp_action');
var: 'lassoapp_custom'=(action_param: 'lassoapp_custom');
var: 'lassoapp_name'='';

var: 'lassoapp_admin' = (admin_lassoservicepath) + '/LassoAdmin/BuildLassoApps/';

_admin_addvar: 'export_token', -default=(lasso_uniqueid + '_' + $admin_increment), -override=(action_param: 'export_token');
if: !(global_defined: '_lassoapp_export_') || !(global: '_lassoapp_export_')->(isa: 'map');
	global: '_lassoapp_export_' = (map);
/if;

if: (var: 'lassoapp_entry') == '';
	var: 'lassoapp_entry'='default' + '.' + 'lasso';  // Workaround for LassoApp issue
/if;

if: ($lassoapp_root == 'custom');
	var: 'lassoapp_root' = $lassoapp_custom;
	var: 'lassoapp_folder' = $lassoapp_root;
	var: 'temp' = $lassoapp_root->(split: '/')->(last)->(split: '\\')->(last);
	if: $temp >> '.lasso';
		$lassoapp_root->(removetrailing: $temp);
	/if;
else;
	var: 'lassoapp_name' = $lassoapp_root + '.LassoApp';
	var: 'lassoapp_folder' = $lassoapp_admin;
	var: 'lassoapp_root' = $lassoapp_folder + $lassoapp_root;
/if;

if: ($lassoapp_admin == '') || !(file_exists: $lassoapp_admin);
	file_create: $lassoapp_admin;
/if;

if: ($lassoapp_folder != '') && !(file_exists: $lassoapp_folder);
	var: 'lassoapp_success'='An unknown error occurred.';
	var: 'lassoapp_error'='LassoApp folder not found. Specify a custom root or select a LassoApp folder.';
	var: 'lassoapp_action'='Error';
/if;

var: 'lassoapp_result' = $lassoapp_root;
$lassoapp_result->(removetrailing: '/');
$lassoapp_result->(removetrailing: '\\');
$lassoapp_result += '.LassoApp';

if: ($lassoapp_name == '') || ($lassoapp_name == '.lassoapp') || ($lassoapp_result !>> $lassoapp_name);
	var: 'lassoapp_name' = $lassoapp_result->(split: '/')->(last)->(split: '\\')->(last);
/if;

if: ($lassoapp_name == '.lassoapp');
	var: 'lassoapp_name' = 'default.lassoapp';
/if;

if: ((var: 'lassoapp_action') >> 'Create') || ((var: 'lassoapp_action') >> 'Download');

	if: ($lassoapp_action >> 'Download');
		(global: '_lassoapp_export_')->(insert: $export_token = false);
	/if;

	var: 'lassoapp_error'='An unknown error occurred.';

	if: (file_exists: $lassoapp_result);
		 var: 'lassoapp_backup'=$lassoapp_result;
		 $lassoapp_backup = (string_replace: $lassoapp_backup, -find='.LassoApp', -replace='2.LassoApp');
		 file_move: $lassoapp_result, $lassoapp_backup, -fileoverwrite;
	/if;

	// Call the LassoApp Create function with the appropriate arguments
	protect;
		var: 'lassoapp_error'=(LassoApp_Create: -root=$lassoapp_root, -entry=$lassoapp_entry, -result=$lassoapp_result);
		handle_error;
			var: 'lassoapp_error' = 'An error occurred building the LassoApp';
			var: 'lassoapp_extended' = (String_ReplaceRegExp: (Error_CurrentError), -Find=' at: [\\s\\S]*', -replace='');
		/handle_error;
	/protect;

	// Call the LassoApp Dump function to clear the old LassoApp from the cache.
	lassoapp_dump: $lassoapp_name;

	if: (file_exists: $lassoapp_result);
		var: 'lassoapp_success'='The LassoApp \"' + $lassoapp_name + '\" was created successfully.';

		if: ($lassoapp_action >> 'Download');
		
		(global: '_lassoapp_export_')->(insert: $export_token = false);
			(global: '_lassoapp_export_')->(insert: $export_token = $lassoapp_result);
			var: 'export_token' = (lasso_uniqueid + '_' + $admin_increment);
		
		/if;

	/if;
/if;

// list directories
var: 'dirs' = (file_listdirectory: $lassoapp_admin);
if: file_currenterror >> 'No Permission';
	var: 'lassoapp_message'='This site does not have permission to access the BuildLassoApps folder. Use the option to build LassoApps within the Web server root or contact your Server Administrator for help.';
else;
	loop: -loopfrom=$dirs->size, -loopto=1, -loopincrement=(-1);
		if: !($dirs->(get: loop_count)->(endswith: '/'));
			$dirs->(remove: loop_count);
		/if;
	/loop;
/if;
?>
