<?LassoScript

_admin_addvar: -session='_siteadmin', 'query_datasourceid', -default=1, -override=(action_param: 'query_datasourceid');
_admin_addvar: -session='_siteadmin', 'query_hostid', -default=1, -override=(action_param: 'query_hostid');
_admin_addvar: -session='_siteadmin', 'query_databaseid', -override=(action_param: 'query_databaseid');
_admin_addvar: -session='_siteadmin', 'query_tableid', -override=(action_param: 'query_tableid');

_admin_addvar: 'query_action', -default='None', -override=(action_param: 'query_action');
_admin_addvar: 'query_sql';
_admin_addvar: 'query_history', -session='_siteadmin', -default=(array);
_admin_addvar: 'query_databaseold', -default='None', -override=(action_param: 'query_databaseold');

_admin_addvar: 'query_showfields', -session='_siteadmin', -default='all', -override=(action_param: 'query_showfields');
_admin_addvar: 'query_maxrecords', -session='_siteadmin', -default='50', -override=(action_param: 'query_maxrecords');
_admin_addvar: 'query_fieldheight', -session='_siteadmin', -default='4', -override=(action_param: 'query_fieldheight');
_admin_addvar: 'query_autosubmit', -session='_siteadmin', -default='No', -override=(action_param: 'query_autosubmit');
_admin_addvar: 'query_exportformat', -session='_siteadmin', -default='tab', -override=(action_param: 'query_exportformat');
_admin_addvar: 'query_exportlines', -session='_siteadmin', -default=(((lasso_version: -platform) >> 'win') ? 'win' | 'unix'), -override=(action_param: 'query_exportlines');
_admin_addvar: 'query_exportfields', -session='_siteadmin', -default='y', -override=(action_param: 'query_exportfields');


//
// Maintain History
//

if: ($query_action && (action_param:'sql'));
	$query_sql = (action_param:'sql');
	if: ($query_sql->size < 1024) && ($query_history->last != $query_sql);
		$query_history->(removeall: $query_sql);
		$query_history->(insert: $query_sql);
	/if;
/if;
if: ($query_history->size > 20);
	$query_history->(remove: 1);
/if;


//
// Build Menus
//

var: 'query_datasourcemap' = (array);
var: 'query_hostmap' = (array);
var: 'query_databasemap' = (array);
var: 'query_tablemap' = (array);

if: ($query_action >> 'Refresh');
	_admin_refreshsecurity;
/if;

var: 'temp_datasourcemap' = (_admin_listconnectors);
var: 'query_datasourcemap' = (array);
loop: $temp_datasourcemap->size;
	var: 'temp'=$temp_datasourcemap->(get:loop_count)->second;
	var: 'id'=$temp_datasourcemap->(get:loop_count)->first;
	if: ($temp->(find: 'name') != 'fmremeotedatasource') && ($temp->(find: 'name') != 'fmserveradvanceddatasource') && ($temp->(find: 'name') != 'fmserver9datasource') && ($temp->(find: 'name') != 'spotlightds');
		$query_datasourcemap->(insert: $id = $temp);
	/if;
/loop;
var: 'temp' = (_admin_defaultconnector: -id=$query_datasourceid, $query_datasourcemap);
if: ($temp != null);
	var: 'query_datasourceid' = $temp->first;
	var: 'query_datasourcedetail' = $temp->second;
	var: 'query_datasourcealias' = $query_datasourcedetail->(find: 'alias');
else;
	var: 'query_datasourceid' = 0;
	var: 'query_datasourcedetail' = null;
/if;

if: ($query_action >> 'Refresh') && ($query_datasourceid != 0);
	_admin_refreshconnector: $query_datasourceid;
/if;

if: ($query_datasourceid > 0);
	var: 'query_hostmap' = (_admin_listhosts: $query_datasourceid);
	var: 'temp' = (_admin_defaulthost: $query_hostid, $query_hostmap);
	if: ($temp != null);
		var: 'query_hostid' = $temp->first;
		var: 'query_hostdetail' = $temp->second;
	else;
		var: 'query_hostid' = 0;
		var: 'query_hostdetail' = null;
	/if;
else;
	var: 'query_hostid' = 0;
	var: 'query_hostdetail' = null;
/if;

if: ($query_hostid > 0);
	var: 'query_databasemap' = (_admin_listdatabases: $query_hostid);
	var: 'temp' = (_admin_defaultdatabase: $query_databaseid, $query_databasemap);
	if: ($temp != null);
		var: 'query_databaseid' = $temp->first;
		var: 'query_databasedetail' = $temp->second;
		var: 'query_databasename' = $query_databasedetail->(find: 'name');
		var: 'query_databasealias' = $query_databasedetail->(find: 'alias');
	else;
		var: 'query_databaseid' = 0;
		var: 'query_databasedetail' = null;
	/if;
else;
	var: 'query_databaseid' = 0;
	var: 'query_databasedetail' = null;
/if;

if: ($query_databaseid > 0);
	var: 'query_tablemap' = (_admin_listtables: $query_databaseid);
	var: 'temp' = (_admin_defaulttable: $query_tableid, $query_tablemap);
	if: ($temp != null);
		var: 'query_tableid' = $temp->first;
		var: 'query_tabledetail' = $temp->second;
		var: 'query_tablename' = $query_tabledetail->(find: 'name');
		var: 'query_tablealias' = $query_tabledetail->(find: 'alias');
	else;
		var: 'query_tableid' = 0;
		var: 'query_tabledetail' = null;
	/if;
else;
	var: 'query_tableid' = 0;
	var: 'query_tabledetail' = null;
/if;


//
// Perform SQL Statement
//

if: ($query_action >> 'Reset');

	var: 'query_showfields' = 8;
	var: 'query_maxrecords' = 50;
	var: 'query_fieldheight' = 4;
	var: 'query_exportformat' = 'tab';
	
else: ($query_action >> 'Export');

	// Perform Export

	file_serve: (include: (lassoapp_link: 'utility/sql/browse/export.lasso')), -type='application/force-download', -file='SQLExport_' + date->(format: '%Y%m%d%H%M%S') + '.txt';

/if;

?>
