<?LassoScript
	
	//
	// ORPHANED CONTAINER TAGS
	//
	
	Define_Tag: 'Link', -Container, -Priority='Replace', -namespace='_global_';
		\Link_URL->(eval: -params=(array: -noreturn));
		if: (#output != '');
			#output->(removetrailing: '?');
			return: '<a href="' + (encode_html: #output) + '">' + (Run_Children) + '</a>';
		/if;
	/Define_Tag;

	define_tag('cache', -priority='replace', -namespace='_global_', -container,
			-required='name',
			-optional='expires',
			-optional='condition',
			-optional='session',
			-optional='useglobal',
			-optional='log');

		\cache_internal->eval;

		local('c_exists') = (\cache_exists->run(-params=params));
		local('c_store') = true;
		local('c_content') = '';
		
		if((local('condition') == true) || (#c_exists == false));
			if(#c_useglobal);
				local('count') = integer(globals->find(#c_prefix + 'store'));
				thread_atomic(globals->find(#c_prefix + 'content'));
					#c_store = (#count == integer(globals->find(#c_prefix + 'store')));
					if(#c_store);
						#c_content = string(run_children);
						globals->insert((#c_prefix + 'content') = #c_content);
						globals->insert((#c_prefix + 'date') = date->format('%Q %T'));
						globals->insert((#c_prefix + 'store') = integer(globals->find(#c_prefix + 'store')) + 1);
						#c_log ? log_warning('Cache: Storing ' + #c_type + ' Container "' + #c_name + '".');
						return(#c_content);
					else;
						#c_log ? log_warning('Cache: Waiting for ' + #c_type + ' Container "' + #c_name + '".');
					/if;
				/thread_atomic;
			else;
				#c_content = string(run_children);
				vars->insert((#c_prefix + 'content') = #c_content);
				vars->insert((#c_prefix + 'date') = date->format('%Q %T'));
				vars->insert((#c_prefix + 'store') = integer(vars->find(#c_prefix + 'store')) + 1);
				if(#c_session);
					session_addvar(-name=#session, #c_prefix + 'content', #c_prefix + 'date', #c_prefix + 'fetch', #c_prefix + 'store');
				/if;
				#c_log ? log_warning('Cache: Storing ' + #c_type + ' Container "' + #c_name + '".');
				return(#c_content);
			/if;
		else;
			#c_log ? log_warning('Cache: Fetching ' + #c_type + ' Container "' + #c_name + '".');
		/if;
		
		// Return the content
		if(#c_useglobal);
			thread_atomic(globals->find(#c_prefix + 'fetch'));
				globals->insert((#c_prefix + 'fetch') = integer(globals->find(#c_prefix + 'fetch')) + 1);
			/thread_atomic;
			return(globals->find(#c_prefix + 'content'));
		else;
			vars->insert((#c_prefix + 'fetch') = integer(vars->find(#c_prefix + 'fetch')) + 1);
			return(vars->find(#c_prefix + 'content'));
		/if;

	/define_tag;

	//
	// PRIVILEGED TAG
	//
	//	Custom version of cache tags with thread safety and garbage collection
	//	Johan Slve 2007-09-24
	//
	
	define_tag: 'Preferences', -privileged, -namespace = 'Cache_';
		local: 'preferences' = (map:
			'_cache_enable' = 'Y',
			'_cache_host' = 'Y',
			'_cache_expire' = (60*60*24),
			'_cache_limit' = (32*1024),
			'_cache_totalstoragelimit' = (50*1024*1024),
			'_cache_expirefrequency' = 'never'
		);
		inline: -log=$__startup_loglevel__, -search, 
				-database='lasso_internal', 
				-table='global_prefs', 
				-keyfield='store_key', 
				-op='bw', 'store_key'='_cache_';
			records;
				#preferences->(insert: (field: 'store_key') = (field: 'data'));
			/records;
		/inline;
		return: @#preferences;
	/define_tag;

?>