<?lassoscript

	// This file creates the following tags:
	// [Lasso_DatasourceIs]
	// [Lasso_DatasourceIsLassoMySQL]
	// [Lasso_DatasourceIsMySQL]
	// [Lasso_DatasourceIsFileMaker]
	// [Lasso_DatasourceIsFileMakerSA]
	// [Lasso_DatasourceIsSQLite]
	// [Lasso_DatasourceIsJDBC]
	// [Lasso_DatasourceIsODBC]
	// [Lasso_DatasourceIsOracle]
	// [Lasso_DatasourceIsSQLServer]
	// [Lasso_DatasourceIsPostgreSQL]
	// [Lasso_DatasourceIsOpenBase]
	// [Lasso_DatasourceIsSpotlight]
	// [Lasso_DatasourceIs4D]

	// This is the parent for the [Lasso_DatasourceIs...] tags. It does all the work.
	define_tag('DatasourceIs',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-Required = 'Datasource',
			-Required = 'Name',
			-privileged);
		local('result');
		inline
		(
			-log = 'none',
			-database = 'lasso_internal',
			-table = 'security_datasources',
			-sql = '\
				select \
					b.name as Datasource, \
					c.name as Host \
				from \
					security_datasource_databases as a \
					left join security_datasources as b on (a.id_datasource = b.id) \
					left join security_datasource_hosts as c on (a.id_host = c.id) \
				where \
					case \
						when a.alias is not null and length(a.alias) > 0 then \
							a.alias \
						else \
							a.name \
					end like \'' encode_sql92(#Name) '\''
			);

			if(#Datasource == 'JDBC');
				#result = ((field('Datasource') >> #Datasource) || field('Host')->beginswith('jdbc'));
			else;
				#result = (field('Datasource') == #Datasource);
			/if;

		/inline;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsLassoMySQL',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('InternalMySQLD', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsMySQL',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('MySQLDS', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsFileMaker',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('FMRemoteDataSource', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsFileMakerSA',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('FMServerAdvancedDataSource', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsFileMaker9',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('FMServer9DataSource', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsSQLite',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('SQLiteConnector', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsJDBC',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('JDBC', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsODBC',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('ODBC', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsOracle',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('Oracle', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsSQLServer',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('SQLServer', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsPostgreSQL',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('PostGreSQL', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsOpenBase',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('OpenBaseDS', #Name);
		/if;
		return(@#result);
	/define_tag;

	define_tag('DatasourceIsSpotlight',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		local('result' = null);
		if(local_defined('Name'));
			#result = Lasso_DatasourceIs('SpotlightDS', #Name);
		/if;
		return(@#result);
	/define_tag;

	// returns false, because it doesn't exist anymore
	define_tag('DatasourceIs4D',
			-namespace = 'Lasso_',
			-priority = 'replace',
			-optional = 'Name');
		return(false);
	/define_tag;
	
?>