<?LassoScript

namespace_using('compare_');

	define_tag('lessThan');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first < params->second);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('lessThanOrEquals');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first <= params->second);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('greaterThan');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first > params->second);
			return(0);
		/if;
		return(-1);
	/define_tag;
	
	define_tag('greaterThanOrEquals');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first >= params->second);
			return(0);
		/if;
		return(-1);
	/define_tag;
	
	define_tag('contains');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first >> params->second);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('notContains');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first !>> params->second);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('equalTo');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first == params->second);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('notEqualTo');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first != params->second);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('strictEqualTo');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first === params->second);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('strictNotEqualTo');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first !== params->second);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('beginsWith');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first->beginsWith(params->second));
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('notBeginsWith');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(!params->first->beginsWith(params->second));
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('endsWith');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(params->first->endsWith(params->second));
			return(0);
		/if;
		return(1);
	/define_tag;

	define_tag('notEndsWith');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(!params->first->endsWith(params->second));
			return(0);
		/if;
		return(1);
	/define_tag;

	define_tag('regExp');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(string_findregexp(params->first, -find=params->second)->size > 0);
			return(0);
		/if;
		return(1);
	/define_tag;

	define_tag('notRegExp');
		fail_if(params->size < 2, -9956, 'Comparator expected two parameters.');
		if(string_findregexp(params->first, -find=params->second)->size <= 0);
			return(0);
		/if;
		return(1);
	/define_tag;

/namespace_using;

namespace_using('match_');

	define_type('Regexp');
		local('exp'='');
		define_tag('onCreate', -required='exp');
			self->exp = #exp;
		/define_tag;
		define_tag('onCompare');
			local('rhs' = string(params->first->isa('pair')?params->first->first|params->first));
			if(string_findregexp(-find=self->exp, #rhs)->size > 0);
				return(0);
			/if;
			return(1);
		/define_tag;
	/define_type;
	
	define_type('NotRegexp');
		local('exp'='');
		define_tag('onCreate', -required='exp');
			self->exp = #exp;
		/define_tag;
		define_tag('onCompare');
			local('rhs' = string(params->first->isa('pair')?params->first->first|params->first));
			if(string_findregexp(-find=self->exp, #rhs)->size <= 0);
				return(0);
			/if;
			return(1);
		/define_tag;
	/define_type;
	
	define_type('Range');
		local('low'='', 'high'='');
		define_tag('onCreate', -required='low', -required='high');
			self->low = #low;
			self->high = #high;
		/define_tag;
		define_tag('onCompare');
			local('rhs' = (params->first->isa('pair')?params->first->first|string(params->first)));
			if(#rhs >= self->low && #rhs <= self->high);
				return(0);
			/if;
			return(1);
		/define_tag;
	/define_type;
	
	define_type('NotRange');
		local('low'='', 'high'='');
		define_tag('onCreate', -required='low', -required='high');
			self->low = #low;
			self->high = #high;
		/define_tag;
		define_tag('onCompare');
			local('rhs' = (params->first->isa('pair')?params->first->first|string(params->first)));
			if(!(#rhs >= self->low && #rhs <= self->high));
				return(0);
			/if;
			return(1);
		/define_tag;
	/define_type;
	
	define_type('Comparator');
		local('cmp'='');
		local('lhs'=null);
		local('rhs'=null);
		define_tag('onCreate');
			
			fail_if(params->size < 2, -9956, 'Matcher expected a comparator and a value.');
			Local('cmp' = Params->First);
			if(#cmp->isa('tag'));
				self->'cmp' = @#cmp;
			else;
				if(#cmp >> 'ncn' || #cmp >> 'notcontain' || #cmp == '!>>');
					Self->'cmp' = \compare_notcontains;
				else(#cmp >> 'cn' || #cmp >> 'contain' || #cmp == '>>');
					Self->'cmp' = \compare_contains;
				else(#cmp >> 'gte' || (#cmp >> 'greater' && #cmp >> 'equal') || #cmp == '>=');
					Self->'cmp' = \compare_greaterthanorequals;
				else(#cmp >> 'gt' || #cmp >> 'greater' || #cmp == '>');
					Self->'cmp' = \compare_greaterthan;
				else(#cmp >> 'lte' || (#cmp >> 'less' && #cmp >> 'equal') || #cmp == '<=');
					Self->'cmp' = \compare_lessthanorequals;
				else(#cmp >> 'lt' || #cmp >> 'less' || #cmp == '<');
					Self->'cmp' = \compare_lessthan;
				else(#cmp >> 'strictequal' || #cmp == '===');
					Self->'cmp' = \compare_strictequalto;
				else(#cmp >> 'strictnotequal' || #cmp == '!==');
					Self->'cmp' = \compare_strictnotequalto;
				else(#cmp >> 'neq' || #cmp >> 'notequal' || #cmp == '!=');
					Self->'cmp' = \compare_notequalto;
				else(#cmp >> 'eq' || #cmp >> 'equal' || #cmp == '==');
					Self->'cmp' = \compare_equalto;
				else(#cmp >> 'nbw' || #cmp >> 'notbegin');
					Self->'cmp' = \compare_notbeginswith;
				else(#cmp >> 'bw' || #cmp >> 'begin');
					Self->'cmp' = \compare_beginswith;
				else(#cmp >> 'new' || #cmp >> 'notend');
					Self->'cmp' = \compare_notendswith;
				else(#cmp >> 'ew' || #cmp >> 'end');
					Self->'cmp' = \compare_endswith;
				else(#cmp >> 'nrx' || #cmp >> 'notregex');
					Self->'cmp' = \compare_notregexp;
				else(#cmp >> 'rx' || #cmp >> 'regex');
					Self->'cmp' = \compare_regexp;
				else;
					fail: -9956, 'The comparator must be a tag reference or an operator like -bw, -cn, -eq, -ew, -lt, -gt, -rx.'; 
				/if;
			/if;
			if(local_defined('rhs'));
				self->'rhs' = @#rhs;
			else(local_defined('lhs'));
				self->'lhs' = @#lhs;
			else;
				self->'rhs' = Params->Second;
			/if;
		/define_tag;
		define_tag('onCompare');
			local('somehs' = (params->first->isa('pair') ? params->first->first | params->first));
			if (self->'rhs' != null);
				return(self->'cmp'->invoke(#somehs, self->'rhs'));
			else;
				return(self->'cmp'->invoke(self->'lhs', #somehs));
			/if;
		/define_tag;
	/define_type;

/namespace_using;

define_type('series', 'array', -description='Represents a series of values. Two parameters are required to construct a series type: -from and -to. \
									-from and -to are tested based on equality using the == operator and -from is advanced using the prefix ++ operator. \
									-from and -to need not be integers, but they must logically support the required == and ++ operators so that, eventually, -from will be equal to -to based on the application of the prefix ++ operator. \
									The ->size member indicates the total number of values in the series and the ->get member allows random access into the sequence of values. \
									The ->iterator and ->reverseiterator tags will return an iterator for the series.' );

	define_tag('onCreate', -required='from', -copy, -required='to');
		self->removeall;
		self->insert(#from);
		while(#from != #to);
			self->insert(++#from);		
		/while;
	/define_tag;
	
/define_type;

?>