<?LassoScript

	// This file is the only file called at startup by Lasso.
	// This file must include all other files in startup.lassoapp
	// which need to be called.

	Auth_Admin;

	protect;
	
// Set the log level for all inlines within startup.lassoapp
	var: '__startup_loglevel__' = 'none';
	var: '__debug_loglevel__' = 'detail';
	var: '__need_reload__' = false;
	
// Define some string tags early
	library:lassoapp_link:'string.lasso';
	
// Namespaces

	library:lassoapp_link:'namespace.lasso';

// Log Startup Message

	log_always: 'Lasso Professional ' + (lasso_version: -lassoversion)->(substring: 1, (lasso_version: -lassoversion)->(find: ' ') - 1) + ' Started';
	log_always: 'Site ' + (site_name) + ' (' + (site_id) + ') Started';

	var: '__startup_version__' = 'Unknown';
	protect;
		$__startup_version__ = (include: (lassoapp_link: 'version.txt'));
		log_warning: 'Startup Time Stamp: ' + (date: $__startup_version__);
		handle_error;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;
	$__startup_version__->freezevalue;
	$__startup_version__->freezetype;

// Load Lasso Tag Libraries

	Log_Warning: 'Lasso Tags: Defining Lasso 8 Tags';
	
	// Global variable tags [Global] [Global_Defined]
	library: (lassoapp_link: 'globals.lasso'); 

	// Tags
	library: (lassoapp_link: 'tags/bigint.lasso');
	library: (lassoapp_link: 'tags/client.lasso');
	library: (lassoapp_link: 'tags/content.lasso');
	library: (lassoapp_link: 'tags/date.lasso');
	library: (lassoapp_link: 'tags/dns.lasso');
	library: (lassoapp_link: 'tags/error.lasso');
	library: (lassoapp_link: 'tags/file.lasso');
	library: (lassoapp_link: 'tags/mime.lasso');
	library: (lassoapp_link: 'tags/records.lasso');
	library: (lassoapp_link: 'tags/server.lasso');
	library: (lassoapp_link: 'tags/soap.lasso');
	
	// sort_arguments
	library: (lassoapp_link:'sort.lasso');

	// Cache tags [Cache] ... [/Cache] [Cache_Object]
	if: (site_id != 0);
		library: (lassoapp_link: 'Cache.lasso'); 
	/if;

	// Security Tags
	library: (lassoapp_link: 'security.lasso'); 

	// Utility Tags [Named_Param] [Client_...] tags
	library: (lassoapp_link: 'utility.lasso'); 

	// LassoApp_... Tags
	library: (lassoapp_link: 'lassoapp.lasso'); 

	// Comparators/Matchers
	library:lassoapp_link:'comparators.lasso';
	// generic iterator type
	library:lassoapp_link:'iterator.lasso';
	
	// SOAP and XML
	library:lassoapp_link:'namespaces.lasso';
	library:lassoapp_link:'xsd.lasso';
	if: !global('lp7_types.xsd')->isa('xml');
		global('lp7_types.xsd') = xml:include:lassoapp_link:'lp7types.xsd';
	/if;
	if: global('XML_SCHEMA_URIS')->size == 0;
		global('XML_SCHEMA_URIS') = set('http://www.w3.org/1999/XMLSchema', 'http://www.w3.org/2001/XMLSchema');
	/if;
	if: global('_xml_schema_cache')->size == 0;
		// this is a lengthy process (on Macs for some reason), so push it into its own thread
		global('_xml_schema_cache')->\deserialize->asAsync(-params=@array(@include:lassoapp_link:'XMLSchemaMap.xml'), -owner=@global('_xml_schema_cache'), -Name='Startup: XML Schema Cache');	
	/if;
	library:lassoapp_link:'wsdl.lasso';
	library:lassoapp_link:'soap.lasso';
	
// Load Lasso Compatibility Tag Libraries

	Log_Warning: 'Lasso Tags: Defining Lasso Compatibility Tags';

	// Lasso 3 compatibility types [Repetition], [Client_Address] [Client_IP]
	library: (lassoapp_link: 'compatibility.lasso'); 

	// Lasso 3 compatibility tags [Math_ConvertEuro], etc.
	library: (lassoapp_link: 'MiscLibrary.lasso'); 
			
	// Locale tags
	library: (lassoapp_link: 'locale.lasso'); 
			
	// Locale tags
	library: (lassoapp_link: 'DatasourceIs.lasso'); 

	// Image tags (Stub if X11 is missing)
	if: (site_id != 0);
		library: (lassoapp_link: 'image_tags.lasso'); 
	/if;
	
// Check/Repair Databases

	library: (lassoapp_link: 'database_check.lasso'); 
	
// Create Utility Tables and Start Background Processes

	// Session tracker table in site database
	library: (lassoapp_link: 'sessiontrackerinit.lasso'); 

	// Create preferences table and define helper tags
	library: (lassoapp_link: 'LassoAdminStartup.lasso'); 
	// Call _admin_listconnectors asynchronously to initialize global variable
//	{ _admin_listconnectors; }->(AsAsync: -Name='Startup: Identify Data Source Connectors');

	// Software Update Notification check tag
	library: (lassoapp_link: 'sun_updatecheck.lasso'); 

	// Email Queue, SMTP, and POP tags
	library: (lassoapp_link: 'email/tables.inc');
	library: (lassoapp_link: 'email/encode_crammd5.inc');
	library: (lassoapp_link: 'email/encode_quotedprintable.inc');
	library: (lassoapp_link: 'email/smtp.inc');
	library: (lassoapp_link: 'email/compose_send.inc');
	library: (lassoapp_link: 'email/mx.lasso');
	if: (site_id != 0);
		library: (lassoapp_link: 'email/pop_parse.inc');
		library: (lassoapp_link: 'email/smtp_queue.inc');
	/if;
	
	// URL Rewrite
	library: (lassoapp_link: 'urlrewrite.lasso');

	// Turn on Strict Syntax
	library: (lassoapp_link: 'StrictSyntax.lasso'); 
		
	// Schedule Queue and [Event_Schedule] tag
	if: (site_id != 0);
		library: (lassoapp_link: 'scheduleLibrary.lasso'); 
	/if;
	
	// XML_RPC type
	if: (site_id != 0);
		library: (lassoapp_link: 'xml_rpc.lasso');
	/if;
	
	// RPC Introspection
	if: (site_id != 0);
		library: (lassoapp_link: 'RPC_introspect.lasso'); 
	/if;
	
	// LJAX
	if: (site_id != 0);
		library: (lassoapp_link: 'ljax.lasso'); 
	/if;

// Lasso Security

	// Load Lasso Security Modifications
	library: (lassoapp_link: 'LassoSecurity.lasso'); 

	// Refresh Lasso Security
	_security_flushcaches;

	// Load Tag Security
	library: (lassoapp_link: 'tag_security.lasso'); 

// Reload internal data source, and Dump Startup.LassoApp

	// Ensure that any altered database tables are loaded
	if: (global: '__need_reload__') == true;
		_datasource_reload: 1;
	/if;
	global_remove: '__need_reload__';
	
// Set Error Preferences (defaults used until this point)

	library: (lassoapp_link: 'errorSetup.lasso'); 

	admin_setpref: 'lasso_uptime', date;

	handle_error;
		log_always: 'Startup Error: ' error_code ': ' error_msg;
	/handle_error;

// Initialize Trigger

	if: (site_id == 0);
		inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_users', -opbegin='or', -op='eq', 'name'='ADMINISTRATOR', -op='eq', 'name'='administrator', -opend='or', -op='eq', 'password'='', -returnfield='id', -maxrecords=1, -uselimit;		
			if: (found_count) == 1;	
				log_critical: 'Initialize - Required';
				var: '__initialize__' = true;
			/if;
		/inline;
	else: (site_id == 1);
		inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_users', -opbegin='or', -op='eq', 'name'='ADMINISTRATOR', -op='eq', 'name'='administrator', -opend='or', -op='eq', 'password'='', -returnfield='id', -maxrecords=1, -uselimit;		
			if: (found_count) == 1;	
				log_critical: 'Initialize - Installing Redirect';
				define_type: '_initialize';
					define_tag: 'invoke', -privileged;
						inline: -log=$__startup_loglevel__, -search, -database='lasso_internal', -table='security_users', -opbegin='or', -op='eq', 'name'='ADMINISTRATOR', -op='eq', 'name'='administrator', -opend='or', -op='eq', 'password'='', -returnfield='id', -maxrecords=1, -uselimit;
							if: found_count == 1;
								log_critical: 'Initialize - Redirecting';
								redirect_url: '/ServerAdmin.LassoApp';
							else;
								log_critical: 'Initialize - Removing Redirect';
								_security_flushcaches;
								loop: -from=site_atbegin->size, -to=1, -by=-1;
									if: site_atbegin->(get: loop_count)->(isa: '_initialize');
									  site_atbegin->(remove: loop_count);
									/if;
								/loop;
							/if;
						/inline;
					/define_tag;
				/define_type;	
				define_atbegin: _initialize;
			/if;
		/inline;
	/if;
	
	/protect;

	// Call lassoapp_dump asynchronously so it occurs after we finish executing.
	{ Sleep: 15000; LassoApp_Dump: 'Startup.LassoApp' }->(AsAsync: -Name='Startup: Dump Startup.LassoApp');

?>
