<?LassoScript

	define_tag: 'MXLookup',
			-namespace='email_',
			-required='domain',
			-optional='refresh',
			-optional='hostname',
			-privileged;
		local: '_domain' = (string: #domain)->trim &;
		if: (local_defined: 'refresh');
			local: '_refresh' = (#refresh === null) || (#refresh !== false);
		else;
			local: '_refresh' = false;
		/if;
		if: #_refresh == false;
			inline: -log=$__startup_loglevel__,
					-search,
					-database='site',
					-table='smtp_cache',
					-keyfield='id',
					-op='eq', 'domain'=#_domain,
					-op='gt', 'datetime' = date->subtract(-day=1)&format('%Q %T'),
					-sortfield='priority',
					-maxrecords='1', -uselimit;
				records;
					local: 'output' = (map: 
							'cache' = (field: 'id'),
							'route' = 0,
							'domain' = (field: 'domain'),
							'host'=(field: 'host'),
							'username'=(field: 'username'),
							'password'=(field: 'password'),
							'timeout'=(field: 'timeout'),
							'ssl'=(field: 'ssl'),
						);
					return: @#output;
				/records;
			/inline;
		/if;
		inline: -log=$__startup_loglevel__,
				-search,
				-database='site',
				-table='smtp_route',
				-keyfield='id',
				-op='eq', 'domain'=#_domain,
				-maxrecords=1, -uselimit;
			records;
				local: 'route' = (field: 'id');
				inline: -log=$__startup_loglevel__,
						-delete,
						-database='site',
						-table='smtp_cache',
						-key=array(-op='eq', 'domain'=#_domain);
				/inline;
				inline: -log=$__startup_loglevel__,
						-add,
						-database='site',
						-table='smtp_cache',
						-keyfield='id',
						'domain'=#_domain,
						'host'=(field: 'host'),
						'priority'=0,
						'username'=(field: 'username'),
						'password'=(field: 'password'),
						'timeout'=(field: 'timeout'),
						'ssl'=(field: 'ssl'),
						'datetime'=date->format('%Q %T'),
						-maxrecords='1', -uselimit;
				/inline;
				local: 'output' = (map: 
						'cache' = (field: 'id'),
						'route' = (field: 'id'),
						'domain' = (field: 'domain'),
						'host'=(field: 'host'),
						'username'=(field: 'username'),
						'password'=(field: 'password'),
						'timeout'=(field: 'timeout'),
						'ssl'=(field: 'ssl'),
					);
				return: @#output;
			/records;
		/inline;
		local: 'mx' = array;
		protect;
			if: (local_defined: 'hostname');
				local: 'mx' = (dns_lookup: #_domain, -type='mx', -hostname=#hostname);		
			else;
				local: 'mx' = (dns_lookup: #_domain, -type='mx');		
			/if;
		/protect;
		if: #mx->(isa: 'array') && (#mx->size > 0);
			local: 'output' = (map: 
					'domain' = #_domain,
					'host'=#mx->first->second,
					'priority'=#mx->first->first,
				);
			inline: -log=$__startup_loglevel__,
					-delete,
					-database='site',
					-table='smtp_cache',
					-key=array(-op='eq', 'domain'=#_domain);
			/inline;
			inline: -log=$__startup_loglevel__,
					-add,
					-database='site',
					-table='smtp_cache',
					-keyfield='id',
					'domain'=#_domain,
					'host'=#mx->first->second,
					'priority'=#mx->first->first,
					'datetime'=date->format('%Q %T'),
					-maxrecords='1', -uselimit;
				records;
					local: 'output' = (map: 
							'cache' = (field: 'id'),
							'route' = 0,
							'domain' = (field: 'domain'),
							'host'=(field: 'host'),
							'username'=(field: 'username'),
							'password'=(field: 'password'),
							'timeout'=(field: 'timeout'),
							'ssl'=(field: 'ssl'),
						);
					return: @#output;
				/records;
			/inline;
			return(#output);
		/if;		
	/define_tag;
		
?>