<?LassoScript

	// Asynchronous SMTP Sweep

	{

		Protect;
			
			Define_Tag: 'getprefs';
				Local: 'prefs' = (map: 
						'lasso_smtp_pause' = 'N',
						'lasso_smtp_host' = '',
						'lasso_smtp_port' = 25,
						'lasso_smtp_username' = '',
						'lasso_smtp_password' = '',
						'lasso_smtp_timeout' = 15,
						'lasso_smtp_keep_error' = 'Y',
						'lasso_smtp_keep_success' = 'N',
						'lasso_smtp_keep_mime' = 'N',
						'lasso_smtp_sweep_delay' = 5,
						'lasso_smtp_resend_delay' = 600,
						'lasso_smtp_mxretry_delay' = 600,
						'lasso_smtp_max_retries' = 5,
						'lasso_smtp_queue_count' = 4,
						'lasso_smtp_queue_size' = 100,
						'lasso_smtp_lassoservice_ip' = '',
						'lasso_smtp_sendmode' = 'direct',
						'lasso_smtp_ignorehost' = 'N',
						'lasso_smtp_usessl' = 'N',
					);					
				Local: 'prefs' = (admin_getpref: #prefs);
				if: (#prefs->(find: 'lasso_smtp_pause') >> 'Y');
					Global: '__SMTP_Queue_Status__'='Pause';
				else;
					Global: '__SMTP_Queue_Status__'='Active';
				/if;
				if: (#prefs->(find: 'lasso_smtp_lassoservice_ip') != '');
					Global: '__SMTP_IP__' = #prefs->(find: 'lasso_smtp_lassoservice_ip');
				else: (Global: '__lassoservice_ip__') != '';
					Global: '__SMTP_IP__' = (Global: '__lassoservice_ip__');
				else;
					Global: '__SMTP_IP__' = '127.0.0.1';
				/if;
				(global('__mail_debug__') == true) ? log_always('MAIL PREFS ' + #prefs);
				Return: @#prefs;
			/Define_Tag;

			global: '__SMTP_Queue_Status__' = 'Active';
			global: '__SMTP_Queue_Sleep__' = (Date);
			global: '__SMTP_Stage_Status__' = 'Active';
			global: '__SMTP_Stage_Sleep__' = (Date);
			global: '__SMTP_Queues__' = (Array);
			global: '__SMTP_Number__' = 1;
			
			Local: 'prefs' = getprefs;
				
			If: ((Global: '__SMTP_Queue_Status__') >> 'Active');
				Log_Warning: 'SMTP: Starting Email Queue';
			Else;
				Log_Warning: 'SMTP: Pausing Email Queue';
			/If;
			
			// One Cycle Delay at Startup
			Global: '__SMTP_Queue_Status__' = 'Abort';
			Sleep: ((math_range: (integer: #prefs->(find: 'lasso_smtp_sweep_delay')), 1, 3600) * 1000); 
			Global: '__SMTP_Queue_Status__' = 'Refresh';
			
			// Reset all queue_numbers to 0
			inline: -log=$__startup_loglevel__, 
					-database='site',
					-table='smtp_stage',
					-sql='UPDATE smtp_stage SET queue_number = 0';
			/inline;
			
			// Delete Orphans (once at startup)
			local: 'queue_ids' = array;	
			inline: -log=$__startup_loglevel__, -database='site', -sql='SELECT id FROM smtp_queue', -maxrecords='all';
				records;
					#queue_ids->(insert: (field: 'id'));
				/records;
			/inline;
			inline: -log=$__startup_loglevel__, -database='site', -sql='SELECT id FROM smtp_stage WHERE id_email IS NULL OR id_email = 0 OR id_email NOT IN (' + #queue_ids->(join: ', ') + ')', -maxrecords='all';
				if: (found_count > 0);
					log_warning: 'SMTP: Warning deleting ' + found_count + ' orphaned email parts.';
				/if;
			/inline;
			inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_stage WHERE id_email IS NULL OR id_email = 0 OR id_email NOT IN (' + #queue_ids->(join: ', ') + ')', -maxrecords=0;
			/inline;
			inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_error WHERE id_email != 0 AND id_email NOT IN (' + #queue_ids->(join: ', ') + ')', -maxrecords=0;
			/inline;

			While: ((Global: '__SMTP_Queue_Status__') !>> 'Abort');

				If: ((Global: '__SMTP_Queue_Status__') >> 'Refresh');
					Log_Detail: 'SMTP: Refreshing Email Preferences.';
					Local: 'prefs' = getprefs;
				/If;
				
				If: ((Global: '__SMTP_Queue_Status__') >> 'Pause') || ((Global: '__SMTP_Queue_Status__') >> 'Stop');
					Sleep: ((math_range: (integer: #prefs->(find: 'lasso_smtp_sweep_delay')), 1, 3600) * 1000); 
					Loop_Continue;
				else: ((Global: '__SMTP_Queue_Status__') >> 'Sleep') && (!(Global: '__SMTP_Queue_Sleep__')->(isa: 'date') || ((Global: '__SMTP_Queue_Sleep__') > Date));
					Sleep: ((math_range: (integer: #prefs->(find: 'lasso_smtp_sweep_delay')), 1, 3600) * 1000); 
					Loop_Continue;
				/if;
				
				Global: '__SMTP_Queue_Status__' = 'Awake';
				
				Error_Reset;
				
				Protect;

					local: 'check_ids' = (array);
					local: 'delete_ids' = (array);
					local: 'sent_ids' = (array);
					local: 'error_ids' = (array);

					// Update the queue_status based on queue_status of all staged messages
					inline: -log=$__startup_loglevel__,
							-search,
							-database='site',
							-table='smtp_queue',
							-keyfield='id',
							-op='eq', 'queue_status' = 'sending',
							-maxrecords='all',
							-returnfield='id';
						(global('__mail_debug__') == true) ? log_always('MAIL QUEUE SENDING ' + found_count);
						records;
							#check_ids->(insert: (field: 'id'));
						/records;
					/inline;
						
					if: #check_ids->size > 0;
						local: 'temp_map' = (map);
						iterate: #check_ids, (local: 'temp_id');
							#temp_map->(insert: #temp_id = 'sent');
							if: (#temp_map->size >= 50) || (loop_count == #check_ids->size);
								inline: -log=$__startup_loglevel__,
										-database='site',
										-SQL='SELECT id_email, queue_status FROM smtp_stage WHERE id_email IN (' + #temp_map->keys->(join: ', ') + ');';
									if: found_count == 0;
										//#delete_ids->(insert: (field: 'id_email'));
										#delete_ids->(insert: 0 );
									else;
										records;
											if: (#temp_map->(find: (field: 'id_email')) != 'error');
												if: ((field: 'queue_status') >> 'error');
													#temp_map->(insert: (field: 'id_email') = 'error');
												else: (field: 'queue_status') >> 'queued';
													#temp_map->(insert: (field: 'id_email') = 'sending');
												/if;
											/if;
										/records;
									/if;
								/inline;
								iterate: #temp_map->keys, (local: 'temp_key');
									local: 'status' = #temp_map->(find: #temp_key);
									(global('__mail_debug__') == true) ? log_always('MAIL QUEUE MSG ' + #temp_key + ' ' + #status);
									if: ((#status == 'error') && (#prefs->(find: 'lasso_smtp_keep_error') >> 'N')) ||
											((#status == 'sent') && (#prefs->(find: 'lasso_smtp_keep_success') >> 'N'));
										#delete_ids->(insert: (integer: #temp_key));
									else: (#status == 'sent');
										#sent_ids->(insert: (integer: #temp_key));
									else: (#status == 'error');
										#error_ids->(insert: (integer: #temp_key));
									/if;
								/iterate;
								local: 'temp_map' = (map);
							/if;
						/iterate;
					/if;

					if: #delete_ids->size > 0;
						local: 'temp_ids' = (array);
						iterate: #delete_ids, (local: 'temp_id');
							#temp_ids->(insert: #temp_id);
							if: (#temp_ids->size >= 50) || (loop_count == #delete_ids->size);
								inline: -log=$__startup_loglevel__,
										-database='site',
										-SQL='UPDATE smtp_error SET id_email = 0, id_queue = 0 WHERE id_email IN (' + #temp_ids->(join: ', ') + ');';
								/inline;
								inline: -log=$__startup_loglevel__,
										-database='site',
										-SQL='DELETE FROM smtp_stage WHERE id_email IN (' + #temp_ids->(join: ', ') + ');';
								/inline;
								inline: -log=$__startup_loglevel__,
										-database='site',
										-SQL='DELETE FROM smtp_queue WHERE id IN (' + #temp_ids->(join: ', ') + ');';
								/inline;
								local: 'temp_ids' = (array);
							/if;
						/iterate;
					/if;

					if: #sent_ids->size > 0;
						local: 'temp_ids' = (array);
						iterate: #sent_ids, (local: 'temp_id');
							#temp_ids->(insert: #temp_id);
							if: (#temp_ids->size >= 50) || (loop_count == #sent_ids->size);
								inline: -log=$__startup_loglevel__,
										-database='site',
										-SQL='UPDATE smtp_queue SET queue_status = "sent" WHERE id IN (' + #temp_ids->(join: ', ') + ');';
								/inline;
								if: (#prefs->(find: 'lasso_smtp_keep_mime') >> 'N');
									iterate: #temp_ids, (local: 'temp_key');
										inline: -log=$__startup_loglevel__,
												-search = '',
												-database='site',
												-table='smtp_queue',
												-keyfield='id',
												-keyvalue=#temp_key,
												-returnfield='id',
												-returnfield='mime_text';
											records;
												inline: -log=$__startup_loglevel__,
														-update = '',
														-database='site',
														-table='smtp_queue',
														-keyfield='id',
														-keyvalue=(field: 'id'),
														-maxrecords=0,
														'mime_text' = (string_replaceregexp: (field: 'mime_text'), -find='\r\n\r\n[\\S\\s]*', -replace='\r\n\r\n');
												/inline;
											/records;
										/inline;
									/iterate;
								/if;
								local: 'temp_ids' = (array);
							/if;
						/iterate;
					/if;

					if: #error_ids->size > 0;
						local: 'temp_ids' = (array);
						iterate: #error_ids, (local: 'temp_id');
							#temp_ids->(insert: #temp_id);
							if: (#temp_ids->size >= 50) || (loop_count == #error_ids->size);
								inline: -log=$__startup_loglevel__,
										-database='site',
										-SQL='UPDATE smtp_queue SET queue_status = "error" WHERE id IN (' + #temp_ids->(join: ', ') + ');';
								/inline;
								local: 'temp_ids' = (array);
							/if;
						/iterate;
					/if;

					// Flag invalid messages
					inline: -log=$__startup_loglevel__,
							-database='site',
							-table='smtp_queue',
							-sql='SELECT * FROM smtp_queue \
								WHERE \
									queue_status = "queued" AND \
									(mime_text = "" OR \
									mime_from = "" OR \
									mime_recipients = "") \
								ORDER BY queue_priority',
							-maxrecords='all';
							
						(global('__mail_debug__') == true) ? log_always('MAIL QUEUE ERRORS ' + found_count);
						
						Records;
							local: 'queue_error' = '';
							((field: 'mime_from') == '') ? #queue_error += 'Message does not have a valid from address. ';
							((field: 'mime_recipients') == '') ? #queue_error += 'Message does not have any valid recipients. ';
							((field: 'mime_text') == '') ? #queue_error += 'Message does not have a valid body or parts. ';
							#queue_error->trim;
							inline: -log=$__startup_loglevel__,
									-add = '',
									-database='site',
									-table='smtp_error',
									-keyfield='id',
									-maxrecords=0,
									'id_queue'=0,
									'id_email'=(field: 'id'),
									'id_cache'=0,
									'id_route'=0,
									'error' = #queue_error,
									'code' = -1,
									'severity' = 'fatal',
									'datetime' = date->(format: '%Q %T');
							/inline;
							inline: -log=$__startup_loglevel__,
									-update = '',
									-database='site',
									-table='smtp_queue',
									-keyfield='id',
									-keyvalue=(field: 'id'),
									-maxrecords=0,
									'queue_status' = 'error';
							/inline;
						/Records;
					/inline;
				
				// Run this in a local environment so the inline doesn't hang around
				{
					Local: 'prefs' = params->(get: 1);
					
					// Move Messages from smtp_queue to smtp_stage
					inline: -log=$__startup_loglevel__,
							-database='site',
							-table='smtp_queue',
							-sql='SELECT * FROM smtp_queue \
								WHERE \
									queue_status = "queued" AND \
									queue_date < datetime("now","localtime") AND \
									mime_text <> "" AND \
									mime_from <> "" AND \
									mime_recipients <> "" \
								ORDER BY queue_priority',
							-maxrecords=(math_range: (integer: #prefs->(find: 'lasso_smtp_queue_size')), 1, 200),
							-inlinename='mail_move';
					/inline;
					
					resultset: -inlinename='mail_move';
						
						(global('__mail_debug__') == true) ? log_always('MAIL QUEUE SIZE ' + found_count);

						local: 'sendmode' = #prefs->(find: 'lasso_smtp_sendmode');
						local: 'ignorehost' = #prefs->(find: 'lasso_smtp_ignorehost');
						
						records;

							protect;
								local: 'merge_tokens' = null;
								if: ((field: 'merge_tokens') != '');
									#merge_tokens->(deserialize: (field: 'merge_tokens'));
								/if;
							/protect;
							protect;
								local: 'merge_array' = null;
								if: ((field: 'merge_array') != '');
									#merge_array->(deserialize: (field: 'merge_array'));
								/if;
							/protect;
							
							local: 'send_array' = (array);
							if: (#ignorehost !>> 'Y') && ((field: 'smtp_host') != '');
								local: 'send_map' = (map: 
										'mime_text' = (field: 'mime_text'),
										'mime_recipients' = (field: 'mime_recipients')->(split: ','),
										'smtp_host' = (field: 'smtp_host'),
										'smtp_port' = (field: 'smtp_port'),
										'smtp_timeout' = (field: 'smtp_timeout'),
										'smtp_username' = (field: 'smtp_username'),
										'smtp_password' = (field: 'smtp_password'),
										'smtp_ssl' = (field: 'smtp_ssl'),
										'id_route' = 0,
										'id_cache' = 0,
										'merge_tokens' = #merge_tokens,
									);
								#send_array->(insert: #send_map);
							else: (#sendmode >> 'local');
								// Use local SMTP prefs
								local: 'send_map' = (map: 
										'mime_text' = (field: 'mime_text'),
										'mime_recipients' = (field: 'mime_recipients')->(split: ','),
										'smtp_host' = '',
										'smtp_port' = '',
										'smtp_timeout' = '',
										'smtp_username' = '',
										'smtp_password' = '',
										'id_route' = 0,
										'id_cache' = 0,
										'merge_tokens' = #merge_tokens,
									);
								#send_array->(insert: #send_map);
							else: (#sendmode >> 'direct') || (#sendmode >> 'fallback');
								// Use looked up SMTP prefs
								local: 'recipients' = (field: 'mime_recipients')->(split: ',');
								local: 'domains' = (map);
								local: 'hosts' = (map);
								iterate: #recipients, (local: 'address');
									local: 'domain' = (string_replaceregexp: #address->trim &, -find='.*@(\\S*).*', -replace='\\1')->trim &;
									if: #domains >> #domain;
										#domains->(find: #domain)->(insert: #address);
									else;
										#domains->(insert: #domain = (array: #address));
									/if;
								/iterate;
								iterate: #domains->keys, (local: 'domain');
									local: 'mx' = (email_mxlookup: #domain);
									(global('__mail_debug__') == true) ? log_always('MX LOOKUP ' + #domain + ' -> ' + #mx);
									if: (#mx->size > 0) && #mx->(isa: 'map');					
										#hosts->(insert: #domain = (map: 
												'smtp_host' = #mx->(find: 'host'),
												'smtp_port' = #mx->(find: 'port'),
												'smtp_timeout' = #mx->(find: 'timeout'),
												'smtp_ssl' = #mx->(find: 'ssl'),
												'smtp_username' = #mx->(find: 'username'),
												'smtp_password' = #mx->(find: 'password'),
												'id_route' = #mx->(find: 'route'),
												'id_cache' = #mx->(find: 'cache')));
									else; //: (#sendmode >> 'fallback');
										#hosts->(insert: #domain = (map: 
												'smtp_host' = '',
												'smtp_port' = '',
												'smtp_timeout' = '',
												'smtp_ssl' = '',
												'smtp_username' = '',
												'smtp_password' = '',
												'id_route' = 0,
												'id_cache' = 0));
										inline: -log=$__startup_loglevel__,
												-add = '',
												-database='site',
												-table='smtp_error',
												-keyfield='id',
												-maxrecords=0,
												'id_queue'=0,
												'id_email'=(field: 'id'),
												'id_cache'=0,
												'id_route'=0,
												'error' = 'No MX records found for "' + #domain + '".',
												'code' = -1,
												'severity' = ((#sendmode >> 'fallback') ? 'warning' | 'fatal'),
												'datetime' = date->(format: '%Q %T');
										/inline;
									/if;
								/iterate;
								iterate: #hosts->keys, (local: 'host');
									local: 'recipients' = #domains->(find: #host);
									#domains->(removeall: #host);
									local: 'send_map' = #hosts->(find: #host);
									#send_map->(insert: 'mime_recipients' = #recipients);
									#send_map->(insert: 'merge_tokens' = #merge_tokens);
									#send_array->(insert: #send_map);
								/iterate;
							/if;
							
							if: #merge_array->(isa: 'map') && (#merge_array->size > 0);
								local: 'new_array' = (array);
								iterate: #send_array, (local: 'send_map');
									local: 'recipients' = #send_map->(find: 'mime_recipients');
									local: 'nomerge' = (array);
									iterate: #recipients, (local: 'recipient');
										if: (#merge_array->keys >> #recipient);
											local: 'new_map' = #send_map;
											#new_map->(insert: 'mime_recipients' = (array: #recipient));
											local: 'tokens' = #new_map->(find: 'merge_tokens');
											if: !(#tokens->(isa: 'map'));
												local: 'tokens' = #merge_array->(find: #recipient);
											else;
												#tokens->(insertfrom: #merge_array->(find: #recipient)->iterator);
											/if;
											#new_map->(insert: 'merge_tokens' = #tokens);
											#new_array->(insert: #new_map);
										else;
											#nomerge->(insert: #recipient);
										/if;
									/iterate;
									if: #nomerge->size > 0;
										#send_map->(insert: 'mime_recipients' = #nomerge);
										#new_array->(insert: #send_map);
									/if;
								/iterate;
								local: 'send_array' = #new_array;
							/if;

							iterate: #send_array, (local: 'send_map');
								local: 'mime_text' = (field: 'mime_text');
								local: 'merge_tokens' = #send_map->(find: 'merge_tokens');
								if: #merge_tokens->(isa: 'map') && (#merge_tokens->size > 0);
									local: 'mime_text' = (email_merge: #mime_text, -tokens=#merge_tokens);
								/if;
							
								(global('__mail_debug__') == true) ? log_always('MAIL QUEUE STAGE #' + (field: 'id') + ' ' +  #send_map->(find: 'mime_recipients')->(join: ','));
								
								inline: -log=$__startup_loglevel__,
										-add = '',
										-database = 'site',
										-table = 'smtp_stage',
										-maxrecords=0,
										
										'id_site' = (field: 'id_site'),
										'id_email' = (field: 'id'),
										'id_route' = (string: #send_map->(find: 'id_route')),
										'id_cache' = (string: #send_map->(find: 'id_cache')),
										
										'mime_recipients' = #send_map->(find: 'mime_recipients')->(join: ','),
										'mime_from' = (field: 'mime_from'),
										'mime_text' = #mime_text,
										
										'smtp_host' = (string: #send_map->(find: 'smtp_host')),
										'smtp_port' = (string: #send_map->(find: 'smtp_port')),
										'smtp_timeout' = (string: #send_map->(find: 'smtp_timeout')),
										'smtp_ssl' = (string: #send_map->(find: 'smtp_ssl')),
										'smtp_username' = (string: #send_map->(find: 'smtp_username')),
										'smtp_password' = (string: #send_map->(find: 'smtp_password')),
										
										'queue_date' = (field: 'queue_date'),
										'queue_status' = 'queued',
										'queue_error' = '',
										'queue_number' = 0,
										'queue_priority' = (field: 'queue_priority'),
										'queue_retries' = (integer: #prefs->(find: 'lasso_smtp_max_retries')),
										
										'create_date' = date->(format: '%Q %T');
								/inline;
								inline: -log=$__startup_loglevel__,
										-update = '',
										-database = 'site',
										-table = 'smtp_queue',
										-keyfield = 'id',
										-keyvalue = (field: 'id'),
										-maxrecords=0,
										'queue_status' = 'sending';
								/inline;
							/iterate;

							if: ((Global: '__SMTP_Stage_Status__') !>> 'Abort') && ((Global: '__SMTP_Stage_Status__') !>> 'Pause') && ((Global: '__SMTP_Stage_Status__') !>> 'Refresh');
								Global: '__SMTP_Stage_Status__' = 'Active';
							/if;

						/records;
					/resultset;
					
				}->(run: -params=(array: #prefs));
													
					handle_error;
						log_critical: 'SMTP: Unhandled Error (1): ' + error_msg + ' (' + error_code + ')';
					/handle_error;
	
				/Protect;
							
				// If the status hasn't been changed while we were running then sleep;
				if: ((Global: '__SMTP_Queue_Status__') >> 'Awake');
					// Check for unsent messages
					inline: -log=$__startup_loglevel__,
							-database='site',
							-table='smtp_queue',
							-sql='SELECT id FROM smtp_queue \
								WHERE \
									queue_status = "queued" AND \
									queue_date < datetime("now","localtime") AND \
									mime_text <> "" AND \
									mime_from <> "" AND \
									mime_recipients <> "" \
								LIMIT 1',
							-maxrecords='all';
						if: (found_count) > 0;
							global: '__SMTP_Queue_Status__' = 'Active';
						else;
							// Delay Between Active Checks
							inline: -log=$__startup_loglevel__,
									-database='site',
									-table='smtp_queue',
									-sql='SELECT queue_date FROM smtp_queue \
										WHERE \
											queue_status = "queued" \
										ORDER BY queue_date \
										LIMIT 1';
								global: '__SMTP_Queue_Status__' = 'Sleep';
								global: '__SMTP_Queue_Sleep__' = (date_add: date, -hour=1);
								if: ((found_count) > 0) && ((field: 'queue_date') != '');
									if: (date: (field: 'queue_date')) < (date_add: date, -hour=1);
										global: '__SMTP_Queue_Sleep__' = (date: (field: 'queue_date'));
									/if;
								/if;
							/inline;
							(global('__mail_debug__') == true) ? log_always('MAIL QUEUE SLEEP ' + (Global: '__SMTP_Queue_Sleep__'));
							Sleep: ((math_range: (integer: #prefs->(find: 'lasso_smtp_sweep_delay')), 1, 3600) * 1000); 
						/if;
					/inline;
					
				else;
					(global('__mail_debug__') == true) ? log_always('MAIL QUEUE ' + (Global: '__SMTP_Queue_Status__'));			
				/if;
				
			/While;
			
			Log_Warning: 'SMTP: Stopping Email Queue';	
	
			handle_error;
				log_critical: 'SMTP: Unhandled Error (2): ' + error_msg + ' (' + error_code + ')';
			/handle_error;

		/Protect;

	}->(AsAsync: -Name='SMTP: Email Queue (Main)'); 

	{

		Protect;
												
			Define_Tag: 'getprefs';
				Local: 'prefs' = (map: 
						'lasso_smtp_pause' = 'N',
						'lasso_smtp_host' = '',
						'lasso_smtp_port' = 25,
						'lasso_smtp_username' = '',
						'lasso_smtp_password' = '',
						'lasso_smtp_timeout' = 15,
						'lasso_smtp_keep_error' = 'Y',
						'lasso_smtp_keep_success' = 'N',
						'lasso_smtp_keep_mime' = 'N',
						'lasso_smtp_sweep_delay' = 5,
						'lasso_smtp_resend_delay' = 600,
						'lasso_smtp_mxretry_delay' = 600,
						'lasso_smtp_max_retries' = 5,
						'lasso_smtp_queue_count' = 4,
						'lasso_smtp_queue_size' = 100,
						'lasso_smtp_lassoservice_ip' = '',
						'lasso_smtp_sendmode' = 'direct',
						'lasso_smtp_ignorehost' = 'N',
						'lasso_smtp_usessl' = 'N',
					);					
				Local: 'prefs' = (admin_getpref: #prefs);
				if: (#prefs->(find: 'lasso_smtp_pause') >> 'Y');
					Global: '__SMTP_Stage_Status__'='Pause';
				else;
					Global: '__SMTP_Stage_Status__'='Active';
				/if;
				if: (#prefs->(find: 'lasso_smtp_lassoservice_ip') != '');
					Global: '__SMTP_IP__' = #prefs->(find: 'lasso_smtp_lassoservice_ip');
				else: (Global: '__lassoservice_ip__') != '';
					Global: '__SMTP_IP__' = (Global: '__lassoservice_ip__');
				else;
					Global: '__SMTP_IP__' = '127.0.0.1';
				/if;
				(global('__mail_debug__') == true) ? log_always('STAGE PREFS ' + #prefs);
				Return: @#prefs;
			/Define_Tag;

			Local: 'prefs' = getprefs;
				
			// One Cycle Delay at Startup
			global: '__SMTP_Stage_Status__' = 'Abort';
			Sleep: ((math_range: (integer: #prefs->(find: 'lasso_smtp_sweep_delay')), 1, 3600) * 1000); 
			Global: '__SMTP_Stage_Status__' = 'Refresh';
			
			While: ((Global: '__SMTP_Stage_Status__') != 'Abort');
	
				If: ((Global: '__SMTP_Stage_Status__') >> 'Refresh');
					Log_Detail: 'SMTP: Refreshing SMTP Preferences.';
					Local: 'prefs' = getprefs;
				/If;

				If: ((Global: '__SMTP_Stage_Status__') >> 'Pause') || ((Global: '__SMTP_Stage_Status__') >> 'Stop');
					Sleep: ((math_range: (integer: #prefs->(find: 'lasso_smtp_sweep_delay')), 1, 3600) * 1000); 
					Loop_Continue;
				else: ((Global: '__SMTP_Stage_Status__') >> 'Sleep') && (!(Global: '__SMTP_Stage_Sleep__')->(isa: 'date') || ((Global: '__SMTP_Stage_Sleep__') > Date));
					Sleep: ((math_range: (integer: #prefs->(find: 'lasso_smtp_sweep_delay')), 1, 3600) * 1000); 
					Loop_Continue;
				/if;
				
				Global: '__SMTP_Stage_Status__' = 'Awake';

				Error_Reset;
				
				Protect;

					// Queue Operations
					if: ((global: '__SMTP_Queues__')->size < (math_range: (integer: #prefs->(find: 'lasso_smtp_queue_count')), 1, 25));
						local: 'sql' = '';
						inline: -log=$__startup_loglevel__,
								-database='site',
								-table='smtp_stage',
								-sql='SELECT * FROM smtp_stage \
									WHERE \
										queue_status = "queued" AND \
										queue_number = 0 AND \
										queue_date < datetime("now","localtime") \
									ORDER BY queue_priority \
									LIMIT 1';
							if: (found_count > 0);
								local: 'sql' = 'SELECT id FROM smtp_stage \
										WHERE \
											queue_status = "queued" AND \
											queue_date < datetime("now","localtime") AND \
											queue_number = 0 AND \
											smtp_host = "' + (field: 'smtp_host') + '" AND \
											smtp_port = "' + (field: 'smtp_port') + '" AND \
											smtp_username = "' + (field: 'smtp_username') + '" AND \
											smtp_password = "' + (field: 'smtp_password') + '" \
										ORDER BY queue_priority, queue_date \
										LIMIT ' + (math_range: (integer: #prefs->(find: 'lasso_smtp_queue_size')), 1, 200);
							/if;
						/inline;
							
						if: (#sql != '');
							local: 'number' = (integer: (global: '__SMTP_Number__')) + 1;
							global: '__SMTP_Number__' = #number;
						
							inline: -log=$__startup_loglevel__,
									-database='site',
									-table='smtp_stage',
									-sql=#sql;
								local: 'ids' = (array);
								records;
									#ids->(insert: (field: 'id'));
								/records;
								inline: -log=$__startup_loglevel__,
										-database='site',
										-table='smtp_stage',
										-sql='UPDATE smtp_stage \
											SET queue_number = ' + #number + ' \
											WHERE id IN (' + #ids->(join: ',') + ')';
								/inline;
							/inline;
							
								// Queue Object
								{

									Define_Tag: 'error_clean';
										return: (string_replaceregexp: (string_replaceregexp: error_msg, -find='at:[\\w\\W]+', -replace=''), -find='\\s+', -replace=' ')->trim & + (error_msg >> error_code ? '' | ' (' + error_code + ')');
									/Define_tag;

									Protect;
									
										local: 'number' = params->first;
										local: 'prefs' = params->second;
										local: 'makeactive' = false;
										
										(global: '__SMTP_Queues__')->(insert: #number = (date));
										
										inline: -log=$__startup_loglevel__,
												-database='site',
												-table='smtp_stage',
												-sql='SELECT * FROM smtp_stage \
													WHERE \
														queue_status = "queued" AND \
														queue_date < datetime("now","localtime") AND \
														queue_number = "' + #number + '" \
													ORDER BY mime_recipients',
												-maxrecords='all',
												-inlinename='mail_queue';
										/inline;
										
										resultset: -inlinename='mail_queue';
										
											if: (found_count > 0);
											
												local: 'continue' = true;
												local: 'sendmode' = #prefs->(find: 'lasso_smtp_sendmode');

												// Open SMTP connection
												if: ((field: 'smtp_host') != '');
													// Use all field values if host is set
													local: 'smtp_host' = (field: 'smtp_host');
													local: 'smtp_port' = (field: 'smtp_port');
													local: 'smtp_username' = (field: 'smtp_username');
													local: 'smtp_password' = (field: 'smtp_password');
													local: 'smtp_timeout' = (if_empty: (field: 'smtp_timeout'), #prefs->(find: 'lasso_smtp_timeout'));
													local: 'smtp_ssl' = (if_empty: (field: 'smtp_ssl'), #prefs->(find: 'lasso_smtp_usessl'));
												else: (#sendmode >> 'local') || (#sendmode >> 'fallback');
													// Otherwise use all preference values
													local: 'smtp_host' = #prefs->(find: 'lasso_smtp_host');
													local: 'smtp_port' = #prefs->(find: 'lasso_smtp_port');
													local: 'smtp_username' = #prefs->(find: 'lasso_smtp_username');
													local: 'smtp_password' = #prefs->(find: 'lasso_smtp_password');
													local: 'smtp_timeout' = #prefs->(find: 'lasso_smtp_timeout');
													local: 'smtp_ssl' = #prefs->(find: 'lasso_smtp_usessl');
												/if;
												
												// Reality Check
												if: ((integer: (local: 'smtp_port')) <= 0);
													local: 'smtp_port' = 25;
												/if;
												if: ((integer: (local: 'smtp_timeout')) <= 0);
													local: 'smtp_timeout' = 15;
												/if;
												
												if: ((local: 'smtp_host') == '');
													local: 'continue' = false;
													if: (#sendmode >> 'local');
														local: 'smtp_error' = 'SMTP: [' + #number + '] No -Host specified and Lasso is not configured with a default local SMTP server.';
													else: (#sendmode >> 'fallback');
														local: 'smtp_error' = 'SMTP: [' + #number + '] MX record not found and Lasso is not configured with a default host for ' + (field: 'mime_recipients') + '.';
													else;
														local: 'smtp_error' = 'SMTP: [' + #number + '] MX record not found for direct send for ' + (field: 'mime_recipients') + '.';
													/if;
													local: 'makeactive' = true;
													log_critical: #smtp_error;
												/if;
												
												if: (#continue == true);
													if: (found_count == 1);
														Log_Detail: 'SMTP: [' + #number + '] Sending 1 email message to host ' + (local: 'smtp_host') + '.';
													else;
														Log_Detail: 'SMTP: [' + #number + '] Sending ' + (found_count) + ' email messages to host ' + (local: 'smtp_host') + '.';
													/if;
												/if;
												
												if: (#continue == true);
													error_reset;
													protect;
														local: 'smtp' = (email_smtp);
														handle_error;
															local: 'continue' = false;
															local: 'smtp_error' = 'SMTP: [' + #number + '] Failed to initialize SMTP connector.';
															local: 'makeactive' = true;
															log_critical: #smtp_error;
														/handle_error;
													/protect;
												/if;
												if: (#continue == true);
													error_reset;
													protect;
														if: (#smtp_username != '') && (#smtp_password != '');
															#smtp->(open: -host=#smtp_host, -port=(integer: #smtp_port), -username=#smtp_username, -password=#smtp_password, -timeout=(integer: #smtp_timeout), -ssl=(#smtp_ssl >> 'Y'));
														else;
															#smtp->(open: -host=#smtp_host, -port=(integer: #smtp_port), -timeout=(integer: #smtp_timeout), -ssl=(#smtp_ssl >> 'Y'));
														/if;
														handle_error;
															local: 'continue' = false;
															local: 'smtp_error' = 'SMTP: [' + #number + '] Failed to connect to host "' + #smtp_host + '".';
															local: 'makeactive' = true;
															log_critical: #smtp_error;
														/handle_error;
													/protect;
												/if;
												records;
													// default values
													local: 'queue_status' = 'queued';
													local: 'queue_retries' = (integer: (field: 'queue_retries'));
													local: 'queue_error' = '';
													local: 'queue_code' = 0;
													local: 'queue_date' = date->(format: '%Q %T');
													local: 'queue_severity' = '';
													
													// Send each message
													if: ((field: 'mime_from') == '');
														local: 'queue_status' = 'error';
														local: 'queue_error' = 'Message does not have a valid from address.';
														local: 'queue_severity' = 'fatal';
														local: 'queue_retries' = 0;
													else: ((field: 'mime_recipients') == '');
														local: 'queue_status' = 'error';
														local: 'queue_error' = 'Message does not have any valid recipients.';
														local: 'queue_severity' = 'fatal';
														local: 'queue_retries' = 0;
													else: ((field: 'mime_text') == '');
														local: 'queue_status' = 'error';
														local: 'queue_error' = 'Message does not have a valid body or parts.';
														local: 'queue_severity' = 'fatal';
														local: 'queue_retries' = 0;
													else: (#continue == true);
														error_reset;
														protect;
															local: 'message' = (field: 'mime_text');
															#message += '\r\n';
															#smtp->(send: -from=(field: 'mime_from'), -recipients=(field: 'mime_recipients')->(split: ','), -message=#message);
															local: 'queue_status' = 'sent';
															handle_error;
																if: ((string: error_msg) >> 'SMTP') && 
																		( ((integer: error_code) != -8001) && ( ((integer: error_code) < 100) || ((integer: error_code) == 221) || ((integer: error_code) == 421) ) );
																	// 221 and 421 signal the connection is closing
																	// Two digit and negative error codes are internal
																	local: 'continue' = false;
																	local: 'smtp_error' = 'SMTP: [' + #number + '] Host "' + #smtp_host + '" terminated connection. ' + error_clean;
																	local: 'makeactive' = true;
																	log_warning: #smtp_error;
																else: ((string: error_msg) >> 'SMTP') && 
																		( ((integer: error_code) != -8001) && ( ((integer: error_code) < 400) || ((integer: error_code) >= 500) ) );
																	local: 'queue_status' = 'error';
																	local: 'queue_retries'= #queue_retries - 1;
																	local: 'queue_error' = error_clean;
																	local: 'queue_code' = error_code;
																	local: 'queue_severity' = 'fatal';
																	local: 'queue_date' = (date)->(format: '%Q %T');
																	log_warning: 'SMTP: [' + #number + '] ' + #queue_error;
																	#smtp->(command: 'RSET\r\n', -expect=250);
																else;
																	// -8001 and 400 Error Codes are Warnings
																	local: 'queue_status' = 'queued';
																	local: 'queue_retries'= #queue_retries - 1;
																	local: 'queue_error' = error_clean;
																	local: 'queue_code' = error_code;
																	local: 'queue_severity' = 'warning';
																	local: 'queue_date' = (date_add: #queue_date, -second=(math_range: (integer: #prefs->(find: 'lasso_smtp_resend_delay')), 60, 3600))->(format: '%Q %T');
																	log_warning: 'SMTP: [' + #number + '] ' + #queue_error;
																	local: 'makeactive' = true;
																	if: (integer: error_code) == -8001;
																		local: 'continue' = false;
																	else;
																		#smtp->(command: 'RSET\r\n', -expect=250);
																	/if;
																/if;
															/handle_error;
														/protect;
													/if;
													
													// Shut SMTP connection if we don't need it
													if: (local: 'continue') == false;
														protect;
															if: (local_defined: 'smtp');
																#smtp->close;
																local_remove: 'smtp';
															/if;
														/protect;
													/if;
													
													// Handle general SMTP errors
													if: (local_defined: 'smtp_error');
														local: 'queue_status' = 'queued';
														local: 'queue_retries'= #queue_retries - 1;
														local: 'queue_error' = #smtp_error;
														local: 'queue_severity' = 'warning';
														local: 'queue_date' = (date_add: #queue_date, -second=(math_range: (integer: #prefs->(find: 'lasso_smtp_resend_delay')), 60, 3600))->(format: '%Q %T');
														local: 'makeactive' = true;
														
														// Clear SMTP Error (remaining messages will requeue with no error)
														if: (found_count - loop_count > 0);
															log_warning: 'SMTP: [' + #number + '] Requeuing ' + (found_count - loop_count) + ' messages after error.';
														/if;
														local_remove: 'smtp_error';
													/if;
													
													// Decide if we want to delete the message or not
													if: (#queue_retries <= 0);
														local: 'queue_status' = 'error';
													/if;
													
													local: 'inline' = (array:
															-update = '',
															-database='site',
															-table='smtp_stage',
															-keyfield='id',
															-keyvalue=(field: 'id'),
															-maxrecords=0,
															'queue_status' = #queue_status,
															'queue_date' = #queue_date,
															'queue_retries' = #queue_retries,
															'queue_error' = #queue_error,
															'queue_number' = 0,
														);
													
													if: (#queue_error != '');
														inline: -log=$__startup_loglevel__,
																-add = '',
																-database='site',
																-table='smtp_error',
																-keyfield='id',
																-maxrecords=0,
																'id_queue'=(field: 'id'),
																'id_email'=(field: 'id_email'),
																'id_cache'=(field: 'id_cache'),
																'id_route'=(field: 'id_route'),
																'error' = #queue_error,
																'code' = #queue_code,
																'severity' = #queue_severity,
																'datetime' = date->(format: '%Q %T');
														/inline;
													/if;
																										
													if: ((#queue_status == 'error') && (#prefs->(find: 'lasso_smtp_keep_error') >> 'N')) ||
														((#queue_status == 'sent') && (#prefs->(find: 'lasso_smtp_keep_success') >> 'N'));
														
														inline: -log=$__startup_loglevel__,
																-database='site',
																-SQL='UPDATE smtp_error SET id_queue = 0 WHERE id_queue = ' + (integer: (field: 'id')) + '; \
																	  DELETE FROM smtp_stage WHERE id = ' + (integer: (field: 'id')) + ';';
														/inline;
													
													else: (#queue_status == 'sent') && (#prefs->(find: 'lasso_smtp_keep_mime') >> 'N');
													
														#inline->(insert: 'mime_text' = (string_replaceregexp: (field: 'mime_text'), -find='\r\n\r\n[\\S\\s]*', -replace='\r\n\r\n'));
														
													/if;
														
													inline: -log=$__startup_loglevel__,
															#inline;
													/inline;
														
												/records;
												
												protect;
													if: (local_defined: 'smtp');
														#smtp->close;
														local_remove: 'smtp';
													/if;
												/protect;
											/if;
										
										/resultset;
									
										handle: (local_defined: 'smtp');
											protect;
												#smtp->'net'->close;
											/protect;
										/handle;
										
										(global: '__SMTP_Queues__')->(removeall: #number);
										
										Log_Detail: 'SMTP: [' + #number + '] Done sending messages.';
										
										if: ((Global: '__SMTP_Queue_Status__') !>> 'Abort') && ((Global: '__SMTP_Queue_Status__') !>> 'Pause') && ((Global: '__SMTP_Queue_Status__') !>> 'Refresh');
											Global: '__SMTP_Queue_Status__' = 'Active';
										/if;

										if: (#makeactive == true) && ((Global: '__SMTP_Stage_Status__') !>> 'Pause') && ((Global: '__SMTP_Stage_Status__') !>> 'Stop') && ((Global: '__SMTP_Stage_Status__') !>> 'Refresh');
											global: '__SMTP_Stage_Status__' = 'Active';
										/if;
										
										handle_error;
											log_critical: 'SMTP: [' + #number + '] Unhandled Error (3): ' + error_msg + ' (' + error_code + ')';
										/handle_error;
										
									/Protect;
									
								}->(AsAsync: -Params=(array: #number, #prefs), -Name=('SMTP: SMTP Queue (#' + #number + ')'));
							
						/if;
					/if;
					
					// If the status hasn't been changed while we were running then sleep;
					if: ((Global: '__SMTP_Stage_Status__') >> 'Awake') && ((Global: '__SMTP_Stage_Status__') !>> 'Pause') && ((Global: '__SMTP_Stage_Status__') !>> 'Stop');
						// Check for unsent messages
						inline: -log=$__startup_loglevel__,
								-database='site',
								-table='smtp_stage',
								-sql='SELECT id FROM smtp_stage \
									WHERE \
										queue_status = "queued" AND \
										queue_number = 0 AND \
										queue_date <= datetime("now","localtime") \
									LIMIT 1';
							if: (found_count) > 0;
								global: '__SMTP_Stage_Status__' = 'Active';
							else;
								inline: -log=$__startup_loglevel__,
										-database='site',
										-table='smtp_stage',
										-sql='SELECT queue_date FROM smtp_stage \
											WHERE \
												queue_status = "queued" AND \
												queue_number = 0 \
											ORDER BY queue_date \
											LIMIT 1';
									global: '__SMTP_Stage_Status__' = 'Sleep';
									global: '__SMTP_Stage_Sleep__' = (date_add: date, -hour=1);
									if: ((found_count) > 0) && ((field: 'queue_date') != '');
										if: (date: (field: 'queue_date')) < (date_add: date, -hour=1);
											global: '__SMTP_Stage_Sleep__' = (date: (field: 'queue_date'));
										/if;
									/if;
								/inline;
							/if;
						/inline;
					/if;
					handle_error;
						log_critical: 'SMTP: Unhandled Error (4): ' + error_msg + ' (' + error_code + ')';
					/handle_error;
	
				/Protect;
							
				(global('__mail_debug__') == true) ? log_always('STAGE QUEUE ' + (Global: '__SMTP_Stage_Status__'));			

				// Delay Between Active Checks
				Sleep: ((math_range: (integer: #prefs->(find: 'lasso_smtp_sweep_delay')), 1, 3600) * 1000); 
				
			/While;
			
			Log_Warning: 'SMTP: Stopping SMTP Queue';	
	
			handle_error;
				log_critical: 'SMTP: Unhandled Error (5): ' + error_msg + ' (' + error_code + ')';
			/handle_error;

		/Protect;

	}->(AsAsync: -Name='SMTP: SMTP Queue (Main)'); 
?>
