<?LassoScript

	{
		
		Error_Reset;
		
		Protect;
		
			Log_Warning: 'SMTP: Initializing Email Queue';
		
			// Check if the table exists
			Local: 'table_smtp_queue_exists' = false;
			Local: 'table_smtp_queue_alter' = false;
			Local: 'table_smtp_route_exists' = false;
			Local: 'table_smtp_cache_exists' = false;
			Local: 'table_smtp_error_exists' = false;
			Local: 'table_smtp_stage_exists' = false;
			
			Inline: -log=$__startup_loglevel__,
					-Database='site',
					-SQL='SELECT name,sql from sqlite_master WHERE type="table" AND name LIKE "smtp_%"';
				records;
					if: (field: 'name') == 'smtp_queue';
						local: 'table_smtp_queue_exists' = true;
						local: 'table_smtp_queue_alter' = (((field: 'sql') !>> 'merge_tokens') || ((field: 'sql') !>> 'merge_array') || ((field: 'sql') !>> 'smtp_ssl'));
					else: (field: 'name') == 'smtp_route';
						local: 'table_smtp_route_exists' = true;
					else: (field: 'name') == 'smtp_cache';
						local: 'table_smtp_cache_exists' = true;
					else: (field: 'name') == 'smtp_error';
						local: 'table_smtp_error_exists' = true;
					else: (field: 'name') == 'smtp_stage';
						local: 'table_smtp_stage_exists' = true;
						local: 'table_smtp_stage_alter' = ((field: 'sql') !>> 'smtp_ssl');
					/if;
				/records;
			/Inline;

			if: #table_smtp_queue_exists == true;
				
				// Delete all records that are marked as non-restart or are past end date
				Inline: -log=$__startup_loglevel__,
						-Database='site',
						-table='smtp_queue',
						-SQL='DELETE FROM smtp_queue WHERE queue_status="delete"';
				/Inline;
				
				// Update all records with empty queue_number
				Inline: -log=$__startup_loglevel__,
						-Database='site',
						-table='smtp_queue',
						-SQL='UPDATE smtp_queue SET queue_number=0';
				/Inline;
			/if;

			if: #table_smtp_queue_exists == false || #table_smtp_queue_alter == true;
				
				local: 'temp_name' = 'email_' + lasso_uniqueid;				
				inline: -database='site', -sql='BEGIN TRANSACTION';
					if: #table_smtp_queue_alter == true;
						inline: -log=$__startup_loglevel__, -database='site', -sql='CREATE TEMPORARY TABLE ' + #temp_name + ' AS SELECT * FROM smtp_queue';
						/inline;			
						inline: -log=$__startup_loglevel__, -database='site', -sql='DROP TABLE smtp_queue';
						/inline;
					/if;
					// Create table
					var: '__need_reload__' = true;
					Inline: -log=$__startup_loglevel__,
							-Database='site',
							-SQL='CREATE TABLE smtp_queue \
							(\
								id INTEGER, \
								
								id_site INTEGER, \
								id_route INTEGER, \
								id_cache INTEGER, \
								
								mime_text TEXT, \
								mime_recipients TEXT, \
								mime_from TEXT, \
								
								smtp_host TEXT, \
								smtp_port INTEGER DEFAULT 25, \
								smtp_timeout INTEGER DEFAULT 15, \
								smtp_username TEXT, \
								smtp_password TEXT, \
								smtp_ssl TEXT, \
								
								queue_date TEXT, \
								queue_status TEXT, \
								queue_error TEXT, \
								queue_number INTEGER DEFAULT 0, \
								queue_priority INTEGER DEFAULT 0, \
								queue_retries INTEGER DEFAULT 0, \
								
								merge_array TEXT, \
								merge_tokens TEXT, \
								
								create_date TEXT, \
								PRIMARY KEY (id) \
							)';
					/Inline;
					if: #table_smtp_queue_alter == true;
						inline: -log=$__startup_loglevel__, -database='site', -sql='INSERT INTO smtp_queue (mime_text,mime_recipients,mime_from,smtp_host,smtp_port,smtp_timeout,smtp_username,smtp_password,queue_date,queue_status,queue_error,queue_number,queue_priority,queue_retries,create_date) SELECT mime_text,mime_recipients,mime_from,smtp_host,smtp_port,smtp_timeout,smtp_username,smtp_password,queue_date,queue_status,queue_error,queue_number,queue_priority,queue_retries,create_date FROM ' + #temp_name;
						/inline;
						inline: -log=$__startup_loglevel__, -database='site', -sql='DROP TABLE ' + #temp_name;
						/inline;
					/if;
					inline: -log=$__startup_loglevel__, -database='site', -sql='COMMIT TRANSACTION';
					/inline;
				/inline;
			/if;

			if: #table_smtp_stage_exists == false || #table_smtp_queue_alter == true;
				
				local: 'temp_name' = 'email_' + lasso_uniqueid;				
				inline: -database='site', -sql='BEGIN TRANSACTION';
					if: #table_smtp_queue_alter == true;
						inline: -log=$__startup_loglevel__, -database='site', -sql='CREATE TEMPORARY TABLE ' + #temp_name + ' AS SELECT * FROM smtp_stage';
						/inline;			
						inline: -log=$__startup_loglevel__, -database='site', -sql='DROP TABLE smtp_stage';
						/inline;
					/if;

					// Create table
					var: '__need_reload__' = true;
					Inline: -log=$__startup_loglevel__,
							-Database='site',
							-SQL='CREATE TABLE smtp_stage \
							(\
								id INTEGER, \
								
								id_site INTEGER, \
								id_email INTEGER, \
								id_route INTEGER, \
								id_cache INTEGER, \
								
								mime_text TEXT, \
								mime_recipients TEXT, \
								mime_from TEXT, \
								
								smtp_host TEXT, \
								smtp_port INTEGER DEFAULT 25, \
								smtp_timeout INTEGER DEFAULT 15, \
								smtp_username TEXT, \
								smtp_password TEXT, \
								smtp_ssl TEXT, \
								
								queue_date TEXT, \
								queue_status TEXT, \
								queue_error TEXT, \
								queue_number INTEGER DEFAULT 0, \
								queue_priority INTEGER DEFAULT 0, \
								queue_retries INTEGER DEFAULT 0, \
								
								create_date TEXT, \
								PRIMARY KEY (id) \
							)';
					/Inline;
					if: #table_smtp_queue_alter == true;
						inline: -log=$__startup_loglevel__, -database='site', -sql='INSERT INTO smtp_stage (mime_text,mime_recipients,mime_from,smtp_host,smtp_port,smtp_timeout,smtp_username,smtp_password,queue_date,queue_status,queue_error,queue_number,queue_priority,queue_retries,create_date) SELECT mime_text,mime_recipients,mime_from,smtp_host,smtp_port,smtp_timeout,smtp_username,smtp_password,queue_date,queue_status,queue_error,queue_number,queue_priority,queue_retries,create_date FROM ' + #temp_name;
						/inline;
						inline: -log=$__startup_loglevel__, -database='site', -sql='DROP TABLE ' + #temp_name;
						/inline;
					/if;
					inline: -log=$__startup_loglevel__, -database='site', -sql='COMMIT TRANSACTION';
					/inline;
				/inline;

			/if;

			if: #table_smtp_error_exists == false;
				// Create table
				var: '__need_reload__' = true;
				Inline: -log=$__startup_loglevel__,
						-Database='site',
						-SQL='CREATE TABLE smtp_error \
						(\
							id INTEGER, \
							
							id_email INTEGER, \
							id_queue INTEGER, \
							id_route INTEGER, \
							id_cache INTEGER, \
							
							code TEXT, \
							error TEXT, \
							severity TEXT, \
							
							datetime TEXT, \
							PRIMARY KEY (id) \
						)';
				/Inline;
			/if;

			if: #table_smtp_route_exists == false;
				// Create table
				var: '__need_reload__' = true;
				Inline: -log=$__startup_loglevel__,
						-Database='site',
						-SQL='CREATE TABLE smtp_route \
						(\
							id INTEGER, \
							domain TEXT, \
							host TEXT, \
							port INTEGER, \
							retry INTEGER, \
							timeout INTEGER, \
							username TEXT, \
							password TEXT, \
							ssl TEXT, \
							priority INTEGER, \
							comment TEXT, \
							datetime TEXT, \
							PRIMARY KEY (id) \
						)';
				/Inline;
			/if;

			if: #table_smtp_cache_exists == false;
				// Create table
				var: '__need_reload__' = true;
				Inline: -log=$__startup_loglevel__,
						-Database='site',
						-SQL='CREATE TABLE smtp_cache \
						(\
							id INTEGER, \
							id_route INTEGER, \
							domain TEXT, \
							host TEXT, \
							port INTEGER, \
							retry INTEGER, \
							timeout INTEGER, \
							username TEXT, \
							password TEXT, \
							ssl TEXT, \
							priority INTEGER, \
							datetime TEXT, \
							PRIMARY KEY (id) \
						)';
				/Inline;
			/if;

			handle_error;
				log_critical: 'SMTP: Table Creation Error: ' + error_msg + ' (' + error_code + ')';
			/handle_error;
		
		/protect;

	}->(Run);

?>
