<?LassoScript
	// This startup script is enclosed in a compound expression so the variables will not
	// show up in the list of global variables.
	// It is run asynchronously to speed up start up.

	{
	
		Log_Warning: 'Lasso Errors: Setting User Preferences';

		inline: -search,
				-log=$__startup_loglevel__, 
				-database='lasso_internal', 
				-table='global_prefs', 
				-op='bw', 'store_key'='log';
			if: (found_count == 0);
				log_setdestination: log_level_critical, log_destination_file, log_destination_database, log_destination_console;
				log_setdestination: log_level_warning, 0, 0, log_destination_console;
				log_setdestination: log_level_detail, 0, 0, log_destination_console;
				log_setdestination: log_level_deprecated, 0, 0, log_destination_console;
				log_setdestination: log_level_sql, 0, 0, log_destination_console;
			else;
				records;
					local: 'key' = (integer: (field: 'data'));
					local: 'console' = (#key->(bittest: 1) ? log_destination_console | 0);
					local: 'file' = (#key->(bittest: 2) ? log_destination_file | 0);
					local: 'database' = (#key->(bittest: 3) ? log_destination_database | 0);
	
					if: (field: 'store_key') == 'log_critical_dest';
						log_setdestination: log_level_critical, #file, #database, #console;
					else: (field: 'store_key') == 'log_warning_dest';
						log_setdestination: log_level_warning, #file, #database, #console;
					else: (field: 'store_key') == 'log_detail_pref';
						log_setdestination: log_level_detail, #file, #database, #console;
					else: (field: 'store_key') == 'log_deprecated_pref';
						log_setdestination: log_level_deprecated, #file, #database, #console;
					else: (field: 'store_key') == 'log_sql_pref';
						log_setdestination: log_level_sql, #file, #database, #console;
					/if;
				/records;
			/if;

		/inline;
				
	}->(asasync);
	
?>