<?lassoscript

	// This file creates a stub [Image] data type iff the ImageMagick module failed to load.
	if: ((Lasso_TagExists: 'Image') == false);
		{
			Local: 'path' = admin_lassoservicepath;
			Local: 'server_path' = #path + '/../../LassoModules/';
			Local: 'site_path' = #path + '/LassoModules/';
			If: ( ((File_ListDirectory: #server_path)->(Join: ', ') >> 'ImageTag') ||
					((File_ListDirectory: #site_path)->(Join: ', ') >> 'ImageTag') );
				Log_Critical: 'Image: The image tags have not loaded. This is usually due to ImageMagick or X11 not being installed.';
			/If;
		}->(Run);
		Define_Tag: 'Image';
			Log_Warning: 'Image: The image tags have not loaded. This is usually due to ImageMagick or X11 not being installed.';
			Fail: -9951, 'Image: The image tags have not loaded. This is usually due to ImageMagick or X11 not being installed.';
		/Define_Tag;
	/If;

	// This file creates a stub [OS_Process] data type iff the OS Process module failed to load.
	if: ((Lasso_TagExists: 'OS_Process') == false);
		Define_Tag: 'OS_Process';
			Log_Warning: 'OS_Process: The OS Process tags module is not installed.';
			Fail: -9951, 'OS_Process: The OS Process tags module is not installed.';
		/Define_Tag;
	/If;

?>