<?LassoScript

// Populate the security_tags table for site 0

{

	local: 'tags_category' = (array:
		'Administration' = (array: 'Admin_CreateUser','Admin_GroupAssignUser','Admin_GroupRemoveUser','Admin_GroupListUsers','Admin_ChangeUser','Admin_ListGroups'),
		'Database' = (array: 'Database_ChangeField','Database_CreateField','Database_CreateTable','Database_RemoveField','Database_RemoveTable'),
		'File' = (array: 'File','File_Copy','File_Create','File_CreationDate','File_CurrentError','File_Delete','File_Exists','File_GetLineCount','File_GetSize','File_IsDirectory','File_ListDirectory','File_ModDate','File_Move','File_Read','File_ReadLine','File_Rename','File_SetSize','File_Write'),
		'Include' = (array: 'Include','Include_URL','Include_Raw','Library'),
		'Technical' = (array: 'Lasso_ExecutionTimeLimit','LassoApp_Create','LassoApp_Dump','LassoApp_List','Process','Sleep','Net'),
		'Utility' = (array: 'Cache','Email_Immediate','Email_Pop','Email_Send','Event_Schedule','Log','Log_Critical','Log_Deprecated','Log_Detail','Log_SQL','Log_Warning'),
	);
	
	local: 'tags_alias' = (array:
		'Database_ChangeField' = (array: 'Database_ChangeColumn'),
		'Database_CreateField' = (array: 'Database_CreateColumn'),
		'Database_RemoveField' = (array: 'Database_RemoveColumn'),
		'File_ListDirectory' = (array: 'Directory_Lister','Directory_NameItem','DirectoryNameItem'),
		'Net' = (array: 'TCP_Close','TCP_Open','TCP_Send'),
		'Cache' = (array: 'Cache_Store','Cache_Fetch','Cache_Object'),
	);
	
	local: 'tags' = (array);
	local: 'temp_array' = #tags_category;
	#temp_array->(merge: #tags_alias);
	iterate: #temp_array, (local: 'item');
		#tags->(merge: #item->second);
	/iterate;

	if: (site_id == 0);
	
		local: 'sql' = 'SELECT DISTINCT name FROM security_tags';
		inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=#sql, -maxrecords='all';
			records;
				#tags->(removeall: (field: 'name'));
			/records;
	
			if: #tags->size > 0;
		
				local: 'inserts' = (array);
				iterate: #tags, (local: 'tag');
					#inserts->(insert: 'INSERT INTO security_tags (name, id_site, enabled) VALUES ' + '(\'' + #tag + '\',' + site_id + ',\'Y\');');
				/iterate;
				
				if: #inserts->size > 0;
					inline: -database='lasso_internal', 
							-table='security_tags', 
							-log=$__startup_loglevel__,
							-sql='BEGIN TRANSACTION; ' + #inserts->(join: ' ') + ' COMMIT TRANSACTION;';
					/inline;
					_security_flushcaches;
				/if;
				
			/if;
		
		/inline;
	
	else;

		define_tag: 'tag_id', -required='name';
			local: 'tag' = (tags_find: #name);
			if: #tag->(isa: 'tag');
				return: #tag->id;
			else;
				log_warning: 'Tag Security: [' + #name + '] not found';
			/if;
			return: 0;
		/define_tag;
	
		local: 'tags_ids' = array;
		iterate: #tags, (local: 'tag');
			local: 'id' = (tag_id: #tag);
			if: #id > 0;
				#tags_ids->(insert: #id);
			/if;
		/iterate;
		
		local: 'sql' = 'SELECT id_tag FROM security_group_tag_map WHERE id_group=1';
		inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=#sql, -maxrecords='all';
			records;
				#tags_ids->(removeall: (field: 'id_tag'));
			/records;
		/inline;
	
		local: 'inserts' = (array);
		iterate: #tags_ids, (local: 'id');
			#inserts->(insert: 'INSERT INTO security_group_tag_map (id_group,id_tag,allow_exec) VALUES (1,' + (integer: #id) + ',"Y");');
		/iterate;

		if: #inserts->size > 0;
			inline: -database='lasso_internal', 
					-table='security_group_tag_map', 
					-log=$__startup_loglevel__,
					-sql='BEGIN TRANSACTION; ' + #inserts->(join: ' ') + ' COMMIT TRANSACTION;';
			/inline;
			_security_flushcaches;
		/if;
	
	/if;

}->run;

?>