[
	define_type: 'bigint', -prototype;
		local: 'value' = (array);
		local: 'base' = 1000000000;
		local: 'size' = 9;
		local: 'sign' = 1;
		
		local: 'padding';
		local: 'padchar';
		local: 'padright';
		local: 'hexadecimal';
		local: 'groupchar';
		
		define_tag: 'oncreate',
				-optional='value';
			if: (local_defined: 'value');
				if: #value->(isa: 'integer') && (#value < self->'base') && (#value > (-1 * self->'base'));
					if: #value < 0;
						self->'value' = (array: -1 * #value);
						self->'sign' = -1;
					else;
						self->'value' = (array: #value);
					/if;
				else: #value->(isa: 'decimal') && (#value < self->'base') && (#value > (-1 * self->'base'));
					if: #value < 0;
						self->'value' = (array: -1 * (integer: #value));
						self->'sign' = -1;
					else;
						self->'value' = (array: (integer: #value));
					/if;
				else: #value->(isa: 'bigint');
					self->'value' = #value->'value';
					self->'sign' = #value->'sign';
				else;
					local: '_value' = (string: #value)->trim &;
					if: #_value->(beginswith: '-');
						self->'sign' = -1;
						#_value->(replace: '-', '');
					/if;
					#_value = (string_replaceregexp: #_value, -find='\\D.*', -replace='');
					if: #_value->size > self->'size';
						local: 'pos' = (if_empty: #_value->size % self->'size', self->'size');
						self->'value'->(insert: (integer: #_value->(substring: 1, #pos)));
						loop: -from=#pos+1, -to=#_value->size, -by=self->'size';
							self->'value'->(insert: (integer: #_value->(substring: loop_count, self->'size')), 1);
						/loop;
					else;
						self->'value' = (array: (integer: #_value));
					/if;
				/if;			
			else;
				self->'value' = (array: 0);
			/if;
		/define_tag;
		
		define_tag: '*', -required='value';
			local: 'output' = (bigint: 0);
			#output->'value'->removeall;
			if: #value->(isa: 'integer') && (#value < self->'base') && (#value > (-1 * self->'base'));
				local: '_value' = #value;
				if: #_value < 0;
					#output->'sign' = -1 * self->'sign';
					#_value *= -1;
				else: #_value == 0;
					return: @#output;
				else;
					#output->'sign' = self->'sign';
				/if;
				iterate: self->'value', (local: 'temp');
					#output->'value'->(insert: #temp * #_value);
				/iterate;
				#output->normalize;
				return: @#output;
			else: #value->(isa: 'decimal') && (#value < self->'base') && (#value > (-1 * self->'base'));
				local: '_value' = #value;
				if: #_value < 0;
					#output->'sign' = -1 * self->'sign';
					#_value *= -1;
				else: #_value == 0;
					return: @#output;
				else;
					#output->'sign' = self->'sign';
				/if;
				iterate: self->'value', (local: 'temp');
					local: 'temp2' = #_value * #temp;

					local: 'tempint' = (math_floor: #temp2);
					local: 'temprem' = #temp2 - #tempint;
					#output->'value'->(insert: #tempint);
					if: loop_count == 1;
						#output->'value'->first += (integer: #temprem);
					else;
						loop: -from=loop_count - 1, -to=1, -by=-1;
							local: 'temp3' = self->'base' * #temprem;
							local: 'tempint' = (math_floor: #temp3);
							local: 'temprem' = #temp3 - #tempint;
							#output->('value')->(get: loop_count) += (integer: #tempint);	
							if: #temprem == 0;
								loop_abort;
							/if;
						/loop;
					/if;
				/iterate;
				#output->normalize;
				return: @#output;
			else;
				if: !#value->(isa: 'bigint');
					local: '_value' = (bigint: #value);
				else;
					local: '_value' = @#value;
				/if;
				local: 'size' = self->'value'->size + #_value->'value'->size - 1;
				loop: #size;
					#output->'value'->(insert: 0);
				/loop;
				iterate: self->'value', (local: 'temp1');
					local: 'offset1' = loop_count;
					iterate: #_value->'value', (local: 'temp2');
						local: 'offset2' = #offset1 + loop_count - 1;
						#output->'value'->(get: #offset2) += (#temp1 * #temp2);
					/iterate;
				/iterate;
				#output->'sign' = self->'sign' * #_value->'sign';
				#output->normalize;
				return: @#output;
			/if;
		/define_tag;

		define_tag: '/', -required='value';
			fail_if: #value == 0, -8864, 'Error: Cannot divide bigint by 0';
			local: '_value' = 1.0 / #value;
			local: 'output' = self * #_value;
			return: @#output;
		/define_tag;

		define_tag: '+', -required='value';
			local: 'output' = (bigint: 0);
			#output->'value'->removeall;
			if: (#value->(isa: 'integer') || #value->(isa: 'decimal')) && (#value < self->'base') && (#value > (-1 * self->'base'));
				local: '_value' = (integer: #value);
				iterate: self->'value', (local: 'temp');
					#output->'value'->(insert: #temp);
				/iterate;
				#output->'value'->first += self->'sign' * #_value;
				#output->normalize;
				return: @#output;
			else;
				if: !#value->(isa: 'bigint');
					local: '_value' = (bigint: #value);
				else;
					local: '_value' = @#value;
				/if;
				local: 'min' = (math_min: self->'value'->size, #_value->'value'->size);
				loop: #min;
					#output->'value'->(insert: self->'sign' * self->'value'->(get: loop_count) + #_value->'sign' * #_value->'value'->(get: loop_count));
				/loop;
				loop: -from=#min + 1, -to=self->'value'->size;
					#output->'value'->(insert: self->'sign' * self->'value'->(get: loop_count));
				/loop;
				loop: -from=#min + 1, -to=#_value->'value'->size;
					#output->'value'->(insert: #_value->'sign' * #_value->'value'->(get: loop_count));
				/loop;
				#output->normalize;
				return: @#output;
			/if;
		/define_tag;

		define_tag: '-', -required='value';
			local: 'output' = (bigint: 0);
			#output->'value'->removeall;
			if: (#value->(isa: 'integer') || #value->(isa: 'decimal')) && (#value < self->'base') && (#value > (-1 * self->'base'));
				local: '_value' = (integer: #value);
				iterate: self->'value', (local: 'temp');
					#output->'value'->(insert: #temp);
				/iterate;
				#output->'value'->first -= self->'sign' * #_value;
				#output->normalize;
				return: @#output;
			else;
				if: !#value->(isa: 'bigint');
					local: '_value' = (bigint: #value);
				else;
					local: '_value' = @#value;
				/if;
				local: 'min' = (math_min: self->'value'->size, #_value->'value'->size);
				loop: #min;
					#output->'value'->(insert: self->'sign' * self->'value'->(get: loop_count) - #_value->'sign' * #_value->'value'->(get: loop_count));
				/loop;
				loop: -from=#min + 1, -to=self->'value'->size;
					#output->'value'->(insert: self->'sign' * self->'value'->(get: loop_count));
				/loop;
				loop: -from=#min + 1, -to=#_value->'value'->size;
					#output->'value'->(insert: -1 * #_value->'sign' * #_value->'value'->(get: loop_count));
				/loop;
				#output->normalize;
				return: @#output;
			/if;
		/define_tag;

		define_tag: '*=', -required='value';
			local: 'output' = self * #value;
			self->'value' = #output->'value';
			self->'sign' = #output->'sign';
		/define_tag;

		define_tag: '+=', -required='value';
			local: 'output' = self + #value;
			self->'value' = #output->'value';
			self->'sign' = #output->'sign';
		/define_tag;

		define_tag: '-=', -required='value';
			local: 'output' = self - #value;
			self->'value' = #output->'value';
			self->'sign' = #output->'sign';
		/define_tag;

		define_tag: '/=', -required='value';
			local: 'output' = self / #value;
			self->'value' = #output->'value';
			self->'sign' = #output->'sign';
		/define_tag;

		define_tag: 'normalize';
			local: 'pos' = 1;
			while: #pos <= self->'value'->size;
				local: 'temp' = self->'value'->(get: loop_count);
				local: 'carry' = #temp / self->'base';
				local: 'remainder' = #temp % self->'base';
				local: 'update' = (#carry != 0);
				local: 'last' = (self->'value'->size == loop_count);
				if: #remainder < 0;
					if: #update || (#last == false);
						#remainder += self->'base';
						#carry -= 1;
					else;
						#remainder *= -1;
						self->'sign' *= -1;
						local: 'update' = true;
					/if;
					local: 'update' = true;
				/if;
				if: #update;
					self->'value'->(get: loop_count) = #remainder;
					if: #last;
						self->'value'->(insert: #carry);
					else;
						self->'value'->(get: loop_count + 1) += #carry;
					/if;
				/if;
				#pos++;
			/while;
			loop: -from=self->'value'->size, -to=1, -by=-1;
				if: self->'value'->(get: loop_count) == 0;
					self->'value'->(remove: loop_count);
				else;
					loop_abort;
				/if;
			/loop;
		/define_tag;
		
		define_tag: 'oncompare', -required='value';
			if: (#value->(isa: 'integer') || #value->(isa: 'decimal')) && (#value < self->'base') && (#value > (-1 * self->'base'));
				if: self->'sign' < 0;
					(#value >= 0) ? return: -1;
					(self->'value'->size > 1) ? return: -1;
					(self->'value'->first < (#value * -1)) ? return: 1;
					(self->'value'->first > (#value * -1)) ? return: -1;
					return: 0;
				else: self->'sign' > 0;
					(#value <= 0) ? return: 1;
					(self->'value'->size > 1) ? return: 1;
					(self->'value'->first > #value) ? return: 1;
					(self->'value'->first < #value) ? return: -1;
					return: 0;
				/if;
			else;
				if: !#value->(isa: 'bigint');
					local: '_value' = (bigint: #value);
				else;
					local: '_value' = @#value;
				/if;
				if: self->'sign' < 0;
					(#_value->'sign' > 0) ? return: -1;
					(self->'value'->size > #_value->'value'->size) ? return: -1;
					(self->'value'->size < #_value->'value'->size) ? return: 1;
					loop: self->'value'->size;
						local: 'temp' = (self->'value'->(get: loop_count)) - (#_value->'value'->(get: loop_count));
						#temp < 0 ? return: 1;
						#temp > 0 ? return: -1;
					/loop;
					return: 0;
				else: self->'sign' > 0;
					(#_value->'sign' < 0) ? return: 1;
					(self->'value'->size > #_value->'value'->size) ? return: 1;
					(self->'value'->size < #_value->'value'->size) ? return: -1;
					loop: self->'value'->size;
						local: 'temp' = (self->'value'->(get: loop_count)) - (#_value->'value'->(get: loop_count));
						#temp < 0 ? return: -1;
						#temp > 0 ? return: 1;
					/loop;
					return: 0;
				/if;
			/if;

		/define_tag;
		
		define_tag: 'onconvert', -required='type';
			if: #type == 'decimal';
				local: 'output' = 0.0;
				local: 'base' = 1;
				iterate: self->'value', (local: 'temp');
					#output += #temp * #base;
					#base *= self->'base';
				/iterate;
				#output *= self->'sign';
				return: @#output;
			else: #type == 'integer';
				if: self->'value'->size > 2;
					log_warning: 'Warning: BigInt cast to integer causing truncation';
				/if;
				local: 'output' = self->'value'->first;
				if: self->'value'->size >= 2;
					local: 'base' = self->'base';
					#output += self->'value'->second * self->'base';
				/if;
				#output *= self->'sign';
				return: @#output;
			else;
				local: 'output' = '';
				loop: -from=self->'value'->size, -to=1, -by=-1;
					local: 'temp' = self->'value'->(get: loop_count);
					if: #output != '';
						#output += ('0' * (self->'size' - (string: #temp)->size));
					/if;
					#output += #temp;
				/loop;
				if: #output == '';
					#output = '0';
				/if;
				if: (string: self->'groupchar') != '';
					local: 'char' = (string: self->'groupchar');
					if: #char->size > 1;
						local: 'char' = #char->(substring: 1, 1);
					/if;
					local: 'temp' = '';
					loop: -from=#output->size-2, -to=2, -by=-3;
						#output->(merge: loop_count, #char);
					/loop;
				/if;
				if: self->'sign' < 0;
					#output = '-' + #output;
				/if;
				if: (integer: self->'padding') > 0;
					local: 'char' = (if_empty: (string: self->'padchar'), ' ');
					if: #char->size > 1;
						local: 'char' = #char->(substring: 1, 1);
					/if;
					if: #output->size < (integer: self->'padding');
						local: 'padding' = (self->'padchar' * ((integer: self->'padding') - #output->size));
						if: self->'padright' == true;
							#output += #padding;
						else;
							#output = #padding + #output;
						/if;
					/if;
				/if;
				return: @#output;
			/if;
		/define_tag;
		
		define_tag: 'setformat',
				-optional='padding',
				-optional='padchar',
				-optional='padright',
				-optional='groupchar';
			iterate: params, (local: 'param');
				if: #param->(isa: 'pair') && self->properties->first >> (#param->first - '-');
					self->properties->first->(insert: (#param->first - '-') = #param->second);
				/if;
			/iterate;
		/define_tag;
		
	/define_type;

]