<?LassoScript

	// Client.Lasso
	//
	// Implements:
	// [Client_URL]
	// [Client_Encoding]
	//
	// Copyright  2007 LassoSoft, LLC
	
	// [Client_URL] returns the complete URL which was used to call the current
	// page.  -NoArgs can be used to exclude GET arguments.

	define_tag: 'url', 
			-namespace='client',
			-optional='noargs';
		local: 'output' = '';
		if: (server_port == 443);
			#output += 'https://';
		else;
			#output += 'http://';
		/if;
		#output += server_name;
		if: (server_port != 443) && (server_port != 80);
			#output += ':' + server_port;
		/if;
		#output += response_filepath;
		if: (client_getargs != '') && !(local_defined: 'noargs');
			#output += '?' + client_getargs;			
		/if;
		return: @#output;
	/define_tag;

	// [Client_Encoding] returns the encoding which will be used to send the page
	// to the browser.  Can be changed with -FormContentType.

	Define_Tag: 'Encoding', -Namespace='Client_';
		Return: $__input_encoding__;
	/Define_Tag;

?>