<?LassoScript

	// Content.Lasso
	//
	// Implements:
	// [Content_Body]
	// [Content_Header]
	// [Content_Encoding]
	//
	// Copyright  2007 LassoSoft, LLC

	// [Content_Body] can be called as a tag to replace the body of the page or
	// can be used in an expression in order to modify or add to the current body
	// of the page.  This tag accesses the variables __html_reply__.
	// [Content_Body: '<html> ... </html>']
	// [Content_Body += '<p>Some New Content</p>']
	// [Content_Body->(Replace: '\r', '')]
	
	Define_Tag: 'Body', -Namespace='Content_', -Optional='value';
		If: (Local_Defined: 'value');
			$__html_reply__ = #value;
		Else;
			Return: @$__html_reply__;
		/If;
	/Define_Tag;

	// [Content_Header] can be called as a tag to replace the HTTP header of the page
	// or can be use din an expression in order to modify or add to the current
	// header of the page.
	// [Content_Header: '302 FOUND']
	// [Content_Header += '\r\nHeader: Value']
	// [Content_Header->(Replace: '127.0.0.1', client_ip)]

	Define_Tag: 'Header', -Namespace='Content_', -Optional='value';
		If: (Local_Defined: 'value');
			$__http_header__ = #value;
		Else;
			Return: @$__http_header__;
		/If;
	/Define_Tag;

	// [Content_Encoding] returns the encoding which will be used to send the page
	// to the browser.  Can be changed with [Content_Type].
	// [Content_Encoding]

	Define_Tag: 'Encoding', -Namespace='Content_';
		Return: $__encoding__;
	/Define_Tag;

?>