<?LassoScript

	define_tag: 'reset', -namespace='error_';
		error_code = 0;
		error_msg = '';
	/define_tag;

	define_tag: 'push', -namespace='error_';
		!(var_defined: '__error_stack__') ? var: '__error_stack__' = stack;
		$__error_stack__->(insert: (pair: error_code = error_msg));
		error_code = 0;
		error_msg = 'No Error';
	/define_tag;

	define_tag: 'pop', -namespace='error_';
		!(var_defined: '__error_stack__') ? var: '__error_stack__' = stack;
		fail_if: $__error_stack__->size <= 0, -9956, 'Error stack is empty';
		local: 'temp' = $__error_stack__->(get);
		error_code = #temp->first;
		error_msg = #temp->second;
	/define_tag;

	// constants for new error codes and messages		
	define_constant:'assert',  -namespace="error_code_", -10000;
	define_constant:'assert',  -namespace="error_msg_", "Internal program assertion";
	define_constant:'streamreaderror',  -namespace="error_code_", -9999;
	define_constant:'streamreaderror',  -namespace="error_msg_", "Error reading from stream";
	define_constant:'streamwriteerror',  -namespace="error_code_", -9998;
	define_constant:'streamwriteerror',  -namespace="error_msg_", "Error writing to stream";
	define_constant:'memory',  -namespace="error_code_", -9997;
	define_constant:'memory',  -namespace="error_msg_", "Memory error";
	define_constant:'invalidmemoryobject',  -namespace="error_code_", -9996;
	define_constant:'invalidmemoryobject',  -namespace="error_msg_", "Invalid memory object";
	define_constant:'outofmemory',  -namespace="error_code_", -9995;
	define_constant:'outofmemory',  -namespace="error_msg_", "Out of memory";
	define_constant:'outofstackspace',  -namespace="error_code_", -9994;
	define_constant:'outofstackspace',  -namespace="error_msg_", "Out of stack space";
	define_constant:'couldnotlockmemory',  -namespace="error_code_", -9993;
	define_constant:'couldnotlockmemory',  -namespace="error_msg_", "Could not lock memory";
	define_constant:'couldnotunlockmemory',  -namespace="error_code_", -9992;
	define_constant:'couldnotunlockmemory',  -namespace="error_msg_", "Could not unlock memory";
	define_constant:'couldnotdisposememory',  -namespace="error_code_", -9991;
	define_constant:'couldnotdisposememory',  -namespace="error_msg_", "Could not dispose memory";
	define_constant:'file',  -namespace="error_code_", -9990;
	define_constant:'file',  -namespace="error_msg_", "File error";
	define_constant:'fileinvalid',  -namespace="error_code_", -9989;
	define_constant:'fileinvalid',  -namespace="error_msg_", "The file object is invalid";
	define_constant:'fileinvalidaccessmode',  -namespace="error_code_", -9988;
	define_constant:'fileinvalidaccessmode',  -namespace="error_msg_", "Invalid access mode";
	define_constant:'couldnotcreateoropenfile',  -namespace="error_code_", -9987;
	define_constant:'couldnotcreateoropenfile',  -namespace="error_msg_", "Could not create or open file";
	define_constant:'couldnotclosefile',  -namespace="error_code_", -9986;
	define_constant:'couldnotclosefile',  -namespace="error_msg_", "Could not close file";
	define_constant:'couldnotdeletefile',  -namespace="error_code_", -9985;
	define_constant:'couldnotdeletefile',  -namespace="error_msg_", "Could not delete file";
	define_constant:'filenotfound',  -namespace="error_code_", -9984;
	define_constant:'filenotfound',  -namespace="error_msg_", "File not found";
	define_constant:'filealreadyexists',  -namespace="error_code_", -9983;
	define_constant:'filealreadyexists',  -namespace="error_msg_", "File already exists";
	define_constant:'filecorrupt',  -namespace="error_code_", -9982;
	define_constant:'filecorrupt',  -namespace="error_msg_", "The file is corrupt";
	define_constant:'volumedoesnotexist',  -namespace="error_code_", -9981;
	define_constant:'volumedoesnotexist',  -namespace="error_msg_", "Volume does not exist";
	define_constant:'diskfull',  -namespace="error_code_", -9980;
	define_constant:'diskfull',  -namespace="error_msg_", "Disk full";
	define_constant:'directoryfull',  -namespace="error_code_", -9979;
	define_constant:'directoryfull',  -namespace="error_msg_", "Directory full";
	define_constant:'ioerror',  -namespace="error_code_", -9978;
	define_constant:'ioerror',  -namespace="error_msg_", "I/O error";
	define_constant:'invalidpathname',  -namespace="error_code_", -9977;
	define_constant:'invalidpathname',  -namespace="error_msg_", "Invalid pathname";
	define_constant:'invalidfilename',  -namespace="error_code_", -9976;
	define_constant:'invalidfilename',  -namespace="error_msg_", "Invalid filename";
	define_constant:'filelocked',  -namespace="error_code_", -9975;
	define_constant:'filelocked',  -namespace="error_msg_", "File locked";
	define_constant:'fileunlocked',  -namespace="error_code_", -9974;
	define_constant:'fileunlocked',  -namespace="error_msg_", "File unlocked";
	define_constant:'fileisopen',  -namespace="error_code_", -9973;
	define_constant:'fileisopen',  -namespace="error_msg_", "File is already open with write permission";
	define_constant:'fileisclosed',  -namespace="error_code_", -9972;
	define_constant:'fileisclosed',  -namespace="error_msg_", "File is closed";
	define_constant:'bof',  -namespace="error_code_", -9971;
	define_constant:'bof',  -namespace="error_msg_", "Beginning of file reached";
	define_constant:'eof',  -namespace="error_code_", -9970;
	define_constant:'eof',  -namespace="error_msg_", "End of file reached";
	define_constant:'couldnotwritetofile',  -namespace="error_code_", -9969;
	define_constant:'couldnotwritetofile',  -namespace="error_msg_", "Could not write to file";
	define_constant:'couldnotreadfromfile',  -namespace="error_code_", -9968;
	define_constant:'couldnotreadfromfile',  -namespace="error_msg_", "Could not read from file";
	define_constant:'resnotfound',  -namespace="error_code_", -9967;
	define_constant:'resnotfound',  -namespace="error_msg_", "Resource not found";
	define_constant:'resource',  -namespace="error_code_", -9966;
	define_constant:'resource',  -namespace="error_msg_", "Resource error";
	define_constant:'network',  -namespace="error_code_", -9965;
	define_constant:'network',  -namespace="error_msg_", "Network error";
	define_constant:'invalidusername',  -namespace="error_code_", -9964;
	define_constant:'invalidusername',  -namespace="error_msg_", "Invalid user name";
	define_constant:'invalidpassword',  -namespace="error_code_", -9963;
	define_constant:'invalidpassword',  -namespace="error_msg_", "Invalid password";
	define_constant:'invaliddatabase',  -namespace="error_code_", -9962;
	define_constant:'invaliddatabase',  -namespace="error_msg_", "Invalid database";
	define_constant:'nopermission',  -namespace="error_code_", -9961;
	define_constant:'nopermission',  -namespace="error_msg_", "No permission";
	define_constant:'fieldrestriction',  -namespace="error_code_", -9960;
	define_constant:'fieldrestriction',  -namespace="error_msg_", "Field restriction";
	define_constant:'webadderror',  -namespace="error_code_", -9959;
	define_constant:'webadderror',  -namespace="error_msg_", "Add error";
	define_constant:'webupdateerror',  -namespace="error_code_", -9958;
	define_constant:'webupdateerror',  -namespace="error_msg_", "Update error";
	define_constant:'webdeleteerror',  -namespace="error_code_", -9957;
	define_constant:'webdeleteerror',  -namespace="error_msg_", "Delete error";
	define_constant:'invalidparameter',  -namespace="error_code_", -9956;
	define_constant:'invalidparameter',  -namespace="error_msg_", "An invalid parameter was passed to a tag";
	define_constant:'overflow',  -namespace="error_code_", -9955;
	define_constant:'overflow',  -namespace="error_msg_", "Overflow: some memory passed to a function was too small to hold the results";
	define_constant:'nilpointer',  -namespace="error_code_", -9954;
	define_constant:'nilpointer',  -namespace="error_msg_", "A pointer was nil when it should not have been";
	define_constant:'unknownerror',  -namespace="error_code_", -9953;
	define_constant:'unknownerror',  -namespace="error_msg_", "Unknown error";
	define_constant:'loopaborted',  -namespace="error_code_", -9952;
	define_constant:'loopaborted',  -namespace="error_msg_", "A looping tag was aborted";
	define_constant:'syntaxerror',  -namespace="error_code_", -9951;
	define_constant:'syntaxerror',  -namespace="error_msg_", "Bad syntax used in a format file; parsing of the file was aborted";
	define_constant:'dividebyzero',  -namespace="error_code_", -9950;
	define_constant:'dividebyzero',  -namespace="error_msg_", "Divide by zero";
	define_constant:'illegalinstruction',  -namespace="error_code_", -9949;
	define_constant:'illegalinstruction',  -namespace="error_msg_", "Illegal instruction";
	define_constant:'tagnotfound',  -namespace="error_code_", -9948;
	define_constant:'tagnotfound',  -namespace="error_msg_", "Tag not found";
	define_constant:'varnotfound',  -namespace="error_code_", -9947;
	define_constant:'varnotfound',  -namespace="error_msg_", "Variable not found";
	define_constant:'aborted',  -namespace="error_code_", -9946;
	define_constant:'aborted',  -namespace="error_msg_", "Execution was aborted.";
	define_constant:'failure',  -namespace="error_code_", -9945;
	define_constant:'failure',  -namespace="error_msg_", "Execution failed.";
	define_constant:'preconditionfailed',  -namespace="error_code_", -9944;
	define_constant:'preconditionfailed',  -namespace="error_msg_", "Precondition failed";
	define_constant:'postconditionfailed',  -namespace="error_code_", -9943;
	define_constant:'postconditionfailed',  -namespace="error_msg_", "Postcondition failed";
	define_constant:'criterianotmet',  -namespace="error_code_", -9942;
	define_constant:'criterianotmet',  -namespace="error_msg_", "Criteria not met";
	define_constant:'illegaluseoffrozeninstance',  -namespace="error_code_", -9941;
	define_constant:'illegaluseoffrozeninstance',  -namespace="error_msg_", "Illegal attempt to modify a frozen value or type";
	define_constant:'datasourceerror',  -namespace="error_code_", -3000;
	define_constant:'datasourceerror',  -namespace="error_msg_", "A data source error has occurred";
	define_constant:'webmodulenotfound',  -namespace="error_code_", -2000;
	define_constant:'webmodulenotfound',  -namespace="error_msg_", "The module was not found";
	define_constant:'webnosuchobject',  -namespace="error_code_", -1728;
	define_constant:'webnosuchobject',  -namespace="error_msg_", "No records found";
	define_constant:'webtimeout',  -namespace="error_code_", -1712;
	define_constant:'webtimeout',  -namespace="error_msg_", "Timeout";
	define_constant:'webactionnotsupported',  -namespace="error_code_", -802;
	define_constant:'webactionnotsupported',  -namespace="error_msg_", "Action not supported";
	define_constant:'webrepeatingrelatedfield',  -namespace="error_code_", -801;
	define_constant:'webrepeatingrelatedfield',  -namespace="error_msg_", "Repeating related fields are not supported";
	define_constant:'webrequiredfieldmissing',  -namespace="error_code_", -800;
	define_constant:'webrequiredfieldmissing',  -namespace="error_msg_", "Value missing for required field";
	define_constant:'connectioninvalid',  -namespace="error_code_", -609;
	define_constant:'connectioninvalid',  -namespace="error_msg_", "The specified database was not found";
	define_constant:'httpfilenotfound',  -namespace="error_code_", 404;
	define_constant:'httpfilenotfound',  -namespace="error_msg_", "File not found";
	define_constant:'noerr',  -namespace="error_code_", 0;
	define_constant:'noerr',  -namespace="error_msg_", "No error";

?>