<?LassoScript
/*
local:'sample'="<?xml version='1.0' ?>
<methodCall>
<methodName>method_TestNormal</methodName>
<params>
<param><value><string>This Is A test</string></value></param>
<param><value><int>234</int></value></param>
<param><value><double>234.000000</double></value></param>
<param><value><dateTime.iso8601>19691231T16:00:00</dateTime.iso8601></value></param>
<param><value><base64>VGVzdGluZyBCYXNlNjQ= </base64></value></param>
</params>
</methodCall>";

local:'sample2'='<?xml version='1.0' ?>
<methodResponse>
<params>
<param><value><array><data><value><struct><member><name>Reason</name>
<value><string>Whew!!!</string></value></member>
<member>
<name>Rubadubdub</name>
<value><string>Inmytub</string></value>
</member></struct></value></data></array></value></param>
<param><value><array><data><value>
<string>This Is A test</string></value>
<value><string>One</string></value><value><string>Two</string></value>
<value><string>Three and four</string></value></data></array></value></param>
<param><value><boolean>1</boolean></value></param>
<param><value><int>234</int></value></param>
<param><value><string>This Is A test</string></value></param>
<param><value><double>234.000000</double></value></param>
<param><value><dateTime.iso8601>19691231T16:00:00</dateTime></value></param>
<param><value><base64>VGVzdGluZyBCYXNlNjQ= </base64></value></param>
</params></methodResponse>';
*/

define_tag:'_XMLRPC_ExConverter', -required='type', -required='encoding';
	local:'ret'=bytes;
	select:#type->type;
		case:'string';
			#ret->importString:'<string>';
			#ret->importString:encode_html:#type;
			#ret->importString:'</string>';
		case:'bytes';
			#ret->importString:'<base64>';
			#ret->importString:encode_base64:#type;
			#ret->importString:'</base64>';
		case:'base64';
			#ret->importString:'<base64>';
			#ret->importString:#type;
			#ret->importString:'</base64>';
		case:'integer';
			#ret->importString:'<int>';
			#ret->importString:string:#type;
			#ret->importString:'</int>';
		case:'boolean';
			#ret->importString:'<boolean>';
			#ret->importString:string:#type;
			#ret->importString:'</boolean>';		
		case:'date';
			#ret->importString:'<dateTime.iso8601>';
			#ret->importString:(#type->format:'%Y%m%dT%H:%M:%S');
			#ret->importString:'</dateTime.iso8601>';		
		case:'decimal';
			#ret->importString:'<double>';
			#ret->importString:string:#type;
			#ret->importString:'</double>';		
		case:'array';
			#ret->importString:'<array>';
			#ret->importString:'<data>';
			iterate:#type, local:'i';
				#ret->importString:'<value>';
				#ret->importAs(_XMLRPC_ExConverter(#i, #encoding), 'BINARY');
				#ret->importString:'</value>';
			/iterate;
			#ret->importString:'</data>';
			#ret->importString:'</array>';		
		case:'map';
			#ret->importString:'<struct>';
			iterate:#type, local:'i';
				#ret->importString:'<member>';
				#ret->importString:'<name>';
				#ret->importString:(#i->first);
				#ret->importString:'</name>';
				#ret->importString:'<value>';
				#ret->importAs(_XMLRPC_ExConverter(#i->second, #encoding), 'BINARY');
				#ret->importString:'</value>';
				#ret->importString:'</member>';
			/iterate;
			#ret->importString:'</struct>';		
		case:'pair';
			#ret->importString:'<struct>';
			#ret->importString:'<member>';
			#ret->importString:'<name>';
			#ret->importString:"first";
			#ret->importString:'</name>';
			#ret->importString:'<value>';
			#ret->importAs(_XMLRPC_ExConverter(#type->first, #encoding), 'BINARY');
			#ret->importString:'</value>';
			#ret->importString:'</member>';
			
			#ret->importString:'<member>';
			#ret->importString:'<name>';
			#ret->importString:"second";
			#ret->importString:'</name>';
			#ret->importString:'<value>';
			#ret->importAs(_XMLRPC_ExConverter(#type->second, #encoding), 'BINARY');
			#ret->importString:'</value>';
			#ret->importString:'</member>';
			#ret->importString:'</struct>';	
		case:'null';
			#ret->importString:'<string/>';				
	/select;
	return:@#ret;
/define_tag;

define_tag:'_XMLRPC_XMLInConverter', -required='xml', -type='xml';

	select:#xml->name;
		case:'string';
			return:(#xml->contents);
		case:'base64';
			return:decode_base64:(#xml->contents);
		case:'int';
			return:integer:(#xml->contents);
		case:'double';
			return:decimal:(#xml->contents);
		case:'boolean';
			return:boolean:(#xml->contents);
		case:'dateTime.iso8601';
			return:(date:(#xml->contents), -format='%Y%m%dT%H:%M:%S');
		case:'array';
			local:'ret'=array;
			local:'values' = #xml->extract:'/array/data/value/*';
			iterate:#values, local:'i';
				if:#i->nodetype == "ELEMENT_NODE";
					#ret->insert:@(_XMLRPC_XMLInConverter:#i);
				else;
					#ret->insert:string(#i->contents);
				/if;
			/iterate;
			return: #ret;
		case:'struct';
			local:'ret'=map;
			iterate: #xml->children, (local: 'member');
				local: 'nm' = null;
				local: 'vl' = null;
				iterate: #member->children, (local: 'child');
					if: (#child->nodetype == 'ELEMENT_NODE') && (#child->name == 'name');
						local: 'nm' = #child->contents;
					else: (#child->nodetype == 'ELEMENT_NODE') && (#child->name == 'value');
						iterate: #child->extract('*'), (local: 'value');
							if: #value->nodetype == 'ELEMENT_NODE';
								local: 'vl' = (_XMLRPC_XMLInConverter:#value);
							else;
								local: 'vl' = string(#value->contents);
							/if;
							loop_abort;
						/iterate;
					/if;
				/iterate;
				if: #nm != null && #vl != null;
					#ret->(insert: #nm=#vl);
				/if;
			/iterate;
			return:#ret;
		case;
			log_warning: 'XML-RPC: Unknown Type (' + #xml + ')';
	/select;
/define_tag;

define_tag:'_XMLRPC_InConverter', -required='bytes', -required='encoding';
	local:'xml'=xml:#bytes;
	return:@_XMLRPC_XMLInConverter:#xml;
/define_tag;

(global:'__internal_converters__')->insert:'XML-RPC'=\_XMLRPC_InConverter;
(global:'__external_converters__')->insert:'XML-RPC'=\_XMLRPC_ExConverter;

define_type:'rpc', -namespace='xml_', -prototype;
	local:'params'=array;
	local:'method'=string;
	
	define_tag:'onCreate', -description='Receives either an array of args to send or a response to parse.';
		local: 'params' = null;
		if: (params->size > 0);
			local: 'params' = params->(get:1);
		/if;
		if:local_defined:'params' && #params->isa:'array';
			iterate:#params, local:'i';
				self->'params'->insert:@#i;
			/iterate;
		else:#params->(isa: 'string') && (#params !>> '<');
			self->'params'->(insert:(string:#params));
		else:local_defined:'params' && (#params != null);
			error_seterrorcode: 0;
			error_seterrormessage: '';
			protect;
				local:'xml' = xml:#params;
				handle_error;
					self->'params'->(insert:(string:#params));
					return;
				/handle_error;
			/protect;
			local:'mname' = #xml->extractOne:'/methodCall/methodName';
			self->'method' = #mname->contents;
			
			local:'xmlparams' = #xml->extract:'/methodCall/params/param/value/*';
			iterate:#xmlparams, local:'i';
				self->'params'->insert:null;
				local: 'j' = bytes;
				#j->(importstring: #i);
				self->'params'->last->(deserialize:#j, 'XML-RPC');
			/iterate;
		/if;
	/define_tag;
	
	define_tag:'getparams'; 
		return:@self->'params';
	/define_tag;
	
	define_tag:'getmethod';
		return:@self->'method';
	/define_tag;
	
	define_tag:'response', -optional='full', -optional='fault';
		local:'ret'='<?xml version=\'1.0\' ?><methodResponse>';
		if:!local_defined:'fault' || !#fault;
			#ret += '<params>';
			iterate:self->'params', local:'i';
				#ret += "<param><value>";
				#ret += (#i->serialize:'XML-RPC');
				#ret += "</value></param>";
			/iterate;
			#ret += '</params>';
		else;
			#ret += '<fault>';
			local:'code'=0, 'string'=string;
			iterate:self->'params', local:'i';
				if:#i->isa:'pair';
					if:#i->first == '-faultcode';
						#code = integer:(#i->second);
					else:#i->first == '-faultstring';
						#string = string:(#i->second);
					/if;
				/if;
			/iterate;
			fail_if:!#code || !#string, -1, 'Both a -faultcode and -fault string must be provided as parameters.';
			
			#ret +=  '<value>
			         <struct>
			            <member>
			               <name>faultCode</name>
			               <value>' (#code->serialize:'XML-RPC') '</value>
			               </member>
			            <member>
			               <name>faultString</name>
			               <value>' (#string->serialize:'XML-RPC') '</value>
			               </member>
			            </struct>
			         </value>';
			
			#ret += '</fault>';
		/if;
		#ret += '</methodResponse>';
		
		if:local_defined:'full' && #full;
			return: 'HTTP/1.1 200 OK\r\nConnection: close\r\nContent-Length: ' #ret->size '\r\n\r\n' #ret;
		/if;		
		return:@#ret;
	/define_tag;
	
	define_tag:'call', -required='uri', -required='method';
		self->'method' = #method;
		
		local:'req' = "<?xml version='1.0' ?><methodCall><methodName>" #method "</methodName><params>";
		iterate:self->'params', local:'i';
			#req += "<param><value>";
			#req += (#i->serialize:'XML-RPC');
			#req += "</value></param>";
		/iterate;
		#req += "</params></methodCall>";
		local:'result' = (include_url:#uri, -postparams=#req, -SendMIMEHeaders=(array:'Content-Type'='text/xml'));
		fail_if:!#result, -1, 'Received no response from server.';
		// clear out params
		self->'params'->removeAll;
		local:'xml' = xml:#result;
		local:'xmlparams' = #xml->extract:'/methodResponse/params/param/value/*';
		iterate:#xmlparams, local:'i';
			self->'params'->insert:null;
			if (#i->nodetype == 'ELEMENT_NODE');
				local:'bytes' = bytes;
				#bytes->importString:string:#i;
				self->'params'->last->(deserialize:#bytes, 'XML-RPC');
			else;
				self->'params'->last = string(#i);
			/if;
		/iterate;
		return:@self->'params';
	/define_tag;
	
/define_type;

?>