<?LassoScript

define_type:'prettyPrintingNSMap', 'map';
    define_tag:'onConvert';
        if (params->first == 'string');
            local:'ret'='';
            iterate:self, local:'i';
                #ret += '<font color="red">' #i->first '</font>';
                #ret += '<br/>\n';
                #ret += '<div class="xsdcontentbox">' #i->second '</div>';
            /iterate;
            return:#ret;
        /if;
    /define_tag;

    define_tag:'findType', -required='ns', -required='name',
                -description='Returns a type, if found, given a <namespace>:<typename> string.';
        //log_detail:'NSMap: ' #ns ' ' #name;
        local:'nsMap' = @self->find(#ns);
        if (#nsMap->isa('map'));
            return(#nsMap->find(#name));
        /if;
    /define_tag;
/define_type;

define_type:'prettyPrintingTypeMap', 'map';
    define_tag:'onConvert';
        if (params->first == 'string');
            local:'ret'='';
            iterate:self, local:'i';
                #ret += #i->second;
                #ret += '\n';
            /iterate;
            return:#ret;
        /if;
    /define_tag;
/define_type;

namespace_using:'xsd_';

define_type:'ref', -prototype;
    local:'string'='';
	local:'cardinality'=pair(1=1); // first is min, second is max
    define_tag:'onCreate';
        if (params->size);
        	if:params->first->isa:'ref';
        		self->string = params->first->'string';
        	else;
	            self->string = string(params->first);
	        /if;
	        self->string->trim;
        /if;
    /define_tag;
    define_tag:'onAssign';
        if:params->first->isa:'string';
            self->string = params->first;
            return:true;
        /if;
    /define_tag;

	define_tag:'onConvert';
        if (params->first == 'string');
			return:self->'string';

//            local:'ret'='<div class="xsdrefsingle"><div class="grouplabel">' self->string;
//            #ret += '&nbsp;' * 3;
//            #ret += '{' self->'cardinality'->first ',' self->'cardinality'->second '}</div></div>\r\n';
//            return:#ret;
        /if;
    /define_tag;

	define_tag:'namespace';
        local:'cpy'= self->string;
        #cpy->removetrailing(self->name);
        #cpy->removetrailing(':');
        return:#cpy;
    /define_tag;
    define_tag:'name';
        return:self->string->split(':')->last;
    /define_tag;
    define_tag:'size';
        return(self->string->size);
    /define_tag;
    define_tag:'length';
        return(self->string->length);
    /define_tag;
/define_type;

//define_prototype:'xsd_ref', _xsd_ref;

define_type:'attribute', -prototype;
    local:'name'='';
    local:'base'=xsd_ref;
    local:'use'='';
    local:'fixed'='';
    local:'default'=null;
    local:'comment'='';
	local:'cardinality'=pair(1=1); // first is min, second is max
/*
	define_tag:'onConvert';
        if (params->first == 'string');
            local:'ret'=
            	'<div class="xsdattributesingle">\
            		<div class="grouplabel">@';
            #ret += self->name;
            #ret += '&nbsp;' * 3;
            #ret += '{' self->'cardinality'->first ',' self->'cardinality'->second '}';
			#ret += '</div>';
           	#ret += '<div class="groupcontent">Base Type: ';
           	#ret += self->base;
            if (self->comment->size);
                #ret += '<div class="xsdcomment">' self->comment '</div>';
            /if;
            #ret += '</div></div>';
            return:#ret;
        /if;
    /define_tag;
*/
/define_type;

define_type:'type', -prototype;
    local:'name'='';
    local:'namespace'='';
    local:'base'=xsd_ref;
    local:'attributes'=null;
    local:'content'=null;
    local:'contentBinder'='';
    local:'comment'='';
	local:'cardinality'=pair(1=1); // first is min, second is max

    define_tag:'setName', -required='xml', -required='tns', -required='name';
        if (#name !>> ':');
            self->name = #name;
            self->namespace = #tns;
        else;
            local:'splt'=#name->split(':');
            self->name = #splt->last;
            self->namespace = xsd_lookupNamespaceUri(#xml, #splt->first);
        /if;
    /define_tag;

    define_tag:'onConvert', -description='This is mainly for debugging support. On conversion to string, the type will "pretty print".';
        if (params->first == 'string');
        	return:self->'name';
/*
        	local:'p'='';
            if (self->name->beginsWith:'@');
            	#p += '<div class="xsdattributegrouping">\
            			<div class="xsdattributegroupinglabel">';
            else;
            	#p += '<div class="xsdtypegrouping">\
            			<div class="xsdtypegroupinglabel">';
            /if;
            #p += 		self->namespace ':' self->name;
            #p += '&nbsp;' * 3;
            #p += '{' self->'cardinality'->first ',' self->'cardinality'->second '}';
            #p += 		'</div>';
            #p += '<div class="groupcontent">';
            if (self->comment->size);
                #p += '<div class="xsdcomment">' self->comment '</div>';
            /if;
            #p += 'Base Type: ';
            if (self->base->size);
                #p += xsd_ref(self->base);
            else;
                #p += 'None<br />';
            /if;

            if (self->attributes->size);
            	#p += 'Attributes: ';
                iterate:self->attributes, local:'att';
                    #p += #att;
                /iterate;
            /if;

            if (self->contentBinder);
                #p += '<b>' self->contentBinder '</b> of:';
            else;
                #p += 'No Content';
            /if;
            if (self->content->size);
                iterate:self->content, local:'c';
                    #p += #c;
                /iterate;
            /if;
            #p += '</div></div>';
            return:#p;
*/
        /if;
    /define_tag;

    define_tag:'make', -required='xml', -type='xml', -description='Make a new instance based on this schema info';
		//log_detail:'make: ' #xml->name;
		if: self->contentBinder->size; // complex type
			local:'xmlLocalName' = #xml->extractOne('local-name()');
			if: self->name == 'Array';
				//log_detail:'make: making array ' self->name;
				local:'ret' = oneoff(self->name, 'array');
				iterate:#xml->extract('*'), local:'c';
					#ret->insert(self->_tryGenerating(#c));
				/iterate;
			else;
				local:'ret' = oneoff(self->name);
		        iterate:#xml->extract('*'), local:'c';
		        	//log_detail:'make: making sub element ' #c->name;
	            	#ret->properties->second->insert(#c->name = self->_tryGenerating(#c));
	    	    /iterate;
			/if;
	        return:#ret;
        /if;

        if ($XML_SCHEMA_URIS >> self->namespace);
            return:self->_makeSimple(#xml, self->name);
        /if;
        return:self->_makeSimple(#xml, self->base->name);
    /define_tag;

	define_tag:'_makeSimple', -required='xml', -type='xml', -required='named';
        if( (:'int', 'integer', 'positiveInteger', 'negativeInteger', 'nonPositiveInteger', 'nonNegativeInteger') >> #named);
            return:integer(string(#xml->contents));
        else((:'double', 'float') >> #named);
            return:decimal(string(#xml->contents));
        else(#named == 'string');
            return:string(#xml->contents);
        else if (#named == 'boolean');
        	return:boolean(#xml->contents);
        /if;
	/define_tag;

	define_tag:'_tryGenerating', -required='xml', -type='xml';
		if: #xml->extractOne('namespace-uri()') == self->namespace && (local('found') := self->content->find(self->findlocal(#xml->extractOne('local-name()'))))->size;
			//log_detail:'tryGenerating: making nested type ' #xml->name;
			return:#found->first->make(#xml);
		else;
			//log_detail:'tryGenerating: calling xsd_generate on ' #xml->name;
			return:xsd_generate(#xml);
		/if;
	/define_tag;

	define_type:'findlocal';
		local:'named'='';

		define_tag:'onCreate', -required='arg';
			self->named = #arg;
		/define_tag;

	    define_tag:'onCompare', -required='against';
	    	if:#against->isa('type') || #against->isa('type');
	    		return:self->named->compare(#against->name);
	    	/if;
	    	return:-1;
	    /define_tag;
	/define_type;

/define_type;

define_type:'blankBase';
	local:'bbSourceType'=null;
	local:'bbMemberOrdering'=array;

	define_tag:'bbConvertToXML', -required='generateOuter', -type='boolean';
		local:'ret' = '';
		if:#generateOuter;
			#ret = '<' self->type '>';
		/if;
		local:'_it' = self->bbMemberOrdering->iterator;
		while:!#_it->atEnd;
			local:'prop' = @self->properties->first->find(#_it->value);
			if:#prop != null;
				if:#prop->isa('xsd_blankBase');
					// Use value name if it differs from type name.
					if: #_it->value == #prop->type;
						#ret += #prop->bbConvertToXML(true);
					else;
						#ret += '<' #_it->value '>' #prop->bbConvertToXML(false) + '</' #_it->value '>';
					/if;
				else;
					local:'strVal' = string(#prop);
					if:#strVal->size == 0;
						#ret += '<' #_it->value '/>';
					else;
						#ret += '<' #_it->value '>' #strVal '</' #_it->value '>';
					/if;
				/if;
			/if;
			local_remove:'prop';
			#_it->forward;
		/while;
		if:#generateOuter;
			#ret += '</' self->type '>';
		/if;
		return:#ret;
	/define_tag;
/define_type;

define_type:'blankArrayBase', 'xsd_blankBase', 'array';
	define_tag:'bbConvertToXML';
		local:'ret' = '';
		#ret = '<' self->type '>';
		local:'_it' = self->iterator;
		while:!#_it->atEnd;
			if:#_it->value->isa('xsd_blankBase');
				#ret += #_it->value->bbConvertToXML;
			else;
				#ret += '<UNKNOWN>' #_it->value '</UNKNOWN>';
			/if;
			local_remove:'prop';
			#_it->forward;
		/while;
		#ret += '</' self->type '>';
		return:#ret;
	/define_tag;
/define_type;

//define_prototype:'xsd_type', _xsd_type;

define_tag:'lookupNamespaceUri', -required='xml', -type='xml', -required='prefix', -type='string';
    local:'tst' = #xml->extractOne('normalize-space(ancestor-or-self::*/namespace::*[local-name()=\'' #prefix '\'])');
    if:#tst == 'http://www.w3.org/1999/XMLSchema'; // bah
    	return:'http://www.w3.org/2001/XMLSchema';
    /if;
    return:#tst;
/define_tag;

define_tag:'fullyQualifyName', -required='xml', -type='xml',
        -required='tns', -type='string', -required='name', -type='string';
    if (#name !>> ':'); // easy
        return: #tns ':' #name;
    /if;
    local:'splt'=#name->split(':');
    return:#xml->extractOne('normalize-space(ancestor-or-self::*/namespace::*[local-name()=\''
                #splt->first
                '\'])')
                ':' #splt->last;
/define_tag;

define_tag:'buildType', -required='xml', -type='xml', -required='tns', -type='string';
	local:'newT' = null;
    select:#xml->name;
        case:'element';
            #newT = @xsd_processElement(#xml, #tns);
        case:'complexType';
            #newT = @xsd_processComplexType(#xml, #tns);
        case:'simpleType';
            #newT = @xsd_processSimpleType(#xml, #tns);
        case:'import';
            #newT = @xsd_processImport(#xml, #tns);
        case:'attribute';
            #newT = @xsd_processAttribute(#xml, #tns);
        case:'attributeGroup';
            #newT = @xsd_processAttributeGroup(#xml, #tns);
        case:'group';
            #newT = @xsd_processGroup(#xml, #tns);
        case:'any';
            #newT = @xsd_processAny(#xml, #tns);
        case;
            #newT = xsd_type;
            select:#xml->name;
                case:'choice';
                    xsd_continueChoice(#xml, #tns, #newT);
                case:'sequence';
                    xsd_continueSequence(#xml, #tns, #newT);
                case:'all';
                    xsd_continueAll(#xml, #tns, #newT);
                case:'annotation';
                    xsd_continueAnnotation(#xml, #tns, #newT);
                case;
                    log_warning:'Unhandled XMLSchema node: ' #xml->path;
            /select;
    /select;
    if:#newT != null;
	    xsd_checkCardinality(#xml, #newT);
	/if;
	return:#newT;
/define_tag;

define_tag:'checkCardinality', -required='xml', -type='xml', -required='type';
	local:'card' = #xml->extractOne('normalize-space(@minOccurs)');
	if:#card->size;
		#type->'cardinality'->first = integer:#card;
	/if;
	#card = #xml->extractOne('normalize-space(@maxOccurs)');
	if:#card->size;
		if:#card != 'unbounded';
			#card = integer:#card;
		/if;
		#type->'cardinality'->second = #card;
	/if;
/define_tag;

define_tag:'continueAnyAttribute', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    local('attr' = xsd_attribute);
    local('namespace' = #xml->extract('normalize-space(@namespace)'));

    select:#namespace;
        case:'##any';
            #attr->base = '*:*';
        case:'##other';
            #attr->base = '!' #tns ':*';
        case:'##targetNamespace';
            #attr->base= #tns ':*';
        case:'##local';
            #attr->base= #tns ':*';
        case;
            #attr->base = #namespace ':*';
    /select;

    #attr->name = '*';
    if (!(#type->attributes->isa:'array'));
        #type->attributes = array;
    /if;
    #type->attributes->insert(@#attr);
/define_tag;

define_tag:'continueAttribute', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    local('ref' = #xml->extract('normalize-space(@ref)'));
    if (#ref->size);
        if (!(#type->attributes->isa:'array'));
            #type->attributes = array;
        /if;
        local:'qualified' = xsd_ref(xsd_fullyQualifyName(#xml, #tns, #ref));
        #type->attributes->insert(@#qualified);

        if: #qualified->string == $SOAPENC + ':arrayType';
        	local:'typeDig' = #xml->extractOne("normalize-space(@*[local-name()='arrayType'])");
			if:#typeDig->size;
	        	if:!#type->content->isa('array');
	        		#type->content = array(xsd_ref(xsd_fullyQualifyName(#xml, #tns, #typeDig)));
	        	else;
	        		#type->content->insert(xsd_ref(xsd_fullyQualifyName(#xml, #tns, #typeDig)));
	        	/if;
        	/if;
        /if;

        local:'aryType';
        return;
    /if;
    local('attr' = xsd_attribute);
    local('base' = #xml->extract('normalize-space(@type)'));
    #attr->base = xsd_ref:xsd_fullyQualifyName(#xml, #tns, #base);
    #attr->name = #xml->extract('normalize-space(@name)');
    #attr->use = #xml->extract('normalize-space(@use)');
    #attr->default = #xml->extract('normalize-space(@default)');
    #attr->fixed = #xml->extract('normalize-space(@fixed)');
    if (!(#type->attributes->isa:'array'));
        #type->attributes = array;
    /if;
    #type->attributes->insert(@#attr);
/define_tag;

define_tag:'continueDocumentation', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    local('uri'=#xml->extract('normalize-space(@source)'));
    if (#uri->size);
        protect;
        	local:'c' = #xml->extract('text()');
        	if:#c->size;
	            #type->comment += '<a href="' #uri '">' #c '</a>';
	        else;
	        	#type->comment += '<a href="' #uri '">documentation source</a>';
	        /if;
        /protect;
    /if;
    #type->comment += #xml->contents;
/define_tag;

define_tag:'continueAnnotation', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    iterate:#xml->extract("*"), local:'d';
        select:#d->name;
            case:'documentation';
                xsd_continueDocumentation(#d, #tns, #type);
            case:'appinfo';
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
/define_tag;

define_tag:'continueExtension', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    local:'base' = #xml->extract('normalize-space(@base)');
    if (!#base);
        log_warning:'Missing base attribute: ' #xml->path;
    else;
        #type->base = xsd_ref:xsd_fullyQualifyName(#xml, #tns, #base); // split namespace
    /if;
    iterate:#xml->extract("*"), local:'d';
        select:#d->name;
            case:'attribute';
                xsd_continueAttribute(#d, #tns, #type);
            case:'attributeGroup';
                xsd_continueAttributeGroup(#d, #tns, #type);
            case:'choice';
                xsd_continueChoice(#d, #tns, #type);
            case:'group';
                xsd_continueGroup(#d, #tns, #type);
            case:'sequence';
                xsd_continueSequence(#d, #tns, #type);
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
/define_tag;

define_tag:'continueUnion', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    local('memberTypes' = #xml->extract('normalize-space(@memberTypes)'));
    if (#memberTypes->size);
        #type->base = xsd_ref:xsd_fullyQualifyName(#xml, #tns, #memberTypes);
    /if;

    #type->contentBinder += 'union';
    #type->content = array;

    iterate: #xml->extract("*"), local:'d';
        select:#d->name;
            case:'simpleType';
                local:'new'=xsd_buildType(#d, #tns);
                if (#new != null);
                    #type->content->insert(#new);
                /if;
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
/define_tag;

define_tag:'continueList', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    local('itemType' = #xml->extract('normalize-space(@itemType)'));
    if (#itemType->size);
        #type->base = xsd_ref:xsd_fullyQualifyName(#xml, #tns, #itemType);
    /if;
    #type->contentBinder += 'list';
    iterate:#xml->extract("*"), local:'d';
        select:#d->name;
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #type);
            case:'simpleType';
                if (#type->content == null);
                    #type->content = array;
                /if;
                #type->content->insert(@xsd_processSimpleType(#d, #tns));
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;

/define_tag;

define_tag:'continueSimpleContent', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    iterate:#xml->extract("*"), local:'d';
        select:#d->name;
            case:'restriction';
                xsd_continueRestriction(#d, #tns, #type);
            case:'extension';
                xsd_continueExtension(#d, #tns, #type);
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #type);
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
/define_tag;

define_tag:'continueRestriction', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    local('base' = #xml->extract('normalize-space(@base)'));
    if (#base->size);
        #type->base = xsd_ref:xsd_fullyQualifyName(#xml, #tns, #base);
        if:#type->base->string == $SOAPENC + ':Array';
        	#type->contentBinder += 'Array';
        /if;
    /if;
    iterate:#xml->extract("*"), local:'d';
        select:#d->name;
        	case:'attribute';
        		xsd_continueAttribute(#d, #tns, #type);
  /*          case:'restriction';
                xsd_continueRestriction(#d, #tns, #type);
            case:'extension';
                xsd_continueExtension(#d, #tns, #type);
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #type);
*/
            case;
 //               log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
/define_tag;

define_tag:'continueComplexContent', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    iterate:#xml->extract("*"), local:'d';
        select:#d->name;
            case:'extension';
                xsd_continueExtension(#d, #tns, #type);
            case:'restriction';
                xsd_continueRestriction(#d, #tns, #type);
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
/define_tag;

define_tag:'continueAny', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    #type->contentBinder += 'any';
    #type->content = array;

    iterate: #xml->extract("*"), local:'d';
        local:'new'=xsd_buildType(#d, #tns);
        if (#new != nulls);
            #type->content->insert(#new);
        /if;
    /iterate;
/define_tag;

define_tag:'continueAttributeGroup', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';

    local('ref'=#xml->extractOne('normalize-space(@ref)'));
    if (#ref->size);
        if (#type->attributes == null);
            #type->attributes = array;
        /if;
        #type->attributes->insert(@xsd_ref:xsd_fullyQualifyName(#xml, #tns, #ref));
        return;
    /if;
/*
    local:'psuedoattr'=xml_type;
    iterate: #xml->extract("*"), local:'d';
        select:#d->name;
            case:'annotation';
                xsd_continueAnnotation(#xml, #tns, #psuedoattr);
            case;
                local:'new'=xsd_buildType(#d, #tns);
                if (#new != null);
                    #psuedoattr->attributes->insert(#new);
                /if;
        /select;
    /iterate;
*/
    #type->attributes->insert(@xsd_processAttributeGroup(#xml, #tns));
/define_tag;

define_tag:'continueGroup', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    #type->contentBinder += 'group';
    #type->content = array;

    iterate: #xml->extract("*"), local:'d';
        select:#d->name;
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #type);
            case;
                local:'new'=xsd_buildType(#d, #tns);
                if (#new != null);
                    #type->content->insert(#new);
                /if;
        /select;
    /iterate;
/define_tag;

define_tag:'continueSequence', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    #type->contentBinder += 'sequence';
    #type->content = array;

    iterate: #xml->extract("*"), local:'d';
        local:'new'=xsd_buildType(#d, #tns);
        if (#new != null);
            #type->content->insert(#new);
        /if;
    /iterate;
/define_tag;

define_tag:'continueChoice', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    #type->contentBinder += 'choice';
    #type->content = array;
    iterate:#xml->extract("*"), local:'d';
        local:'new'=xsd_buildType(#d, #tns);
        if (#new != null);
            #type->content->insert(#new);
        /if;
    /iterate;
/define_tag;

define_tag:'continueAll', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    #type->contentBinder += 'all';
    #type->content = array;
    iterate:#xml->extract("*"), local:'d';
        local:'new'=xsd_buildType(#d, #tns);
        if (#new != null);
            #type->content->insert(#new);
        /if;
    /iterate;
/define_tag;

define_tag:'continueKey', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';
    // write me!
/define_tag;

define_tag:'continueSimpleType', -required='xml', -type='xml', -required='tns', -type='string', -required='type';
    iterate:#xml->extract('*'), local:'d';
        select:#d->name;
            case:'restriction';
                xsd_continueRestriction(#d, #tns, #type);
            case:'union';
                xsd_continueUnion(#d, #tns, #type);
            case:'list';
                xsd_continueList(#d, #tns, #type);
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #type);
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
/define_tag;

define_tag:'continueComplexType', -required='xml', -type='xml',
                                        -required='tns', -type='string',
                                        -required='type';

    local('name' = #xml->extractOne('normalize-space(@name)'));
    if (#name->size);
        #type->setName(#xml, #tns, #name);
    /if;
    iterate:#xml->extract("*"), local:'d';
        select:#d->name;
            case:'complexContent';
                xsd_continueComplexContent(#d, #tns, #type);
            case:'simpleContent';
                xsd_continueSimpleContent(#d, #tns, #type);
            case:'all';
                xsd_continueAll(#d, #tns, #type);
            case:'sequence';
                xsd_continueSequence(#d, #tns, #type);
            case:'attribute';
                xsd_continueAttribute(#d, #tns, #type);
            case:'choice';
                xsd_continueChoice(#d, #tns, #type);
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #type);
            case:'group';
                xsd_continueGroup(#d, #tns, #type);
            case:'attributeGroup';
                xsd_continueAttributeGroup(#d, #tns, #type);
            case:'anyAttribute';
                xsd_continueAnyAttribute(#d, #tns, #type);
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;

/define_tag;

define_tag:'processComplexType', -required='xml', -type='xml', -required='tns', -type='string';
    local:'t'=xsd_type;
    xsd_continueComplexType(#xml, #tns, #t);
    return:#t;
/define_tag;

define_tag:'processSimpleType', -required='xml', -type='xml', -required='tns', -type='string';
    local('name' = #xml->extractOne('normalize-space(@name)'));
    local:'simpletype' = xsd_type;
	if (#name);
        #simpletype->name = #name;
    /if;
    #simpletype->namespace = #tns;
    xsd_continueSimpleType(#xml, #tns, #simpletype);
    return:#simpleType;
/define_tag;

define_tag:'processGroup', -required='xml', -type='xml', -required='tns', -type='string';
    local('name' = #xml->extractOne('normalize-space(@name)'),
            'ref' = #xml->extractOne('normalize-space(@ref)'));
    if (#ref->size);
        return:xsd_ref:xsd_fullyQualifyName(#xml, #tns, #ref);
    /if;
    local:'element' = xsd_type;
	if (#name);
        #element->name = #name;
    /if;
    #element->namespace = #tns;

    iterate:#xml->extract('*'), local:'d';
        select:#d->name;
            case:'all';
                xsd_continueAll(#d, #tns, #element);
            case:'choice';
                xsd_continueChoice(#d, #tns, #element);
            case:'sequence';
                xsd_continueSequence(#d, #tns, #element);
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #element);
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
    return:#element;
/define_tag;

define_tag:'processAny', -required='xml', -type='xml', -required='tns', -type='string';
    local('namespace' = #xml->extractOne('normalize-space(@namespace)'));
    local:'xsd'=xsd_type;
    #xsd->name = '*';
    select:#namespace;
        case:'##any';
            #xsd->namespace = '*';
        case:'##other';
            #xsd->namespace = '!' #tns;
        case;
            #xsd->namespace = #namespace;
    /select;

    iterate:#xml->extract('*'), local:'d';
        select:#d->name;
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #element);
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
    return:#xsd;
/define_tag;

define_tag:'processElement', -required='xml', -type='xml', -required='tns', -type='string';
    local('name' = #xml->extractOne('normalize-space(@name)'),
            'type' = #xml->extractOne('normalize-space(@type)'));

	if(#type->size == 0);
	   #type = #xml->extractOne('normalize-space(@ref)');
	   if (#type->size);
	       // this is a ref
	       // not a named type on its own
	       if (#type !>> ':');
	           #type = #tns ':' #type;
	       else;
	           #type = xsd_fullyQualifyName(#xml, #tns, #type);
	       /if;
	       return:xsd_ref:#type;
	   /if;
	else; // if this is an element with the same name as it's type, ignore it?
		if:#type->endsWith:#name;
			#name = 'ELEMENT-' + #name;
		/if;
	/if;
    local:'element' = xsd_type;
	if (#name);
        #element->name = #name;
    /if;
    #element->namespace = #tns;
	if:#type->size > 0;
        #element->base = xsd_ref:xsd_fullyQualifyName(#xml, #tns, #type);
	/if;

	xsd_checkCardinality(#xml, #element);

    iterate:#xml->extract('*'), local:'d';
        select:#d->name;
            case:'complexType';
                xsd_continueComplexType(#d, #tns, #element);
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #element);
            case:'key';
                xsd_continueKey(#d, #tns, #element);
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
    return:#element;
/define_tag;

define_tag:'processAttribute', -required='xml', -type='xml',
                                        -required='tns', -type='string';
    local('ref' = #xml->extractOne('normalize-space(@ref)'));
    if (#ref->size);
        return:xsd_ref:xsd_fullyQualifyName(#xml, #tns, #ref);
    /if;
    local('attr' = xsd_attribute);
    local('base' = #xml->extract('normalize-space(@type)'));
    #attr->base = xsd_ref:xsd_fullyQualifyName(#xml, #tns, #base);
    #attr->name = #xml->extract('normalize-space(@name)');
    #attr->use = #xml->extract('normalize-space(@use)');
    #attr->default = #xml->extract('normalize-space(@default)');
    #attr->fixed = #xml->extract('normalize-space(@fixed)');

    iterate:#xml->extract('*'), local:'d';
        select:#d->name;
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #attr);
            case:'simpleType';
                xsd_continueSimpleType(#d, #tns, #attr);
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
    return:#attr;
/define_tag;

define_tag:'processAttributeGroup', -required='xml', -type='xml', -required='tns', -type='string';
   local('name' = #xml->extractOne('normalize-space(@name)'),
            'type' = #xml->extractOne('normalize-space(@ref)'));
   if (#type->size);
       // this is a ref
       // not a named type on its own
       if (#type !>> ':');
           #type = #tns ':' #type;
       /if;
       return:xsd_ref:#type;
   /if;
    local:'element' = xsd_type;
	if (#name);
        #element->name = '@' + #name; // special attribute group marker
    /if;
    #element->namespace = #tns;
	#element->content = array;
	#element->attributes = array;

    iterate:#xml->extract('*'), local:'d';
        select:#d->name;
            case:'attribute';
                xsd_continueAttribute(#d, #tns, #element);
//            case:'attributeGroup';
//                #element->content->insert(xsd_processAttributeGroup(#d, #tns, #element));
            case:'anyAttribute';
                xsd_continueAnyAttribute(#d, #tns, #element);
            case:'annotation';
                xsd_continueAnnotation(#d, #tns, #element);
            case;
                log_warning:'Not understood: ' #d->path;
        /select;
    /iterate;
    return:#element;
/define_tag;

define_tag:'processImport', -required='xml', -type='xml', -required='tns', -type='string';
    local('schemaLocation' = #xml->extractOne("normalize-space(@schemaLocation)"));
    local('namespace' = #xml->extractOne("normalize-space(@namespace)"));
    if (#schemaLocation->size);
        protect;
            local:'d' = include_url:#schemaLocation;
            if (#namespace->size);
                xsd_loadSchema(xml(#d), #namespace);
            else;
                xsd_loadSchema(xml(#d));
            /if;
        /protect;
    /if;
    return:null;
/define_tag;

define_tag:'processInclude', -required='xml', -type='xml', -required='tns', -type='string';
    local('schemaLocation' = #xml->extractOne("normalize-space(@schemaLocation)"));
    if (#schemaLocation->size);
        protect;
            local:'d' = include_url:#schemaLocation;
            xsd_loadSchema(xml(#d), #tns);
        /protect;
    /if;
    return:null;
/define_tag;

define_tag:'processSchema', -required='xml', -required='tns';
    local:'tnsmap'=null;

    $_xml_schema_cache->insert(#tns=prettyPrintingTypeMap);
    #tnsmap = @$_xml_schema_cache->find(#tns);

    iterate:#xml->extract("*"), local('type');
        if ( $XML_SCHEMA_URIS >> #type->extract('namespace-uri()'));
            local:'t' = xsd_buildType(#type, #tns);
            if (#t != null);
                #tnsmap->insert( #t->name = #t );
            /if;
        /if;
    /iterate;
/define_tag;

define_tag:'loadSchema', -required='xml', -type='xml', -optional='inTns', -type='string',
        -description='Loads and stores information about all contained types.';

    local:'schemas' = #xml->extract("//*[local-name()='schema']"); /* */
    iterate:#schemas, local('schema');
        // check its namespace
        local:'tns' = #schema->extractOne('namespace-uri()');
        if ($XML_SCHEMA_URIS >> #tns);
            if (local_defined('inTns'));
                #tns = #inTns;
            else;
                #tns = #schema->extractOne('normalize-space(@targetNamespace)');
            /if;
            if: xsd_cache->find(#tns)->size == 0;
            	xsd_processSchema(#schema, #tns);
            /if;
        /if;
    /iterate;
/define_tag;

define_tag:'getSchemaType', -required='for', -description='Accepts a Lasso type name and returns the name for it in the lp7_types.xsd';
	select:#for;
		case: 'null';
			return:"nullType";
		case:'string';
			return:"stringType";
		case:'integer';
			return:"integerType";
		case:'decimal';
			return:"decimalType";
		case:'bytes';
			return:'bytesType';
		case:'boolean';
			return:"booleanType";
		case:'pair';
			return:"pairType";
		case:'array';
			return:"arrayType";
		case:'map';
			return:"mapType";
		case:'tag';
			return:"customTagType";
		case;
			return:'customType';
	/select;
	fail:-1, 'Unsupported type: ' #for;
/define_tag;

define_tag:'deserialize', -required='thedata', -type='xml', -required='type', -type='string',
                    -priority='low',
                    -criteria=((:'int', 'integer', 'positiveInteger', 'negativeInteger', 'nonPositiveInteger', 'nonNegativeInteger') >> #type);
    return:integer(string(#thedata->contents));
/define_tag;

define_tag:'deserialize', -required='thedata', -type='xml', -required='type', -type='string',
                    -priority='low',
                    -criteria=((:'double', 'float') >> #type);
    return:decimal(string(#thedata->contents));
/define_tag;

define_tag:'deserialize', -required='thedata', -type='xml', -required='type', -type='string',
                    -priority='low',
                    -criteria=(#type == 'string');
    return:string(#thedata->contents);
/define_tag;

define_tag:'deserialize', -required='thedata', -type='xml', -priority='low';
    local:'typeName' = #thedata->extractOne("normalize-space(@*[local-name()='type'])");
//    log_detail:#typeName;
    if (#typeName->size);
        local:'splt' = #typeName->split(':');
        if (#splt->size > 1);
            local:'namespace' = xsd_lookupNamespaceUri(#thedata, #splt->first);
            local:'name' = #splt->second;
        else;
            local:'namespace' = #thedata->extractOne('normalize-space(namespace-uri(.))');
            local:'name' = #splt->first;
        /if;
    else;
        local:'namespace' = #thedata->extractOne('normalize-space(namespace-uri(.))');
        local:'name' = #thedata->extractOne('normalize-space(name(.))');
    /if;
    // find the namespace map
    local:'xsdtype' = @xsd_cache->findType(#namespace, #name);
    if (#xsdtype != null);
        return:#xsdtype->make(#thedata);
    /if;
    fail:-1, 'Could not find schema for type.';
/define_tag;

define_tag:'isSimpleType', -required='name';
	// List from http://www.w3.org/2001/XMLSchema-datatypes
	return: (:'string', 'boolean', 'float', 'double', 'decimal',
			'dateTime', 'duration', 'hexBinary', 'base64Binary',
			'anyURI', 'ID', 'IDREF', 'ENTITY', 'NOTATION',
			'normalizedString', 'token', 'language', 'IDREFS',
			'ENTITIES', 'NMTOKEN', 'NMTOKENS', 'Name', 'QName',
			'NCName', 'integer', 'nonNegativeInteger',
			'positiveInteger', 'nonPositiveInteger', 'negativeInteger',
			'byte', 'int', 'long', 'short', 'unsignedByte',
			'unsignedInt', 'unsignedLong', 'unsignedShort', 'date',
			'time', 'gYearMonth', 'gYear', 'gMonthDay', 'gDay',
			'gMonth') >> #name;
/define_tag;

define_tag:'generateBlankSimpleType', -required='name';
	if: (:'int', 'integer', 'positiveInteger', 'negativeInteger', 'nonPositiveInteger', 'nonNegativeInteger') >> #name;
		return:0;
	else if: (:'double', 'float', 'decimal') >> #name;
		return:0.0;
	else if: 'boolean' == #name;
		return:false;
	else;
		return:'';
	/if;
/define_tag;

define_tag:'generateBlankFromType', -required='theType', -optional='name';
	if:#theType->isa('xsd_ref');
		local:'tst' = @xsd_lookupType(#theType->namespace, #theType->name);
//		log_detail('THE TYPE: ' #tst ' FROM: ' #theType);
		fail_if:null == #tst, -1, 'Could not find type ref ' #theType;
		local_reset('theType'=@#tst);
	/if;
	local:'isArray' = false;
	local:'ret' = null;
	if:!local_defined('name');
		local:'name' = #theType->name;
	/if;
	if: ($XML_SCHEMA_URIS >> #theType->base->namespace) && xsd_isSimpleType(#theType->base->name);
		#ret = xsd_generateBlankSimpleType(#theType->base->name);
	else if: #theType->name->beginsWith('ELEMENT-');
		fail_if:null == #theType->base, -1, 'Could not find base for ' #theType->name;
		local:'tstE' = @xsd_lookupType(#theType->base->namespace, #theType->base->name);
		fail_if:null == #tstE, -1, 'Could not find type for ' #theType->base->name;
		#ret = xsd_generateBlankFromType(#tstE, #theType->name - 'ELEMENT-');
	else if: null != #theType->base && #theType->base->namespace == $SOAPENC && #theType->base->name == 'Array';
		#ret = oneoff(#name, 'xsd_blankArrayBase');
		#ret->bbSourceType = @#theType;
		#isArray = true;
	else if: #theType->base->size; // generate the base type first
//		log_detail(#theType->name '-' #theType->base);
		#ret = xsd_generateBlankFromType(#theType->base);
		#ret->isa('blankBase') ?
			#ret->bbSourceType = @#theType;
	else;
		#ret = oneoff(#name, 'xsd_blankBase');
		#ret->bbSourceType = @#theType;
	/if;
	if:!#isArray && #theType->content->size;
		local:'_it' = #theType->content->iterator;
		while:!#_it->atEnd;
			local:'doctoredName' = #_it->value->name - 'ELEMENT-';
			if (#doctoredName != '*');
				#ret->bbMemberOrdering->insertLast(#doctoredName);
				#ret->properties->first->insert(#doctoredName = @xsd_generateBlankFromType(#_it->value));
			/if;
			#_it->forward;
		/while;
	/if;
	return:#ret;
/define_tag;

define_tag:'generateType', -required='namespace', -required='type';
	local:'theType' = @xsd_cache->find(#namespace)->find(#type);
	if: #theType->type == 'null';
		#theType = @xsd_cache->find(#namespace)->find('ELEMENT-' #type);
	/if;
	fail_if:#theType->type == 'null', -1, 'Could not find the specified type.';
	return:xsd_generateBlankFromType(#theType);
/define_tag;

define_tag:'generate', -required='xml', -type='xml';
	local:'type' = #xml->extractOne('normalize-space(@*[local-name()=\'type\'])');
	if:#type == null;
		#type = #xml->extractOne('name()');
	/if;
	fail_if:#type == null, -1, 'Could not find the type attribute on ' string(#xml);

	local:'colonPos' = #type->find(':');
	if:#colonPos > 0;
		// should cache this
		local:'uri' = xsd_lookupNamespaceUri( #xml, #type->substring(1,#colonPos-1) );
		fail_if:#uri == null, -1, 'Could not find namespace uri for ' #type->substring(1,#colonPos-1) ' ' #type;
	else;
		local:'uri' = #xml->extractOne('namespace-uri()');
		#colonPos = 0;
	/if;

	//log_detail:'xsd_generate: ' #xml->name ' ' #type ' ' #uri;
	local:'tm' = @xsd_cache->find(#uri);
	if:#tm != null;
		local:'thetype' = #tm->find(#type->substring(#colonPos+1, #type->length - #colonPos));
		if:#thetype != null;
			//log_detail:'xsd_generate: calling make on ' #xml->name ' ' #thetype->type;
			return:#thetype->make(#xml);
		/if;
	/if;
	if:!local_defined('strict');
		// we can't find any information about this type
		// dynamically generate
		local:'typeName' = #xml->extract('local-name()');
		//log_detail:'xsd_generate: dynamic on ' #typeName;
		local:'ret' = oneoff(#typeName);
		iterate:#xml->extract('*'), local:'c';
				//log_detail:'AUTO GEN ' + #c;
				#ret->properties->first->insert(#c->extract('local-name()') = xsd_generate(#c));
		/iterate;
		return:#ret;
	/if;
	fail_if:#thetype == null, -1, 'Could not find type map instance for ' #type ' ' #uri;
/define_tag;

define_tag:'cache';
    return:$_xml_schema_cache;
/define_tag;

define_tag:'lookupType', -required='namespace', -required='name';
	local:'tm' = @xsd_cache->find(#namespace);
	if:null != #tm;
		return:#tm->find(#name);
	/if;
/define_tag;

/namespace_using;

?>